"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = __importDefault(require("./"));
var _2 = require("./");
describe('SDK exports', function () {
    it('should export Kava as a default', function () {
        expect(_1.default).toBeDefined();
    });
    it('should contain expected modules', function () {
        expect(_1.default.utils).toBeDefined();
        expect(_1.default.tx).toBeDefined();
        expect(_1.default.msg).toBeDefined();
        expect(_1.default.crypto).toBeDefined();
    });
    it('should export each module individually', function () {
        expect(_2.utils).toBeDefined();
        expect(_2.tx).toBeDefined();
        expect(_2.msg).toBeDefined();
        expect(_2.crypto).toBeDefined();
    });
    it('derives the correct kava address from ox address', function () {
        expect(_2.utils.kavaToEthAddress('kava1vlpsrmdyuywvaqrv7rx6xga224sqfwz3fyfhwq')).toEqual('0x67C301eDA4E11Cce806Cf0CDa323aA556004b851');
    });
    it('derives the correct 0x address from a kava address', function () {
        expect(_2.utils.ethToKavaAddress('0x7Bbf300890857b8c241b219C6a489431669b3aFA')).toEqual('kava10wlnqzyss4accfqmyxwx5jy5x9nfkwh6qm7n4t');
    });
});
