import { Coin } from '../../types/Coin';
declare function newMsgDeposit(depositor: string, tokenA: Coin, tokenB: Coin, slippage: string, deadline: string): {
    type: string;
    value: {
        depositor: string;
        token_a: Coin;
        token_b: Coin;
        slippage: string;
        deadline: string;
    };
};
declare function newMsgWithdraw(from: string, shares: any, minTokenA: Coin, minTokenB: Coin, deadline: string): {
    type: string;
    value: {
        from: string;
        shares: any;
        min_token_a: Coin;
        min_token_b: Coin;
        deadline: string;
    };
};
declare function newMsgSwapExactForTokens(requester: string, exactTokenA: Coin, tokenB: Coin, slippage: string, deadline: string): {
    type: string;
    value: {
        requester: string;
        exact_token_a: Coin;
        token_b: Coin;
        slippage: string;
        deadline: string;
    };
};
declare function newMsgSwapForExactTokens(requester: string, tokenA: Coin, exactTokenB: Coin, slippage: string, deadline: string): {
    type: string;
    value: {
        requester: string;
        token_a: Coin;
        exact_token_b: Coin;
        slippage: string;
        deadline: string;
    };
};
export declare const swap: {
    newMsgDeposit: typeof newMsgDeposit;
    newMsgWithdraw: typeof newMsgWithdraw;
    newMsgSwapExactForTokens: typeof newMsgSwapExactForTokens;
    newMsgSwapForExactTokens: typeof newMsgSwapForExactTokens;
};
export {};
