import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "ethermint.evm.v1";
/** EventEthereumTx defines the event for an Ethereum transaction */
export interface EventEthereumTx {
    /** amount */
    amount: string;
    /** eth_hash is the Ethereum hash of the transaction */
    ethHash: string;
    /** index of the transaction in the block */
    index: string;
    /** gas_used is the amount of gas used by the transaction */
    gasUsed: string;
    /** hash is the Tendermint hash of the transaction */
    hash: string;
    /** recipient of the transaction */
    recipient: string;
    /** eth_tx_failed contains a VM error should it occur */
    ethTxFailed: string;
}
/** EventTxLog defines the event for an Ethereum transaction log */
export interface EventTxLog {
    /** tx_logs is an array of transaction logs */
    txLogs: string[];
}
/** EventMessage */
export interface EventMessage {
    /** module which emits the event */
    module: string;
    /** sender of the message */
    sender: string;
    /** tx_type is the type of the message */
    txType: string;
}
/** EventBlockBloom defines an Ethereum block bloom filter event */
export interface EventBlockBloom {
    /** bloom is the bloom filter of the block */
    bloom: string;
}
export declare const EventEthereumTx: {
    encode(message: EventEthereumTx, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventEthereumTx;
    fromJSON(object: any): EventEthereumTx;
    toJSON(message: EventEthereumTx): unknown;
    create(base?: DeepPartial<EventEthereumTx>): EventEthereumTx;
    fromPartial(object: DeepPartial<EventEthereumTx>): EventEthereumTx;
};
export declare const EventTxLog: {
    encode(message: EventTxLog, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventTxLog;
    fromJSON(object: any): EventTxLog;
    toJSON(message: EventTxLog): unknown;
    create(base?: DeepPartial<EventTxLog>): EventTxLog;
    fromPartial(object: DeepPartial<EventTxLog>): EventTxLog;
};
export declare const EventMessage: {
    encode(message: EventMessage, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventMessage;
    fromJSON(object: any): EventMessage;
    toJSON(message: EventMessage): unknown;
    create(base?: DeepPartial<EventMessage>): EventMessage;
    fromPartial(object: DeepPartial<EventMessage>): EventMessage;
};
export declare const EventBlockBloom: {
    encode(message: EventBlockBloom, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventBlockBloom;
    fromJSON(object: any): EventBlockBloom;
    toJSON(message: EventBlockBloom): unknown;
    create(base?: DeepPartial<EventBlockBloom>): EventBlockBloom;
    fromPartial(object: DeepPartial<EventBlockBloom>): EventBlockBloom;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
