import Long from "long";
import _m0 from "protobufjs/minimal";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Any } from "../../../google/protobuf/any";
import { Params } from "./genesis";
export declare const protobufPackage = "kava.auction.v1beta1";
/** QueryParamsRequest defines the request type for querying x/auction parameters. */
export interface QueryParamsRequest {
}
/** QueryParamsResponse defines the response type for querying x/auction parameters. */
export interface QueryParamsResponse {
    params?: Params | undefined;
}
/** QueryAuctionRequest is the request type for the Query/Auction RPC method. */
export interface QueryAuctionRequest {
    auctionId: Long;
}
/** QueryAuctionResponse is the response type for the Query/Auction RPC method. */
export interface QueryAuctionResponse {
    auction?: Any | undefined;
}
/** QueryAuctionsRequest is the request type for the Query/Auctions RPC method. */
export interface QueryAuctionsRequest {
    type: string;
    owner: string;
    denom: string;
    phase: string;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest | undefined;
}
/** QueryAuctionsResponse is the response type for the Query/Auctions RPC method. */
export interface QueryAuctionsResponse {
    auctions: Any[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse | undefined;
}
/** QueryNextAuctionIDRequest defines the request type for querying x/auction next auction ID. */
export interface QueryNextAuctionIDRequest {
}
/** QueryNextAuctionIDResponse defines the response type for querying x/auction next auction ID. */
export interface QueryNextAuctionIDResponse {
    id: Long;
}
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
};
export declare const QueryAuctionRequest: {
    encode(message: QueryAuctionRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAuctionRequest;
    fromJSON(object: any): QueryAuctionRequest;
    toJSON(message: QueryAuctionRequest): unknown;
    create(base?: DeepPartial<QueryAuctionRequest>): QueryAuctionRequest;
    fromPartial(object: DeepPartial<QueryAuctionRequest>): QueryAuctionRequest;
};
export declare const QueryAuctionResponse: {
    encode(message: QueryAuctionResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAuctionResponse;
    fromJSON(object: any): QueryAuctionResponse;
    toJSON(message: QueryAuctionResponse): unknown;
    create(base?: DeepPartial<QueryAuctionResponse>): QueryAuctionResponse;
    fromPartial(object: DeepPartial<QueryAuctionResponse>): QueryAuctionResponse;
};
export declare const QueryAuctionsRequest: {
    encode(message: QueryAuctionsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAuctionsRequest;
    fromJSON(object: any): QueryAuctionsRequest;
    toJSON(message: QueryAuctionsRequest): unknown;
    create(base?: DeepPartial<QueryAuctionsRequest>): QueryAuctionsRequest;
    fromPartial(object: DeepPartial<QueryAuctionsRequest>): QueryAuctionsRequest;
};
export declare const QueryAuctionsResponse: {
    encode(message: QueryAuctionsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAuctionsResponse;
    fromJSON(object: any): QueryAuctionsResponse;
    toJSON(message: QueryAuctionsResponse): unknown;
    create(base?: DeepPartial<QueryAuctionsResponse>): QueryAuctionsResponse;
    fromPartial(object: DeepPartial<QueryAuctionsResponse>): QueryAuctionsResponse;
};
export declare const QueryNextAuctionIDRequest: {
    encode(_: QueryNextAuctionIDRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryNextAuctionIDRequest;
    fromJSON(_: any): QueryNextAuctionIDRequest;
    toJSON(_: QueryNextAuctionIDRequest): unknown;
    create(base?: DeepPartial<QueryNextAuctionIDRequest>): QueryNextAuctionIDRequest;
    fromPartial(_: DeepPartial<QueryNextAuctionIDRequest>): QueryNextAuctionIDRequest;
};
export declare const QueryNextAuctionIDResponse: {
    encode(message: QueryNextAuctionIDResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryNextAuctionIDResponse;
    fromJSON(object: any): QueryNextAuctionIDResponse;
    toJSON(message: QueryNextAuctionIDResponse): unknown;
    create(base?: DeepPartial<QueryNextAuctionIDResponse>): QueryNextAuctionIDResponse;
    fromPartial(object: DeepPartial<QueryNextAuctionIDResponse>): QueryNextAuctionIDResponse;
};
/** Query defines the gRPC querier service for auction module */
export interface Query {
    /** Params queries all parameters of the auction module. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    /** Auction queries an individual Auction by auction ID */
    Auction(request: QueryAuctionRequest): Promise<QueryAuctionResponse>;
    /** Auctions queries auctions filtered by asset denom, owner address, phase, and auction type */
    Auctions(request: QueryAuctionsRequest): Promise<QueryAuctionsResponse>;
    /** NextAuctionID queries the next auction ID */
    NextAuctionID(request: QueryNextAuctionIDRequest): Promise<QueryNextAuctionIDResponse>;
}
export declare const QueryServiceName = "kava.auction.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    Auction(request: QueryAuctionRequest): Promise<QueryAuctionResponse>;
    Auctions(request: QueryAuctionsRequest): Promise<QueryAuctionsResponse>;
    NextAuctionID(request: QueryNextAuctionIDRequest): Promise<QueryNextAuctionIDResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
