import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.bep3.v1beta1";
/** MsgCreateAtomicSwap defines the Msg/CreateAtomicSwap request type. */
export interface MsgCreateAtomicSwap {
    from: string;
    to: string;
    recipientOtherChain: string;
    senderOtherChain: string;
    randomNumberHash: string;
    timestamp: Long;
    amount: Coin[];
    heightSpan: Long;
}
/** MsgCreateAtomicSwapResponse defines the Msg/CreateAtomicSwap response type. */
export interface MsgCreateAtomicSwapResponse {
}
/** MsgClaimAtomicSwap defines the Msg/ClaimAtomicSwap request type. */
export interface MsgClaimAtomicSwap {
    from: string;
    swapId: string;
    randomNumber: string;
}
/** MsgClaimAtomicSwapResponse defines the Msg/ClaimAtomicSwap response type. */
export interface MsgClaimAtomicSwapResponse {
}
/** MsgRefundAtomicSwap defines the Msg/RefundAtomicSwap request type. */
export interface MsgRefundAtomicSwap {
    from: string;
    swapId: string;
}
/** MsgRefundAtomicSwapResponse defines the Msg/RefundAtomicSwap response type. */
export interface MsgRefundAtomicSwapResponse {
}
export declare const MsgCreateAtomicSwap: {
    encode(message: MsgCreateAtomicSwap, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCreateAtomicSwap;
    fromJSON(object: any): MsgCreateAtomicSwap;
    toJSON(message: MsgCreateAtomicSwap): unknown;
    create(base?: DeepPartial<MsgCreateAtomicSwap>): MsgCreateAtomicSwap;
    fromPartial(object: DeepPartial<MsgCreateAtomicSwap>): MsgCreateAtomicSwap;
};
export declare const MsgCreateAtomicSwapResponse: {
    encode(_: MsgCreateAtomicSwapResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCreateAtomicSwapResponse;
    fromJSON(_: any): MsgCreateAtomicSwapResponse;
    toJSON(_: MsgCreateAtomicSwapResponse): unknown;
    create(base?: DeepPartial<MsgCreateAtomicSwapResponse>): MsgCreateAtomicSwapResponse;
    fromPartial(_: DeepPartial<MsgCreateAtomicSwapResponse>): MsgCreateAtomicSwapResponse;
};
export declare const MsgClaimAtomicSwap: {
    encode(message: MsgClaimAtomicSwap, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimAtomicSwap;
    fromJSON(object: any): MsgClaimAtomicSwap;
    toJSON(message: MsgClaimAtomicSwap): unknown;
    create(base?: DeepPartial<MsgClaimAtomicSwap>): MsgClaimAtomicSwap;
    fromPartial(object: DeepPartial<MsgClaimAtomicSwap>): MsgClaimAtomicSwap;
};
export declare const MsgClaimAtomicSwapResponse: {
    encode(_: MsgClaimAtomicSwapResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimAtomicSwapResponse;
    fromJSON(_: any): MsgClaimAtomicSwapResponse;
    toJSON(_: MsgClaimAtomicSwapResponse): unknown;
    create(base?: DeepPartial<MsgClaimAtomicSwapResponse>): MsgClaimAtomicSwapResponse;
    fromPartial(_: DeepPartial<MsgClaimAtomicSwapResponse>): MsgClaimAtomicSwapResponse;
};
export declare const MsgRefundAtomicSwap: {
    encode(message: MsgRefundAtomicSwap, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRefundAtomicSwap;
    fromJSON(object: any): MsgRefundAtomicSwap;
    toJSON(message: MsgRefundAtomicSwap): unknown;
    create(base?: DeepPartial<MsgRefundAtomicSwap>): MsgRefundAtomicSwap;
    fromPartial(object: DeepPartial<MsgRefundAtomicSwap>): MsgRefundAtomicSwap;
};
export declare const MsgRefundAtomicSwapResponse: {
    encode(_: MsgRefundAtomicSwapResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRefundAtomicSwapResponse;
    fromJSON(_: any): MsgRefundAtomicSwapResponse;
    toJSON(_: MsgRefundAtomicSwapResponse): unknown;
    create(base?: DeepPartial<MsgRefundAtomicSwapResponse>): MsgRefundAtomicSwapResponse;
    fromPartial(_: DeepPartial<MsgRefundAtomicSwapResponse>): MsgRefundAtomicSwapResponse;
};
/** Msg defines the bep3 Msg service. */
export interface Msg {
    /** CreateAtomicSwap defines a method for creating an atomic swap */
    CreateAtomicSwap(request: MsgCreateAtomicSwap): Promise<MsgCreateAtomicSwapResponse>;
    /** ClaimAtomicSwap defines a method for claiming an atomic swap */
    ClaimAtomicSwap(request: MsgClaimAtomicSwap): Promise<MsgClaimAtomicSwapResponse>;
    /** RefundAtomicSwap defines a method for refunding an atomic swap */
    RefundAtomicSwap(request: MsgRefundAtomicSwap): Promise<MsgRefundAtomicSwapResponse>;
}
export declare const MsgServiceName = "kava.bep3.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    CreateAtomicSwap(request: MsgCreateAtomicSwap): Promise<MsgCreateAtomicSwapResponse>;
    ClaimAtomicSwap(request: MsgClaimAtomicSwap): Promise<MsgClaimAtomicSwapResponse>;
    RefundAtomicSwap(request: MsgRefundAtomicSwap): Promise<MsgRefundAtomicSwapResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
