import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.cdp.v1beta1";
/** CDP defines the state of a single collateralized debt position. */
export interface CDP {
    id: Long;
    owner: Uint8Array;
    type: string;
    collateral?: Coin | undefined;
    principal?: Coin | undefined;
    accumulatedFees?: Coin | undefined;
    feesUpdated?: Date | undefined;
    interestFactor: string;
}
/** Deposit defines an amount of coins deposited by an account to a cdp */
export interface Deposit {
    cdpId: Long;
    depositor: string;
    amount?: Coin | undefined;
}
/** TotalPrincipal defines the total principal of a given collateral type */
export interface TotalPrincipal {
    collateralType: string;
    amount?: Coin | undefined;
}
/** TotalCollateral defines the total collateral of a given collateral type */
export interface TotalCollateral {
    collateralType: string;
    amount?: Coin | undefined;
}
/** OwnerCDPIndex defines the cdp ids for a single cdp owner */
export interface OwnerCDPIndex {
    cdpIds: Long[];
}
export declare const CDP: {
    encode(message: CDP, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CDP;
    fromJSON(object: any): CDP;
    toJSON(message: CDP): unknown;
    create(base?: DeepPartial<CDP>): CDP;
    fromPartial(object: DeepPartial<CDP>): CDP;
};
export declare const Deposit: {
    encode(message: Deposit, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Deposit;
    fromJSON(object: any): Deposit;
    toJSON(message: Deposit): unknown;
    create(base?: DeepPartial<Deposit>): Deposit;
    fromPartial(object: DeepPartial<Deposit>): Deposit;
};
export declare const TotalPrincipal: {
    encode(message: TotalPrincipal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TotalPrincipal;
    fromJSON(object: any): TotalPrincipal;
    toJSON(message: TotalPrincipal): unknown;
    create(base?: DeepPartial<TotalPrincipal>): TotalPrincipal;
    fromPartial(object: DeepPartial<TotalPrincipal>): TotalPrincipal;
};
export declare const TotalCollateral: {
    encode(message: TotalCollateral, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TotalCollateral;
    fromJSON(object: any): TotalCollateral;
    toJSON(message: TotalCollateral): unknown;
    create(base?: DeepPartial<TotalCollateral>): TotalCollateral;
    fromPartial(object: DeepPartial<TotalCollateral>): TotalCollateral;
};
export declare const OwnerCDPIndex: {
    encode(message: OwnerCDPIndex, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): OwnerCDPIndex;
    fromJSON(object: any): OwnerCDPIndex;
    toJSON(message: OwnerCDPIndex): unknown;
    create(base?: DeepPartial<OwnerCDPIndex>): OwnerCDPIndex;
    fromPartial(object: DeepPartial<OwnerCDPIndex>): OwnerCDPIndex;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
