import Long from "long";
import _m0 from "protobufjs/minimal";
import { ModuleAccount } from "../../../cosmos/auth/v1beta1/auth";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Deposit, TotalCollateral, TotalPrincipal } from "./cdp";
import { Params } from "./genesis";
export declare const protobufPackage = "kava.cdp.v1beta1";
/** QueryParamsRequest defines the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
/** QueryParamsResponse defines the response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
    params?: Params | undefined;
}
/** QueryAccountsRequest defines the request type for the Query/Accounts RPC method. */
export interface QueryAccountsRequest {
}
/** QueryAccountsResponse defines the response type for the Query/Accounts RPC method. */
export interface QueryAccountsResponse {
    accounts: ModuleAccount[];
}
/** QueryCdpRequest defines the request type for the Query/Cdp RPC method. */
export interface QueryCdpRequest {
    collateralType: string;
    owner: string;
}
/** QueryCdpResponse defines the response type for the Query/Cdp RPC method. */
export interface QueryCdpResponse {
    cdp?: CDPResponse | undefined;
}
/** QueryCdpsRequest is the params for a filtered CDP query, the request type for the Query/Cdps RPC method. */
export interface QueryCdpsRequest {
    collateralType: string;
    owner: string;
    id: Long;
    /** sdk.Dec as a string */
    ratio: string;
    pagination?: PageRequest | undefined;
}
/** QueryCdpsResponse defines the response type for the Query/Cdps RPC method. */
export interface QueryCdpsResponse {
    cdps: CDPResponse[];
    pagination?: PageResponse | undefined;
}
/** QueryDepositsRequest defines the request type for the Query/Deposits RPC method. */
export interface QueryDepositsRequest {
    collateralType: string;
    owner: string;
}
/** QueryDepositsResponse defines the response type for the Query/Deposits RPC method. */
export interface QueryDepositsResponse {
    deposits: Deposit[];
}
/** QueryTotalPrincipalRequest defines the request type for the Query/TotalPrincipal RPC method. */
export interface QueryTotalPrincipalRequest {
    collateralType: string;
}
/** QueryTotalPrincipalResponse defines the response type for the Query/TotalPrincipal RPC method. */
export interface QueryTotalPrincipalResponse {
    totalPrincipal: TotalPrincipal[];
}
/** QueryTotalCollateralRequest defines the request type for the Query/TotalCollateral RPC method. */
export interface QueryTotalCollateralRequest {
    collateralType: string;
}
/** QueryTotalCollateralResponse defines the response type for the Query/TotalCollateral RPC method. */
export interface QueryTotalCollateralResponse {
    totalCollateral: TotalCollateral[];
}
/** CDPResponse defines the state of a single collateralized debt position. */
export interface CDPResponse {
    id: Long;
    owner: string;
    type: string;
    collateral?: Coin | undefined;
    principal?: Coin | undefined;
    accumulatedFees?: Coin | undefined;
    feesUpdated?: Date | undefined;
    interestFactor: string;
    collateralValue?: Coin | undefined;
    collateralizationRatio: string;
}
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
};
export declare const QueryAccountsRequest: {
    encode(_: QueryAccountsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAccountsRequest;
    fromJSON(_: any): QueryAccountsRequest;
    toJSON(_: QueryAccountsRequest): unknown;
    create(base?: DeepPartial<QueryAccountsRequest>): QueryAccountsRequest;
    fromPartial(_: DeepPartial<QueryAccountsRequest>): QueryAccountsRequest;
};
export declare const QueryAccountsResponse: {
    encode(message: QueryAccountsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAccountsResponse;
    fromJSON(object: any): QueryAccountsResponse;
    toJSON(message: QueryAccountsResponse): unknown;
    create(base?: DeepPartial<QueryAccountsResponse>): QueryAccountsResponse;
    fromPartial(object: DeepPartial<QueryAccountsResponse>): QueryAccountsResponse;
};
export declare const QueryCdpRequest: {
    encode(message: QueryCdpRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCdpRequest;
    fromJSON(object: any): QueryCdpRequest;
    toJSON(message: QueryCdpRequest): unknown;
    create(base?: DeepPartial<QueryCdpRequest>): QueryCdpRequest;
    fromPartial(object: DeepPartial<QueryCdpRequest>): QueryCdpRequest;
};
export declare const QueryCdpResponse: {
    encode(message: QueryCdpResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCdpResponse;
    fromJSON(object: any): QueryCdpResponse;
    toJSON(message: QueryCdpResponse): unknown;
    create(base?: DeepPartial<QueryCdpResponse>): QueryCdpResponse;
    fromPartial(object: DeepPartial<QueryCdpResponse>): QueryCdpResponse;
};
export declare const QueryCdpsRequest: {
    encode(message: QueryCdpsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCdpsRequest;
    fromJSON(object: any): QueryCdpsRequest;
    toJSON(message: QueryCdpsRequest): unknown;
    create(base?: DeepPartial<QueryCdpsRequest>): QueryCdpsRequest;
    fromPartial(object: DeepPartial<QueryCdpsRequest>): QueryCdpsRequest;
};
export declare const QueryCdpsResponse: {
    encode(message: QueryCdpsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCdpsResponse;
    fromJSON(object: any): QueryCdpsResponse;
    toJSON(message: QueryCdpsResponse): unknown;
    create(base?: DeepPartial<QueryCdpsResponse>): QueryCdpsResponse;
    fromPartial(object: DeepPartial<QueryCdpsResponse>): QueryCdpsResponse;
};
export declare const QueryDepositsRequest: {
    encode(message: QueryDepositsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryDepositsRequest;
    fromJSON(object: any): QueryDepositsRequest;
    toJSON(message: QueryDepositsRequest): unknown;
    create(base?: DeepPartial<QueryDepositsRequest>): QueryDepositsRequest;
    fromPartial(object: DeepPartial<QueryDepositsRequest>): QueryDepositsRequest;
};
export declare const QueryDepositsResponse: {
    encode(message: QueryDepositsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryDepositsResponse;
    fromJSON(object: any): QueryDepositsResponse;
    toJSON(message: QueryDepositsResponse): unknown;
    create(base?: DeepPartial<QueryDepositsResponse>): QueryDepositsResponse;
    fromPartial(object: DeepPartial<QueryDepositsResponse>): QueryDepositsResponse;
};
export declare const QueryTotalPrincipalRequest: {
    encode(message: QueryTotalPrincipalRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalPrincipalRequest;
    fromJSON(object: any): QueryTotalPrincipalRequest;
    toJSON(message: QueryTotalPrincipalRequest): unknown;
    create(base?: DeepPartial<QueryTotalPrincipalRequest>): QueryTotalPrincipalRequest;
    fromPartial(object: DeepPartial<QueryTotalPrincipalRequest>): QueryTotalPrincipalRequest;
};
export declare const QueryTotalPrincipalResponse: {
    encode(message: QueryTotalPrincipalResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalPrincipalResponse;
    fromJSON(object: any): QueryTotalPrincipalResponse;
    toJSON(message: QueryTotalPrincipalResponse): unknown;
    create(base?: DeepPartial<QueryTotalPrincipalResponse>): QueryTotalPrincipalResponse;
    fromPartial(object: DeepPartial<QueryTotalPrincipalResponse>): QueryTotalPrincipalResponse;
};
export declare const QueryTotalCollateralRequest: {
    encode(message: QueryTotalCollateralRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalCollateralRequest;
    fromJSON(object: any): QueryTotalCollateralRequest;
    toJSON(message: QueryTotalCollateralRequest): unknown;
    create(base?: DeepPartial<QueryTotalCollateralRequest>): QueryTotalCollateralRequest;
    fromPartial(object: DeepPartial<QueryTotalCollateralRequest>): QueryTotalCollateralRequest;
};
export declare const QueryTotalCollateralResponse: {
    encode(message: QueryTotalCollateralResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalCollateralResponse;
    fromJSON(object: any): QueryTotalCollateralResponse;
    toJSON(message: QueryTotalCollateralResponse): unknown;
    create(base?: DeepPartial<QueryTotalCollateralResponse>): QueryTotalCollateralResponse;
    fromPartial(object: DeepPartial<QueryTotalCollateralResponse>): QueryTotalCollateralResponse;
};
export declare const CDPResponse: {
    encode(message: CDPResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CDPResponse;
    fromJSON(object: any): CDPResponse;
    toJSON(message: CDPResponse): unknown;
    create(base?: DeepPartial<CDPResponse>): CDPResponse;
    fromPartial(object: DeepPartial<CDPResponse>): CDPResponse;
};
/** Query defines the gRPC querier service for cdp module */
export interface Query {
    /** Params queries all parameters of the cdp module. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    /** Accounts queries the CDP module accounts. */
    Accounts(request: QueryAccountsRequest): Promise<QueryAccountsResponse>;
    /** TotalPrincipal queries the total principal of a given collateral type. */
    TotalPrincipal(request: QueryTotalPrincipalRequest): Promise<QueryTotalPrincipalResponse>;
    /** TotalCollateral queries the total collateral of a given collateral type. */
    TotalCollateral(request: QueryTotalCollateralRequest): Promise<QueryTotalCollateralResponse>;
    /** Cdps queries all active CDPs. */
    Cdps(request: QueryCdpsRequest): Promise<QueryCdpsResponse>;
    /** Cdp queries a CDP with the input owner address and collateral type. */
    Cdp(request: QueryCdpRequest): Promise<QueryCdpResponse>;
    /** Deposits queries deposits associated with the CDP owned by an address for a collateral type. */
    Deposits(request: QueryDepositsRequest): Promise<QueryDepositsResponse>;
}
export declare const QueryServiceName = "kava.cdp.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    Accounts(request: QueryAccountsRequest): Promise<QueryAccountsResponse>;
    TotalPrincipal(request: QueryTotalPrincipalRequest): Promise<QueryTotalPrincipalResponse>;
    TotalCollateral(request: QueryTotalCollateralRequest): Promise<QueryTotalCollateralResponse>;
    Cdps(request: QueryCdpsRequest): Promise<QueryCdpsResponse>;
    Cdp(request: QueryCdpRequest): Promise<QueryCdpResponse>;
    Deposits(request: QueryDepositsRequest): Promise<QueryDepositsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
