import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.cdp.v1beta1";
/** MsgCreateCDP defines a message to create a new CDP. */
export interface MsgCreateCDP {
    sender: string;
    collateral?: Coin | undefined;
    principal?: Coin | undefined;
    collateralType: string;
}
/** MsgCreateCDPResponse defines the Msg/CreateCDP response type. */
export interface MsgCreateCDPResponse {
    cdpId: Long;
}
/** MsgDeposit defines a message to deposit to a CDP. */
export interface MsgDeposit {
    depositor: string;
    owner: string;
    collateral?: Coin | undefined;
    collateralType: string;
}
/** MsgDepositResponse defines the Msg/Deposit response type. */
export interface MsgDepositResponse {
}
/** MsgWithdraw defines a message to withdraw collateral from a CDP. */
export interface MsgWithdraw {
    depositor: string;
    owner: string;
    collateral?: Coin | undefined;
    collateralType: string;
}
/** MsgWithdrawResponse defines the Msg/Withdraw response type. */
export interface MsgWithdrawResponse {
}
/** MsgDrawDebt defines a message to draw debt from a CDP. */
export interface MsgDrawDebt {
    sender: string;
    collateralType: string;
    principal?: Coin | undefined;
}
/** MsgDrawDebtResponse defines the Msg/DrawDebt response type. */
export interface MsgDrawDebtResponse {
}
/** MsgRepayDebt defines a message to repay debt from a CDP. */
export interface MsgRepayDebt {
    sender: string;
    collateralType: string;
    payment?: Coin | undefined;
}
/** MsgRepayDebtResponse defines the Msg/RepayDebt response type. */
export interface MsgRepayDebtResponse {
}
/**
 * MsgLiquidate defines a message to attempt to liquidate a CDP whos
 * collateralization ratio is under its liquidation ratio.
 */
export interface MsgLiquidate {
    keeper: string;
    borrower: string;
    collateralType: string;
}
/** MsgLiquidateResponse defines the Msg/Liquidate response type. */
export interface MsgLiquidateResponse {
}
export declare const MsgCreateCDP: {
    encode(message: MsgCreateCDP, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCreateCDP;
    fromJSON(object: any): MsgCreateCDP;
    toJSON(message: MsgCreateCDP): unknown;
    create(base?: DeepPartial<MsgCreateCDP>): MsgCreateCDP;
    fromPartial(object: DeepPartial<MsgCreateCDP>): MsgCreateCDP;
};
export declare const MsgCreateCDPResponse: {
    encode(message: MsgCreateCDPResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgCreateCDPResponse;
    fromJSON(object: any): MsgCreateCDPResponse;
    toJSON(message: MsgCreateCDPResponse): unknown;
    create(base?: DeepPartial<MsgCreateCDPResponse>): MsgCreateCDPResponse;
    fromPartial(object: DeepPartial<MsgCreateCDPResponse>): MsgCreateCDPResponse;
};
export declare const MsgDeposit: {
    encode(message: MsgDeposit, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDeposit;
    fromJSON(object: any): MsgDeposit;
    toJSON(message: MsgDeposit): unknown;
    create(base?: DeepPartial<MsgDeposit>): MsgDeposit;
    fromPartial(object: DeepPartial<MsgDeposit>): MsgDeposit;
};
export declare const MsgDepositResponse: {
    encode(_: MsgDepositResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDepositResponse;
    fromJSON(_: any): MsgDepositResponse;
    toJSON(_: MsgDepositResponse): unknown;
    create(base?: DeepPartial<MsgDepositResponse>): MsgDepositResponse;
    fromPartial(_: DeepPartial<MsgDepositResponse>): MsgDepositResponse;
};
export declare const MsgWithdraw: {
    encode(message: MsgWithdraw, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgWithdraw;
    fromJSON(object: any): MsgWithdraw;
    toJSON(message: MsgWithdraw): unknown;
    create(base?: DeepPartial<MsgWithdraw>): MsgWithdraw;
    fromPartial(object: DeepPartial<MsgWithdraw>): MsgWithdraw;
};
export declare const MsgWithdrawResponse: {
    encode(_: MsgWithdrawResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgWithdrawResponse;
    fromJSON(_: any): MsgWithdrawResponse;
    toJSON(_: MsgWithdrawResponse): unknown;
    create(base?: DeepPartial<MsgWithdrawResponse>): MsgWithdrawResponse;
    fromPartial(_: DeepPartial<MsgWithdrawResponse>): MsgWithdrawResponse;
};
export declare const MsgDrawDebt: {
    encode(message: MsgDrawDebt, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDrawDebt;
    fromJSON(object: any): MsgDrawDebt;
    toJSON(message: MsgDrawDebt): unknown;
    create(base?: DeepPartial<MsgDrawDebt>): MsgDrawDebt;
    fromPartial(object: DeepPartial<MsgDrawDebt>): MsgDrawDebt;
};
export declare const MsgDrawDebtResponse: {
    encode(_: MsgDrawDebtResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDrawDebtResponse;
    fromJSON(_: any): MsgDrawDebtResponse;
    toJSON(_: MsgDrawDebtResponse): unknown;
    create(base?: DeepPartial<MsgDrawDebtResponse>): MsgDrawDebtResponse;
    fromPartial(_: DeepPartial<MsgDrawDebtResponse>): MsgDrawDebtResponse;
};
export declare const MsgRepayDebt: {
    encode(message: MsgRepayDebt, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRepayDebt;
    fromJSON(object: any): MsgRepayDebt;
    toJSON(message: MsgRepayDebt): unknown;
    create(base?: DeepPartial<MsgRepayDebt>): MsgRepayDebt;
    fromPartial(object: DeepPartial<MsgRepayDebt>): MsgRepayDebt;
};
export declare const MsgRepayDebtResponse: {
    encode(_: MsgRepayDebtResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRepayDebtResponse;
    fromJSON(_: any): MsgRepayDebtResponse;
    toJSON(_: MsgRepayDebtResponse): unknown;
    create(base?: DeepPartial<MsgRepayDebtResponse>): MsgRepayDebtResponse;
    fromPartial(_: DeepPartial<MsgRepayDebtResponse>): MsgRepayDebtResponse;
};
export declare const MsgLiquidate: {
    encode(message: MsgLiquidate, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgLiquidate;
    fromJSON(object: any): MsgLiquidate;
    toJSON(message: MsgLiquidate): unknown;
    create(base?: DeepPartial<MsgLiquidate>): MsgLiquidate;
    fromPartial(object: DeepPartial<MsgLiquidate>): MsgLiquidate;
};
export declare const MsgLiquidateResponse: {
    encode(_: MsgLiquidateResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgLiquidateResponse;
    fromJSON(_: any): MsgLiquidateResponse;
    toJSON(_: MsgLiquidateResponse): unknown;
    create(base?: DeepPartial<MsgLiquidateResponse>): MsgLiquidateResponse;
    fromPartial(_: DeepPartial<MsgLiquidateResponse>): MsgLiquidateResponse;
};
/** Msg defines the cdp Msg service. */
export interface Msg {
    /** CreateCDP defines a method to create a new CDP. */
    CreateCDP(request: MsgCreateCDP): Promise<MsgCreateCDPResponse>;
    /** Deposit defines a method to deposit to a CDP. */
    Deposit(request: MsgDeposit): Promise<MsgDepositResponse>;
    /** Withdraw defines a method to withdraw collateral from a CDP. */
    Withdraw(request: MsgWithdraw): Promise<MsgWithdrawResponse>;
    /** DrawDebt defines a method to draw debt from a CDP. */
    DrawDebt(request: MsgDrawDebt): Promise<MsgDrawDebtResponse>;
    /** RepayDebt defines a method to repay debt from a CDP. */
    RepayDebt(request: MsgRepayDebt): Promise<MsgRepayDebtResponse>;
    /**
     * Liquidate defines a method to attempt to liquidate a CDP whos
     * collateralization ratio is under its liquidation ratio.
     */
    Liquidate(request: MsgLiquidate): Promise<MsgLiquidateResponse>;
}
export declare const MsgServiceName = "kava.cdp.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    CreateCDP(request: MsgCreateCDP): Promise<MsgCreateCDPResponse>;
    Deposit(request: MsgDeposit): Promise<MsgDepositResponse>;
    Withdraw(request: MsgWithdraw): Promise<MsgWithdrawResponse>;
    DrawDebt(request: MsgDrawDebt): Promise<MsgDrawDebtResponse>;
    RepayDebt(request: MsgRepayDebt): Promise<MsgRepayDebtResponse>;
    Liquidate(request: MsgLiquidate): Promise<MsgLiquidateResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
