import Long from "long";
import _m0 from "protobufjs/minimal";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Any } from "../../../google/protobuf/any";
import { VoteType } from "./genesis";
export declare const protobufPackage = "kava.committee.v1beta1";
/** QueryCommitteesRequest defines the request type for querying x/committee committees. */
export interface QueryCommitteesRequest {
}
/** QueryCommitteesResponse defines the response type for querying x/committee committees. */
export interface QueryCommitteesResponse {
    committees: Any[];
}
/** QueryCommitteeRequest defines the request type for querying x/committee committee. */
export interface QueryCommitteeRequest {
    committeeId: Long;
}
/** QueryCommitteeResponse defines the response type for querying x/committee committee. */
export interface QueryCommitteeResponse {
    committee?: Any | undefined;
}
/** QueryProposalsRequest defines the request type for querying x/committee proposals. */
export interface QueryProposalsRequest {
    committeeId: Long;
}
/** QueryProposalsResponse defines the response type for querying x/committee proposals. */
export interface QueryProposalsResponse {
    proposals: QueryProposalResponse[];
}
/** QueryProposalRequest defines the request type for querying x/committee proposal. */
export interface QueryProposalRequest {
    proposalId: Long;
}
/** QueryProposalResponse defines the response type for querying x/committee proposal. */
export interface QueryProposalResponse {
    pubProposal?: Any | undefined;
    id: Long;
    committeeId: Long;
    deadline?: Date | undefined;
}
/** QueryNextProposalIDRequest defines the request type for querying x/committee NextProposalID. */
export interface QueryNextProposalIDRequest {
}
/** QueryNextProposalIDRequest defines the response type for querying x/committee NextProposalID. */
export interface QueryNextProposalIDResponse {
    nextProposalId: Long;
}
/** QueryVotesRequest defines the request type for querying x/committee votes. */
export interface QueryVotesRequest {
    proposalId: Long;
    pagination?: PageRequest | undefined;
}
/** QueryVotesResponse defines the response type for querying x/committee votes. */
export interface QueryVotesResponse {
    /** votes defined the queried votes. */
    votes: QueryVoteResponse[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse | undefined;
}
/** QueryVoteRequest defines the request type for querying x/committee vote. */
export interface QueryVoteRequest {
    proposalId: Long;
    voter: string;
}
/** QueryVoteResponse defines the response type for querying x/committee vote. */
export interface QueryVoteResponse {
    proposalId: Long;
    voter: string;
    voteType: VoteType;
}
/** QueryTallyRequest defines the request type for querying x/committee tally. */
export interface QueryTallyRequest {
    proposalId: Long;
}
/** QueryTallyResponse defines the response type for querying x/committee tally. */
export interface QueryTallyResponse {
    proposalId: Long;
    yesVotes: string;
    noVotes: string;
    currentVotes: string;
    possibleVotes: string;
    voteThreshold: string;
    quorum: string;
}
/** QueryRawParamsRequest defines the request type for querying x/committee raw params. */
export interface QueryRawParamsRequest {
    subspace: string;
    key: string;
}
/** QueryRawParamsResponse defines the response type for querying x/committee raw params. */
export interface QueryRawParamsResponse {
    rawData: string;
}
export declare const QueryCommitteesRequest: {
    encode(_: QueryCommitteesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCommitteesRequest;
    fromJSON(_: any): QueryCommitteesRequest;
    toJSON(_: QueryCommitteesRequest): unknown;
    create(base?: DeepPartial<QueryCommitteesRequest>): QueryCommitteesRequest;
    fromPartial(_: DeepPartial<QueryCommitteesRequest>): QueryCommitteesRequest;
};
export declare const QueryCommitteesResponse: {
    encode(message: QueryCommitteesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCommitteesResponse;
    fromJSON(object: any): QueryCommitteesResponse;
    toJSON(message: QueryCommitteesResponse): unknown;
    create(base?: DeepPartial<QueryCommitteesResponse>): QueryCommitteesResponse;
    fromPartial(object: DeepPartial<QueryCommitteesResponse>): QueryCommitteesResponse;
};
export declare const QueryCommitteeRequest: {
    encode(message: QueryCommitteeRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCommitteeRequest;
    fromJSON(object: any): QueryCommitteeRequest;
    toJSON(message: QueryCommitteeRequest): unknown;
    create(base?: DeepPartial<QueryCommitteeRequest>): QueryCommitteeRequest;
    fromPartial(object: DeepPartial<QueryCommitteeRequest>): QueryCommitteeRequest;
};
export declare const QueryCommitteeResponse: {
    encode(message: QueryCommitteeResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryCommitteeResponse;
    fromJSON(object: any): QueryCommitteeResponse;
    toJSON(message: QueryCommitteeResponse): unknown;
    create(base?: DeepPartial<QueryCommitteeResponse>): QueryCommitteeResponse;
    fromPartial(object: DeepPartial<QueryCommitteeResponse>): QueryCommitteeResponse;
};
export declare const QueryProposalsRequest: {
    encode(message: QueryProposalsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryProposalsRequest;
    fromJSON(object: any): QueryProposalsRequest;
    toJSON(message: QueryProposalsRequest): unknown;
    create(base?: DeepPartial<QueryProposalsRequest>): QueryProposalsRequest;
    fromPartial(object: DeepPartial<QueryProposalsRequest>): QueryProposalsRequest;
};
export declare const QueryProposalsResponse: {
    encode(message: QueryProposalsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryProposalsResponse;
    fromJSON(object: any): QueryProposalsResponse;
    toJSON(message: QueryProposalsResponse): unknown;
    create(base?: DeepPartial<QueryProposalsResponse>): QueryProposalsResponse;
    fromPartial(object: DeepPartial<QueryProposalsResponse>): QueryProposalsResponse;
};
export declare const QueryProposalRequest: {
    encode(message: QueryProposalRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryProposalRequest;
    fromJSON(object: any): QueryProposalRequest;
    toJSON(message: QueryProposalRequest): unknown;
    create(base?: DeepPartial<QueryProposalRequest>): QueryProposalRequest;
    fromPartial(object: DeepPartial<QueryProposalRequest>): QueryProposalRequest;
};
export declare const QueryProposalResponse: {
    encode(message: QueryProposalResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryProposalResponse;
    fromJSON(object: any): QueryProposalResponse;
    toJSON(message: QueryProposalResponse): unknown;
    create(base?: DeepPartial<QueryProposalResponse>): QueryProposalResponse;
    fromPartial(object: DeepPartial<QueryProposalResponse>): QueryProposalResponse;
};
export declare const QueryNextProposalIDRequest: {
    encode(_: QueryNextProposalIDRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryNextProposalIDRequest;
    fromJSON(_: any): QueryNextProposalIDRequest;
    toJSON(_: QueryNextProposalIDRequest): unknown;
    create(base?: DeepPartial<QueryNextProposalIDRequest>): QueryNextProposalIDRequest;
    fromPartial(_: DeepPartial<QueryNextProposalIDRequest>): QueryNextProposalIDRequest;
};
export declare const QueryNextProposalIDResponse: {
    encode(message: QueryNextProposalIDResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryNextProposalIDResponse;
    fromJSON(object: any): QueryNextProposalIDResponse;
    toJSON(message: QueryNextProposalIDResponse): unknown;
    create(base?: DeepPartial<QueryNextProposalIDResponse>): QueryNextProposalIDResponse;
    fromPartial(object: DeepPartial<QueryNextProposalIDResponse>): QueryNextProposalIDResponse;
};
export declare const QueryVotesRequest: {
    encode(message: QueryVotesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryVotesRequest;
    fromJSON(object: any): QueryVotesRequest;
    toJSON(message: QueryVotesRequest): unknown;
    create(base?: DeepPartial<QueryVotesRequest>): QueryVotesRequest;
    fromPartial(object: DeepPartial<QueryVotesRequest>): QueryVotesRequest;
};
export declare const QueryVotesResponse: {
    encode(message: QueryVotesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryVotesResponse;
    fromJSON(object: any): QueryVotesResponse;
    toJSON(message: QueryVotesResponse): unknown;
    create(base?: DeepPartial<QueryVotesResponse>): QueryVotesResponse;
    fromPartial(object: DeepPartial<QueryVotesResponse>): QueryVotesResponse;
};
export declare const QueryVoteRequest: {
    encode(message: QueryVoteRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryVoteRequest;
    fromJSON(object: any): QueryVoteRequest;
    toJSON(message: QueryVoteRequest): unknown;
    create(base?: DeepPartial<QueryVoteRequest>): QueryVoteRequest;
    fromPartial(object: DeepPartial<QueryVoteRequest>): QueryVoteRequest;
};
export declare const QueryVoteResponse: {
    encode(message: QueryVoteResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryVoteResponse;
    fromJSON(object: any): QueryVoteResponse;
    toJSON(message: QueryVoteResponse): unknown;
    create(base?: DeepPartial<QueryVoteResponse>): QueryVoteResponse;
    fromPartial(object: DeepPartial<QueryVoteResponse>): QueryVoteResponse;
};
export declare const QueryTallyRequest: {
    encode(message: QueryTallyRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTallyRequest;
    fromJSON(object: any): QueryTallyRequest;
    toJSON(message: QueryTallyRequest): unknown;
    create(base?: DeepPartial<QueryTallyRequest>): QueryTallyRequest;
    fromPartial(object: DeepPartial<QueryTallyRequest>): QueryTallyRequest;
};
export declare const QueryTallyResponse: {
    encode(message: QueryTallyResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTallyResponse;
    fromJSON(object: any): QueryTallyResponse;
    toJSON(message: QueryTallyResponse): unknown;
    create(base?: DeepPartial<QueryTallyResponse>): QueryTallyResponse;
    fromPartial(object: DeepPartial<QueryTallyResponse>): QueryTallyResponse;
};
export declare const QueryRawParamsRequest: {
    encode(message: QueryRawParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRawParamsRequest;
    fromJSON(object: any): QueryRawParamsRequest;
    toJSON(message: QueryRawParamsRequest): unknown;
    create(base?: DeepPartial<QueryRawParamsRequest>): QueryRawParamsRequest;
    fromPartial(object: DeepPartial<QueryRawParamsRequest>): QueryRawParamsRequest;
};
export declare const QueryRawParamsResponse: {
    encode(message: QueryRawParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRawParamsResponse;
    fromJSON(object: any): QueryRawParamsResponse;
    toJSON(message: QueryRawParamsResponse): unknown;
    create(base?: DeepPartial<QueryRawParamsResponse>): QueryRawParamsResponse;
    fromPartial(object: DeepPartial<QueryRawParamsResponse>): QueryRawParamsResponse;
};
/** Query defines the gRPC querier service for committee module */
export interface Query {
    /** Committees queries all committess of the committee module. */
    Committees(request: QueryCommitteesRequest): Promise<QueryCommitteesResponse>;
    /** Committee queries a committee based on committee ID. */
    Committee(request: QueryCommitteeRequest): Promise<QueryCommitteeResponse>;
    /** Proposals queries proposals based on committee ID. */
    Proposals(request: QueryProposalsRequest): Promise<QueryProposalsResponse>;
    /** Deposits queries a proposal based on proposal ID. */
    Proposal(request: QueryProposalRequest): Promise<QueryProposalResponse>;
    /** NextProposalID queries the next proposal ID of the committee module. */
    NextProposalID(request: QueryNextProposalIDRequest): Promise<QueryNextProposalIDResponse>;
    /** Votes queries all votes for a single proposal ID. */
    Votes(request: QueryVotesRequest): Promise<QueryVotesResponse>;
    /** Vote queries the vote of a single voter for a single proposal ID. */
    Vote(request: QueryVoteRequest): Promise<QueryVoteResponse>;
    /** Tally queries the tally of a single proposal ID. */
    Tally(request: QueryTallyRequest): Promise<QueryTallyResponse>;
    /** RawParams queries the raw params data of any subspace and key. */
    RawParams(request: QueryRawParamsRequest): Promise<QueryRawParamsResponse>;
}
export declare const QueryServiceName = "kava.committee.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Committees(request: QueryCommitteesRequest): Promise<QueryCommitteesResponse>;
    Committee(request: QueryCommitteeRequest): Promise<QueryCommitteeResponse>;
    Proposals(request: QueryProposalsRequest): Promise<QueryProposalsResponse>;
    Proposal(request: QueryProposalRequest): Promise<QueryProposalResponse>;
    NextProposalID(request: QueryNextProposalIDRequest): Promise<QueryNextProposalIDResponse>;
    Votes(request: QueryVotesRequest): Promise<QueryVotesResponse>;
    Vote(request: QueryVoteRequest): Promise<QueryVoteResponse>;
    Tally(request: QueryTallyRequest): Promise<QueryTallyResponse>;
    RawParams(request: QueryRawParamsRequest): Promise<QueryRawParamsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
