import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.community.v1beta1";
/** CommunityPoolLendDepositProposal deposits from the community pool into lend */
export interface CommunityPoolLendDepositProposal {
    title: string;
    description: string;
    amount: Coin[];
}
/** CommunityPoolLendWithdrawProposal withdraws a lend position back to the community pool */
export interface CommunityPoolLendWithdrawProposal {
    title: string;
    description: string;
    amount: Coin[];
}
/**
 * CommunityCDPRepayDebtProposal repays a cdp debt position owned by the community module
 * This proposal exists primarily to allow committees to repay community module cdp debts.
 */
export interface CommunityCDPRepayDebtProposal {
    title: string;
    description: string;
    collateralType: string;
    payment?: Coin | undefined;
}
/**
 * CommunityCDPWithdrawCollateralProposal withdraws cdp collateral owned by the community module
 * This proposal exists primarily to allow committees to withdraw community module cdp collateral.
 */
export interface CommunityCDPWithdrawCollateralProposal {
    title: string;
    description: string;
    collateralType: string;
    collateral?: Coin | undefined;
}
export declare const CommunityPoolLendDepositProposal: {
    encode(message: CommunityPoolLendDepositProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolLendDepositProposal;
    fromJSON(object: any): CommunityPoolLendDepositProposal;
    toJSON(message: CommunityPoolLendDepositProposal): unknown;
    create(base?: DeepPartial<CommunityPoolLendDepositProposal>): CommunityPoolLendDepositProposal;
    fromPartial(object: DeepPartial<CommunityPoolLendDepositProposal>): CommunityPoolLendDepositProposal;
};
export declare const CommunityPoolLendWithdrawProposal: {
    encode(message: CommunityPoolLendWithdrawProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolLendWithdrawProposal;
    fromJSON(object: any): CommunityPoolLendWithdrawProposal;
    toJSON(message: CommunityPoolLendWithdrawProposal): unknown;
    create(base?: DeepPartial<CommunityPoolLendWithdrawProposal>): CommunityPoolLendWithdrawProposal;
    fromPartial(object: DeepPartial<CommunityPoolLendWithdrawProposal>): CommunityPoolLendWithdrawProposal;
};
export declare const CommunityCDPRepayDebtProposal: {
    encode(message: CommunityCDPRepayDebtProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityCDPRepayDebtProposal;
    fromJSON(object: any): CommunityCDPRepayDebtProposal;
    toJSON(message: CommunityCDPRepayDebtProposal): unknown;
    create(base?: DeepPartial<CommunityCDPRepayDebtProposal>): CommunityCDPRepayDebtProposal;
    fromPartial(object: DeepPartial<CommunityCDPRepayDebtProposal>): CommunityCDPRepayDebtProposal;
};
export declare const CommunityCDPWithdrawCollateralProposal: {
    encode(message: CommunityCDPWithdrawCollateralProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityCDPWithdrawCollateralProposal;
    fromJSON(object: any): CommunityCDPWithdrawCollateralProposal;
    toJSON(message: CommunityCDPWithdrawCollateralProposal): unknown;
    create(base?: DeepPartial<CommunityCDPWithdrawCollateralProposal>): CommunityCDPWithdrawCollateralProposal;
    fromPartial(object: DeepPartial<CommunityCDPWithdrawCollateralProposal>): CommunityCDPWithdrawCollateralProposal;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
