import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin, DecCoin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.community.v1beta1";
/** QueryBalanceRequest defines the request type for querying x/community balance. */
export interface QueryBalanceRequest {
}
/** QueryBalanceResponse defines the response type for querying x/community balance. */
export interface QueryBalanceResponse {
    coins: Coin[];
}
/** QueryTotalBalanceRequest defines the request type for querying total community pool balance. */
export interface QueryTotalBalanceRequest {
}
/**
 * QueryTotalBalanceResponse defines the response type for querying total
 * community pool balance. This matches the x/distribution CommunityPool query response.
 */
export interface QueryTotalBalanceResponse {
    /** pool defines community pool's coins. */
    pool: DecCoin[];
}
/** QueryAnnualizedRewardsRequest defines the request type for querying the annualized rewards. */
export interface QueryAnnualizedRewardsRequest {
}
/** QueryAnnualizedRewardsResponse defines the response type for querying the annualized rewards. */
export interface QueryAnnualizedRewardsResponse {
    /** staking_rewards is the calculated annualized staking rewards percentage rate */
    stakingRewards: string;
}
export declare const QueryBalanceRequest: {
    encode(_: QueryBalanceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryBalanceRequest;
    fromJSON(_: any): QueryBalanceRequest;
    toJSON(_: QueryBalanceRequest): unknown;
    create(base?: DeepPartial<QueryBalanceRequest>): QueryBalanceRequest;
    fromPartial(_: DeepPartial<QueryBalanceRequest>): QueryBalanceRequest;
};
export declare const QueryBalanceResponse: {
    encode(message: QueryBalanceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryBalanceResponse;
    fromJSON(object: any): QueryBalanceResponse;
    toJSON(message: QueryBalanceResponse): unknown;
    create(base?: DeepPartial<QueryBalanceResponse>): QueryBalanceResponse;
    fromPartial(object: DeepPartial<QueryBalanceResponse>): QueryBalanceResponse;
};
export declare const QueryTotalBalanceRequest: {
    encode(_: QueryTotalBalanceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalBalanceRequest;
    fromJSON(_: any): QueryTotalBalanceRequest;
    toJSON(_: QueryTotalBalanceRequest): unknown;
    create(base?: DeepPartial<QueryTotalBalanceRequest>): QueryTotalBalanceRequest;
    fromPartial(_: DeepPartial<QueryTotalBalanceRequest>): QueryTotalBalanceRequest;
};
export declare const QueryTotalBalanceResponse: {
    encode(message: QueryTotalBalanceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalBalanceResponse;
    fromJSON(object: any): QueryTotalBalanceResponse;
    toJSON(message: QueryTotalBalanceResponse): unknown;
    create(base?: DeepPartial<QueryTotalBalanceResponse>): QueryTotalBalanceResponse;
    fromPartial(object: DeepPartial<QueryTotalBalanceResponse>): QueryTotalBalanceResponse;
};
export declare const QueryAnnualizedRewardsRequest: {
    encode(_: QueryAnnualizedRewardsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAnnualizedRewardsRequest;
    fromJSON(_: any): QueryAnnualizedRewardsRequest;
    toJSON(_: QueryAnnualizedRewardsRequest): unknown;
    create(base?: DeepPartial<QueryAnnualizedRewardsRequest>): QueryAnnualizedRewardsRequest;
    fromPartial(_: DeepPartial<QueryAnnualizedRewardsRequest>): QueryAnnualizedRewardsRequest;
};
export declare const QueryAnnualizedRewardsResponse: {
    encode(message: QueryAnnualizedRewardsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryAnnualizedRewardsResponse;
    fromJSON(object: any): QueryAnnualizedRewardsResponse;
    toJSON(message: QueryAnnualizedRewardsResponse): unknown;
    create(base?: DeepPartial<QueryAnnualizedRewardsResponse>): QueryAnnualizedRewardsResponse;
    fromPartial(object: DeepPartial<QueryAnnualizedRewardsResponse>): QueryAnnualizedRewardsResponse;
};
/** Query defines the gRPC querier service for x/community. */
export interface Query {
    /** Balance queries the balance of all coins of x/community module. */
    Balance(request: QueryBalanceRequest): Promise<QueryBalanceResponse>;
    /**
     * TotalBalance queries the balance of all coins, including x/distribution,
     * x/community, and supplied balances.
     */
    TotalBalance(request: QueryTotalBalanceRequest): Promise<QueryTotalBalanceResponse>;
    /**
     * AnnualizedRewards calculates and returns the current annualized reward percentages,
     * like staking rewards, for the chain.
     */
    AnnualizedRewards(request: QueryAnnualizedRewardsRequest): Promise<QueryAnnualizedRewardsResponse>;
}
export declare const QueryServiceName = "kava.community.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Balance(request: QueryBalanceRequest): Promise<QueryBalanceResponse>;
    TotalBalance(request: QueryTotalBalanceRequest): Promise<QueryTotalBalanceResponse>;
    AnnualizedRewards(request: QueryAnnualizedRewardsRequest): Promise<QueryAnnualizedRewardsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
