import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.earn.v1beta1";
/** CommunityPoolDepositProposal deposits from the community pool into an earn vault */
export interface CommunityPoolDepositProposal {
    title: string;
    description: string;
    amount?: Coin | undefined;
}
/** CommunityPoolDepositProposalJSON defines a CommunityPoolDepositProposal with a deposit */
export interface CommunityPoolDepositProposalJSON {
    title: string;
    description: string;
    amount?: Coin | undefined;
    deposit: Coin[];
}
/** CommunityPoolWithdrawProposal withdraws from an earn vault back to community pool */
export interface CommunityPoolWithdrawProposal {
    title: string;
    description: string;
    amount?: Coin | undefined;
}
/** CommunityPoolWithdrawProposalJSON defines a CommunityPoolWithdrawProposal with a deposit */
export interface CommunityPoolWithdrawProposalJSON {
    title: string;
    description: string;
    amount?: Coin | undefined;
    deposit: Coin[];
}
export declare const CommunityPoolDepositProposal: {
    encode(message: CommunityPoolDepositProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolDepositProposal;
    fromJSON(object: any): CommunityPoolDepositProposal;
    toJSON(message: CommunityPoolDepositProposal): unknown;
    create(base?: DeepPartial<CommunityPoolDepositProposal>): CommunityPoolDepositProposal;
    fromPartial(object: DeepPartial<CommunityPoolDepositProposal>): CommunityPoolDepositProposal;
};
export declare const CommunityPoolDepositProposalJSON: {
    encode(message: CommunityPoolDepositProposalJSON, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolDepositProposalJSON;
    fromJSON(object: any): CommunityPoolDepositProposalJSON;
    toJSON(message: CommunityPoolDepositProposalJSON): unknown;
    create(base?: DeepPartial<CommunityPoolDepositProposalJSON>): CommunityPoolDepositProposalJSON;
    fromPartial(object: DeepPartial<CommunityPoolDepositProposalJSON>): CommunityPoolDepositProposalJSON;
};
export declare const CommunityPoolWithdrawProposal: {
    encode(message: CommunityPoolWithdrawProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolWithdrawProposal;
    fromJSON(object: any): CommunityPoolWithdrawProposal;
    toJSON(message: CommunityPoolWithdrawProposal): unknown;
    create(base?: DeepPartial<CommunityPoolWithdrawProposal>): CommunityPoolWithdrawProposal;
    fromPartial(object: DeepPartial<CommunityPoolWithdrawProposal>): CommunityPoolWithdrawProposal;
};
export declare const CommunityPoolWithdrawProposalJSON: {
    encode(message: CommunityPoolWithdrawProposalJSON, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolWithdrawProposalJSON;
    fromJSON(object: any): CommunityPoolWithdrawProposalJSON;
    toJSON(message: CommunityPoolWithdrawProposalJSON): unknown;
    create(base?: DeepPartial<CommunityPoolWithdrawProposalJSON>): CommunityPoolWithdrawProposalJSON;
    fromPartial(object: DeepPartial<CommunityPoolWithdrawProposalJSON>): CommunityPoolWithdrawProposalJSON;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
