import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "kava.evmutil.v1beta1";
/**
 * ConversionPair defines a Kava ERC20 address and corresponding denom that is
 * allowed to be converted between ERC20 and sdk.Coin
 */
export interface ConversionPair {
    /** ERC20 address of the token on the Kava EVM */
    kavaErc20Address: Uint8Array;
    /** Denom of the corresponding sdk.Coin */
    denom: string;
}
/**
 * AllowedCosmosCoinERC20Token defines allowed cosmos-sdk denom & metadata
 * for evm token representations of sdk assets.
 * NOTE: once evm token contracts are deployed, changes to metadata for a given
 * cosmos_denom will not change metadata of deployed contract.
 */
export interface AllowedCosmosCoinERC20Token {
    /** Denom of the sdk.Coin */
    cosmosDenom: string;
    /** Name of ERC20 contract */
    name: string;
    /** Symbol of ERC20 contract */
    symbol: string;
    /** Number of decimals ERC20 contract is deployed with. */
    decimals: number;
}
export declare const ConversionPair: {
    encode(message: ConversionPair, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ConversionPair;
    fromJSON(object: any): ConversionPair;
    toJSON(message: ConversionPair): unknown;
    create(base?: DeepPartial<ConversionPair>): ConversionPair;
    fromPartial(object: DeepPartial<ConversionPair>): ConversionPair;
};
export declare const AllowedCosmosCoinERC20Token: {
    encode(message: AllowedCosmosCoinERC20Token, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AllowedCosmosCoinERC20Token;
    fromJSON(object: any): AllowedCosmosCoinERC20Token;
    toJSON(message: AllowedCosmosCoinERC20Token): unknown;
    create(base?: DeepPartial<AllowedCosmosCoinERC20Token>): AllowedCosmosCoinERC20Token;
    fromPartial(object: DeepPartial<AllowedCosmosCoinERC20Token>): AllowedCosmosCoinERC20Token;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
