import Long from "long";
import _m0 from "protobufjs/minimal";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Params } from "./genesis";
export declare const protobufPackage = "kava.evmutil.v1beta1";
/** QueryParamsRequest defines the request type for querying x/evmutil parameters. */
export interface QueryParamsRequest {
}
/** QueryParamsResponse defines the response type for querying x/evmutil parameters. */
export interface QueryParamsResponse {
    params?: Params | undefined;
}
/** QueryDeployedCosmosCoinContractsRequest defines the request type for Query/DeployedCosmosCoinContracts method. */
export interface QueryDeployedCosmosCoinContractsRequest {
    /**
     * optional query param to only return specific denoms in the list
     * denoms that do not have deployed contracts will be omitted from the result
     * must request fewer than 100 denoms at a time.
     */
    cosmosDenoms: string[];
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest | undefined;
}
/** QueryDeployedCosmosCoinContractsResponse defines the response type for the Query/DeployedCosmosCoinContracts method. */
export interface QueryDeployedCosmosCoinContractsResponse {
    /** deployed_cosmos_coin_contracts is a list of cosmos-sdk coin denom and its deployed contract address */
    deployedCosmosCoinContracts: DeployedCosmosCoinContract[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse | undefined;
}
/** DeployedCosmosCoinContract defines a deployed token contract to the evm representing a native cosmos-sdk coin */
export interface DeployedCosmosCoinContract {
    cosmosDenom: string;
    address: string;
}
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
};
export declare const QueryDeployedCosmosCoinContractsRequest: {
    encode(message: QueryDeployedCosmosCoinContractsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryDeployedCosmosCoinContractsRequest;
    fromJSON(object: any): QueryDeployedCosmosCoinContractsRequest;
    toJSON(message: QueryDeployedCosmosCoinContractsRequest): unknown;
    create(base?: DeepPartial<QueryDeployedCosmosCoinContractsRequest>): QueryDeployedCosmosCoinContractsRequest;
    fromPartial(object: DeepPartial<QueryDeployedCosmosCoinContractsRequest>): QueryDeployedCosmosCoinContractsRequest;
};
export declare const QueryDeployedCosmosCoinContractsResponse: {
    encode(message: QueryDeployedCosmosCoinContractsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryDeployedCosmosCoinContractsResponse;
    fromJSON(object: any): QueryDeployedCosmosCoinContractsResponse;
    toJSON(message: QueryDeployedCosmosCoinContractsResponse): unknown;
    create(base?: DeepPartial<QueryDeployedCosmosCoinContractsResponse>): QueryDeployedCosmosCoinContractsResponse;
    fromPartial(object: DeepPartial<QueryDeployedCosmosCoinContractsResponse>): QueryDeployedCosmosCoinContractsResponse;
};
export declare const DeployedCosmosCoinContract: {
    encode(message: DeployedCosmosCoinContract, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): DeployedCosmosCoinContract;
    fromJSON(object: any): DeployedCosmosCoinContract;
    toJSON(message: DeployedCosmosCoinContract): unknown;
    create(base?: DeepPartial<DeployedCosmosCoinContract>): DeployedCosmosCoinContract;
    fromPartial(object: DeepPartial<DeployedCosmosCoinContract>): DeployedCosmosCoinContract;
};
/** Query defines the gRPC querier service for evmutil module */
export interface Query {
    /** Params queries all parameters of the evmutil module. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    /** DeployedCosmosCoinContracts queries a list cosmos coin denom and their deployed erc20 address */
    DeployedCosmosCoinContracts(request: QueryDeployedCosmosCoinContractsRequest): Promise<QueryDeployedCosmosCoinContractsResponse>;
}
export declare const QueryServiceName = "kava.evmutil.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    DeployedCosmosCoinContracts(request: QueryDeployedCosmosCoinContractsRequest): Promise<QueryDeployedCosmosCoinContractsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
