import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.evmutil.v1beta1";
/** MsgConvertCoinToERC20 defines a conversion from sdk.Coin to Kava ERC20 for EVM-native assets. */
export interface MsgConvertCoinToERC20 {
    /** Kava bech32 address initiating the conversion. */
    initiator: string;
    /** EVM 0x hex address that will receive the converted Kava ERC20 tokens. */
    receiver: string;
    /** Amount is the sdk.Coin amount to convert. */
    amount?: Coin | undefined;
}
/** MsgConvertCoinToERC20Response defines the response value from Msg/ConvertCoinToERC20. */
export interface MsgConvertCoinToERC20Response {
}
/** MsgConvertERC20ToCoin defines a conversion from Kava ERC20 to sdk.Coin for EVM-native assets. */
export interface MsgConvertERC20ToCoin {
    /** EVM 0x hex address initiating the conversion. */
    initiator: string;
    /** Kava bech32 address that will receive the converted sdk.Coin. */
    receiver: string;
    /** EVM 0x hex address of the ERC20 contract. */
    kavaErc20Address: string;
    /** ERC20 token amount to convert. */
    amount: string;
}
/**
 * MsgConvertERC20ToCoinResponse defines the response value from
 * Msg/MsgConvertERC20ToCoin.
 */
export interface MsgConvertERC20ToCoinResponse {
}
/** MsgConvertCosmosCoinToERC20 defines a conversion from cosmos sdk.Coin to ERC20 for cosmos-native assets. */
export interface MsgConvertCosmosCoinToERC20 {
    /** Kava bech32 address initiating the conversion. */
    initiator: string;
    /** EVM hex address that will receive the ERC20 tokens. */
    receiver: string;
    /** Amount is the sdk.Coin amount to convert. */
    amount?: Coin | undefined;
}
/** MsgConvertCosmosCoinToERC20Response defines the response value from Msg/MsgConvertCosmosCoinToERC20. */
export interface MsgConvertCosmosCoinToERC20Response {
}
/** MsgConvertCosmosCoinFromERC20 defines a conversion from ERC20 to cosmos coins for cosmos-native assets. */
export interface MsgConvertCosmosCoinFromERC20 {
    /** EVM hex address initiating the conversion. */
    initiator: string;
    /** Kava bech32 address that will receive the cosmos coins. */
    receiver: string;
    /** Amount is the amount to convert, expressed as a Cosmos coin. */
    amount?: Coin | undefined;
}
/** MsgConvertCosmosCoinFromERC20Response defines the response value from Msg/MsgConvertCosmosCoinFromERC20. */
export interface MsgConvertCosmosCoinFromERC20Response {
}
export declare const MsgConvertCoinToERC20: {
    encode(message: MsgConvertCoinToERC20, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCoinToERC20;
    fromJSON(object: any): MsgConvertCoinToERC20;
    toJSON(message: MsgConvertCoinToERC20): unknown;
    create(base?: DeepPartial<MsgConvertCoinToERC20>): MsgConvertCoinToERC20;
    fromPartial(object: DeepPartial<MsgConvertCoinToERC20>): MsgConvertCoinToERC20;
};
export declare const MsgConvertCoinToERC20Response: {
    encode(_: MsgConvertCoinToERC20Response, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCoinToERC20Response;
    fromJSON(_: any): MsgConvertCoinToERC20Response;
    toJSON(_: MsgConvertCoinToERC20Response): unknown;
    create(base?: DeepPartial<MsgConvertCoinToERC20Response>): MsgConvertCoinToERC20Response;
    fromPartial(_: DeepPartial<MsgConvertCoinToERC20Response>): MsgConvertCoinToERC20Response;
};
export declare const MsgConvertERC20ToCoin: {
    encode(message: MsgConvertERC20ToCoin, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertERC20ToCoin;
    fromJSON(object: any): MsgConvertERC20ToCoin;
    toJSON(message: MsgConvertERC20ToCoin): unknown;
    create(base?: DeepPartial<MsgConvertERC20ToCoin>): MsgConvertERC20ToCoin;
    fromPartial(object: DeepPartial<MsgConvertERC20ToCoin>): MsgConvertERC20ToCoin;
};
export declare const MsgConvertERC20ToCoinResponse: {
    encode(_: MsgConvertERC20ToCoinResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertERC20ToCoinResponse;
    fromJSON(_: any): MsgConvertERC20ToCoinResponse;
    toJSON(_: MsgConvertERC20ToCoinResponse): unknown;
    create(base?: DeepPartial<MsgConvertERC20ToCoinResponse>): MsgConvertERC20ToCoinResponse;
    fromPartial(_: DeepPartial<MsgConvertERC20ToCoinResponse>): MsgConvertERC20ToCoinResponse;
};
export declare const MsgConvertCosmosCoinToERC20: {
    encode(message: MsgConvertCosmosCoinToERC20, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinToERC20;
    fromJSON(object: any): MsgConvertCosmosCoinToERC20;
    toJSON(message: MsgConvertCosmosCoinToERC20): unknown;
    create(base?: DeepPartial<MsgConvertCosmosCoinToERC20>): MsgConvertCosmosCoinToERC20;
    fromPartial(object: DeepPartial<MsgConvertCosmosCoinToERC20>): MsgConvertCosmosCoinToERC20;
};
export declare const MsgConvertCosmosCoinToERC20Response: {
    encode(_: MsgConvertCosmosCoinToERC20Response, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinToERC20Response;
    fromJSON(_: any): MsgConvertCosmosCoinToERC20Response;
    toJSON(_: MsgConvertCosmosCoinToERC20Response): unknown;
    create(base?: DeepPartial<MsgConvertCosmosCoinToERC20Response>): MsgConvertCosmosCoinToERC20Response;
    fromPartial(_: DeepPartial<MsgConvertCosmosCoinToERC20Response>): MsgConvertCosmosCoinToERC20Response;
};
export declare const MsgConvertCosmosCoinFromERC20: {
    encode(message: MsgConvertCosmosCoinFromERC20, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinFromERC20;
    fromJSON(object: any): MsgConvertCosmosCoinFromERC20;
    toJSON(message: MsgConvertCosmosCoinFromERC20): unknown;
    create(base?: DeepPartial<MsgConvertCosmosCoinFromERC20>): MsgConvertCosmosCoinFromERC20;
    fromPartial(object: DeepPartial<MsgConvertCosmosCoinFromERC20>): MsgConvertCosmosCoinFromERC20;
};
export declare const MsgConvertCosmosCoinFromERC20Response: {
    encode(_: MsgConvertCosmosCoinFromERC20Response, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinFromERC20Response;
    fromJSON(_: any): MsgConvertCosmosCoinFromERC20Response;
    toJSON(_: MsgConvertCosmosCoinFromERC20Response): unknown;
    create(base?: DeepPartial<MsgConvertCosmosCoinFromERC20Response>): MsgConvertCosmosCoinFromERC20Response;
    fromPartial(_: DeepPartial<MsgConvertCosmosCoinFromERC20Response>): MsgConvertCosmosCoinFromERC20Response;
};
/** Msg defines the evmutil Msg service. */
export interface Msg {
    /** ConvertCoinToERC20 defines a method for converting sdk.Coin to Kava ERC20. */
    ConvertCoinToERC20(request: MsgConvertCoinToERC20): Promise<MsgConvertCoinToERC20Response>;
    /** ConvertERC20ToCoin defines a method for converting Kava ERC20 to sdk.Coin. */
    ConvertERC20ToCoin(request: MsgConvertERC20ToCoin): Promise<MsgConvertERC20ToCoinResponse>;
    /** ConvertCosmosCoinToERC20 defines a method for converting a cosmos sdk.Coin to an ERC20. */
    ConvertCosmosCoinToERC20(request: MsgConvertCosmosCoinToERC20): Promise<MsgConvertCosmosCoinToERC20Response>;
    /** ConvertCosmosCoinFromERC20 defines a method for converting a cosmos sdk.Coin to an ERC20. */
    ConvertCosmosCoinFromERC20(request: MsgConvertCosmosCoinFromERC20): Promise<MsgConvertCosmosCoinFromERC20Response>;
}
export declare const MsgServiceName = "kava.evmutil.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    ConvertCoinToERC20(request: MsgConvertCoinToERC20): Promise<MsgConvertCoinToERC20Response>;
    ConvertERC20ToCoin(request: MsgConvertERC20ToCoin): Promise<MsgConvertERC20ToCoinResponse>;
    ConvertCosmosCoinToERC20(request: MsgConvertCosmosCoinToERC20): Promise<MsgConvertCosmosCoinToERC20Response>;
    ConvertCosmosCoinFromERC20(request: MsgConvertCosmosCoinFromERC20): Promise<MsgConvertCosmosCoinFromERC20Response>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
