import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Borrow, Deposit, Params } from "./hard";
export declare const protobufPackage = "kava.hard.v1beta1";
/** GenesisState defines the hard module's genesis state. */
export interface GenesisState {
    params?: Params | undefined;
    previousAccumulationTimes: GenesisAccumulationTime[];
    deposits: Deposit[];
    borrows: Borrow[];
    totalSupplied: Coin[];
    totalBorrowed: Coin[];
    totalReserves: Coin[];
}
/** GenesisAccumulationTime stores the previous distribution time and its corresponding denom. */
export interface GenesisAccumulationTime {
    collateralType: string;
    previousAccumulationTime?: Date | undefined;
    supplyInterestFactor: string;
    borrowInterestFactor: string;
}
export declare const GenesisState: {
    encode(message: GenesisState, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): unknown;
    create(base?: DeepPartial<GenesisState>): GenesisState;
    fromPartial(object: DeepPartial<GenesisState>): GenesisState;
};
export declare const GenesisAccumulationTime: {
    encode(message: GenesisAccumulationTime, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisAccumulationTime;
    fromJSON(object: any): GenesisAccumulationTime;
    toJSON(message: GenesisAccumulationTime): unknown;
    create(base?: DeepPartial<GenesisAccumulationTime>): GenesisAccumulationTime;
    fromPartial(object: DeepPartial<GenesisAccumulationTime>): GenesisAccumulationTime;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
