import Long from "long";
import _m0 from "protobufjs/minimal";
import { DelegatorClaim, EarnClaim, HardLiquidityProviderClaim, MultiRewardIndex, SavingsClaim, SwapClaim, USDXMintingClaim } from "./claims";
import { Params } from "./params";
export declare const protobufPackage = "kava.incentive.v1beta1";
/** AccumulationTime stores the previous reward distribution time and its corresponding collateral type */
export interface AccumulationTime {
    collateralType: string;
    previousAccumulationTime?: Date | undefined;
}
/** GenesisRewardState groups together the global state for a particular reward so it can be exported in genesis. */
export interface GenesisRewardState {
    accumulationTimes: AccumulationTime[];
    multiRewardIndexes: MultiRewardIndex[];
}
/** GenesisState is the state that must be provided at genesis. */
export interface GenesisState {
    params?: Params | undefined;
    usdxRewardState?: GenesisRewardState | undefined;
    hardSupplyRewardState?: GenesisRewardState | undefined;
    hardBorrowRewardState?: GenesisRewardState | undefined;
    delegatorRewardState?: GenesisRewardState | undefined;
    swapRewardState?: GenesisRewardState | undefined;
    usdxMintingClaims: USDXMintingClaim[];
    hardLiquidityProviderClaims: HardLiquidityProviderClaim[];
    delegatorClaims: DelegatorClaim[];
    swapClaims: SwapClaim[];
    savingsRewardState?: GenesisRewardState | undefined;
    savingsClaims: SavingsClaim[];
    earnRewardState?: GenesisRewardState | undefined;
    earnClaims: EarnClaim[];
}
export declare const AccumulationTime: {
    encode(message: AccumulationTime, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AccumulationTime;
    fromJSON(object: any): AccumulationTime;
    toJSON(message: AccumulationTime): unknown;
    create(base?: DeepPartial<AccumulationTime>): AccumulationTime;
    fromPartial(object: DeepPartial<AccumulationTime>): AccumulationTime;
};
export declare const GenesisRewardState: {
    encode(message: GenesisRewardState, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisRewardState;
    fromJSON(object: any): GenesisRewardState;
    toJSON(message: GenesisRewardState): unknown;
    create(base?: DeepPartial<GenesisRewardState>): GenesisRewardState;
    fromPartial(object: DeepPartial<GenesisRewardState>): GenesisRewardState;
};
export declare const GenesisState: {
    encode(message: GenesisState, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): unknown;
    create(base?: DeepPartial<GenesisState>): GenesisState;
    fromPartial(object: DeepPartial<GenesisState>): GenesisState;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
