import Long from "long";
import _m0 from "protobufjs/minimal";
import { Apy } from "./apy";
import { DelegatorClaim, EarnClaim, HardLiquidityProviderClaim, MultiRewardIndex, RewardIndex, SavingsClaim, SwapClaim, USDXMintingClaim } from "./claims";
import { Params } from "./params";
export declare const protobufPackage = "kava.incentive.v1beta1";
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
    params?: Params | undefined;
}
/** QueryRewardsRequest is the request type for the Query/Rewards RPC method. */
export interface QueryRewardsRequest {
    /** owner is the address of the user to query rewards for. */
    owner: string;
    /**
     * reward_type is the type of reward to query rewards for, e.g. hard, earn,
     * swap.
     */
    rewardType: string;
    /**
     * unsynchronized is a flag to query rewards that are not simulated for reward
     * synchronized for the current block.
     */
    unsynchronized: boolean;
}
/** QueryRewardsResponse is the response type for the Query/Rewards RPC method. */
export interface QueryRewardsResponse {
    usdxMintingClaims: USDXMintingClaim[];
    hardLiquidityProviderClaims: HardLiquidityProviderClaim[];
    delegatorClaims: DelegatorClaim[];
    swapClaims: SwapClaim[];
    savingsClaims: SavingsClaim[];
    earnClaims: EarnClaim[];
}
/** QueryRewardFactorsRequest is the request type for the Query/RewardFactors RPC method. */
export interface QueryRewardFactorsRequest {
}
/** QueryRewardFactorsResponse is the response type for the Query/RewardFactors RPC method. */
export interface QueryRewardFactorsResponse {
    usdxMintingRewardFactors: RewardIndex[];
    hardSupplyRewardFactors: MultiRewardIndex[];
    hardBorrowRewardFactors: MultiRewardIndex[];
    delegatorRewardFactors: MultiRewardIndex[];
    swapRewardFactors: MultiRewardIndex[];
    savingsRewardFactors: MultiRewardIndex[];
    earnRewardFactors: MultiRewardIndex[];
}
/** QueryApysRequest is the request type for the Query/Apys RPC method. */
export interface QueryApyRequest {
}
/** QueryApysResponse is the response type for the Query/Apys RPC method. */
export interface QueryApyResponse {
    earn: Apy[];
}
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
};
export declare const QueryRewardsRequest: {
    encode(message: QueryRewardsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardsRequest;
    fromJSON(object: any): QueryRewardsRequest;
    toJSON(message: QueryRewardsRequest): unknown;
    create(base?: DeepPartial<QueryRewardsRequest>): QueryRewardsRequest;
    fromPartial(object: DeepPartial<QueryRewardsRequest>): QueryRewardsRequest;
};
export declare const QueryRewardsResponse: {
    encode(message: QueryRewardsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardsResponse;
    fromJSON(object: any): QueryRewardsResponse;
    toJSON(message: QueryRewardsResponse): unknown;
    create(base?: DeepPartial<QueryRewardsResponse>): QueryRewardsResponse;
    fromPartial(object: DeepPartial<QueryRewardsResponse>): QueryRewardsResponse;
};
export declare const QueryRewardFactorsRequest: {
    encode(_: QueryRewardFactorsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardFactorsRequest;
    fromJSON(_: any): QueryRewardFactorsRequest;
    toJSON(_: QueryRewardFactorsRequest): unknown;
    create(base?: DeepPartial<QueryRewardFactorsRequest>): QueryRewardFactorsRequest;
    fromPartial(_: DeepPartial<QueryRewardFactorsRequest>): QueryRewardFactorsRequest;
};
export declare const QueryRewardFactorsResponse: {
    encode(message: QueryRewardFactorsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardFactorsResponse;
    fromJSON(object: any): QueryRewardFactorsResponse;
    toJSON(message: QueryRewardFactorsResponse): unknown;
    create(base?: DeepPartial<QueryRewardFactorsResponse>): QueryRewardFactorsResponse;
    fromPartial(object: DeepPartial<QueryRewardFactorsResponse>): QueryRewardFactorsResponse;
};
export declare const QueryApyRequest: {
    encode(_: QueryApyRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryApyRequest;
    fromJSON(_: any): QueryApyRequest;
    toJSON(_: QueryApyRequest): unknown;
    create(base?: DeepPartial<QueryApyRequest>): QueryApyRequest;
    fromPartial(_: DeepPartial<QueryApyRequest>): QueryApyRequest;
};
export declare const QueryApyResponse: {
    encode(message: QueryApyResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryApyResponse;
    fromJSON(object: any): QueryApyResponse;
    toJSON(message: QueryApyResponse): unknown;
    create(base?: DeepPartial<QueryApyResponse>): QueryApyResponse;
    fromPartial(object: DeepPartial<QueryApyResponse>): QueryApyResponse;
};
/** Query defines the gRPC querier service for incentive module. */
export interface Query {
    /** Params queries module params. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    /** Rewards queries reward information for a given user. */
    Rewards(request: QueryRewardsRequest): Promise<QueryRewardsResponse>;
    /** Rewards queries the reward factors. */
    RewardFactors(request: QueryRewardFactorsRequest): Promise<QueryRewardFactorsResponse>;
    /** Apy queries incentive reward apy for a reward. */
    Apy(request: QueryApyRequest): Promise<QueryApyResponse>;
}
export declare const QueryServiceName = "kava.incentive.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    Rewards(request: QueryRewardsRequest): Promise<QueryRewardsResponse>;
    RewardFactors(request: QueryRewardFactorsRequest): Promise<QueryRewardFactorsResponse>;
    Apy(request: QueryApyRequest): Promise<QueryApyResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
