import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "kava.incentive.v1beta1";
/**
 * Selection is a pair of denom and multiplier name. It holds the choice of multiplier a user makes when they claim a
 * denom.
 */
export interface Selection {
    denom: string;
    multiplierName: string;
}
/** MsgClaimUSDXMintingReward message type used to claim USDX minting rewards */
export interface MsgClaimUSDXMintingReward {
    sender: string;
    multiplierName: string;
}
/** MsgClaimUSDXMintingRewardResponse defines the Msg/ClaimUSDXMintingReward response type. */
export interface MsgClaimUSDXMintingRewardResponse {
}
/** MsgClaimHardReward message type used to claim Hard liquidity provider rewards */
export interface MsgClaimHardReward {
    sender: string;
    denomsToClaim: Selection[];
}
/** MsgClaimHardRewardResponse defines the Msg/ClaimHardReward response type. */
export interface MsgClaimHardRewardResponse {
}
/** MsgClaimDelegatorReward message type used to claim delegator rewards */
export interface MsgClaimDelegatorReward {
    sender: string;
    denomsToClaim: Selection[];
}
/** MsgClaimDelegatorRewardResponse defines the Msg/ClaimDelegatorReward response type. */
export interface MsgClaimDelegatorRewardResponse {
}
/** MsgClaimSwapReward message type used to claim delegator rewards */
export interface MsgClaimSwapReward {
    sender: string;
    denomsToClaim: Selection[];
}
/** MsgClaimSwapRewardResponse defines the Msg/ClaimSwapReward response type. */
export interface MsgClaimSwapRewardResponse {
}
/** MsgClaimSavingsReward message type used to claim savings rewards */
export interface MsgClaimSavingsReward {
    sender: string;
    denomsToClaim: Selection[];
}
/** MsgClaimSavingsRewardResponse defines the Msg/ClaimSavingsReward response type. */
export interface MsgClaimSavingsRewardResponse {
}
/** MsgClaimEarnReward message type used to claim earn rewards */
export interface MsgClaimEarnReward {
    sender: string;
    denomsToClaim: Selection[];
}
/** MsgClaimEarnRewardResponse defines the Msg/ClaimEarnReward response type. */
export interface MsgClaimEarnRewardResponse {
}
export declare const Selection: {
    encode(message: Selection, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Selection;
    fromJSON(object: any): Selection;
    toJSON(message: Selection): unknown;
    create(base?: DeepPartial<Selection>): Selection;
    fromPartial(object: DeepPartial<Selection>): Selection;
};
export declare const MsgClaimUSDXMintingReward: {
    encode(message: MsgClaimUSDXMintingReward, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimUSDXMintingReward;
    fromJSON(object: any): MsgClaimUSDXMintingReward;
    toJSON(message: MsgClaimUSDXMintingReward): unknown;
    create(base?: DeepPartial<MsgClaimUSDXMintingReward>): MsgClaimUSDXMintingReward;
    fromPartial(object: DeepPartial<MsgClaimUSDXMintingReward>): MsgClaimUSDXMintingReward;
};
export declare const MsgClaimUSDXMintingRewardResponse: {
    encode(_: MsgClaimUSDXMintingRewardResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimUSDXMintingRewardResponse;
    fromJSON(_: any): MsgClaimUSDXMintingRewardResponse;
    toJSON(_: MsgClaimUSDXMintingRewardResponse): unknown;
    create(base?: DeepPartial<MsgClaimUSDXMintingRewardResponse>): MsgClaimUSDXMintingRewardResponse;
    fromPartial(_: DeepPartial<MsgClaimUSDXMintingRewardResponse>): MsgClaimUSDXMintingRewardResponse;
};
export declare const MsgClaimHardReward: {
    encode(message: MsgClaimHardReward, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimHardReward;
    fromJSON(object: any): MsgClaimHardReward;
    toJSON(message: MsgClaimHardReward): unknown;
    create(base?: DeepPartial<MsgClaimHardReward>): MsgClaimHardReward;
    fromPartial(object: DeepPartial<MsgClaimHardReward>): MsgClaimHardReward;
};
export declare const MsgClaimHardRewardResponse: {
    encode(_: MsgClaimHardRewardResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimHardRewardResponse;
    fromJSON(_: any): MsgClaimHardRewardResponse;
    toJSON(_: MsgClaimHardRewardResponse): unknown;
    create(base?: DeepPartial<MsgClaimHardRewardResponse>): MsgClaimHardRewardResponse;
    fromPartial(_: DeepPartial<MsgClaimHardRewardResponse>): MsgClaimHardRewardResponse;
};
export declare const MsgClaimDelegatorReward: {
    encode(message: MsgClaimDelegatorReward, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimDelegatorReward;
    fromJSON(object: any): MsgClaimDelegatorReward;
    toJSON(message: MsgClaimDelegatorReward): unknown;
    create(base?: DeepPartial<MsgClaimDelegatorReward>): MsgClaimDelegatorReward;
    fromPartial(object: DeepPartial<MsgClaimDelegatorReward>): MsgClaimDelegatorReward;
};
export declare const MsgClaimDelegatorRewardResponse: {
    encode(_: MsgClaimDelegatorRewardResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimDelegatorRewardResponse;
    fromJSON(_: any): MsgClaimDelegatorRewardResponse;
    toJSON(_: MsgClaimDelegatorRewardResponse): unknown;
    create(base?: DeepPartial<MsgClaimDelegatorRewardResponse>): MsgClaimDelegatorRewardResponse;
    fromPartial(_: DeepPartial<MsgClaimDelegatorRewardResponse>): MsgClaimDelegatorRewardResponse;
};
export declare const MsgClaimSwapReward: {
    encode(message: MsgClaimSwapReward, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimSwapReward;
    fromJSON(object: any): MsgClaimSwapReward;
    toJSON(message: MsgClaimSwapReward): unknown;
    create(base?: DeepPartial<MsgClaimSwapReward>): MsgClaimSwapReward;
    fromPartial(object: DeepPartial<MsgClaimSwapReward>): MsgClaimSwapReward;
};
export declare const MsgClaimSwapRewardResponse: {
    encode(_: MsgClaimSwapRewardResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimSwapRewardResponse;
    fromJSON(_: any): MsgClaimSwapRewardResponse;
    toJSON(_: MsgClaimSwapRewardResponse): unknown;
    create(base?: DeepPartial<MsgClaimSwapRewardResponse>): MsgClaimSwapRewardResponse;
    fromPartial(_: DeepPartial<MsgClaimSwapRewardResponse>): MsgClaimSwapRewardResponse;
};
export declare const MsgClaimSavingsReward: {
    encode(message: MsgClaimSavingsReward, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimSavingsReward;
    fromJSON(object: any): MsgClaimSavingsReward;
    toJSON(message: MsgClaimSavingsReward): unknown;
    create(base?: DeepPartial<MsgClaimSavingsReward>): MsgClaimSavingsReward;
    fromPartial(object: DeepPartial<MsgClaimSavingsReward>): MsgClaimSavingsReward;
};
export declare const MsgClaimSavingsRewardResponse: {
    encode(_: MsgClaimSavingsRewardResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimSavingsRewardResponse;
    fromJSON(_: any): MsgClaimSavingsRewardResponse;
    toJSON(_: MsgClaimSavingsRewardResponse): unknown;
    create(base?: DeepPartial<MsgClaimSavingsRewardResponse>): MsgClaimSavingsRewardResponse;
    fromPartial(_: DeepPartial<MsgClaimSavingsRewardResponse>): MsgClaimSavingsRewardResponse;
};
export declare const MsgClaimEarnReward: {
    encode(message: MsgClaimEarnReward, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimEarnReward;
    fromJSON(object: any): MsgClaimEarnReward;
    toJSON(message: MsgClaimEarnReward): unknown;
    create(base?: DeepPartial<MsgClaimEarnReward>): MsgClaimEarnReward;
    fromPartial(object: DeepPartial<MsgClaimEarnReward>): MsgClaimEarnReward;
};
export declare const MsgClaimEarnRewardResponse: {
    encode(_: MsgClaimEarnRewardResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgClaimEarnRewardResponse;
    fromJSON(_: any): MsgClaimEarnRewardResponse;
    toJSON(_: MsgClaimEarnRewardResponse): unknown;
    create(base?: DeepPartial<MsgClaimEarnRewardResponse>): MsgClaimEarnRewardResponse;
    fromPartial(_: DeepPartial<MsgClaimEarnRewardResponse>): MsgClaimEarnRewardResponse;
};
/** Msg defines the incentive Msg service. */
export interface Msg {
    /** ClaimUSDXMintingReward is a message type used to claim USDX minting rewards */
    ClaimUSDXMintingReward(request: MsgClaimUSDXMintingReward): Promise<MsgClaimUSDXMintingRewardResponse>;
    /** ClaimHardReward is a message type used to claim Hard liquidity provider rewards */
    ClaimHardReward(request: MsgClaimHardReward): Promise<MsgClaimHardRewardResponse>;
    /** ClaimDelegatorReward is a message type used to claim delegator rewards */
    ClaimDelegatorReward(request: MsgClaimDelegatorReward): Promise<MsgClaimDelegatorRewardResponse>;
    /** ClaimSwapReward is a message type used to claim swap rewards */
    ClaimSwapReward(request: MsgClaimSwapReward): Promise<MsgClaimSwapRewardResponse>;
    /** ClaimSavingsReward is a message type used to claim savings rewards */
    ClaimSavingsReward(request: MsgClaimSavingsReward): Promise<MsgClaimSavingsRewardResponse>;
    /** ClaimEarnReward is a message type used to claim earn rewards */
    ClaimEarnReward(request: MsgClaimEarnReward): Promise<MsgClaimEarnRewardResponse>;
}
export declare const MsgServiceName = "kava.incentive.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    ClaimUSDXMintingReward(request: MsgClaimUSDXMintingReward): Promise<MsgClaimUSDXMintingRewardResponse>;
    ClaimHardReward(request: MsgClaimHardReward): Promise<MsgClaimHardRewardResponse>;
    ClaimDelegatorReward(request: MsgClaimDelegatorReward): Promise<MsgClaimDelegatorRewardResponse>;
    ClaimSwapReward(request: MsgClaimSwapReward): Promise<MsgClaimSwapRewardResponse>;
    ClaimSavingsReward(request: MsgClaimSavingsReward): Promise<MsgClaimSavingsRewardResponse>;
    ClaimEarnReward(request: MsgClaimEarnReward): Promise<MsgClaimEarnRewardResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
