import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.issuance.v1beta1";
/** MsgIssueTokens represents a message used by the issuer to issue new tokens */
export interface MsgIssueTokens {
    sender: string;
    tokens?: Coin | undefined;
    receiver: string;
}
/** MsgIssueTokensResponse defines the Msg/IssueTokens response type. */
export interface MsgIssueTokensResponse {
}
/** MsgRedeemTokens represents a message used by the issuer to redeem (burn) tokens */
export interface MsgRedeemTokens {
    sender: string;
    tokens?: Coin | undefined;
}
/** MsgRedeemTokensResponse defines the Msg/RedeemTokens response type. */
export interface MsgRedeemTokensResponse {
}
/** MsgBlockAddress represents a message used by the issuer to block an address from holding or transferring tokens */
export interface MsgBlockAddress {
    sender: string;
    denom: string;
    blockedAddress: string;
}
/** MsgBlockAddressResponse defines the Msg/BlockAddress response type. */
export interface MsgBlockAddressResponse {
}
/** MsgUnblockAddress message type used by the issuer to unblock an address from holding or transferring tokens */
export interface MsgUnblockAddress {
    sender: string;
    denom: string;
    blockedAddress: string;
}
/** MsgUnblockAddressResponse defines the Msg/UnblockAddress response type. */
export interface MsgUnblockAddressResponse {
}
/** MsgSetPauseStatus message type used by the issuer to pause or unpause status */
export interface MsgSetPauseStatus {
    sender: string;
    denom: string;
    status: boolean;
}
/** MsgSetPauseStatusResponse defines the Msg/SetPauseStatus response type. */
export interface MsgSetPauseStatusResponse {
}
export declare const MsgIssueTokens: {
    encode(message: MsgIssueTokens, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgIssueTokens;
    fromJSON(object: any): MsgIssueTokens;
    toJSON(message: MsgIssueTokens): unknown;
    create(base?: DeepPartial<MsgIssueTokens>): MsgIssueTokens;
    fromPartial(object: DeepPartial<MsgIssueTokens>): MsgIssueTokens;
};
export declare const MsgIssueTokensResponse: {
    encode(_: MsgIssueTokensResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgIssueTokensResponse;
    fromJSON(_: any): MsgIssueTokensResponse;
    toJSON(_: MsgIssueTokensResponse): unknown;
    create(base?: DeepPartial<MsgIssueTokensResponse>): MsgIssueTokensResponse;
    fromPartial(_: DeepPartial<MsgIssueTokensResponse>): MsgIssueTokensResponse;
};
export declare const MsgRedeemTokens: {
    encode(message: MsgRedeemTokens, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRedeemTokens;
    fromJSON(object: any): MsgRedeemTokens;
    toJSON(message: MsgRedeemTokens): unknown;
    create(base?: DeepPartial<MsgRedeemTokens>): MsgRedeemTokens;
    fromPartial(object: DeepPartial<MsgRedeemTokens>): MsgRedeemTokens;
};
export declare const MsgRedeemTokensResponse: {
    encode(_: MsgRedeemTokensResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgRedeemTokensResponse;
    fromJSON(_: any): MsgRedeemTokensResponse;
    toJSON(_: MsgRedeemTokensResponse): unknown;
    create(base?: DeepPartial<MsgRedeemTokensResponse>): MsgRedeemTokensResponse;
    fromPartial(_: DeepPartial<MsgRedeemTokensResponse>): MsgRedeemTokensResponse;
};
export declare const MsgBlockAddress: {
    encode(message: MsgBlockAddress, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgBlockAddress;
    fromJSON(object: any): MsgBlockAddress;
    toJSON(message: MsgBlockAddress): unknown;
    create(base?: DeepPartial<MsgBlockAddress>): MsgBlockAddress;
    fromPartial(object: DeepPartial<MsgBlockAddress>): MsgBlockAddress;
};
export declare const MsgBlockAddressResponse: {
    encode(_: MsgBlockAddressResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgBlockAddressResponse;
    fromJSON(_: any): MsgBlockAddressResponse;
    toJSON(_: MsgBlockAddressResponse): unknown;
    create(base?: DeepPartial<MsgBlockAddressResponse>): MsgBlockAddressResponse;
    fromPartial(_: DeepPartial<MsgBlockAddressResponse>): MsgBlockAddressResponse;
};
export declare const MsgUnblockAddress: {
    encode(message: MsgUnblockAddress, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgUnblockAddress;
    fromJSON(object: any): MsgUnblockAddress;
    toJSON(message: MsgUnblockAddress): unknown;
    create(base?: DeepPartial<MsgUnblockAddress>): MsgUnblockAddress;
    fromPartial(object: DeepPartial<MsgUnblockAddress>): MsgUnblockAddress;
};
export declare const MsgUnblockAddressResponse: {
    encode(_: MsgUnblockAddressResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgUnblockAddressResponse;
    fromJSON(_: any): MsgUnblockAddressResponse;
    toJSON(_: MsgUnblockAddressResponse): unknown;
    create(base?: DeepPartial<MsgUnblockAddressResponse>): MsgUnblockAddressResponse;
    fromPartial(_: DeepPartial<MsgUnblockAddressResponse>): MsgUnblockAddressResponse;
};
export declare const MsgSetPauseStatus: {
    encode(message: MsgSetPauseStatus, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetPauseStatus;
    fromJSON(object: any): MsgSetPauseStatus;
    toJSON(message: MsgSetPauseStatus): unknown;
    create(base?: DeepPartial<MsgSetPauseStatus>): MsgSetPauseStatus;
    fromPartial(object: DeepPartial<MsgSetPauseStatus>): MsgSetPauseStatus;
};
export declare const MsgSetPauseStatusResponse: {
    encode(_: MsgSetPauseStatusResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSetPauseStatusResponse;
    fromJSON(_: any): MsgSetPauseStatusResponse;
    toJSON(_: MsgSetPauseStatusResponse): unknown;
    create(base?: DeepPartial<MsgSetPauseStatusResponse>): MsgSetPauseStatusResponse;
    fromPartial(_: DeepPartial<MsgSetPauseStatusResponse>): MsgSetPauseStatusResponse;
};
/** Msg defines the issuance Msg service. */
export interface Msg {
    /** IssueTokens message type used by the issuer to issue new tokens */
    IssueTokens(request: MsgIssueTokens): Promise<MsgIssueTokensResponse>;
    /** RedeemTokens message type used by the issuer to redeem (burn) tokens */
    RedeemTokens(request: MsgRedeemTokens): Promise<MsgRedeemTokensResponse>;
    /** BlockAddress message type used by the issuer to block an address from holding or transferring tokens */
    BlockAddress(request: MsgBlockAddress): Promise<MsgBlockAddressResponse>;
    /** UnblockAddress message type used by the issuer to unblock an address from holding or transferring tokens */
    UnblockAddress(request: MsgUnblockAddress): Promise<MsgUnblockAddressResponse>;
    /** SetPauseStatus message type used to pause or unpause status */
    SetPauseStatus(request: MsgSetPauseStatus): Promise<MsgSetPauseStatusResponse>;
}
export declare const MsgServiceName = "kava.issuance.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    IssueTokens(request: MsgIssueTokens): Promise<MsgIssueTokensResponse>;
    RedeemTokens(request: MsgRedeemTokens): Promise<MsgRedeemTokensResponse>;
    BlockAddress(request: MsgBlockAddress): Promise<MsgBlockAddressResponse>;
    UnblockAddress(request: MsgUnblockAddress): Promise<MsgUnblockAddressResponse>;
    SetPauseStatus(request: MsgSetPauseStatus): Promise<MsgSetPauseStatusResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
