import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.kavadist.v1beta1";
/**
 * CommunityPoolMultiSpendProposal spends from the community pool by sending to one or more
 * addresses
 */
export interface CommunityPoolMultiSpendProposal {
    title: string;
    description: string;
    recipientList: MultiSpendRecipient[];
}
/** CommunityPoolMultiSpendProposalJSON defines a CommunityPoolMultiSpendProposal with a deposit */
export interface CommunityPoolMultiSpendProposalJSON {
    title: string;
    description: string;
    recipientList: MultiSpendRecipient[];
    deposit: Coin[];
}
/** MultiSpendRecipient defines a recipient and the amount of coins they are receiving */
export interface MultiSpendRecipient {
    address: string;
    amount: Coin[];
}
export declare const CommunityPoolMultiSpendProposal: {
    encode(message: CommunityPoolMultiSpendProposal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolMultiSpendProposal;
    fromJSON(object: any): CommunityPoolMultiSpendProposal;
    toJSON(message: CommunityPoolMultiSpendProposal): unknown;
    create(base?: DeepPartial<CommunityPoolMultiSpendProposal>): CommunityPoolMultiSpendProposal;
    fromPartial(object: DeepPartial<CommunityPoolMultiSpendProposal>): CommunityPoolMultiSpendProposal;
};
export declare const CommunityPoolMultiSpendProposalJSON: {
    encode(message: CommunityPoolMultiSpendProposalJSON, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolMultiSpendProposalJSON;
    fromJSON(object: any): CommunityPoolMultiSpendProposalJSON;
    toJSON(message: CommunityPoolMultiSpendProposalJSON): unknown;
    create(base?: DeepPartial<CommunityPoolMultiSpendProposalJSON>): CommunityPoolMultiSpendProposalJSON;
    fromPartial(object: DeepPartial<CommunityPoolMultiSpendProposalJSON>): CommunityPoolMultiSpendProposalJSON;
};
export declare const MultiSpendRecipient: {
    encode(message: MultiSpendRecipient, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MultiSpendRecipient;
    fromJSON(object: any): MultiSpendRecipient;
    toJSON(message: MultiSpendRecipient): unknown;
    create(base?: DeepPartial<MultiSpendRecipient>): MultiSpendRecipient;
    fromPartial(object: DeepPartial<MultiSpendRecipient>): MultiSpendRecipient;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
