import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.liquid.v1beta1";
/** QueryDelegatedBalanceRequest defines the request type for Query/DelegatedBalance method. */
export interface QueryDelegatedBalanceRequest {
    /** delegator is the address of the account to query */
    delegator: string;
}
/** DelegatedBalanceResponse defines the response type for the Query/DelegatedBalance method. */
export interface QueryDelegatedBalanceResponse {
    /** vested is the amount of all delegated coins that have vested (ie not locked) */
    vested?: Coin | undefined;
    /** vesting is the amount of all delegated coins that are still vesting (ie locked) */
    vesting?: Coin | undefined;
}
/** QueryTotalSupplyRequest defines the request type for Query/TotalSupply method. */
export interface QueryTotalSupplyRequest {
}
/** TotalSupplyResponse defines the response type for the Query/TotalSupply method. */
export interface QueryTotalSupplyResponse {
    /** Height is the block height at which these totals apply */
    height: Long;
    /** Result is a list of coins supplied to liquid */
    result: Coin[];
}
export declare const QueryDelegatedBalanceRequest: {
    encode(message: QueryDelegatedBalanceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryDelegatedBalanceRequest;
    fromJSON(object: any): QueryDelegatedBalanceRequest;
    toJSON(message: QueryDelegatedBalanceRequest): unknown;
    create(base?: DeepPartial<QueryDelegatedBalanceRequest>): QueryDelegatedBalanceRequest;
    fromPartial(object: DeepPartial<QueryDelegatedBalanceRequest>): QueryDelegatedBalanceRequest;
};
export declare const QueryDelegatedBalanceResponse: {
    encode(message: QueryDelegatedBalanceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryDelegatedBalanceResponse;
    fromJSON(object: any): QueryDelegatedBalanceResponse;
    toJSON(message: QueryDelegatedBalanceResponse): unknown;
    create(base?: DeepPartial<QueryDelegatedBalanceResponse>): QueryDelegatedBalanceResponse;
    fromPartial(object: DeepPartial<QueryDelegatedBalanceResponse>): QueryDelegatedBalanceResponse;
};
export declare const QueryTotalSupplyRequest: {
    encode(_: QueryTotalSupplyRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalSupplyRequest;
    fromJSON(_: any): QueryTotalSupplyRequest;
    toJSON(_: QueryTotalSupplyRequest): unknown;
    create(base?: DeepPartial<QueryTotalSupplyRequest>): QueryTotalSupplyRequest;
    fromPartial(_: DeepPartial<QueryTotalSupplyRequest>): QueryTotalSupplyRequest;
};
export declare const QueryTotalSupplyResponse: {
    encode(message: QueryTotalSupplyResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalSupplyResponse;
    fromJSON(object: any): QueryTotalSupplyResponse;
    toJSON(message: QueryTotalSupplyResponse): unknown;
    create(base?: DeepPartial<QueryTotalSupplyResponse>): QueryTotalSupplyResponse;
    fromPartial(object: DeepPartial<QueryTotalSupplyResponse>): QueryTotalSupplyResponse;
};
/** Query defines the gRPC querier service for liquid module */
export interface Query {
    /**
     * DelegatedBalance returns an account's vesting and vested coins currently delegated to validators.
     * It ignores coins in unbonding delegations.
     */
    DelegatedBalance(request: QueryDelegatedBalanceRequest): Promise<QueryDelegatedBalanceResponse>;
    /** TotalSupply returns the total sum of all coins currently locked into the liquid module. */
    TotalSupply(request: QueryTotalSupplyRequest): Promise<QueryTotalSupplyResponse>;
}
export declare const QueryServiceName = "kava.liquid.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    DelegatedBalance(request: QueryDelegatedBalanceRequest): Promise<QueryDelegatedBalanceResponse>;
    TotalSupply(request: QueryTotalSupplyRequest): Promise<QueryTotalSupplyResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
