import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.liquid.v1beta1";
/** MsgMintDerivative defines the Msg/MintDerivative request type. */
export interface MsgMintDerivative {
    /** sender is the owner of the delegation to be converted */
    sender: string;
    /** validator is the validator of the delegation to be converted */
    validator: string;
    /** amount is the quantity of staked assets to be converted */
    amount?: Coin | undefined;
}
/** MsgMintDerivativeResponse defines the Msg/MintDerivative response type. */
export interface MsgMintDerivativeResponse {
    /** received is the amount of staking derivative minted and sent to the sender */
    received?: Coin | undefined;
}
/** MsgBurnDerivative defines the Msg/BurnDerivative request type. */
export interface MsgBurnDerivative {
    /** sender is the owner of the derivatives to be converted */
    sender: string;
    /** validator is the validator of the derivatives to be converted */
    validator: string;
    /** amount is the quantity of derivatives to be converted */
    amount?: Coin | undefined;
}
/** MsgBurnDerivativeResponse defines the Msg/BurnDerivative response type. */
export interface MsgBurnDerivativeResponse {
    /** received is the number of delegation shares sent to the sender */
    received: string;
}
export declare const MsgMintDerivative: {
    encode(message: MsgMintDerivative, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgMintDerivative;
    fromJSON(object: any): MsgMintDerivative;
    toJSON(message: MsgMintDerivative): unknown;
    create(base?: DeepPartial<MsgMintDerivative>): MsgMintDerivative;
    fromPartial(object: DeepPartial<MsgMintDerivative>): MsgMintDerivative;
};
export declare const MsgMintDerivativeResponse: {
    encode(message: MsgMintDerivativeResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgMintDerivativeResponse;
    fromJSON(object: any): MsgMintDerivativeResponse;
    toJSON(message: MsgMintDerivativeResponse): unknown;
    create(base?: DeepPartial<MsgMintDerivativeResponse>): MsgMintDerivativeResponse;
    fromPartial(object: DeepPartial<MsgMintDerivativeResponse>): MsgMintDerivativeResponse;
};
export declare const MsgBurnDerivative: {
    encode(message: MsgBurnDerivative, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgBurnDerivative;
    fromJSON(object: any): MsgBurnDerivative;
    toJSON(message: MsgBurnDerivative): unknown;
    create(base?: DeepPartial<MsgBurnDerivative>): MsgBurnDerivative;
    fromPartial(object: DeepPartial<MsgBurnDerivative>): MsgBurnDerivative;
};
export declare const MsgBurnDerivativeResponse: {
    encode(message: MsgBurnDerivativeResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgBurnDerivativeResponse;
    fromJSON(object: any): MsgBurnDerivativeResponse;
    toJSON(message: MsgBurnDerivativeResponse): unknown;
    create(base?: DeepPartial<MsgBurnDerivativeResponse>): MsgBurnDerivativeResponse;
    fromPartial(object: DeepPartial<MsgBurnDerivativeResponse>): MsgBurnDerivativeResponse;
};
/** Msg defines the liquid Msg service. */
export interface Msg {
    /** MintDerivative defines a method for converting a delegation into staking deriviatives. */
    MintDerivative(request: MsgMintDerivative): Promise<MsgMintDerivativeResponse>;
    /** BurnDerivative defines a method for converting staking deriviatives into a delegation. */
    BurnDerivative(request: MsgBurnDerivative): Promise<MsgBurnDerivativeResponse>;
}
export declare const MsgServiceName = "kava.liquid.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    MintDerivative(request: MsgMintDerivative): Promise<MsgMintDerivativeResponse>;
    BurnDerivative(request: MsgBurnDerivative): Promise<MsgBurnDerivativeResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
