import Long from "long";
import _m0 from "protobufjs/minimal";
import { Params } from "./store";
export declare const protobufPackage = "kava.pricefeed.v1beta1";
/**
 * QueryParamsRequest defines the request type for querying x/pricefeed
 * parameters.
 */
export interface QueryParamsRequest {
}
/**
 * QueryParamsResponse defines the response type for querying x/pricefeed
 * parameters.
 */
export interface QueryParamsResponse {
    params?: Params | undefined;
}
/** QueryPriceRequest is the request type for the Query/PriceRequest RPC method. */
export interface QueryPriceRequest {
    marketId: string;
}
/** QueryPriceResponse is the response type for the Query/Prices RPC method. */
export interface QueryPriceResponse {
    price?: CurrentPriceResponse | undefined;
}
/** QueryPricesRequest is the request type for the Query/Prices RPC method. */
export interface QueryPricesRequest {
}
/** QueryPricesResponse is the response type for the Query/Prices RPC method. */
export interface QueryPricesResponse {
    prices: CurrentPriceResponse[];
}
/** QueryRawPricesRequest is the request type for the Query/RawPrices RPC method. */
export interface QueryRawPricesRequest {
    marketId: string;
}
/**
 * QueryRawPricesResponse is the response type for the Query/RawPrices RPC
 * method.
 */
export interface QueryRawPricesResponse {
    rawPrices: PostedPriceResponse[];
}
/** QueryOraclesRequest is the request type for the Query/Oracles RPC method. */
export interface QueryOraclesRequest {
    marketId: string;
}
/** QueryOraclesResponse is the response type for the Query/Oracles RPC method. */
export interface QueryOraclesResponse {
    /** List of oracle addresses */
    oracles: string[];
}
/** QueryMarketsRequest is the request type for the Query/Markets RPC method. */
export interface QueryMarketsRequest {
}
/** QueryMarketsResponse is the response type for the Query/Markets RPC method. */
export interface QueryMarketsResponse {
    /** List of markets */
    markets: MarketResponse[];
}
/** PostedPriceResponse defines a price for market posted by a specific oracle. */
export interface PostedPriceResponse {
    marketId: string;
    oracleAddress: string;
    price: string;
    expiry?: Date | undefined;
}
/**
 * CurrentPriceResponse defines a current price for a particular market in the pricefeed
 * module.
 */
export interface CurrentPriceResponse {
    marketId: string;
    price: string;
}
/** MarketResponse defines an asset in the pricefeed. */
export interface MarketResponse {
    marketId: string;
    baseAsset: string;
    quoteAsset: string;
    oracles: string[];
    active: boolean;
}
export declare const QueryParamsRequest: {
    encode(_: QueryParamsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): unknown;
    create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
};
export declare const QueryParamsResponse: {
    encode(message: QueryParamsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): unknown;
    create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
};
export declare const QueryPriceRequest: {
    encode(message: QueryPriceRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryPriceRequest;
    fromJSON(object: any): QueryPriceRequest;
    toJSON(message: QueryPriceRequest): unknown;
    create(base?: DeepPartial<QueryPriceRequest>): QueryPriceRequest;
    fromPartial(object: DeepPartial<QueryPriceRequest>): QueryPriceRequest;
};
export declare const QueryPriceResponse: {
    encode(message: QueryPriceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryPriceResponse;
    fromJSON(object: any): QueryPriceResponse;
    toJSON(message: QueryPriceResponse): unknown;
    create(base?: DeepPartial<QueryPriceResponse>): QueryPriceResponse;
    fromPartial(object: DeepPartial<QueryPriceResponse>): QueryPriceResponse;
};
export declare const QueryPricesRequest: {
    encode(_: QueryPricesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryPricesRequest;
    fromJSON(_: any): QueryPricesRequest;
    toJSON(_: QueryPricesRequest): unknown;
    create(base?: DeepPartial<QueryPricesRequest>): QueryPricesRequest;
    fromPartial(_: DeepPartial<QueryPricesRequest>): QueryPricesRequest;
};
export declare const QueryPricesResponse: {
    encode(message: QueryPricesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryPricesResponse;
    fromJSON(object: any): QueryPricesResponse;
    toJSON(message: QueryPricesResponse): unknown;
    create(base?: DeepPartial<QueryPricesResponse>): QueryPricesResponse;
    fromPartial(object: DeepPartial<QueryPricesResponse>): QueryPricesResponse;
};
export declare const QueryRawPricesRequest: {
    encode(message: QueryRawPricesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRawPricesRequest;
    fromJSON(object: any): QueryRawPricesRequest;
    toJSON(message: QueryRawPricesRequest): unknown;
    create(base?: DeepPartial<QueryRawPricesRequest>): QueryRawPricesRequest;
    fromPartial(object: DeepPartial<QueryRawPricesRequest>): QueryRawPricesRequest;
};
export declare const QueryRawPricesResponse: {
    encode(message: QueryRawPricesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryRawPricesResponse;
    fromJSON(object: any): QueryRawPricesResponse;
    toJSON(message: QueryRawPricesResponse): unknown;
    create(base?: DeepPartial<QueryRawPricesResponse>): QueryRawPricesResponse;
    fromPartial(object: DeepPartial<QueryRawPricesResponse>): QueryRawPricesResponse;
};
export declare const QueryOraclesRequest: {
    encode(message: QueryOraclesRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryOraclesRequest;
    fromJSON(object: any): QueryOraclesRequest;
    toJSON(message: QueryOraclesRequest): unknown;
    create(base?: DeepPartial<QueryOraclesRequest>): QueryOraclesRequest;
    fromPartial(object: DeepPartial<QueryOraclesRequest>): QueryOraclesRequest;
};
export declare const QueryOraclesResponse: {
    encode(message: QueryOraclesResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryOraclesResponse;
    fromJSON(object: any): QueryOraclesResponse;
    toJSON(message: QueryOraclesResponse): unknown;
    create(base?: DeepPartial<QueryOraclesResponse>): QueryOraclesResponse;
    fromPartial(object: DeepPartial<QueryOraclesResponse>): QueryOraclesResponse;
};
export declare const QueryMarketsRequest: {
    encode(_: QueryMarketsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryMarketsRequest;
    fromJSON(_: any): QueryMarketsRequest;
    toJSON(_: QueryMarketsRequest): unknown;
    create(base?: DeepPartial<QueryMarketsRequest>): QueryMarketsRequest;
    fromPartial(_: DeepPartial<QueryMarketsRequest>): QueryMarketsRequest;
};
export declare const QueryMarketsResponse: {
    encode(message: QueryMarketsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): QueryMarketsResponse;
    fromJSON(object: any): QueryMarketsResponse;
    toJSON(message: QueryMarketsResponse): unknown;
    create(base?: DeepPartial<QueryMarketsResponse>): QueryMarketsResponse;
    fromPartial(object: DeepPartial<QueryMarketsResponse>): QueryMarketsResponse;
};
export declare const PostedPriceResponse: {
    encode(message: PostedPriceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PostedPriceResponse;
    fromJSON(object: any): PostedPriceResponse;
    toJSON(message: PostedPriceResponse): unknown;
    create(base?: DeepPartial<PostedPriceResponse>): PostedPriceResponse;
    fromPartial(object: DeepPartial<PostedPriceResponse>): PostedPriceResponse;
};
export declare const CurrentPriceResponse: {
    encode(message: CurrentPriceResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CurrentPriceResponse;
    fromJSON(object: any): CurrentPriceResponse;
    toJSON(message: CurrentPriceResponse): unknown;
    create(base?: DeepPartial<CurrentPriceResponse>): CurrentPriceResponse;
    fromPartial(object: DeepPartial<CurrentPriceResponse>): CurrentPriceResponse;
};
export declare const MarketResponse: {
    encode(message: MarketResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MarketResponse;
    fromJSON(object: any): MarketResponse;
    toJSON(message: MarketResponse): unknown;
    create(base?: DeepPartial<MarketResponse>): MarketResponse;
    fromPartial(object: DeepPartial<MarketResponse>): MarketResponse;
};
/** Query defines the gRPC querier service for pricefeed module */
export interface Query {
    /** Params queries all parameters of the pricefeed module. */
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    /** Price queries price details based on a market */
    Price(request: QueryPriceRequest): Promise<QueryPriceResponse>;
    /** Prices queries all prices */
    Prices(request: QueryPricesRequest): Promise<QueryPricesResponse>;
    /** RawPrices queries all raw prices based on a market */
    RawPrices(request: QueryRawPricesRequest): Promise<QueryRawPricesResponse>;
    /** Oracles queries all oracles based on a market */
    Oracles(request: QueryOraclesRequest): Promise<QueryOraclesResponse>;
    /** Markets queries all markets */
    Markets(request: QueryMarketsRequest): Promise<QueryMarketsResponse>;
}
export declare const QueryServiceName = "kava.pricefeed.v1beta1.Query";
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
    Price(request: QueryPriceRequest): Promise<QueryPriceResponse>;
    Prices(request: QueryPricesRequest): Promise<QueryPricesResponse>;
    RawPrices(request: QueryRawPricesRequest): Promise<QueryRawPricesResponse>;
    Oracles(request: QueryOraclesRequest): Promise<QueryOraclesResponse>;
    Markets(request: QueryMarketsRequest): Promise<QueryMarketsResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
