import Long from "long";
import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "kava.pricefeed.v1beta1";
/** Params defines the parameters for the pricefeed module. */
export interface Params {
    markets: Market[];
}
/** Market defines an asset in the pricefeed. */
export interface Market {
    marketId: string;
    baseAsset: string;
    quoteAsset: string;
    oracles: Uint8Array[];
    active: boolean;
}
/** PostedPrice defines a price for market posted by a specific oracle. */
export interface PostedPrice {
    marketId: string;
    oracleAddress: Uint8Array;
    price: string;
    expiry?: Date | undefined;
}
/**
 * CurrentPrice defines a current price for a particular market in the pricefeed
 * module.
 */
export interface CurrentPrice {
    marketId: string;
    price: string;
}
export declare const Params: {
    encode(message: Params, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Params;
    fromJSON(object: any): Params;
    toJSON(message: Params): unknown;
    create(base?: DeepPartial<Params>): Params;
    fromPartial(object: DeepPartial<Params>): Params;
};
export declare const Market: {
    encode(message: Market, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Market;
    fromJSON(object: any): Market;
    toJSON(message: Market): unknown;
    create(base?: DeepPartial<Market>): Market;
    fromPartial(object: DeepPartial<Market>): Market;
};
export declare const PostedPrice: {
    encode(message: PostedPrice, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PostedPrice;
    fromJSON(object: any): PostedPrice;
    toJSON(message: PostedPrice): unknown;
    create(base?: DeepPartial<PostedPrice>): PostedPrice;
    fromPartial(object: DeepPartial<PostedPrice>): PostedPrice;
};
export declare const CurrentPrice: {
    encode(message: CurrentPrice, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CurrentPrice;
    fromJSON(object: any): CurrentPrice;
    toJSON(message: CurrentPrice): unknown;
    create(base?: DeepPartial<CurrentPrice>): CurrentPrice;
    fromPartial(object: DeepPartial<CurrentPrice>): CurrentPrice;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
