import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
export declare const protobufPackage = "kava.swap.v1beta1";
/** MsgDeposit represents a message for depositing liquidity into a pool */
export interface MsgDeposit {
    /** depositor represents the address to deposit funds from */
    depositor: string;
    /** token_a represents one token of deposit pair */
    tokenA?: Coin | undefined;
    /** token_b represents one token of deposit pair */
    tokenB?: Coin | undefined;
    /** slippage represents the max decimal percentage price change */
    slippage: string;
    /** deadline represents the unix timestamp to complete the deposit by */
    deadline: Long;
}
/** MsgDepositResponse defines the Msg/Deposit response type. */
export interface MsgDepositResponse {
}
/** MsgWithdraw represents a message for withdrawing liquidity from a pool */
export interface MsgWithdraw {
    /** from represents the address we are withdrawing for */
    from: string;
    /** shares represents the amount of shares to withdraw */
    shares: string;
    /** min_token_a represents the minimum a token to withdraw */
    minTokenA?: Coin | undefined;
    /** min_token_a represents the minimum a token to withdraw */
    minTokenB?: Coin | undefined;
    /** deadline represents the unix timestamp to complete the withdraw by */
    deadline: Long;
}
/** MsgWithdrawResponse defines the Msg/Withdraw response type. */
export interface MsgWithdrawResponse {
}
/** MsgSwapExactForTokens represents a message for trading exact coinA for coinB */
export interface MsgSwapExactForTokens {
    /** represents the address swaping the tokens */
    requester: string;
    /** exact_token_a represents the exact amount to swap for token_b */
    exactTokenA?: Coin | undefined;
    /** token_b represents the desired token_b to swap for */
    tokenB?: Coin | undefined;
    /** slippage represents the maximum change in token_b allowed */
    slippage: string;
    /** deadline represents the unix timestamp to complete the swap by */
    deadline: Long;
}
/**
 * MsgSwapExactForTokensResponse defines the Msg/SwapExactForTokens response
 * type.
 */
export interface MsgSwapExactForTokensResponse {
}
/**
 * MsgSwapForExactTokens represents a message for trading coinA for an exact
 * coinB
 */
export interface MsgSwapForExactTokens {
    /** represents the address swaping the tokens */
    requester: string;
    /** token_a represents the desired token_a to swap for */
    tokenA?: Coin | undefined;
    /** exact_token_b represents the exact token b amount to swap for token a */
    exactTokenB?: Coin | undefined;
    /** slippage represents the maximum change in token_a allowed */
    slippage: string;
    /** deadline represents the unix timestamp to complete the swap by */
    deadline: Long;
}
/**
 * MsgSwapForExactTokensResponse defines the Msg/SwapForExactTokensResponse
 * response type.
 */
export interface MsgSwapForExactTokensResponse {
}
export declare const MsgDeposit: {
    encode(message: MsgDeposit, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDeposit;
    fromJSON(object: any): MsgDeposit;
    toJSON(message: MsgDeposit): unknown;
    create(base?: DeepPartial<MsgDeposit>): MsgDeposit;
    fromPartial(object: DeepPartial<MsgDeposit>): MsgDeposit;
};
export declare const MsgDepositResponse: {
    encode(_: MsgDepositResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgDepositResponse;
    fromJSON(_: any): MsgDepositResponse;
    toJSON(_: MsgDepositResponse): unknown;
    create(base?: DeepPartial<MsgDepositResponse>): MsgDepositResponse;
    fromPartial(_: DeepPartial<MsgDepositResponse>): MsgDepositResponse;
};
export declare const MsgWithdraw: {
    encode(message: MsgWithdraw, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgWithdraw;
    fromJSON(object: any): MsgWithdraw;
    toJSON(message: MsgWithdraw): unknown;
    create(base?: DeepPartial<MsgWithdraw>): MsgWithdraw;
    fromPartial(object: DeepPartial<MsgWithdraw>): MsgWithdraw;
};
export declare const MsgWithdrawResponse: {
    encode(_: MsgWithdrawResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgWithdrawResponse;
    fromJSON(_: any): MsgWithdrawResponse;
    toJSON(_: MsgWithdrawResponse): unknown;
    create(base?: DeepPartial<MsgWithdrawResponse>): MsgWithdrawResponse;
    fromPartial(_: DeepPartial<MsgWithdrawResponse>): MsgWithdrawResponse;
};
export declare const MsgSwapExactForTokens: {
    encode(message: MsgSwapExactForTokens, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSwapExactForTokens;
    fromJSON(object: any): MsgSwapExactForTokens;
    toJSON(message: MsgSwapExactForTokens): unknown;
    create(base?: DeepPartial<MsgSwapExactForTokens>): MsgSwapExactForTokens;
    fromPartial(object: DeepPartial<MsgSwapExactForTokens>): MsgSwapExactForTokens;
};
export declare const MsgSwapExactForTokensResponse: {
    encode(_: MsgSwapExactForTokensResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSwapExactForTokensResponse;
    fromJSON(_: any): MsgSwapExactForTokensResponse;
    toJSON(_: MsgSwapExactForTokensResponse): unknown;
    create(base?: DeepPartial<MsgSwapExactForTokensResponse>): MsgSwapExactForTokensResponse;
    fromPartial(_: DeepPartial<MsgSwapExactForTokensResponse>): MsgSwapExactForTokensResponse;
};
export declare const MsgSwapForExactTokens: {
    encode(message: MsgSwapForExactTokens, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSwapForExactTokens;
    fromJSON(object: any): MsgSwapForExactTokens;
    toJSON(message: MsgSwapForExactTokens): unknown;
    create(base?: DeepPartial<MsgSwapForExactTokens>): MsgSwapForExactTokens;
    fromPartial(object: DeepPartial<MsgSwapForExactTokens>): MsgSwapForExactTokens;
};
export declare const MsgSwapForExactTokensResponse: {
    encode(_: MsgSwapForExactTokensResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MsgSwapForExactTokensResponse;
    fromJSON(_: any): MsgSwapForExactTokensResponse;
    toJSON(_: MsgSwapForExactTokensResponse): unknown;
    create(base?: DeepPartial<MsgSwapForExactTokensResponse>): MsgSwapForExactTokensResponse;
    fromPartial(_: DeepPartial<MsgSwapForExactTokensResponse>): MsgSwapForExactTokensResponse;
};
/** Msg defines the swap Msg service. */
export interface Msg {
    /** Deposit defines a method for depositing liquidity into a pool */
    Deposit(request: MsgDeposit): Promise<MsgDepositResponse>;
    /** Withdraw defines a method for withdrawing liquidity into a pool */
    Withdraw(request: MsgWithdraw): Promise<MsgWithdrawResponse>;
    /** SwapExactForTokens represents a message for trading exact coinA for coinB */
    SwapExactForTokens(request: MsgSwapExactForTokens): Promise<MsgSwapExactForTokensResponse>;
    /** SwapForExactTokens represents a message for trading coinA for an exact coinB */
    SwapForExactTokens(request: MsgSwapForExactTokens): Promise<MsgSwapForExactTokensResponse>;
}
export declare const MsgServiceName = "kava.swap.v1beta1.Msg";
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Deposit(request: MsgDeposit): Promise<MsgDepositResponse>;
    Withdraw(request: MsgWithdraw): Promise<MsgWithdrawResponse>;
    SwapExactForTokens(request: MsgSwapExactForTokens): Promise<MsgSwapExactForTokensResponse>;
    SwapForExactTokens(request: MsgSwapForExactTokens): Promise<MsgSwapForExactTokensResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
