// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: ethermint/evm/v1/events.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";

export const protobufPackage = "ethermint.evm.v1";

/** EventEthereumTx defines the event for an Ethereum transaction */
export interface EventEthereumTx {
  /** amount */
  amount: string;
  /** eth_hash is the Ethereum hash of the transaction */
  ethHash: string;
  /** index of the transaction in the block */
  index: string;
  /** gas_used is the amount of gas used by the transaction */
  gasUsed: string;
  /** hash is the Tendermint hash of the transaction */
  hash: string;
  /** recipient of the transaction */
  recipient: string;
  /** eth_tx_failed contains a VM error should it occur */
  ethTxFailed: string;
}

/** EventTxLog defines the event for an Ethereum transaction log */
export interface EventTxLog {
  /** tx_logs is an array of transaction logs */
  txLogs: string[];
}

/** EventMessage */
export interface EventMessage {
  /** module which emits the event */
  module: string;
  /** sender of the message */
  sender: string;
  /** tx_type is the type of the message */
  txType: string;
}

/** EventBlockBloom defines an Ethereum block bloom filter event */
export interface EventBlockBloom {
  /** bloom is the bloom filter of the block */
  bloom: string;
}

function createBaseEventEthereumTx(): EventEthereumTx {
  return { amount: "", ethHash: "", index: "", gasUsed: "", hash: "", recipient: "", ethTxFailed: "" };
}

export const EventEthereumTx = {
  encode(message: EventEthereumTx, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.amount !== "") {
      writer.uint32(10).string(message.amount);
    }
    if (message.ethHash !== "") {
      writer.uint32(18).string(message.ethHash);
    }
    if (message.index !== "") {
      writer.uint32(26).string(message.index);
    }
    if (message.gasUsed !== "") {
      writer.uint32(34).string(message.gasUsed);
    }
    if (message.hash !== "") {
      writer.uint32(42).string(message.hash);
    }
    if (message.recipient !== "") {
      writer.uint32(50).string(message.recipient);
    }
    if (message.ethTxFailed !== "") {
      writer.uint32(58).string(message.ethTxFailed);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EventEthereumTx {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEventEthereumTx();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.amount = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.ethHash = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.index = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.gasUsed = reader.string();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.hash = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.recipient = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.ethTxFailed = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EventEthereumTx {
    return {
      amount: isSet(object.amount) ? globalThis.String(object.amount) : "",
      ethHash: isSet(object.ethHash) ? globalThis.String(object.ethHash) : "",
      index: isSet(object.index) ? globalThis.String(object.index) : "",
      gasUsed: isSet(object.gasUsed) ? globalThis.String(object.gasUsed) : "",
      hash: isSet(object.hash) ? globalThis.String(object.hash) : "",
      recipient: isSet(object.recipient) ? globalThis.String(object.recipient) : "",
      ethTxFailed: isSet(object.ethTxFailed) ? globalThis.String(object.ethTxFailed) : "",
    };
  },

  toJSON(message: EventEthereumTx): unknown {
    const obj: any = {};
    if (message.amount !== "") {
      obj.amount = message.amount;
    }
    if (message.ethHash !== "") {
      obj.ethHash = message.ethHash;
    }
    if (message.index !== "") {
      obj.index = message.index;
    }
    if (message.gasUsed !== "") {
      obj.gasUsed = message.gasUsed;
    }
    if (message.hash !== "") {
      obj.hash = message.hash;
    }
    if (message.recipient !== "") {
      obj.recipient = message.recipient;
    }
    if (message.ethTxFailed !== "") {
      obj.ethTxFailed = message.ethTxFailed;
    }
    return obj;
  },

  create(base?: DeepPartial<EventEthereumTx>): EventEthereumTx {
    return EventEthereumTx.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EventEthereumTx>): EventEthereumTx {
    const message = createBaseEventEthereumTx();
    message.amount = object.amount ?? "";
    message.ethHash = object.ethHash ?? "";
    message.index = object.index ?? "";
    message.gasUsed = object.gasUsed ?? "";
    message.hash = object.hash ?? "";
    message.recipient = object.recipient ?? "";
    message.ethTxFailed = object.ethTxFailed ?? "";
    return message;
  },
};

function createBaseEventTxLog(): EventTxLog {
  return { txLogs: [] };
}

export const EventTxLog = {
  encode(message: EventTxLog, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.txLogs) {
      writer.uint32(10).string(v!);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EventTxLog {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEventTxLog();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.txLogs.push(reader.string());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EventTxLog {
    return {
      txLogs: globalThis.Array.isArray(object?.txLogs) ? object.txLogs.map((e: any) => globalThis.String(e)) : [],
    };
  },

  toJSON(message: EventTxLog): unknown {
    const obj: any = {};
    if (message.txLogs?.length) {
      obj.txLogs = message.txLogs;
    }
    return obj;
  },

  create(base?: DeepPartial<EventTxLog>): EventTxLog {
    return EventTxLog.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EventTxLog>): EventTxLog {
    const message = createBaseEventTxLog();
    message.txLogs = object.txLogs?.map((e) => e) || [];
    return message;
  },
};

function createBaseEventMessage(): EventMessage {
  return { module: "", sender: "", txType: "" };
}

export const EventMessage = {
  encode(message: EventMessage, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.module !== "") {
      writer.uint32(10).string(message.module);
    }
    if (message.sender !== "") {
      writer.uint32(18).string(message.sender);
    }
    if (message.txType !== "") {
      writer.uint32(26).string(message.txType);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EventMessage {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEventMessage();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.module = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.sender = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.txType = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EventMessage {
    return {
      module: isSet(object.module) ? globalThis.String(object.module) : "",
      sender: isSet(object.sender) ? globalThis.String(object.sender) : "",
      txType: isSet(object.txType) ? globalThis.String(object.txType) : "",
    };
  },

  toJSON(message: EventMessage): unknown {
    const obj: any = {};
    if (message.module !== "") {
      obj.module = message.module;
    }
    if (message.sender !== "") {
      obj.sender = message.sender;
    }
    if (message.txType !== "") {
      obj.txType = message.txType;
    }
    return obj;
  },

  create(base?: DeepPartial<EventMessage>): EventMessage {
    return EventMessage.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EventMessage>): EventMessage {
    const message = createBaseEventMessage();
    message.module = object.module ?? "";
    message.sender = object.sender ?? "";
    message.txType = object.txType ?? "";
    return message;
  },
};

function createBaseEventBlockBloom(): EventBlockBloom {
  return { bloom: "" };
}

export const EventBlockBloom = {
  encode(message: EventBlockBloom, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.bloom !== "") {
      writer.uint32(10).string(message.bloom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EventBlockBloom {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEventBlockBloom();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.bloom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EventBlockBloom {
    return { bloom: isSet(object.bloom) ? globalThis.String(object.bloom) : "" };
  },

  toJSON(message: EventBlockBloom): unknown {
    const obj: any = {};
    if (message.bloom !== "") {
      obj.bloom = message.bloom;
    }
    return obj;
  },

  create(base?: DeepPartial<EventBlockBloom>): EventBlockBloom {
    return EventBlockBloom.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EventBlockBloom>): EventBlockBloom {
    const message = createBaseEventBlockBloom();
    message.bloom = object.bloom ?? "";
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
