// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: ethermint/evm/v1/evm.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";

export const protobufPackage = "ethermint.evm.v1";

/** Params defines the EVM module parameters */
export interface Params {
  /**
   * evm_denom represents the token denomination used to run the EVM state
   * transitions.
   */
  evmDenom: string;
  /** enable_create toggles state transitions that use the vm.Create function */
  enableCreate: boolean;
  /** enable_call toggles state transitions that use the vm.Call function */
  enableCall: boolean;
  /** extra_eips defines the additional EIPs for the vm.Config */
  extraEips: Long[];
  /** chain_config defines the EVM chain configuration parameters */
  chainConfig?:
    | ChainConfig
    | undefined;
  /** list of allowed eip712 msgs and their types */
  eip712AllowedMsgs: EIP712AllowedMsg[];
  /**
   * allow_unprotected_txs defines if replay-protected (i.e non EIP155
   * signed) transactions can be executed on the state machine.
   */
  allowUnprotectedTxs: boolean;
}

/**
 * ChainConfig defines the Ethereum ChainConfig parameters using *sdk.Int values
 * instead of *big.Int.
 */
export interface ChainConfig {
  /** homestead_block switch (nil no fork, 0 = already homestead) */
  homesteadBlock: string;
  /** dao_fork_block corresponds to TheDAO hard-fork switch block (nil no fork) */
  daoForkBlock: string;
  /** dao_fork_support defines whether the nodes supports or opposes the DAO hard-fork */
  daoForkSupport: boolean;
  /**
   * eip150_block: EIP150 implements the Gas price changes
   * (https://github.com/ethereum/EIPs/issues/150) EIP150 HF block (nil no fork)
   */
  eip150Block: string;
  /** eip150_hash: EIP150 HF hash (needed for header only clients as only gas pricing changed) */
  eip150Hash: string;
  /** eip155_block: EIP155Block HF block */
  eip155Block: string;
  /** eip158_block: EIP158 HF block */
  eip158Block: string;
  /** byzantium_block: Byzantium switch block (nil no fork, 0 = already on byzantium) */
  byzantiumBlock: string;
  /** constantinople_block: Constantinople switch block (nil no fork, 0 = already activated) */
  constantinopleBlock: string;
  /** petersburg_block: Petersburg switch block (nil same as Constantinople) */
  petersburgBlock: string;
  /** istanbul_block: Istanbul switch block (nil no fork, 0 = already on istanbul) */
  istanbulBlock: string;
  /** muir_glacier_block: Eip-2384 (bomb delay) switch block (nil no fork, 0 = already activated) */
  muirGlacierBlock: string;
  /** berlin_block: Berlin switch block (nil = no fork, 0 = already on berlin) */
  berlinBlock: string;
  /** london_block: London switch block (nil = no fork, 0 = already on london) */
  londonBlock: string;
  /** arrow_glacier_block: Eip-4345 (bomb delay) switch block (nil = no fork, 0 = already activated) */
  arrowGlacierBlock: string;
  /** gray_glacier_block: EIP-5133 (bomb delay) switch block (nil = no fork, 0 = already activated) */
  grayGlacierBlock: string;
  /** merge_netsplit_block: Virtual fork after The Merge to use as a network splitter */
  mergeNetsplitBlock: string;
  /** shanghai_block switch block (nil = no fork, 0 = already on shanghai) */
  shanghaiBlock: string;
  /** cancun_block switch block (nil = no fork, 0 = already on cancun) */
  cancunBlock: string;
}

/** State represents a single Storage key value pair item. */
export interface State {
  /** key is the stored key */
  key: string;
  /** value is the stored value for the given key */
  value: string;
}

/**
 * TransactionLogs define the logs generated from a transaction execution
 * with a given hash. It it used for import/export data as transactions are not
 * persisted on blockchain state after an upgrade.
 */
export interface TransactionLogs {
  /** hash of the transaction */
  hash: string;
  /** logs is an array of Logs for the given transaction hash */
  logs: Log[];
}

/**
 * Log represents an protobuf compatible Ethereum Log that defines a contract
 * log event. These events are generated by the LOG opcode and stored/indexed by
 * the node.
 *
 * NOTE: address, topics and data are consensus fields. The rest of the fields
 * are derived, i.e. filled in by the nodes, but not secured by consensus.
 */
export interface Log {
  /** address of the contract that generated the event */
  address: string;
  /** topics is a list of topics provided by the contract. */
  topics: string[];
  /** data which is supplied by the contract, usually ABI-encoded */
  data: Uint8Array;
  /** block_number of the block in which the transaction was included */
  blockNumber: Long;
  /** tx_hash is the transaction hash */
  txHash: string;
  /** tx_index of the transaction in the block */
  txIndex: Long;
  /** block_hash of the block in which the transaction was included */
  blockHash: string;
  /** index of the log in the block */
  index: Long;
  /**
   * removed is true if this log was reverted due to a chain
   * reorganisation. You must pay attention to this field if you receive logs
   * through a filter query.
   */
  removed: boolean;
}

/** TxResult stores results of Tx execution. */
export interface TxResult {
  /**
   * contract_address contains the ethereum address of the created contract (if
   * any). If the state transition is an evm.Call, the contract address will be
   * empty.
   */
  contractAddress: string;
  /** bloom represents the bloom filter bytes */
  bloom: Uint8Array;
  /**
   * tx_logs contains the transaction hash and the proto-compatible ethereum
   * logs.
   */
  txLogs?:
    | TransactionLogs
    | undefined;
  /** ret defines the bytes from the execution. */
  ret: Uint8Array;
  /** reverted flag is set to true when the call has been reverted */
  reverted: boolean;
  /** gas_used notes the amount of gas consumed while execution */
  gasUsed: Long;
}

/** AccessTuple is the element type of an access list. */
export interface AccessTuple {
  /** address is a hex formatted ethereum address */
  address: string;
  /** storage_keys are hex formatted hashes of the storage keys */
  storageKeys: string[];
}

/** TraceConfig holds extra parameters to trace functions. */
export interface TraceConfig {
  /** tracer is a custom javascript tracer */
  tracer: string;
  /**
   * timeout overrides the default timeout of 5 seconds for JavaScript-based tracing
   * calls
   */
  timeout: string;
  /** reexec defines the number of blocks the tracer is willing to go back */
  reexec: Long;
  /** disable_stack switches stack capture */
  disableStack: boolean;
  /** disable_storage switches storage capture */
  disableStorage: boolean;
  /** debug can be used to print output during capture end */
  debug: boolean;
  /** limit defines the maximum length of output, but zero means unlimited */
  limit: number;
  /** overrides can be used to execute a trace using future fork rules */
  overrides?:
    | ChainConfig
    | undefined;
  /** enable_memory switches memory capture */
  enableMemory: boolean;
  /** enable_return_data switches the capture of return data */
  enableReturnData: boolean;
  /** tracer_json_config configures the tracer using a JSON string */
  tracerJsonConfig: string;
}

/** EIP712AllowedMsg stores an allowed legacy msg and its eip712 type. */
export interface EIP712AllowedMsg {
  /** msg's proto type name. ie "/cosmos.bank.v1beta1.MsgSend" */
  msgTypeUrl: string;
  /** name of the eip712 value type. ie "MsgValueSend" */
  msgValueTypeName: string;
  /** types of the msg value */
  valueTypes: EIP712MsgAttrType[];
  /** nested types of the msg value */
  nestedTypes: EIP712NestedMsgType[];
}

/** EIP712MsgType is the eip712 type of a single message. */
export interface EIP712NestedMsgType {
  /** name of the nested type. ie "Fee", "Coin" */
  name: string;
  /** attrs of the nested type */
  attrs: EIP712MsgAttrType[];
}

/** EIP712MsgAttrType is the eip712 type of a single message attribute. */
export interface EIP712MsgAttrType {
  name: string;
  type: string;
}

function createBaseParams(): Params {
  return {
    evmDenom: "",
    enableCreate: false,
    enableCall: false,
    extraEips: [],
    chainConfig: undefined,
    eip712AllowedMsgs: [],
    allowUnprotectedTxs: false,
  };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.evmDenom !== "") {
      writer.uint32(10).string(message.evmDenom);
    }
    if (message.enableCreate !== false) {
      writer.uint32(16).bool(message.enableCreate);
    }
    if (message.enableCall !== false) {
      writer.uint32(24).bool(message.enableCall);
    }
    writer.uint32(34).fork();
    for (const v of message.extraEips) {
      writer.int64(v);
    }
    writer.ldelim();
    if (message.chainConfig !== undefined) {
      ChainConfig.encode(message.chainConfig, writer.uint32(42).fork()).ldelim();
    }
    for (const v of message.eip712AllowedMsgs) {
      EIP712AllowedMsg.encode(v!, writer.uint32(50).fork()).ldelim();
    }
    if (message.allowUnprotectedTxs !== false) {
      writer.uint32(56).bool(message.allowUnprotectedTxs);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.evmDenom = reader.string();
          continue;
        case 2:
          if (tag !== 16) {
            break;
          }

          message.enableCreate = reader.bool();
          continue;
        case 3:
          if (tag !== 24) {
            break;
          }

          message.enableCall = reader.bool();
          continue;
        case 4:
          if (tag === 32) {
            message.extraEips.push(reader.int64() as Long);

            continue;
          }

          if (tag === 34) {
            const end2 = reader.uint32() + reader.pos;
            while (reader.pos < end2) {
              message.extraEips.push(reader.int64() as Long);
            }

            continue;
          }

          break;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.chainConfig = ChainConfig.decode(reader, reader.uint32());
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.eip712AllowedMsgs.push(EIP712AllowedMsg.decode(reader, reader.uint32()));
          continue;
        case 7:
          if (tag !== 56) {
            break;
          }

          message.allowUnprotectedTxs = reader.bool();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      evmDenom: isSet(object.evmDenom) ? globalThis.String(object.evmDenom) : "",
      enableCreate: isSet(object.enableCreate) ? globalThis.Boolean(object.enableCreate) : false,
      enableCall: isSet(object.enableCall) ? globalThis.Boolean(object.enableCall) : false,
      extraEips: globalThis.Array.isArray(object?.extraEips) ? object.extraEips.map((e: any) => Long.fromValue(e)) : [],
      chainConfig: isSet(object.chainConfig) ? ChainConfig.fromJSON(object.chainConfig) : undefined,
      eip712AllowedMsgs: globalThis.Array.isArray(object?.eip712AllowedMsgs)
        ? object.eip712AllowedMsgs.map((e: any) => EIP712AllowedMsg.fromJSON(e))
        : [],
      allowUnprotectedTxs: isSet(object.allowUnprotectedTxs) ? globalThis.Boolean(object.allowUnprotectedTxs) : false,
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.evmDenom !== "") {
      obj.evmDenom = message.evmDenom;
    }
    if (message.enableCreate !== false) {
      obj.enableCreate = message.enableCreate;
    }
    if (message.enableCall !== false) {
      obj.enableCall = message.enableCall;
    }
    if (message.extraEips?.length) {
      obj.extraEips = message.extraEips.map((e) => (e || Long.ZERO).toString());
    }
    if (message.chainConfig !== undefined) {
      obj.chainConfig = ChainConfig.toJSON(message.chainConfig);
    }
    if (message.eip712AllowedMsgs?.length) {
      obj.eip712AllowedMsgs = message.eip712AllowedMsgs.map((e) => EIP712AllowedMsg.toJSON(e));
    }
    if (message.allowUnprotectedTxs !== false) {
      obj.allowUnprotectedTxs = message.allowUnprotectedTxs;
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.evmDenom = object.evmDenom ?? "";
    message.enableCreate = object.enableCreate ?? false;
    message.enableCall = object.enableCall ?? false;
    message.extraEips = object.extraEips?.map((e) => Long.fromValue(e)) || [];
    message.chainConfig = (object.chainConfig !== undefined && object.chainConfig !== null)
      ? ChainConfig.fromPartial(object.chainConfig)
      : undefined;
    message.eip712AllowedMsgs = object.eip712AllowedMsgs?.map((e) => EIP712AllowedMsg.fromPartial(e)) || [];
    message.allowUnprotectedTxs = object.allowUnprotectedTxs ?? false;
    return message;
  },
};

function createBaseChainConfig(): ChainConfig {
  return {
    homesteadBlock: "",
    daoForkBlock: "",
    daoForkSupport: false,
    eip150Block: "",
    eip150Hash: "",
    eip155Block: "",
    eip158Block: "",
    byzantiumBlock: "",
    constantinopleBlock: "",
    petersburgBlock: "",
    istanbulBlock: "",
    muirGlacierBlock: "",
    berlinBlock: "",
    londonBlock: "",
    arrowGlacierBlock: "",
    grayGlacierBlock: "",
    mergeNetsplitBlock: "",
    shanghaiBlock: "",
    cancunBlock: "",
  };
}

export const ChainConfig = {
  encode(message: ChainConfig, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.homesteadBlock !== "") {
      writer.uint32(10).string(message.homesteadBlock);
    }
    if (message.daoForkBlock !== "") {
      writer.uint32(18).string(message.daoForkBlock);
    }
    if (message.daoForkSupport !== false) {
      writer.uint32(24).bool(message.daoForkSupport);
    }
    if (message.eip150Block !== "") {
      writer.uint32(34).string(message.eip150Block);
    }
    if (message.eip150Hash !== "") {
      writer.uint32(42).string(message.eip150Hash);
    }
    if (message.eip155Block !== "") {
      writer.uint32(50).string(message.eip155Block);
    }
    if (message.eip158Block !== "") {
      writer.uint32(58).string(message.eip158Block);
    }
    if (message.byzantiumBlock !== "") {
      writer.uint32(66).string(message.byzantiumBlock);
    }
    if (message.constantinopleBlock !== "") {
      writer.uint32(74).string(message.constantinopleBlock);
    }
    if (message.petersburgBlock !== "") {
      writer.uint32(82).string(message.petersburgBlock);
    }
    if (message.istanbulBlock !== "") {
      writer.uint32(90).string(message.istanbulBlock);
    }
    if (message.muirGlacierBlock !== "") {
      writer.uint32(98).string(message.muirGlacierBlock);
    }
    if (message.berlinBlock !== "") {
      writer.uint32(106).string(message.berlinBlock);
    }
    if (message.londonBlock !== "") {
      writer.uint32(138).string(message.londonBlock);
    }
    if (message.arrowGlacierBlock !== "") {
      writer.uint32(146).string(message.arrowGlacierBlock);
    }
    if (message.grayGlacierBlock !== "") {
      writer.uint32(162).string(message.grayGlacierBlock);
    }
    if (message.mergeNetsplitBlock !== "") {
      writer.uint32(170).string(message.mergeNetsplitBlock);
    }
    if (message.shanghaiBlock !== "") {
      writer.uint32(178).string(message.shanghaiBlock);
    }
    if (message.cancunBlock !== "") {
      writer.uint32(186).string(message.cancunBlock);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): ChainConfig {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseChainConfig();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.homesteadBlock = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.daoForkBlock = reader.string();
          continue;
        case 3:
          if (tag !== 24) {
            break;
          }

          message.daoForkSupport = reader.bool();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.eip150Block = reader.string();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.eip150Hash = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.eip155Block = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.eip158Block = reader.string();
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.byzantiumBlock = reader.string();
          continue;
        case 9:
          if (tag !== 74) {
            break;
          }

          message.constantinopleBlock = reader.string();
          continue;
        case 10:
          if (tag !== 82) {
            break;
          }

          message.petersburgBlock = reader.string();
          continue;
        case 11:
          if (tag !== 90) {
            break;
          }

          message.istanbulBlock = reader.string();
          continue;
        case 12:
          if (tag !== 98) {
            break;
          }

          message.muirGlacierBlock = reader.string();
          continue;
        case 13:
          if (tag !== 106) {
            break;
          }

          message.berlinBlock = reader.string();
          continue;
        case 17:
          if (tag !== 138) {
            break;
          }

          message.londonBlock = reader.string();
          continue;
        case 18:
          if (tag !== 146) {
            break;
          }

          message.arrowGlacierBlock = reader.string();
          continue;
        case 20:
          if (tag !== 162) {
            break;
          }

          message.grayGlacierBlock = reader.string();
          continue;
        case 21:
          if (tag !== 170) {
            break;
          }

          message.mergeNetsplitBlock = reader.string();
          continue;
        case 22:
          if (tag !== 178) {
            break;
          }

          message.shanghaiBlock = reader.string();
          continue;
        case 23:
          if (tag !== 186) {
            break;
          }

          message.cancunBlock = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): ChainConfig {
    return {
      homesteadBlock: isSet(object.homesteadBlock) ? globalThis.String(object.homesteadBlock) : "",
      daoForkBlock: isSet(object.daoForkBlock) ? globalThis.String(object.daoForkBlock) : "",
      daoForkSupport: isSet(object.daoForkSupport) ? globalThis.Boolean(object.daoForkSupport) : false,
      eip150Block: isSet(object.eip150Block) ? globalThis.String(object.eip150Block) : "",
      eip150Hash: isSet(object.eip150Hash) ? globalThis.String(object.eip150Hash) : "",
      eip155Block: isSet(object.eip155Block) ? globalThis.String(object.eip155Block) : "",
      eip158Block: isSet(object.eip158Block) ? globalThis.String(object.eip158Block) : "",
      byzantiumBlock: isSet(object.byzantiumBlock) ? globalThis.String(object.byzantiumBlock) : "",
      constantinopleBlock: isSet(object.constantinopleBlock) ? globalThis.String(object.constantinopleBlock) : "",
      petersburgBlock: isSet(object.petersburgBlock) ? globalThis.String(object.petersburgBlock) : "",
      istanbulBlock: isSet(object.istanbulBlock) ? globalThis.String(object.istanbulBlock) : "",
      muirGlacierBlock: isSet(object.muirGlacierBlock) ? globalThis.String(object.muirGlacierBlock) : "",
      berlinBlock: isSet(object.berlinBlock) ? globalThis.String(object.berlinBlock) : "",
      londonBlock: isSet(object.londonBlock) ? globalThis.String(object.londonBlock) : "",
      arrowGlacierBlock: isSet(object.arrowGlacierBlock) ? globalThis.String(object.arrowGlacierBlock) : "",
      grayGlacierBlock: isSet(object.grayGlacierBlock) ? globalThis.String(object.grayGlacierBlock) : "",
      mergeNetsplitBlock: isSet(object.mergeNetsplitBlock) ? globalThis.String(object.mergeNetsplitBlock) : "",
      shanghaiBlock: isSet(object.shanghaiBlock) ? globalThis.String(object.shanghaiBlock) : "",
      cancunBlock: isSet(object.cancunBlock) ? globalThis.String(object.cancunBlock) : "",
    };
  },

  toJSON(message: ChainConfig): unknown {
    const obj: any = {};
    if (message.homesteadBlock !== "") {
      obj.homesteadBlock = message.homesteadBlock;
    }
    if (message.daoForkBlock !== "") {
      obj.daoForkBlock = message.daoForkBlock;
    }
    if (message.daoForkSupport !== false) {
      obj.daoForkSupport = message.daoForkSupport;
    }
    if (message.eip150Block !== "") {
      obj.eip150Block = message.eip150Block;
    }
    if (message.eip150Hash !== "") {
      obj.eip150Hash = message.eip150Hash;
    }
    if (message.eip155Block !== "") {
      obj.eip155Block = message.eip155Block;
    }
    if (message.eip158Block !== "") {
      obj.eip158Block = message.eip158Block;
    }
    if (message.byzantiumBlock !== "") {
      obj.byzantiumBlock = message.byzantiumBlock;
    }
    if (message.constantinopleBlock !== "") {
      obj.constantinopleBlock = message.constantinopleBlock;
    }
    if (message.petersburgBlock !== "") {
      obj.petersburgBlock = message.petersburgBlock;
    }
    if (message.istanbulBlock !== "") {
      obj.istanbulBlock = message.istanbulBlock;
    }
    if (message.muirGlacierBlock !== "") {
      obj.muirGlacierBlock = message.muirGlacierBlock;
    }
    if (message.berlinBlock !== "") {
      obj.berlinBlock = message.berlinBlock;
    }
    if (message.londonBlock !== "") {
      obj.londonBlock = message.londonBlock;
    }
    if (message.arrowGlacierBlock !== "") {
      obj.arrowGlacierBlock = message.arrowGlacierBlock;
    }
    if (message.grayGlacierBlock !== "") {
      obj.grayGlacierBlock = message.grayGlacierBlock;
    }
    if (message.mergeNetsplitBlock !== "") {
      obj.mergeNetsplitBlock = message.mergeNetsplitBlock;
    }
    if (message.shanghaiBlock !== "") {
      obj.shanghaiBlock = message.shanghaiBlock;
    }
    if (message.cancunBlock !== "") {
      obj.cancunBlock = message.cancunBlock;
    }
    return obj;
  },

  create(base?: DeepPartial<ChainConfig>): ChainConfig {
    return ChainConfig.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<ChainConfig>): ChainConfig {
    const message = createBaseChainConfig();
    message.homesteadBlock = object.homesteadBlock ?? "";
    message.daoForkBlock = object.daoForkBlock ?? "";
    message.daoForkSupport = object.daoForkSupport ?? false;
    message.eip150Block = object.eip150Block ?? "";
    message.eip150Hash = object.eip150Hash ?? "";
    message.eip155Block = object.eip155Block ?? "";
    message.eip158Block = object.eip158Block ?? "";
    message.byzantiumBlock = object.byzantiumBlock ?? "";
    message.constantinopleBlock = object.constantinopleBlock ?? "";
    message.petersburgBlock = object.petersburgBlock ?? "";
    message.istanbulBlock = object.istanbulBlock ?? "";
    message.muirGlacierBlock = object.muirGlacierBlock ?? "";
    message.berlinBlock = object.berlinBlock ?? "";
    message.londonBlock = object.londonBlock ?? "";
    message.arrowGlacierBlock = object.arrowGlacierBlock ?? "";
    message.grayGlacierBlock = object.grayGlacierBlock ?? "";
    message.mergeNetsplitBlock = object.mergeNetsplitBlock ?? "";
    message.shanghaiBlock = object.shanghaiBlock ?? "";
    message.cancunBlock = object.cancunBlock ?? "";
    return message;
  },
};

function createBaseState(): State {
  return { key: "", value: "" };
}

export const State = {
  encode(message: State, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.key !== "") {
      writer.uint32(10).string(message.key);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): State {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.key = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.value = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): State {
    return {
      key: isSet(object.key) ? globalThis.String(object.key) : "",
      value: isSet(object.value) ? globalThis.String(object.value) : "",
    };
  },

  toJSON(message: State): unknown {
    const obj: any = {};
    if (message.key !== "") {
      obj.key = message.key;
    }
    if (message.value !== "") {
      obj.value = message.value;
    }
    return obj;
  },

  create(base?: DeepPartial<State>): State {
    return State.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<State>): State {
    const message = createBaseState();
    message.key = object.key ?? "";
    message.value = object.value ?? "";
    return message;
  },
};

function createBaseTransactionLogs(): TransactionLogs {
  return { hash: "", logs: [] };
}

export const TransactionLogs = {
  encode(message: TransactionLogs, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.hash !== "") {
      writer.uint32(10).string(message.hash);
    }
    for (const v of message.logs) {
      Log.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): TransactionLogs {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseTransactionLogs();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.hash = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.logs.push(Log.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): TransactionLogs {
    return {
      hash: isSet(object.hash) ? globalThis.String(object.hash) : "",
      logs: globalThis.Array.isArray(object?.logs) ? object.logs.map((e: any) => Log.fromJSON(e)) : [],
    };
  },

  toJSON(message: TransactionLogs): unknown {
    const obj: any = {};
    if (message.hash !== "") {
      obj.hash = message.hash;
    }
    if (message.logs?.length) {
      obj.logs = message.logs.map((e) => Log.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<TransactionLogs>): TransactionLogs {
    return TransactionLogs.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<TransactionLogs>): TransactionLogs {
    const message = createBaseTransactionLogs();
    message.hash = object.hash ?? "";
    message.logs = object.logs?.map((e) => Log.fromPartial(e)) || [];
    return message;
  },
};

function createBaseLog(): Log {
  return {
    address: "",
    topics: [],
    data: new Uint8Array(0),
    blockNumber: Long.UZERO,
    txHash: "",
    txIndex: Long.UZERO,
    blockHash: "",
    index: Long.UZERO,
    removed: false,
  };
}

export const Log = {
  encode(message: Log, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.address !== "") {
      writer.uint32(10).string(message.address);
    }
    for (const v of message.topics) {
      writer.uint32(18).string(v!);
    }
    if (message.data.length !== 0) {
      writer.uint32(26).bytes(message.data);
    }
    if (!message.blockNumber.equals(Long.UZERO)) {
      writer.uint32(32).uint64(message.blockNumber);
    }
    if (message.txHash !== "") {
      writer.uint32(42).string(message.txHash);
    }
    if (!message.txIndex.equals(Long.UZERO)) {
      writer.uint32(48).uint64(message.txIndex);
    }
    if (message.blockHash !== "") {
      writer.uint32(58).string(message.blockHash);
    }
    if (!message.index.equals(Long.UZERO)) {
      writer.uint32(64).uint64(message.index);
    }
    if (message.removed !== false) {
      writer.uint32(72).bool(message.removed);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Log {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseLog();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.address = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.topics.push(reader.string());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.data = reader.bytes();
          continue;
        case 4:
          if (tag !== 32) {
            break;
          }

          message.blockNumber = reader.uint64() as Long;
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.txHash = reader.string();
          continue;
        case 6:
          if (tag !== 48) {
            break;
          }

          message.txIndex = reader.uint64() as Long;
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.blockHash = reader.string();
          continue;
        case 8:
          if (tag !== 64) {
            break;
          }

          message.index = reader.uint64() as Long;
          continue;
        case 9:
          if (tag !== 72) {
            break;
          }

          message.removed = reader.bool();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Log {
    return {
      address: isSet(object.address) ? globalThis.String(object.address) : "",
      topics: globalThis.Array.isArray(object?.topics) ? object.topics.map((e: any) => globalThis.String(e)) : [],
      data: isSet(object.data) ? bytesFromBase64(object.data) : new Uint8Array(0),
      blockNumber: isSet(object.blockNumber) ? Long.fromValue(object.blockNumber) : Long.UZERO,
      txHash: isSet(object.txHash) ? globalThis.String(object.txHash) : "",
      txIndex: isSet(object.txIndex) ? Long.fromValue(object.txIndex) : Long.UZERO,
      blockHash: isSet(object.blockHash) ? globalThis.String(object.blockHash) : "",
      index: isSet(object.index) ? Long.fromValue(object.index) : Long.UZERO,
      removed: isSet(object.removed) ? globalThis.Boolean(object.removed) : false,
    };
  },

  toJSON(message: Log): unknown {
    const obj: any = {};
    if (message.address !== "") {
      obj.address = message.address;
    }
    if (message.topics?.length) {
      obj.topics = message.topics;
    }
    if (message.data.length !== 0) {
      obj.data = base64FromBytes(message.data);
    }
    if (!message.blockNumber.equals(Long.UZERO)) {
      obj.blockNumber = (message.blockNumber || Long.UZERO).toString();
    }
    if (message.txHash !== "") {
      obj.txHash = message.txHash;
    }
    if (!message.txIndex.equals(Long.UZERO)) {
      obj.txIndex = (message.txIndex || Long.UZERO).toString();
    }
    if (message.blockHash !== "") {
      obj.blockHash = message.blockHash;
    }
    if (!message.index.equals(Long.UZERO)) {
      obj.index = (message.index || Long.UZERO).toString();
    }
    if (message.removed !== false) {
      obj.removed = message.removed;
    }
    return obj;
  },

  create(base?: DeepPartial<Log>): Log {
    return Log.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Log>): Log {
    const message = createBaseLog();
    message.address = object.address ?? "";
    message.topics = object.topics?.map((e) => e) || [];
    message.data = object.data ?? new Uint8Array(0);
    message.blockNumber = (object.blockNumber !== undefined && object.blockNumber !== null)
      ? Long.fromValue(object.blockNumber)
      : Long.UZERO;
    message.txHash = object.txHash ?? "";
    message.txIndex = (object.txIndex !== undefined && object.txIndex !== null)
      ? Long.fromValue(object.txIndex)
      : Long.UZERO;
    message.blockHash = object.blockHash ?? "";
    message.index = (object.index !== undefined && object.index !== null) ? Long.fromValue(object.index) : Long.UZERO;
    message.removed = object.removed ?? false;
    return message;
  },
};

function createBaseTxResult(): TxResult {
  return {
    contractAddress: "",
    bloom: new Uint8Array(0),
    txLogs: undefined,
    ret: new Uint8Array(0),
    reverted: false,
    gasUsed: Long.UZERO,
  };
}

export const TxResult = {
  encode(message: TxResult, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.contractAddress !== "") {
      writer.uint32(10).string(message.contractAddress);
    }
    if (message.bloom.length !== 0) {
      writer.uint32(18).bytes(message.bloom);
    }
    if (message.txLogs !== undefined) {
      TransactionLogs.encode(message.txLogs, writer.uint32(26).fork()).ldelim();
    }
    if (message.ret.length !== 0) {
      writer.uint32(34).bytes(message.ret);
    }
    if (message.reverted !== false) {
      writer.uint32(40).bool(message.reverted);
    }
    if (!message.gasUsed.equals(Long.UZERO)) {
      writer.uint32(48).uint64(message.gasUsed);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): TxResult {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseTxResult();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.contractAddress = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.bloom = reader.bytes();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.txLogs = TransactionLogs.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.ret = reader.bytes();
          continue;
        case 5:
          if (tag !== 40) {
            break;
          }

          message.reverted = reader.bool();
          continue;
        case 6:
          if (tag !== 48) {
            break;
          }

          message.gasUsed = reader.uint64() as Long;
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): TxResult {
    return {
      contractAddress: isSet(object.contractAddress) ? globalThis.String(object.contractAddress) : "",
      bloom: isSet(object.bloom) ? bytesFromBase64(object.bloom) : new Uint8Array(0),
      txLogs: isSet(object.txLogs) ? TransactionLogs.fromJSON(object.txLogs) : undefined,
      ret: isSet(object.ret) ? bytesFromBase64(object.ret) : new Uint8Array(0),
      reverted: isSet(object.reverted) ? globalThis.Boolean(object.reverted) : false,
      gasUsed: isSet(object.gasUsed) ? Long.fromValue(object.gasUsed) : Long.UZERO,
    };
  },

  toJSON(message: TxResult): unknown {
    const obj: any = {};
    if (message.contractAddress !== "") {
      obj.contractAddress = message.contractAddress;
    }
    if (message.bloom.length !== 0) {
      obj.bloom = base64FromBytes(message.bloom);
    }
    if (message.txLogs !== undefined) {
      obj.txLogs = TransactionLogs.toJSON(message.txLogs);
    }
    if (message.ret.length !== 0) {
      obj.ret = base64FromBytes(message.ret);
    }
    if (message.reverted !== false) {
      obj.reverted = message.reverted;
    }
    if (!message.gasUsed.equals(Long.UZERO)) {
      obj.gasUsed = (message.gasUsed || Long.UZERO).toString();
    }
    return obj;
  },

  create(base?: DeepPartial<TxResult>): TxResult {
    return TxResult.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<TxResult>): TxResult {
    const message = createBaseTxResult();
    message.contractAddress = object.contractAddress ?? "";
    message.bloom = object.bloom ?? new Uint8Array(0);
    message.txLogs = (object.txLogs !== undefined && object.txLogs !== null)
      ? TransactionLogs.fromPartial(object.txLogs)
      : undefined;
    message.ret = object.ret ?? new Uint8Array(0);
    message.reverted = object.reverted ?? false;
    message.gasUsed = (object.gasUsed !== undefined && object.gasUsed !== null)
      ? Long.fromValue(object.gasUsed)
      : Long.UZERO;
    return message;
  },
};

function createBaseAccessTuple(): AccessTuple {
  return { address: "", storageKeys: [] };
}

export const AccessTuple = {
  encode(message: AccessTuple, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.address !== "") {
      writer.uint32(10).string(message.address);
    }
    for (const v of message.storageKeys) {
      writer.uint32(18).string(v!);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AccessTuple {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAccessTuple();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.address = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.storageKeys.push(reader.string());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AccessTuple {
    return {
      address: isSet(object.address) ? globalThis.String(object.address) : "",
      storageKeys: globalThis.Array.isArray(object?.storageKeys)
        ? object.storageKeys.map((e: any) => globalThis.String(e))
        : [],
    };
  },

  toJSON(message: AccessTuple): unknown {
    const obj: any = {};
    if (message.address !== "") {
      obj.address = message.address;
    }
    if (message.storageKeys?.length) {
      obj.storageKeys = message.storageKeys;
    }
    return obj;
  },

  create(base?: DeepPartial<AccessTuple>): AccessTuple {
    return AccessTuple.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AccessTuple>): AccessTuple {
    const message = createBaseAccessTuple();
    message.address = object.address ?? "";
    message.storageKeys = object.storageKeys?.map((e) => e) || [];
    return message;
  },
};

function createBaseTraceConfig(): TraceConfig {
  return {
    tracer: "",
    timeout: "",
    reexec: Long.UZERO,
    disableStack: false,
    disableStorage: false,
    debug: false,
    limit: 0,
    overrides: undefined,
    enableMemory: false,
    enableReturnData: false,
    tracerJsonConfig: "",
  };
}

export const TraceConfig = {
  encode(message: TraceConfig, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.tracer !== "") {
      writer.uint32(10).string(message.tracer);
    }
    if (message.timeout !== "") {
      writer.uint32(18).string(message.timeout);
    }
    if (!message.reexec.equals(Long.UZERO)) {
      writer.uint32(24).uint64(message.reexec);
    }
    if (message.disableStack !== false) {
      writer.uint32(40).bool(message.disableStack);
    }
    if (message.disableStorage !== false) {
      writer.uint32(48).bool(message.disableStorage);
    }
    if (message.debug !== false) {
      writer.uint32(64).bool(message.debug);
    }
    if (message.limit !== 0) {
      writer.uint32(72).int32(message.limit);
    }
    if (message.overrides !== undefined) {
      ChainConfig.encode(message.overrides, writer.uint32(82).fork()).ldelim();
    }
    if (message.enableMemory !== false) {
      writer.uint32(88).bool(message.enableMemory);
    }
    if (message.enableReturnData !== false) {
      writer.uint32(96).bool(message.enableReturnData);
    }
    if (message.tracerJsonConfig !== "") {
      writer.uint32(106).string(message.tracerJsonConfig);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): TraceConfig {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseTraceConfig();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.tracer = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.timeout = reader.string();
          continue;
        case 3:
          if (tag !== 24) {
            break;
          }

          message.reexec = reader.uint64() as Long;
          continue;
        case 5:
          if (tag !== 40) {
            break;
          }

          message.disableStack = reader.bool();
          continue;
        case 6:
          if (tag !== 48) {
            break;
          }

          message.disableStorage = reader.bool();
          continue;
        case 8:
          if (tag !== 64) {
            break;
          }

          message.debug = reader.bool();
          continue;
        case 9:
          if (tag !== 72) {
            break;
          }

          message.limit = reader.int32();
          continue;
        case 10:
          if (tag !== 82) {
            break;
          }

          message.overrides = ChainConfig.decode(reader, reader.uint32());
          continue;
        case 11:
          if (tag !== 88) {
            break;
          }

          message.enableMemory = reader.bool();
          continue;
        case 12:
          if (tag !== 96) {
            break;
          }

          message.enableReturnData = reader.bool();
          continue;
        case 13:
          if (tag !== 106) {
            break;
          }

          message.tracerJsonConfig = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): TraceConfig {
    return {
      tracer: isSet(object.tracer) ? globalThis.String(object.tracer) : "",
      timeout: isSet(object.timeout) ? globalThis.String(object.timeout) : "",
      reexec: isSet(object.reexec) ? Long.fromValue(object.reexec) : Long.UZERO,
      disableStack: isSet(object.disableStack) ? globalThis.Boolean(object.disableStack) : false,
      disableStorage: isSet(object.disableStorage) ? globalThis.Boolean(object.disableStorage) : false,
      debug: isSet(object.debug) ? globalThis.Boolean(object.debug) : false,
      limit: isSet(object.limit) ? globalThis.Number(object.limit) : 0,
      overrides: isSet(object.overrides) ? ChainConfig.fromJSON(object.overrides) : undefined,
      enableMemory: isSet(object.enableMemory) ? globalThis.Boolean(object.enableMemory) : false,
      enableReturnData: isSet(object.enableReturnData) ? globalThis.Boolean(object.enableReturnData) : false,
      tracerJsonConfig: isSet(object.tracerJsonConfig) ? globalThis.String(object.tracerJsonConfig) : "",
    };
  },

  toJSON(message: TraceConfig): unknown {
    const obj: any = {};
    if (message.tracer !== "") {
      obj.tracer = message.tracer;
    }
    if (message.timeout !== "") {
      obj.timeout = message.timeout;
    }
    if (!message.reexec.equals(Long.UZERO)) {
      obj.reexec = (message.reexec || Long.UZERO).toString();
    }
    if (message.disableStack !== false) {
      obj.disableStack = message.disableStack;
    }
    if (message.disableStorage !== false) {
      obj.disableStorage = message.disableStorage;
    }
    if (message.debug !== false) {
      obj.debug = message.debug;
    }
    if (message.limit !== 0) {
      obj.limit = Math.round(message.limit);
    }
    if (message.overrides !== undefined) {
      obj.overrides = ChainConfig.toJSON(message.overrides);
    }
    if (message.enableMemory !== false) {
      obj.enableMemory = message.enableMemory;
    }
    if (message.enableReturnData !== false) {
      obj.enableReturnData = message.enableReturnData;
    }
    if (message.tracerJsonConfig !== "") {
      obj.tracerJsonConfig = message.tracerJsonConfig;
    }
    return obj;
  },

  create(base?: DeepPartial<TraceConfig>): TraceConfig {
    return TraceConfig.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<TraceConfig>): TraceConfig {
    const message = createBaseTraceConfig();
    message.tracer = object.tracer ?? "";
    message.timeout = object.timeout ?? "";
    message.reexec = (object.reexec !== undefined && object.reexec !== null)
      ? Long.fromValue(object.reexec)
      : Long.UZERO;
    message.disableStack = object.disableStack ?? false;
    message.disableStorage = object.disableStorage ?? false;
    message.debug = object.debug ?? false;
    message.limit = object.limit ?? 0;
    message.overrides = (object.overrides !== undefined && object.overrides !== null)
      ? ChainConfig.fromPartial(object.overrides)
      : undefined;
    message.enableMemory = object.enableMemory ?? false;
    message.enableReturnData = object.enableReturnData ?? false;
    message.tracerJsonConfig = object.tracerJsonConfig ?? "";
    return message;
  },
};

function createBaseEIP712AllowedMsg(): EIP712AllowedMsg {
  return { msgTypeUrl: "", msgValueTypeName: "", valueTypes: [], nestedTypes: [] };
}

export const EIP712AllowedMsg = {
  encode(message: EIP712AllowedMsg, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.msgTypeUrl !== "") {
      writer.uint32(10).string(message.msgTypeUrl);
    }
    if (message.msgValueTypeName !== "") {
      writer.uint32(18).string(message.msgValueTypeName);
    }
    for (const v of message.valueTypes) {
      EIP712MsgAttrType.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.nestedTypes) {
      EIP712NestedMsgType.encode(v!, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EIP712AllowedMsg {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEIP712AllowedMsg();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.msgTypeUrl = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.msgValueTypeName = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.valueTypes.push(EIP712MsgAttrType.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.nestedTypes.push(EIP712NestedMsgType.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EIP712AllowedMsg {
    return {
      msgTypeUrl: isSet(object.msgTypeUrl) ? globalThis.String(object.msgTypeUrl) : "",
      msgValueTypeName: isSet(object.msgValueTypeName) ? globalThis.String(object.msgValueTypeName) : "",
      valueTypes: globalThis.Array.isArray(object?.valueTypes)
        ? object.valueTypes.map((e: any) => EIP712MsgAttrType.fromJSON(e))
        : [],
      nestedTypes: globalThis.Array.isArray(object?.nestedTypes)
        ? object.nestedTypes.map((e: any) => EIP712NestedMsgType.fromJSON(e))
        : [],
    };
  },

  toJSON(message: EIP712AllowedMsg): unknown {
    const obj: any = {};
    if (message.msgTypeUrl !== "") {
      obj.msgTypeUrl = message.msgTypeUrl;
    }
    if (message.msgValueTypeName !== "") {
      obj.msgValueTypeName = message.msgValueTypeName;
    }
    if (message.valueTypes?.length) {
      obj.valueTypes = message.valueTypes.map((e) => EIP712MsgAttrType.toJSON(e));
    }
    if (message.nestedTypes?.length) {
      obj.nestedTypes = message.nestedTypes.map((e) => EIP712NestedMsgType.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<EIP712AllowedMsg>): EIP712AllowedMsg {
    return EIP712AllowedMsg.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EIP712AllowedMsg>): EIP712AllowedMsg {
    const message = createBaseEIP712AllowedMsg();
    message.msgTypeUrl = object.msgTypeUrl ?? "";
    message.msgValueTypeName = object.msgValueTypeName ?? "";
    message.valueTypes = object.valueTypes?.map((e) => EIP712MsgAttrType.fromPartial(e)) || [];
    message.nestedTypes = object.nestedTypes?.map((e) => EIP712NestedMsgType.fromPartial(e)) || [];
    return message;
  },
};

function createBaseEIP712NestedMsgType(): EIP712NestedMsgType {
  return { name: "", attrs: [] };
}

export const EIP712NestedMsgType = {
  encode(message: EIP712NestedMsgType, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    for (const v of message.attrs) {
      EIP712MsgAttrType.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EIP712NestedMsgType {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEIP712NestedMsgType();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.name = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.attrs.push(EIP712MsgAttrType.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EIP712NestedMsgType {
    return {
      name: isSet(object.name) ? globalThis.String(object.name) : "",
      attrs: globalThis.Array.isArray(object?.attrs) ? object.attrs.map((e: any) => EIP712MsgAttrType.fromJSON(e)) : [],
    };
  },

  toJSON(message: EIP712NestedMsgType): unknown {
    const obj: any = {};
    if (message.name !== "") {
      obj.name = message.name;
    }
    if (message.attrs?.length) {
      obj.attrs = message.attrs.map((e) => EIP712MsgAttrType.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<EIP712NestedMsgType>): EIP712NestedMsgType {
    return EIP712NestedMsgType.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EIP712NestedMsgType>): EIP712NestedMsgType {
    const message = createBaseEIP712NestedMsgType();
    message.name = object.name ?? "";
    message.attrs = object.attrs?.map((e) => EIP712MsgAttrType.fromPartial(e)) || [];
    return message;
  },
};

function createBaseEIP712MsgAttrType(): EIP712MsgAttrType {
  return { name: "", type: "" };
}

export const EIP712MsgAttrType = {
  encode(message: EIP712MsgAttrType, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    if (message.type !== "") {
      writer.uint32(18).string(message.type);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EIP712MsgAttrType {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEIP712MsgAttrType();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.name = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.type = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EIP712MsgAttrType {
    return {
      name: isSet(object.name) ? globalThis.String(object.name) : "",
      type: isSet(object.type) ? globalThis.String(object.type) : "",
    };
  },

  toJSON(message: EIP712MsgAttrType): unknown {
    const obj: any = {};
    if (message.name !== "") {
      obj.name = message.name;
    }
    if (message.type !== "") {
      obj.type = message.type;
    }
    return obj;
  },

  create(base?: DeepPartial<EIP712MsgAttrType>): EIP712MsgAttrType {
    return EIP712MsgAttrType.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EIP712MsgAttrType>): EIP712MsgAttrType {
    const message = createBaseEIP712MsgAttrType();
    message.name = object.name ?? "";
    message.type = object.type ?? "";
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
