// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/auction/v1beta1/auction.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";

export const protobufPackage = "kava.auction.v1beta1";

/** BaseAuction defines common attributes of all auctions */
export interface BaseAuction {
  id: Long;
  initiator: string;
  lot?: Coin | undefined;
  bidder: Uint8Array;
  bid?: Coin | undefined;
  hasReceivedBids: boolean;
  endTime?: Date | undefined;
  maxEndTime?: Date | undefined;
}

/**
 * SurplusAuction is a forward auction that burns what it receives from bids.
 * It is normally used to sell off excess pegged asset acquired by the CDP system.
 */
export interface SurplusAuction {
  baseAuction?: BaseAuction | undefined;
}

/**
 * DebtAuction is a reverse auction that mints what it pays out.
 * It is normally used to acquire pegged asset to cover the CDP system's debts that were not covered by selling
 * collateral.
 */
export interface DebtAuction {
  baseAuction?: BaseAuction | undefined;
  correspondingDebt?: Coin | undefined;
}

/**
 * CollateralAuction is a two phase auction.
 * Initially, in forward auction phase, bids can be placed up to a max bid.
 * Then it switches to a reverse auction phase, where the initial amount up for auction is bid down.
 * Unsold Lot is sent to LotReturns, being divided among the addresses by weight.
 * Collateral auctions are normally used to sell off collateral seized from CDPs.
 */
export interface CollateralAuction {
  baseAuction?: BaseAuction | undefined;
  correspondingDebt?: Coin | undefined;
  maxBid?: Coin | undefined;
  lotReturns?: WeightedAddresses | undefined;
}

/** WeightedAddresses is a type for storing some addresses and associated weights. */
export interface WeightedAddresses {
  addresses: Uint8Array[];
  weights: Uint8Array[];
}

function createBaseBaseAuction(): BaseAuction {
  return {
    id: Long.UZERO,
    initiator: "",
    lot: undefined,
    bidder: new Uint8Array(0),
    bid: undefined,
    hasReceivedBids: false,
    endTime: undefined,
    maxEndTime: undefined,
  };
}

export const BaseAuction = {
  encode(message: BaseAuction, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (!message.id.equals(Long.UZERO)) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.initiator !== "") {
      writer.uint32(18).string(message.initiator);
    }
    if (message.lot !== undefined) {
      Coin.encode(message.lot, writer.uint32(26).fork()).ldelim();
    }
    if (message.bidder.length !== 0) {
      writer.uint32(34).bytes(message.bidder);
    }
    if (message.bid !== undefined) {
      Coin.encode(message.bid, writer.uint32(42).fork()).ldelim();
    }
    if (message.hasReceivedBids !== false) {
      writer.uint32(48).bool(message.hasReceivedBids);
    }
    if (message.endTime !== undefined) {
      Timestamp.encode(toTimestamp(message.endTime), writer.uint32(58).fork()).ldelim();
    }
    if (message.maxEndTime !== undefined) {
      Timestamp.encode(toTimestamp(message.maxEndTime), writer.uint32(66).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BaseAuction {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseAuction();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.id = reader.uint64() as Long;
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.initiator = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.lot = Coin.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.bidder = reader.bytes();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.bid = Coin.decode(reader, reader.uint32());
          continue;
        case 6:
          if (tag !== 48) {
            break;
          }

          message.hasReceivedBids = reader.bool();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.endTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.maxEndTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BaseAuction {
    return {
      id: isSet(object.id) ? Long.fromValue(object.id) : Long.UZERO,
      initiator: isSet(object.initiator) ? globalThis.String(object.initiator) : "",
      lot: isSet(object.lot) ? Coin.fromJSON(object.lot) : undefined,
      bidder: isSet(object.bidder) ? bytesFromBase64(object.bidder) : new Uint8Array(0),
      bid: isSet(object.bid) ? Coin.fromJSON(object.bid) : undefined,
      hasReceivedBids: isSet(object.hasReceivedBids) ? globalThis.Boolean(object.hasReceivedBids) : false,
      endTime: isSet(object.endTime) ? fromJsonTimestamp(object.endTime) : undefined,
      maxEndTime: isSet(object.maxEndTime) ? fromJsonTimestamp(object.maxEndTime) : undefined,
    };
  },

  toJSON(message: BaseAuction): unknown {
    const obj: any = {};
    if (!message.id.equals(Long.UZERO)) {
      obj.id = (message.id || Long.UZERO).toString();
    }
    if (message.initiator !== "") {
      obj.initiator = message.initiator;
    }
    if (message.lot !== undefined) {
      obj.lot = Coin.toJSON(message.lot);
    }
    if (message.bidder.length !== 0) {
      obj.bidder = base64FromBytes(message.bidder);
    }
    if (message.bid !== undefined) {
      obj.bid = Coin.toJSON(message.bid);
    }
    if (message.hasReceivedBids !== false) {
      obj.hasReceivedBids = message.hasReceivedBids;
    }
    if (message.endTime !== undefined) {
      obj.endTime = message.endTime.toISOString();
    }
    if (message.maxEndTime !== undefined) {
      obj.maxEndTime = message.maxEndTime.toISOString();
    }
    return obj;
  },

  create(base?: DeepPartial<BaseAuction>): BaseAuction {
    return BaseAuction.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BaseAuction>): BaseAuction {
    const message = createBaseBaseAuction();
    message.id = (object.id !== undefined && object.id !== null) ? Long.fromValue(object.id) : Long.UZERO;
    message.initiator = object.initiator ?? "";
    message.lot = (object.lot !== undefined && object.lot !== null) ? Coin.fromPartial(object.lot) : undefined;
    message.bidder = object.bidder ?? new Uint8Array(0);
    message.bid = (object.bid !== undefined && object.bid !== null) ? Coin.fromPartial(object.bid) : undefined;
    message.hasReceivedBids = object.hasReceivedBids ?? false;
    message.endTime = object.endTime ?? undefined;
    message.maxEndTime = object.maxEndTime ?? undefined;
    return message;
  },
};

function createBaseSurplusAuction(): SurplusAuction {
  return { baseAuction: undefined };
}

export const SurplusAuction = {
  encode(message: SurplusAuction, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseAuction !== undefined) {
      BaseAuction.encode(message.baseAuction, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SurplusAuction {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSurplusAuction();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseAuction = BaseAuction.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SurplusAuction {
    return { baseAuction: isSet(object.baseAuction) ? BaseAuction.fromJSON(object.baseAuction) : undefined };
  },

  toJSON(message: SurplusAuction): unknown {
    const obj: any = {};
    if (message.baseAuction !== undefined) {
      obj.baseAuction = BaseAuction.toJSON(message.baseAuction);
    }
    return obj;
  },

  create(base?: DeepPartial<SurplusAuction>): SurplusAuction {
    return SurplusAuction.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<SurplusAuction>): SurplusAuction {
    const message = createBaseSurplusAuction();
    message.baseAuction = (object.baseAuction !== undefined && object.baseAuction !== null)
      ? BaseAuction.fromPartial(object.baseAuction)
      : undefined;
    return message;
  },
};

function createBaseDebtAuction(): DebtAuction {
  return { baseAuction: undefined, correspondingDebt: undefined };
}

export const DebtAuction = {
  encode(message: DebtAuction, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseAuction !== undefined) {
      BaseAuction.encode(message.baseAuction, writer.uint32(10).fork()).ldelim();
    }
    if (message.correspondingDebt !== undefined) {
      Coin.encode(message.correspondingDebt, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): DebtAuction {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDebtAuction();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseAuction = BaseAuction.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.correspondingDebt = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): DebtAuction {
    return {
      baseAuction: isSet(object.baseAuction) ? BaseAuction.fromJSON(object.baseAuction) : undefined,
      correspondingDebt: isSet(object.correspondingDebt) ? Coin.fromJSON(object.correspondingDebt) : undefined,
    };
  },

  toJSON(message: DebtAuction): unknown {
    const obj: any = {};
    if (message.baseAuction !== undefined) {
      obj.baseAuction = BaseAuction.toJSON(message.baseAuction);
    }
    if (message.correspondingDebt !== undefined) {
      obj.correspondingDebt = Coin.toJSON(message.correspondingDebt);
    }
    return obj;
  },

  create(base?: DeepPartial<DebtAuction>): DebtAuction {
    return DebtAuction.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<DebtAuction>): DebtAuction {
    const message = createBaseDebtAuction();
    message.baseAuction = (object.baseAuction !== undefined && object.baseAuction !== null)
      ? BaseAuction.fromPartial(object.baseAuction)
      : undefined;
    message.correspondingDebt = (object.correspondingDebt !== undefined && object.correspondingDebt !== null)
      ? Coin.fromPartial(object.correspondingDebt)
      : undefined;
    return message;
  },
};

function createBaseCollateralAuction(): CollateralAuction {
  return { baseAuction: undefined, correspondingDebt: undefined, maxBid: undefined, lotReturns: undefined };
}

export const CollateralAuction = {
  encode(message: CollateralAuction, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseAuction !== undefined) {
      BaseAuction.encode(message.baseAuction, writer.uint32(10).fork()).ldelim();
    }
    if (message.correspondingDebt !== undefined) {
      Coin.encode(message.correspondingDebt, writer.uint32(18).fork()).ldelim();
    }
    if (message.maxBid !== undefined) {
      Coin.encode(message.maxBid, writer.uint32(26).fork()).ldelim();
    }
    if (message.lotReturns !== undefined) {
      WeightedAddresses.encode(message.lotReturns, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CollateralAuction {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCollateralAuction();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseAuction = BaseAuction.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.correspondingDebt = Coin.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.maxBid = Coin.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.lotReturns = WeightedAddresses.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CollateralAuction {
    return {
      baseAuction: isSet(object.baseAuction) ? BaseAuction.fromJSON(object.baseAuction) : undefined,
      correspondingDebt: isSet(object.correspondingDebt) ? Coin.fromJSON(object.correspondingDebt) : undefined,
      maxBid: isSet(object.maxBid) ? Coin.fromJSON(object.maxBid) : undefined,
      lotReturns: isSet(object.lotReturns) ? WeightedAddresses.fromJSON(object.lotReturns) : undefined,
    };
  },

  toJSON(message: CollateralAuction): unknown {
    const obj: any = {};
    if (message.baseAuction !== undefined) {
      obj.baseAuction = BaseAuction.toJSON(message.baseAuction);
    }
    if (message.correspondingDebt !== undefined) {
      obj.correspondingDebt = Coin.toJSON(message.correspondingDebt);
    }
    if (message.maxBid !== undefined) {
      obj.maxBid = Coin.toJSON(message.maxBid);
    }
    if (message.lotReturns !== undefined) {
      obj.lotReturns = WeightedAddresses.toJSON(message.lotReturns);
    }
    return obj;
  },

  create(base?: DeepPartial<CollateralAuction>): CollateralAuction {
    return CollateralAuction.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CollateralAuction>): CollateralAuction {
    const message = createBaseCollateralAuction();
    message.baseAuction = (object.baseAuction !== undefined && object.baseAuction !== null)
      ? BaseAuction.fromPartial(object.baseAuction)
      : undefined;
    message.correspondingDebt = (object.correspondingDebt !== undefined && object.correspondingDebt !== null)
      ? Coin.fromPartial(object.correspondingDebt)
      : undefined;
    message.maxBid = (object.maxBid !== undefined && object.maxBid !== null)
      ? Coin.fromPartial(object.maxBid)
      : undefined;
    message.lotReturns = (object.lotReturns !== undefined && object.lotReturns !== null)
      ? WeightedAddresses.fromPartial(object.lotReturns)
      : undefined;
    return message;
  },
};

function createBaseWeightedAddresses(): WeightedAddresses {
  return { addresses: [], weights: [] };
}

export const WeightedAddresses = {
  encode(message: WeightedAddresses, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.addresses) {
      writer.uint32(10).bytes(v!);
    }
    for (const v of message.weights) {
      writer.uint32(18).bytes(v!);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): WeightedAddresses {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseWeightedAddresses();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.addresses.push(reader.bytes());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.weights.push(reader.bytes());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): WeightedAddresses {
    return {
      addresses: globalThis.Array.isArray(object?.addresses)
        ? object.addresses.map((e: any) => bytesFromBase64(e))
        : [],
      weights: globalThis.Array.isArray(object?.weights) ? object.weights.map((e: any) => bytesFromBase64(e)) : [],
    };
  },

  toJSON(message: WeightedAddresses): unknown {
    const obj: any = {};
    if (message.addresses?.length) {
      obj.addresses = message.addresses.map((e) => base64FromBytes(e));
    }
    if (message.weights?.length) {
      obj.weights = message.weights.map((e) => base64FromBytes(e));
    }
    return obj;
  },

  create(base?: DeepPartial<WeightedAddresses>): WeightedAddresses {
    return WeightedAddresses.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<WeightedAddresses>): WeightedAddresses {
    const message = createBaseWeightedAddresses();
    message.addresses = object.addresses?.map((e) => e) || [];
    message.weights = object.weights?.map((e) => e) || [];
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function toTimestamp(date: Date): Timestamp {
  const seconds = numberToLong(Math.trunc(date.getTime() / 1_000));
  const nanos = (date.getTime() % 1_000) * 1_000_000;
  return { seconds, nanos };
}

function fromTimestamp(t: Timestamp): Date {
  let millis = (t.seconds.toNumber() || 0) * 1_000;
  millis += (t.nanos || 0) / 1_000_000;
  return new globalThis.Date(millis);
}

function fromJsonTimestamp(o: any): Date {
  if (o instanceof globalThis.Date) {
    return o;
  } else if (typeof o === "string") {
    return new globalThis.Date(o);
  } else {
    return fromTimestamp(Timestamp.fromJSON(o));
  }
}

function numberToLong(number: number) {
  return Long.fromNumber(number);
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
