// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/bep3/v1beta1/bep3.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Duration } from "../../../google/protobuf/duration";

export const protobufPackage = "kava.bep3.v1beta1";

/** SwapStatus is the status of an AtomicSwap */
export enum SwapStatus {
  /** SWAP_STATUS_UNSPECIFIED - SWAP_STATUS_UNSPECIFIED represents an unspecified status */
  SWAP_STATUS_UNSPECIFIED = 0,
  /** SWAP_STATUS_OPEN - SWAP_STATUS_OPEN represents an open swap */
  SWAP_STATUS_OPEN = 1,
  /** SWAP_STATUS_COMPLETED - SWAP_STATUS_COMPLETED represents a completed swap */
  SWAP_STATUS_COMPLETED = 2,
  /** SWAP_STATUS_EXPIRED - SWAP_STATUS_EXPIRED represents an expired swap */
  SWAP_STATUS_EXPIRED = 3,
  UNRECOGNIZED = -1,
}

export function swapStatusFromJSON(object: any): SwapStatus {
  switch (object) {
    case 0:
    case "SWAP_STATUS_UNSPECIFIED":
      return SwapStatus.SWAP_STATUS_UNSPECIFIED;
    case 1:
    case "SWAP_STATUS_OPEN":
      return SwapStatus.SWAP_STATUS_OPEN;
    case 2:
    case "SWAP_STATUS_COMPLETED":
      return SwapStatus.SWAP_STATUS_COMPLETED;
    case 3:
    case "SWAP_STATUS_EXPIRED":
      return SwapStatus.SWAP_STATUS_EXPIRED;
    case -1:
    case "UNRECOGNIZED":
    default:
      return SwapStatus.UNRECOGNIZED;
  }
}

export function swapStatusToJSON(object: SwapStatus): string {
  switch (object) {
    case SwapStatus.SWAP_STATUS_UNSPECIFIED:
      return "SWAP_STATUS_UNSPECIFIED";
    case SwapStatus.SWAP_STATUS_OPEN:
      return "SWAP_STATUS_OPEN";
    case SwapStatus.SWAP_STATUS_COMPLETED:
      return "SWAP_STATUS_COMPLETED";
    case SwapStatus.SWAP_STATUS_EXPIRED:
      return "SWAP_STATUS_EXPIRED";
    case SwapStatus.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}

/** SwapDirection is the direction of an AtomicSwap */
export enum SwapDirection {
  /** SWAP_DIRECTION_UNSPECIFIED - SWAP_DIRECTION_UNSPECIFIED represents unspecified or invalid swap direcation */
  SWAP_DIRECTION_UNSPECIFIED = 0,
  /** SWAP_DIRECTION_INCOMING - SWAP_DIRECTION_INCOMING represents is incoming swap (to the kava chain) */
  SWAP_DIRECTION_INCOMING = 1,
  /** SWAP_DIRECTION_OUTGOING - SWAP_DIRECTION_OUTGOING represents an outgoing swap (from the kava chain) */
  SWAP_DIRECTION_OUTGOING = 2,
  UNRECOGNIZED = -1,
}

export function swapDirectionFromJSON(object: any): SwapDirection {
  switch (object) {
    case 0:
    case "SWAP_DIRECTION_UNSPECIFIED":
      return SwapDirection.SWAP_DIRECTION_UNSPECIFIED;
    case 1:
    case "SWAP_DIRECTION_INCOMING":
      return SwapDirection.SWAP_DIRECTION_INCOMING;
    case 2:
    case "SWAP_DIRECTION_OUTGOING":
      return SwapDirection.SWAP_DIRECTION_OUTGOING;
    case -1:
    case "UNRECOGNIZED":
    default:
      return SwapDirection.UNRECOGNIZED;
  }
}

export function swapDirectionToJSON(object: SwapDirection): string {
  switch (object) {
    case SwapDirection.SWAP_DIRECTION_UNSPECIFIED:
      return "SWAP_DIRECTION_UNSPECIFIED";
    case SwapDirection.SWAP_DIRECTION_INCOMING:
      return "SWAP_DIRECTION_INCOMING";
    case SwapDirection.SWAP_DIRECTION_OUTGOING:
      return "SWAP_DIRECTION_OUTGOING";
    case SwapDirection.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}

/** Params defines the parameters for the bep3 module. */
export interface Params {
  /** asset_params define the parameters for each bep3 asset */
  assetParams: AssetParam[];
}

/** AssetParam defines parameters for each bep3 asset. */
export interface AssetParam {
  /** denom represents the denominatin for this asset */
  denom: string;
  /** coin_id represents the registered coin type to use (https://github.com/satoshilabs/slips/blob/master/slip-0044.md) */
  coinId: Long;
  /** supply_limit defines the maximum supply allowed for the asset - a total or time based rate limit */
  supplyLimit?:
    | SupplyLimit
    | undefined;
  /** active specifies if the asset is live or paused */
  active: boolean;
  /** deputy_address the kava address of the deputy */
  deputyAddress: Uint8Array;
  /** fixed_fee defines the fee for incoming swaps */
  fixedFee: string;
  /** min_swap_amount defines the minimum amount able to be swapped in a single message */
  minSwapAmount: string;
  /** max_swap_amount defines the maximum amount able to be swapped in a single message */
  maxSwapAmount: string;
  /** min_block_lock defined the minimum blocks to lock */
  minBlockLock: Long;
  /** min_block_lock defined the maximum blocks to lock */
  maxBlockLock: Long;
}

/** SupplyLimit define the absolute and time-based limits for an assets's supply. */
export interface SupplyLimit {
  /** limit defines the total supply allowed */
  limit: string;
  /** time_limited enables or disables time based supply limiting */
  timeLimited: boolean;
  /** time_period specifies the duration that time_based_limit is evalulated */
  timePeriod?:
    | Duration
    | undefined;
  /** time_based_limit defines the maximum supply that can be swapped within time_period */
  timeBasedLimit: string;
}

/** AtomicSwap defines an atomic swap between chains for the pricefeed module. */
export interface AtomicSwap {
  /** amount represents the amount being swapped */
  amount: Coin[];
  /** random_number_hash represents the hash of the random number */
  randomNumberHash: Uint8Array;
  /** expire_height represents the height when the swap expires */
  expireHeight: Long;
  /** timestamp represents the timestamp of the swap */
  timestamp: Long;
  /** sender is the kava chain sender of the swap */
  sender: Uint8Array;
  /** recipient is the kava chain recipient of the swap */
  recipient: Uint8Array;
  /** sender_other_chain is the sender on the other chain */
  senderOtherChain: string;
  /** recipient_other_chain is the recipient on the other chain */
  recipientOtherChain: string;
  /** closed_block is the block when the swap is closed */
  closedBlock: Long;
  /** status represents the current status of the swap */
  status: SwapStatus;
  /** cross_chain identifies whether the atomic swap is cross chain */
  crossChain: boolean;
  /** direction identifies if the swap is incoming or outgoing */
  direction: SwapDirection;
}

/** AssetSupply defines information about an asset's supply. */
export interface AssetSupply {
  /** incoming_supply represents the incoming supply of an asset */
  incomingSupply?:
    | Coin
    | undefined;
  /** outgoing_supply represents the outgoing supply of an asset */
  outgoingSupply?:
    | Coin
    | undefined;
  /** current_supply represents the current on-chain supply of an asset */
  currentSupply?:
    | Coin
    | undefined;
  /** time_limited_current_supply represents the time limited current supply of an asset */
  timeLimitedCurrentSupply?:
    | Coin
    | undefined;
  /** time_elapsed represents the time elapsed */
  timeElapsed?: Duration | undefined;
}

function createBaseParams(): Params {
  return { assetParams: [] };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.assetParams) {
      AssetParam.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.assetParams.push(AssetParam.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      assetParams: globalThis.Array.isArray(object?.assetParams)
        ? object.assetParams.map((e: any) => AssetParam.fromJSON(e))
        : [],
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.assetParams?.length) {
      obj.assetParams = message.assetParams.map((e) => AssetParam.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.assetParams = object.assetParams?.map((e) => AssetParam.fromPartial(e)) || [];
    return message;
  },
};

function createBaseAssetParam(): AssetParam {
  return {
    denom: "",
    coinId: Long.ZERO,
    supplyLimit: undefined,
    active: false,
    deputyAddress: new Uint8Array(0),
    fixedFee: "",
    minSwapAmount: "",
    maxSwapAmount: "",
    minBlockLock: Long.UZERO,
    maxBlockLock: Long.UZERO,
  };
}

export const AssetParam = {
  encode(message: AssetParam, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (!message.coinId.equals(Long.ZERO)) {
      writer.uint32(16).int64(message.coinId);
    }
    if (message.supplyLimit !== undefined) {
      SupplyLimit.encode(message.supplyLimit, writer.uint32(26).fork()).ldelim();
    }
    if (message.active !== false) {
      writer.uint32(32).bool(message.active);
    }
    if (message.deputyAddress.length !== 0) {
      writer.uint32(42).bytes(message.deputyAddress);
    }
    if (message.fixedFee !== "") {
      writer.uint32(50).string(message.fixedFee);
    }
    if (message.minSwapAmount !== "") {
      writer.uint32(58).string(message.minSwapAmount);
    }
    if (message.maxSwapAmount !== "") {
      writer.uint32(66).string(message.maxSwapAmount);
    }
    if (!message.minBlockLock.equals(Long.UZERO)) {
      writer.uint32(72).uint64(message.minBlockLock);
    }
    if (!message.maxBlockLock.equals(Long.UZERO)) {
      writer.uint32(80).uint64(message.maxBlockLock);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AssetParam {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetParam();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 16) {
            break;
          }

          message.coinId = reader.int64() as Long;
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.supplyLimit = SupplyLimit.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 32) {
            break;
          }

          message.active = reader.bool();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.deputyAddress = reader.bytes();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.fixedFee = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.minSwapAmount = reader.string();
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.maxSwapAmount = reader.string();
          continue;
        case 9:
          if (tag !== 72) {
            break;
          }

          message.minBlockLock = reader.uint64() as Long;
          continue;
        case 10:
          if (tag !== 80) {
            break;
          }

          message.maxBlockLock = reader.uint64() as Long;
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AssetParam {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      coinId: isSet(object.coinId) ? Long.fromValue(object.coinId) : Long.ZERO,
      supplyLimit: isSet(object.supplyLimit) ? SupplyLimit.fromJSON(object.supplyLimit) : undefined,
      active: isSet(object.active) ? globalThis.Boolean(object.active) : false,
      deputyAddress: isSet(object.deputyAddress) ? bytesFromBase64(object.deputyAddress) : new Uint8Array(0),
      fixedFee: isSet(object.fixedFee) ? globalThis.String(object.fixedFee) : "",
      minSwapAmount: isSet(object.minSwapAmount) ? globalThis.String(object.minSwapAmount) : "",
      maxSwapAmount: isSet(object.maxSwapAmount) ? globalThis.String(object.maxSwapAmount) : "",
      minBlockLock: isSet(object.minBlockLock) ? Long.fromValue(object.minBlockLock) : Long.UZERO,
      maxBlockLock: isSet(object.maxBlockLock) ? Long.fromValue(object.maxBlockLock) : Long.UZERO,
    };
  },

  toJSON(message: AssetParam): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (!message.coinId.equals(Long.ZERO)) {
      obj.coinId = (message.coinId || Long.ZERO).toString();
    }
    if (message.supplyLimit !== undefined) {
      obj.supplyLimit = SupplyLimit.toJSON(message.supplyLimit);
    }
    if (message.active !== false) {
      obj.active = message.active;
    }
    if (message.deputyAddress.length !== 0) {
      obj.deputyAddress = base64FromBytes(message.deputyAddress);
    }
    if (message.fixedFee !== "") {
      obj.fixedFee = message.fixedFee;
    }
    if (message.minSwapAmount !== "") {
      obj.minSwapAmount = message.minSwapAmount;
    }
    if (message.maxSwapAmount !== "") {
      obj.maxSwapAmount = message.maxSwapAmount;
    }
    if (!message.minBlockLock.equals(Long.UZERO)) {
      obj.minBlockLock = (message.minBlockLock || Long.UZERO).toString();
    }
    if (!message.maxBlockLock.equals(Long.UZERO)) {
      obj.maxBlockLock = (message.maxBlockLock || Long.UZERO).toString();
    }
    return obj;
  },

  create(base?: DeepPartial<AssetParam>): AssetParam {
    return AssetParam.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AssetParam>): AssetParam {
    const message = createBaseAssetParam();
    message.denom = object.denom ?? "";
    message.coinId = (object.coinId !== undefined && object.coinId !== null)
      ? Long.fromValue(object.coinId)
      : Long.ZERO;
    message.supplyLimit = (object.supplyLimit !== undefined && object.supplyLimit !== null)
      ? SupplyLimit.fromPartial(object.supplyLimit)
      : undefined;
    message.active = object.active ?? false;
    message.deputyAddress = object.deputyAddress ?? new Uint8Array(0);
    message.fixedFee = object.fixedFee ?? "";
    message.minSwapAmount = object.minSwapAmount ?? "";
    message.maxSwapAmount = object.maxSwapAmount ?? "";
    message.minBlockLock = (object.minBlockLock !== undefined && object.minBlockLock !== null)
      ? Long.fromValue(object.minBlockLock)
      : Long.UZERO;
    message.maxBlockLock = (object.maxBlockLock !== undefined && object.maxBlockLock !== null)
      ? Long.fromValue(object.maxBlockLock)
      : Long.UZERO;
    return message;
  },
};

function createBaseSupplyLimit(): SupplyLimit {
  return { limit: "", timeLimited: false, timePeriod: undefined, timeBasedLimit: "" };
}

export const SupplyLimit = {
  encode(message: SupplyLimit, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.limit !== "") {
      writer.uint32(10).string(message.limit);
    }
    if (message.timeLimited !== false) {
      writer.uint32(16).bool(message.timeLimited);
    }
    if (message.timePeriod !== undefined) {
      Duration.encode(message.timePeriod, writer.uint32(26).fork()).ldelim();
    }
    if (message.timeBasedLimit !== "") {
      writer.uint32(34).string(message.timeBasedLimit);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SupplyLimit {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSupplyLimit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.limit = reader.string();
          continue;
        case 2:
          if (tag !== 16) {
            break;
          }

          message.timeLimited = reader.bool();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.timePeriod = Duration.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.timeBasedLimit = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SupplyLimit {
    return {
      limit: isSet(object.limit) ? globalThis.String(object.limit) : "",
      timeLimited: isSet(object.timeLimited) ? globalThis.Boolean(object.timeLimited) : false,
      timePeriod: isSet(object.timePeriod) ? Duration.fromJSON(object.timePeriod) : undefined,
      timeBasedLimit: isSet(object.timeBasedLimit) ? globalThis.String(object.timeBasedLimit) : "",
    };
  },

  toJSON(message: SupplyLimit): unknown {
    const obj: any = {};
    if (message.limit !== "") {
      obj.limit = message.limit;
    }
    if (message.timeLimited !== false) {
      obj.timeLimited = message.timeLimited;
    }
    if (message.timePeriod !== undefined) {
      obj.timePeriod = Duration.toJSON(message.timePeriod);
    }
    if (message.timeBasedLimit !== "") {
      obj.timeBasedLimit = message.timeBasedLimit;
    }
    return obj;
  },

  create(base?: DeepPartial<SupplyLimit>): SupplyLimit {
    return SupplyLimit.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<SupplyLimit>): SupplyLimit {
    const message = createBaseSupplyLimit();
    message.limit = object.limit ?? "";
    message.timeLimited = object.timeLimited ?? false;
    message.timePeriod = (object.timePeriod !== undefined && object.timePeriod !== null)
      ? Duration.fromPartial(object.timePeriod)
      : undefined;
    message.timeBasedLimit = object.timeBasedLimit ?? "";
    return message;
  },
};

function createBaseAtomicSwap(): AtomicSwap {
  return {
    amount: [],
    randomNumberHash: new Uint8Array(0),
    expireHeight: Long.UZERO,
    timestamp: Long.ZERO,
    sender: new Uint8Array(0),
    recipient: new Uint8Array(0),
    senderOtherChain: "",
    recipientOtherChain: "",
    closedBlock: Long.ZERO,
    status: 0,
    crossChain: false,
    direction: 0,
  };
}

export const AtomicSwap = {
  encode(message: AtomicSwap, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.randomNumberHash.length !== 0) {
      writer.uint32(18).bytes(message.randomNumberHash);
    }
    if (!message.expireHeight.equals(Long.UZERO)) {
      writer.uint32(24).uint64(message.expireHeight);
    }
    if (!message.timestamp.equals(Long.ZERO)) {
      writer.uint32(32).int64(message.timestamp);
    }
    if (message.sender.length !== 0) {
      writer.uint32(42).bytes(message.sender);
    }
    if (message.recipient.length !== 0) {
      writer.uint32(50).bytes(message.recipient);
    }
    if (message.senderOtherChain !== "") {
      writer.uint32(58).string(message.senderOtherChain);
    }
    if (message.recipientOtherChain !== "") {
      writer.uint32(66).string(message.recipientOtherChain);
    }
    if (!message.closedBlock.equals(Long.ZERO)) {
      writer.uint32(72).int64(message.closedBlock);
    }
    if (message.status !== 0) {
      writer.uint32(80).int32(message.status);
    }
    if (message.crossChain !== false) {
      writer.uint32(88).bool(message.crossChain);
    }
    if (message.direction !== 0) {
      writer.uint32(96).int32(message.direction);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AtomicSwap {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAtomicSwap();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.randomNumberHash = reader.bytes();
          continue;
        case 3:
          if (tag !== 24) {
            break;
          }

          message.expireHeight = reader.uint64() as Long;
          continue;
        case 4:
          if (tag !== 32) {
            break;
          }

          message.timestamp = reader.int64() as Long;
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.sender = reader.bytes();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.recipient = reader.bytes();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.senderOtherChain = reader.string();
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.recipientOtherChain = reader.string();
          continue;
        case 9:
          if (tag !== 72) {
            break;
          }

          message.closedBlock = reader.int64() as Long;
          continue;
        case 10:
          if (tag !== 80) {
            break;
          }

          message.status = reader.int32() as any;
          continue;
        case 11:
          if (tag !== 88) {
            break;
          }

          message.crossChain = reader.bool();
          continue;
        case 12:
          if (tag !== 96) {
            break;
          }

          message.direction = reader.int32() as any;
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AtomicSwap {
    return {
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
      randomNumberHash: isSet(object.randomNumberHash) ? bytesFromBase64(object.randomNumberHash) : new Uint8Array(0),
      expireHeight: isSet(object.expireHeight) ? Long.fromValue(object.expireHeight) : Long.UZERO,
      timestamp: isSet(object.timestamp) ? Long.fromValue(object.timestamp) : Long.ZERO,
      sender: isSet(object.sender) ? bytesFromBase64(object.sender) : new Uint8Array(0),
      recipient: isSet(object.recipient) ? bytesFromBase64(object.recipient) : new Uint8Array(0),
      senderOtherChain: isSet(object.senderOtherChain) ? globalThis.String(object.senderOtherChain) : "",
      recipientOtherChain: isSet(object.recipientOtherChain) ? globalThis.String(object.recipientOtherChain) : "",
      closedBlock: isSet(object.closedBlock) ? Long.fromValue(object.closedBlock) : Long.ZERO,
      status: isSet(object.status) ? swapStatusFromJSON(object.status) : 0,
      crossChain: isSet(object.crossChain) ? globalThis.Boolean(object.crossChain) : false,
      direction: isSet(object.direction) ? swapDirectionFromJSON(object.direction) : 0,
    };
  },

  toJSON(message: AtomicSwap): unknown {
    const obj: any = {};
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    if (message.randomNumberHash.length !== 0) {
      obj.randomNumberHash = base64FromBytes(message.randomNumberHash);
    }
    if (!message.expireHeight.equals(Long.UZERO)) {
      obj.expireHeight = (message.expireHeight || Long.UZERO).toString();
    }
    if (!message.timestamp.equals(Long.ZERO)) {
      obj.timestamp = (message.timestamp || Long.ZERO).toString();
    }
    if (message.sender.length !== 0) {
      obj.sender = base64FromBytes(message.sender);
    }
    if (message.recipient.length !== 0) {
      obj.recipient = base64FromBytes(message.recipient);
    }
    if (message.senderOtherChain !== "") {
      obj.senderOtherChain = message.senderOtherChain;
    }
    if (message.recipientOtherChain !== "") {
      obj.recipientOtherChain = message.recipientOtherChain;
    }
    if (!message.closedBlock.equals(Long.ZERO)) {
      obj.closedBlock = (message.closedBlock || Long.ZERO).toString();
    }
    if (message.status !== 0) {
      obj.status = swapStatusToJSON(message.status);
    }
    if (message.crossChain !== false) {
      obj.crossChain = message.crossChain;
    }
    if (message.direction !== 0) {
      obj.direction = swapDirectionToJSON(message.direction);
    }
    return obj;
  },

  create(base?: DeepPartial<AtomicSwap>): AtomicSwap {
    return AtomicSwap.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AtomicSwap>): AtomicSwap {
    const message = createBaseAtomicSwap();
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    message.randomNumberHash = object.randomNumberHash ?? new Uint8Array(0);
    message.expireHeight = (object.expireHeight !== undefined && object.expireHeight !== null)
      ? Long.fromValue(object.expireHeight)
      : Long.UZERO;
    message.timestamp = (object.timestamp !== undefined && object.timestamp !== null)
      ? Long.fromValue(object.timestamp)
      : Long.ZERO;
    message.sender = object.sender ?? new Uint8Array(0);
    message.recipient = object.recipient ?? new Uint8Array(0);
    message.senderOtherChain = object.senderOtherChain ?? "";
    message.recipientOtherChain = object.recipientOtherChain ?? "";
    message.closedBlock = (object.closedBlock !== undefined && object.closedBlock !== null)
      ? Long.fromValue(object.closedBlock)
      : Long.ZERO;
    message.status = object.status ?? 0;
    message.crossChain = object.crossChain ?? false;
    message.direction = object.direction ?? 0;
    return message;
  },
};

function createBaseAssetSupply(): AssetSupply {
  return {
    incomingSupply: undefined,
    outgoingSupply: undefined,
    currentSupply: undefined,
    timeLimitedCurrentSupply: undefined,
    timeElapsed: undefined,
  };
}

export const AssetSupply = {
  encode(message: AssetSupply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.incomingSupply !== undefined) {
      Coin.encode(message.incomingSupply, writer.uint32(10).fork()).ldelim();
    }
    if (message.outgoingSupply !== undefined) {
      Coin.encode(message.outgoingSupply, writer.uint32(18).fork()).ldelim();
    }
    if (message.currentSupply !== undefined) {
      Coin.encode(message.currentSupply, writer.uint32(26).fork()).ldelim();
    }
    if (message.timeLimitedCurrentSupply !== undefined) {
      Coin.encode(message.timeLimitedCurrentSupply, writer.uint32(34).fork()).ldelim();
    }
    if (message.timeElapsed !== undefined) {
      Duration.encode(message.timeElapsed, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AssetSupply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetSupply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.incomingSupply = Coin.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.outgoingSupply = Coin.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.currentSupply = Coin.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.timeLimitedCurrentSupply = Coin.decode(reader, reader.uint32());
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.timeElapsed = Duration.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AssetSupply {
    return {
      incomingSupply: isSet(object.incomingSupply) ? Coin.fromJSON(object.incomingSupply) : undefined,
      outgoingSupply: isSet(object.outgoingSupply) ? Coin.fromJSON(object.outgoingSupply) : undefined,
      currentSupply: isSet(object.currentSupply) ? Coin.fromJSON(object.currentSupply) : undefined,
      timeLimitedCurrentSupply: isSet(object.timeLimitedCurrentSupply)
        ? Coin.fromJSON(object.timeLimitedCurrentSupply)
        : undefined,
      timeElapsed: isSet(object.timeElapsed) ? Duration.fromJSON(object.timeElapsed) : undefined,
    };
  },

  toJSON(message: AssetSupply): unknown {
    const obj: any = {};
    if (message.incomingSupply !== undefined) {
      obj.incomingSupply = Coin.toJSON(message.incomingSupply);
    }
    if (message.outgoingSupply !== undefined) {
      obj.outgoingSupply = Coin.toJSON(message.outgoingSupply);
    }
    if (message.currentSupply !== undefined) {
      obj.currentSupply = Coin.toJSON(message.currentSupply);
    }
    if (message.timeLimitedCurrentSupply !== undefined) {
      obj.timeLimitedCurrentSupply = Coin.toJSON(message.timeLimitedCurrentSupply);
    }
    if (message.timeElapsed !== undefined) {
      obj.timeElapsed = Duration.toJSON(message.timeElapsed);
    }
    return obj;
  },

  create(base?: DeepPartial<AssetSupply>): AssetSupply {
    return AssetSupply.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AssetSupply>): AssetSupply {
    const message = createBaseAssetSupply();
    message.incomingSupply = (object.incomingSupply !== undefined && object.incomingSupply !== null)
      ? Coin.fromPartial(object.incomingSupply)
      : undefined;
    message.outgoingSupply = (object.outgoingSupply !== undefined && object.outgoingSupply !== null)
      ? Coin.fromPartial(object.outgoingSupply)
      : undefined;
    message.currentSupply = (object.currentSupply !== undefined && object.currentSupply !== null)
      ? Coin.fromPartial(object.currentSupply)
      : undefined;
    message.timeLimitedCurrentSupply =
      (object.timeLimitedCurrentSupply !== undefined && object.timeLimitedCurrentSupply !== null)
        ? Coin.fromPartial(object.timeLimitedCurrentSupply)
        : undefined;
    message.timeElapsed = (object.timeElapsed !== undefined && object.timeElapsed !== null)
      ? Duration.fromPartial(object.timeElapsed)
      : undefined;
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
