// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/cdp/v1beta1/genesis.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";
import { CDP, Deposit } from "./cdp";

export const protobufPackage = "kava.cdp.v1beta1";

/** GenesisState defines the cdp module's genesis state. */
export interface GenesisState {
  /** params defines all the paramaters of the module. */
  params?: Params | undefined;
  cdps: CDP[];
  deposits: Deposit[];
  startingCdpId: Long;
  debtDenom: string;
  govDenom: string;
  previousAccumulationTimes: GenesisAccumulationTime[];
  totalPrincipals: GenesisTotalPrincipal[];
}

/** Params defines the parameters for the cdp module. */
export interface Params {
  collateralParams: CollateralParam[];
  debtParam?: DebtParam | undefined;
  globalDebtLimit?: Coin | undefined;
  surplusAuctionThreshold: string;
  surplusAuctionLot: string;
  debtAuctionThreshold: string;
  debtAuctionLot: string;
  circuitBreaker: boolean;
}

/** DebtParam defines governance params for debt assets */
export interface DebtParam {
  denom: string;
  referenceAsset: string;
  conversionFactor: string;
  debtFloor: string;
}

/** CollateralParam defines governance parameters for each collateral type within the cdp module */
export interface CollateralParam {
  denom: string;
  type: string;
  liquidationRatio: string;
  debtLimit?: Coin | undefined;
  stabilityFee: string;
  auctionSize: string;
  liquidationPenalty: string;
  spotMarketId: string;
  liquidationMarketId: string;
  keeperRewardPercentage: string;
  checkCollateralizationIndexCount: string;
  conversionFactor: string;
}

/** GenesisAccumulationTime defines the previous distribution time and its corresponding denom */
export interface GenesisAccumulationTime {
  collateralType: string;
  previousAccumulationTime?: Date | undefined;
  interestFactor: string;
}

/** GenesisTotalPrincipal defines the total principal and its corresponding collateral type */
export interface GenesisTotalPrincipal {
  collateralType: string;
  totalPrincipal: string;
}

function createBaseGenesisState(): GenesisState {
  return {
    params: undefined,
    cdps: [],
    deposits: [],
    startingCdpId: Long.UZERO,
    debtDenom: "",
    govDenom: "",
    previousAccumulationTimes: [],
    totalPrincipals: [],
  };
}

export const GenesisState = {
  encode(message: GenesisState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.cdps) {
      CDP.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.deposits) {
      Deposit.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    if (!message.startingCdpId.equals(Long.UZERO)) {
      writer.uint32(32).uint64(message.startingCdpId);
    }
    if (message.debtDenom !== "") {
      writer.uint32(42).string(message.debtDenom);
    }
    if (message.govDenom !== "") {
      writer.uint32(50).string(message.govDenom);
    }
    for (const v of message.previousAccumulationTimes) {
      GenesisAccumulationTime.encode(v!, writer.uint32(58).fork()).ldelim();
    }
    for (const v of message.totalPrincipals) {
      GenesisTotalPrincipal.encode(v!, writer.uint32(66).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.cdps.push(CDP.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.deposits.push(Deposit.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 32) {
            break;
          }

          message.startingCdpId = reader.uint64() as Long;
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.debtDenom = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.govDenom = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.previousAccumulationTimes.push(GenesisAccumulationTime.decode(reader, reader.uint32()));
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.totalPrincipals.push(GenesisTotalPrincipal.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisState {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      cdps: globalThis.Array.isArray(object?.cdps) ? object.cdps.map((e: any) => CDP.fromJSON(e)) : [],
      deposits: globalThis.Array.isArray(object?.deposits) ? object.deposits.map((e: any) => Deposit.fromJSON(e)) : [],
      startingCdpId: isSet(object.startingCdpId) ? Long.fromValue(object.startingCdpId) : Long.UZERO,
      debtDenom: isSet(object.debtDenom) ? globalThis.String(object.debtDenom) : "",
      govDenom: isSet(object.govDenom) ? globalThis.String(object.govDenom) : "",
      previousAccumulationTimes: globalThis.Array.isArray(object?.previousAccumulationTimes)
        ? object.previousAccumulationTimes.map((e: any) => GenesisAccumulationTime.fromJSON(e))
        : [],
      totalPrincipals: globalThis.Array.isArray(object?.totalPrincipals)
        ? object.totalPrincipals.map((e: any) => GenesisTotalPrincipal.fromJSON(e))
        : [],
    };
  },

  toJSON(message: GenesisState): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    if (message.cdps?.length) {
      obj.cdps = message.cdps.map((e) => CDP.toJSON(e));
    }
    if (message.deposits?.length) {
      obj.deposits = message.deposits.map((e) => Deposit.toJSON(e));
    }
    if (!message.startingCdpId.equals(Long.UZERO)) {
      obj.startingCdpId = (message.startingCdpId || Long.UZERO).toString();
    }
    if (message.debtDenom !== "") {
      obj.debtDenom = message.debtDenom;
    }
    if (message.govDenom !== "") {
      obj.govDenom = message.govDenom;
    }
    if (message.previousAccumulationTimes?.length) {
      obj.previousAccumulationTimes = message.previousAccumulationTimes.map((e) => GenesisAccumulationTime.toJSON(e));
    }
    if (message.totalPrincipals?.length) {
      obj.totalPrincipals = message.totalPrincipals.map((e) => GenesisTotalPrincipal.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisState>): GenesisState {
    return GenesisState.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisState>): GenesisState {
    const message = createBaseGenesisState();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    message.cdps = object.cdps?.map((e) => CDP.fromPartial(e)) || [];
    message.deposits = object.deposits?.map((e) => Deposit.fromPartial(e)) || [];
    message.startingCdpId = (object.startingCdpId !== undefined && object.startingCdpId !== null)
      ? Long.fromValue(object.startingCdpId)
      : Long.UZERO;
    message.debtDenom = object.debtDenom ?? "";
    message.govDenom = object.govDenom ?? "";
    message.previousAccumulationTimes =
      object.previousAccumulationTimes?.map((e) => GenesisAccumulationTime.fromPartial(e)) || [];
    message.totalPrincipals = object.totalPrincipals?.map((e) => GenesisTotalPrincipal.fromPartial(e)) || [];
    return message;
  },
};

function createBaseParams(): Params {
  return {
    collateralParams: [],
    debtParam: undefined,
    globalDebtLimit: undefined,
    surplusAuctionThreshold: "",
    surplusAuctionLot: "",
    debtAuctionThreshold: "",
    debtAuctionLot: "",
    circuitBreaker: false,
  };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.collateralParams) {
      CollateralParam.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.debtParam !== undefined) {
      DebtParam.encode(message.debtParam, writer.uint32(18).fork()).ldelim();
    }
    if (message.globalDebtLimit !== undefined) {
      Coin.encode(message.globalDebtLimit, writer.uint32(26).fork()).ldelim();
    }
    if (message.surplusAuctionThreshold !== "") {
      writer.uint32(34).string(message.surplusAuctionThreshold);
    }
    if (message.surplusAuctionLot !== "") {
      writer.uint32(42).string(message.surplusAuctionLot);
    }
    if (message.debtAuctionThreshold !== "") {
      writer.uint32(50).string(message.debtAuctionThreshold);
    }
    if (message.debtAuctionLot !== "") {
      writer.uint32(58).string(message.debtAuctionLot);
    }
    if (message.circuitBreaker !== false) {
      writer.uint32(64).bool(message.circuitBreaker);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralParams.push(CollateralParam.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.debtParam = DebtParam.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.globalDebtLimit = Coin.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.surplusAuctionThreshold = reader.string();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.surplusAuctionLot = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.debtAuctionThreshold = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.debtAuctionLot = reader.string();
          continue;
        case 8:
          if (tag !== 64) {
            break;
          }

          message.circuitBreaker = reader.bool();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      collateralParams: globalThis.Array.isArray(object?.collateralParams)
        ? object.collateralParams.map((e: any) => CollateralParam.fromJSON(e))
        : [],
      debtParam: isSet(object.debtParam) ? DebtParam.fromJSON(object.debtParam) : undefined,
      globalDebtLimit: isSet(object.globalDebtLimit) ? Coin.fromJSON(object.globalDebtLimit) : undefined,
      surplusAuctionThreshold: isSet(object.surplusAuctionThreshold)
        ? globalThis.String(object.surplusAuctionThreshold)
        : "",
      surplusAuctionLot: isSet(object.surplusAuctionLot) ? globalThis.String(object.surplusAuctionLot) : "",
      debtAuctionThreshold: isSet(object.debtAuctionThreshold) ? globalThis.String(object.debtAuctionThreshold) : "",
      debtAuctionLot: isSet(object.debtAuctionLot) ? globalThis.String(object.debtAuctionLot) : "",
      circuitBreaker: isSet(object.circuitBreaker) ? globalThis.Boolean(object.circuitBreaker) : false,
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.collateralParams?.length) {
      obj.collateralParams = message.collateralParams.map((e) => CollateralParam.toJSON(e));
    }
    if (message.debtParam !== undefined) {
      obj.debtParam = DebtParam.toJSON(message.debtParam);
    }
    if (message.globalDebtLimit !== undefined) {
      obj.globalDebtLimit = Coin.toJSON(message.globalDebtLimit);
    }
    if (message.surplusAuctionThreshold !== "") {
      obj.surplusAuctionThreshold = message.surplusAuctionThreshold;
    }
    if (message.surplusAuctionLot !== "") {
      obj.surplusAuctionLot = message.surplusAuctionLot;
    }
    if (message.debtAuctionThreshold !== "") {
      obj.debtAuctionThreshold = message.debtAuctionThreshold;
    }
    if (message.debtAuctionLot !== "") {
      obj.debtAuctionLot = message.debtAuctionLot;
    }
    if (message.circuitBreaker !== false) {
      obj.circuitBreaker = message.circuitBreaker;
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.collateralParams = object.collateralParams?.map((e) => CollateralParam.fromPartial(e)) || [];
    message.debtParam = (object.debtParam !== undefined && object.debtParam !== null)
      ? DebtParam.fromPartial(object.debtParam)
      : undefined;
    message.globalDebtLimit = (object.globalDebtLimit !== undefined && object.globalDebtLimit !== null)
      ? Coin.fromPartial(object.globalDebtLimit)
      : undefined;
    message.surplusAuctionThreshold = object.surplusAuctionThreshold ?? "";
    message.surplusAuctionLot = object.surplusAuctionLot ?? "";
    message.debtAuctionThreshold = object.debtAuctionThreshold ?? "";
    message.debtAuctionLot = object.debtAuctionLot ?? "";
    message.circuitBreaker = object.circuitBreaker ?? false;
    return message;
  },
};

function createBaseDebtParam(): DebtParam {
  return { denom: "", referenceAsset: "", conversionFactor: "", debtFloor: "" };
}

export const DebtParam = {
  encode(message: DebtParam, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.referenceAsset !== "") {
      writer.uint32(18).string(message.referenceAsset);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(26).string(message.conversionFactor);
    }
    if (message.debtFloor !== "") {
      writer.uint32(34).string(message.debtFloor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): DebtParam {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDebtParam();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.referenceAsset = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.conversionFactor = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.debtFloor = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): DebtParam {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      referenceAsset: isSet(object.referenceAsset) ? globalThis.String(object.referenceAsset) : "",
      conversionFactor: isSet(object.conversionFactor) ? globalThis.String(object.conversionFactor) : "",
      debtFloor: isSet(object.debtFloor) ? globalThis.String(object.debtFloor) : "",
    };
  },

  toJSON(message: DebtParam): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.referenceAsset !== "") {
      obj.referenceAsset = message.referenceAsset;
    }
    if (message.conversionFactor !== "") {
      obj.conversionFactor = message.conversionFactor;
    }
    if (message.debtFloor !== "") {
      obj.debtFloor = message.debtFloor;
    }
    return obj;
  },

  create(base?: DeepPartial<DebtParam>): DebtParam {
    return DebtParam.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<DebtParam>): DebtParam {
    const message = createBaseDebtParam();
    message.denom = object.denom ?? "";
    message.referenceAsset = object.referenceAsset ?? "";
    message.conversionFactor = object.conversionFactor ?? "";
    message.debtFloor = object.debtFloor ?? "";
    return message;
  },
};

function createBaseCollateralParam(): CollateralParam {
  return {
    denom: "",
    type: "",
    liquidationRatio: "",
    debtLimit: undefined,
    stabilityFee: "",
    auctionSize: "",
    liquidationPenalty: "",
    spotMarketId: "",
    liquidationMarketId: "",
    keeperRewardPercentage: "",
    checkCollateralizationIndexCount: "",
    conversionFactor: "",
  };
}

export const CollateralParam = {
  encode(message: CollateralParam, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.type !== "") {
      writer.uint32(18).string(message.type);
    }
    if (message.liquidationRatio !== "") {
      writer.uint32(26).string(message.liquidationRatio);
    }
    if (message.debtLimit !== undefined) {
      Coin.encode(message.debtLimit, writer.uint32(34).fork()).ldelim();
    }
    if (message.stabilityFee !== "") {
      writer.uint32(42).string(message.stabilityFee);
    }
    if (message.auctionSize !== "") {
      writer.uint32(50).string(message.auctionSize);
    }
    if (message.liquidationPenalty !== "") {
      writer.uint32(58).string(message.liquidationPenalty);
    }
    if (message.spotMarketId !== "") {
      writer.uint32(66).string(message.spotMarketId);
    }
    if (message.liquidationMarketId !== "") {
      writer.uint32(74).string(message.liquidationMarketId);
    }
    if (message.keeperRewardPercentage !== "") {
      writer.uint32(82).string(message.keeperRewardPercentage);
    }
    if (message.checkCollateralizationIndexCount !== "") {
      writer.uint32(90).string(message.checkCollateralizationIndexCount);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(98).string(message.conversionFactor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CollateralParam {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCollateralParam();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.type = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.liquidationRatio = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.debtLimit = Coin.decode(reader, reader.uint32());
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.stabilityFee = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.auctionSize = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.liquidationPenalty = reader.string();
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.spotMarketId = reader.string();
          continue;
        case 9:
          if (tag !== 74) {
            break;
          }

          message.liquidationMarketId = reader.string();
          continue;
        case 10:
          if (tag !== 82) {
            break;
          }

          message.keeperRewardPercentage = reader.string();
          continue;
        case 11:
          if (tag !== 90) {
            break;
          }

          message.checkCollateralizationIndexCount = reader.string();
          continue;
        case 12:
          if (tag !== 98) {
            break;
          }

          message.conversionFactor = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CollateralParam {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      type: isSet(object.type) ? globalThis.String(object.type) : "",
      liquidationRatio: isSet(object.liquidationRatio) ? globalThis.String(object.liquidationRatio) : "",
      debtLimit: isSet(object.debtLimit) ? Coin.fromJSON(object.debtLimit) : undefined,
      stabilityFee: isSet(object.stabilityFee) ? globalThis.String(object.stabilityFee) : "",
      auctionSize: isSet(object.auctionSize) ? globalThis.String(object.auctionSize) : "",
      liquidationPenalty: isSet(object.liquidationPenalty) ? globalThis.String(object.liquidationPenalty) : "",
      spotMarketId: isSet(object.spotMarketId) ? globalThis.String(object.spotMarketId) : "",
      liquidationMarketId: isSet(object.liquidationMarketId) ? globalThis.String(object.liquidationMarketId) : "",
      keeperRewardPercentage: isSet(object.keeperRewardPercentage)
        ? globalThis.String(object.keeperRewardPercentage)
        : "",
      checkCollateralizationIndexCount: isSet(object.checkCollateralizationIndexCount)
        ? globalThis.String(object.checkCollateralizationIndexCount)
        : "",
      conversionFactor: isSet(object.conversionFactor) ? globalThis.String(object.conversionFactor) : "",
    };
  },

  toJSON(message: CollateralParam): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.type !== "") {
      obj.type = message.type;
    }
    if (message.liquidationRatio !== "") {
      obj.liquidationRatio = message.liquidationRatio;
    }
    if (message.debtLimit !== undefined) {
      obj.debtLimit = Coin.toJSON(message.debtLimit);
    }
    if (message.stabilityFee !== "") {
      obj.stabilityFee = message.stabilityFee;
    }
    if (message.auctionSize !== "") {
      obj.auctionSize = message.auctionSize;
    }
    if (message.liquidationPenalty !== "") {
      obj.liquidationPenalty = message.liquidationPenalty;
    }
    if (message.spotMarketId !== "") {
      obj.spotMarketId = message.spotMarketId;
    }
    if (message.liquidationMarketId !== "") {
      obj.liquidationMarketId = message.liquidationMarketId;
    }
    if (message.keeperRewardPercentage !== "") {
      obj.keeperRewardPercentage = message.keeperRewardPercentage;
    }
    if (message.checkCollateralizationIndexCount !== "") {
      obj.checkCollateralizationIndexCount = message.checkCollateralizationIndexCount;
    }
    if (message.conversionFactor !== "") {
      obj.conversionFactor = message.conversionFactor;
    }
    return obj;
  },

  create(base?: DeepPartial<CollateralParam>): CollateralParam {
    return CollateralParam.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CollateralParam>): CollateralParam {
    const message = createBaseCollateralParam();
    message.denom = object.denom ?? "";
    message.type = object.type ?? "";
    message.liquidationRatio = object.liquidationRatio ?? "";
    message.debtLimit = (object.debtLimit !== undefined && object.debtLimit !== null)
      ? Coin.fromPartial(object.debtLimit)
      : undefined;
    message.stabilityFee = object.stabilityFee ?? "";
    message.auctionSize = object.auctionSize ?? "";
    message.liquidationPenalty = object.liquidationPenalty ?? "";
    message.spotMarketId = object.spotMarketId ?? "";
    message.liquidationMarketId = object.liquidationMarketId ?? "";
    message.keeperRewardPercentage = object.keeperRewardPercentage ?? "";
    message.checkCollateralizationIndexCount = object.checkCollateralizationIndexCount ?? "";
    message.conversionFactor = object.conversionFactor ?? "";
    return message;
  },
};

function createBaseGenesisAccumulationTime(): GenesisAccumulationTime {
  return { collateralType: "", previousAccumulationTime: undefined, interestFactor: "" };
}

export const GenesisAccumulationTime = {
  encode(message: GenesisAccumulationTime, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.previousAccumulationTime !== undefined) {
      Timestamp.encode(toTimestamp(message.previousAccumulationTime), writer.uint32(18).fork()).ldelim();
    }
    if (message.interestFactor !== "") {
      writer.uint32(26).string(message.interestFactor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisAccumulationTime {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisAccumulationTime();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.previousAccumulationTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.interestFactor = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisAccumulationTime {
    return {
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      previousAccumulationTime: isSet(object.previousAccumulationTime)
        ? fromJsonTimestamp(object.previousAccumulationTime)
        : undefined,
      interestFactor: isSet(object.interestFactor) ? globalThis.String(object.interestFactor) : "",
    };
  },

  toJSON(message: GenesisAccumulationTime): unknown {
    const obj: any = {};
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.previousAccumulationTime !== undefined) {
      obj.previousAccumulationTime = message.previousAccumulationTime.toISOString();
    }
    if (message.interestFactor !== "") {
      obj.interestFactor = message.interestFactor;
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisAccumulationTime>): GenesisAccumulationTime {
    return GenesisAccumulationTime.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisAccumulationTime>): GenesisAccumulationTime {
    const message = createBaseGenesisAccumulationTime();
    message.collateralType = object.collateralType ?? "";
    message.previousAccumulationTime = object.previousAccumulationTime ?? undefined;
    message.interestFactor = object.interestFactor ?? "";
    return message;
  },
};

function createBaseGenesisTotalPrincipal(): GenesisTotalPrincipal {
  return { collateralType: "", totalPrincipal: "" };
}

export const GenesisTotalPrincipal = {
  encode(message: GenesisTotalPrincipal, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.totalPrincipal !== "") {
      writer.uint32(18).string(message.totalPrincipal);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisTotalPrincipal {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisTotalPrincipal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.totalPrincipal = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisTotalPrincipal {
    return {
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      totalPrincipal: isSet(object.totalPrincipal) ? globalThis.String(object.totalPrincipal) : "",
    };
  },

  toJSON(message: GenesisTotalPrincipal): unknown {
    const obj: any = {};
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.totalPrincipal !== "") {
      obj.totalPrincipal = message.totalPrincipal;
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisTotalPrincipal>): GenesisTotalPrincipal {
    return GenesisTotalPrincipal.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisTotalPrincipal>): GenesisTotalPrincipal {
    const message = createBaseGenesisTotalPrincipal();
    message.collateralType = object.collateralType ?? "";
    message.totalPrincipal = object.totalPrincipal ?? "";
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function toTimestamp(date: Date): Timestamp {
  const seconds = numberToLong(Math.trunc(date.getTime() / 1_000));
  const nanos = (date.getTime() % 1_000) * 1_000_000;
  return { seconds, nanos };
}

function fromTimestamp(t: Timestamp): Date {
  let millis = (t.seconds.toNumber() || 0) * 1_000;
  millis += (t.nanos || 0) / 1_000_000;
  return new globalThis.Date(millis);
}

function fromJsonTimestamp(o: any): Date {
  if (o instanceof globalThis.Date) {
    return o;
  } else if (typeof o === "string") {
    return new globalThis.Date(o);
  } else {
    return fromTimestamp(Timestamp.fromJSON(o));
  }
}

function numberToLong(number: number) {
  return Long.fromNumber(number);
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
