// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/committee/v1beta1/committee.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Any } from "../../../google/protobuf/any";
import { Duration } from "../../../google/protobuf/duration";

export const protobufPackage = "kava.committee.v1beta1";

/** TallyOption enumerates the valid types of a tally. */
export enum TallyOption {
  /** TALLY_OPTION_UNSPECIFIED - TALLY_OPTION_UNSPECIFIED defines a null tally option. */
  TALLY_OPTION_UNSPECIFIED = 0,
  /** TALLY_OPTION_FIRST_PAST_THE_POST - Votes are tallied each block and the proposal passes as soon as the vote threshold is reached */
  TALLY_OPTION_FIRST_PAST_THE_POST = 1,
  /** TALLY_OPTION_DEADLINE - Votes are tallied exactly once, when the deadline time is reached */
  TALLY_OPTION_DEADLINE = 2,
  UNRECOGNIZED = -1,
}

export function tallyOptionFromJSON(object: any): TallyOption {
  switch (object) {
    case 0:
    case "TALLY_OPTION_UNSPECIFIED":
      return TallyOption.TALLY_OPTION_UNSPECIFIED;
    case 1:
    case "TALLY_OPTION_FIRST_PAST_THE_POST":
      return TallyOption.TALLY_OPTION_FIRST_PAST_THE_POST;
    case 2:
    case "TALLY_OPTION_DEADLINE":
      return TallyOption.TALLY_OPTION_DEADLINE;
    case -1:
    case "UNRECOGNIZED":
    default:
      return TallyOption.UNRECOGNIZED;
  }
}

export function tallyOptionToJSON(object: TallyOption): string {
  switch (object) {
    case TallyOption.TALLY_OPTION_UNSPECIFIED:
      return "TALLY_OPTION_UNSPECIFIED";
    case TallyOption.TALLY_OPTION_FIRST_PAST_THE_POST:
      return "TALLY_OPTION_FIRST_PAST_THE_POST";
    case TallyOption.TALLY_OPTION_DEADLINE:
      return "TALLY_OPTION_DEADLINE";
    case TallyOption.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}

/** BaseCommittee is a common type shared by all Committees */
export interface BaseCommittee {
  id: Long;
  description: string;
  members: Uint8Array[];
  permissions: Any[];
  /** Smallest percentage that must vote for a proposal to pass */
  voteThreshold: string;
  /** The length of time a proposal remains active for. Proposals will close earlier if they get enough votes. */
  proposalDuration?: Duration | undefined;
  tallyOption: TallyOption;
}

/** MemberCommittee is an alias of BaseCommittee */
export interface MemberCommittee {
  baseCommittee?: BaseCommittee | undefined;
}

/** TokenCommittee supports voting on proposals by token holders */
export interface TokenCommittee {
  baseCommittee?: BaseCommittee | undefined;
  quorum: string;
  tallyDenom: string;
}

function createBaseBaseCommittee(): BaseCommittee {
  return {
    id: Long.UZERO,
    description: "",
    members: [],
    permissions: [],
    voteThreshold: "",
    proposalDuration: undefined,
    tallyOption: 0,
  };
}

export const BaseCommittee = {
  encode(message: BaseCommittee, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (!message.id.equals(Long.UZERO)) {
      writer.uint32(8).uint64(message.id);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    for (const v of message.members) {
      writer.uint32(26).bytes(v!);
    }
    for (const v of message.permissions) {
      Any.encode(v!, writer.uint32(34).fork()).ldelim();
    }
    if (message.voteThreshold !== "") {
      writer.uint32(42).string(message.voteThreshold);
    }
    if (message.proposalDuration !== undefined) {
      Duration.encode(message.proposalDuration, writer.uint32(50).fork()).ldelim();
    }
    if (message.tallyOption !== 0) {
      writer.uint32(56).int32(message.tallyOption);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BaseCommittee {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseCommittee();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.id = reader.uint64() as Long;
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.description = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.members.push(reader.bytes());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.permissions.push(Any.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.voteThreshold = reader.string();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.proposalDuration = Duration.decode(reader, reader.uint32());
          continue;
        case 7:
          if (tag !== 56) {
            break;
          }

          message.tallyOption = reader.int32() as any;
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BaseCommittee {
    return {
      id: isSet(object.id) ? Long.fromValue(object.id) : Long.UZERO,
      description: isSet(object.description) ? globalThis.String(object.description) : "",
      members: globalThis.Array.isArray(object?.members) ? object.members.map((e: any) => bytesFromBase64(e)) : [],
      permissions: globalThis.Array.isArray(object?.permissions)
        ? object.permissions.map((e: any) => Any.fromJSON(e))
        : [],
      voteThreshold: isSet(object.voteThreshold) ? globalThis.String(object.voteThreshold) : "",
      proposalDuration: isSet(object.proposalDuration) ? Duration.fromJSON(object.proposalDuration) : undefined,
      tallyOption: isSet(object.tallyOption) ? tallyOptionFromJSON(object.tallyOption) : 0,
    };
  },

  toJSON(message: BaseCommittee): unknown {
    const obj: any = {};
    if (!message.id.equals(Long.UZERO)) {
      obj.id = (message.id || Long.UZERO).toString();
    }
    if (message.description !== "") {
      obj.description = message.description;
    }
    if (message.members?.length) {
      obj.members = message.members.map((e) => base64FromBytes(e));
    }
    if (message.permissions?.length) {
      obj.permissions = message.permissions.map((e) => Any.toJSON(e));
    }
    if (message.voteThreshold !== "") {
      obj.voteThreshold = message.voteThreshold;
    }
    if (message.proposalDuration !== undefined) {
      obj.proposalDuration = Duration.toJSON(message.proposalDuration);
    }
    if (message.tallyOption !== 0) {
      obj.tallyOption = tallyOptionToJSON(message.tallyOption);
    }
    return obj;
  },

  create(base?: DeepPartial<BaseCommittee>): BaseCommittee {
    return BaseCommittee.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BaseCommittee>): BaseCommittee {
    const message = createBaseBaseCommittee();
    message.id = (object.id !== undefined && object.id !== null) ? Long.fromValue(object.id) : Long.UZERO;
    message.description = object.description ?? "";
    message.members = object.members?.map((e) => e) || [];
    message.permissions = object.permissions?.map((e) => Any.fromPartial(e)) || [];
    message.voteThreshold = object.voteThreshold ?? "";
    message.proposalDuration = (object.proposalDuration !== undefined && object.proposalDuration !== null)
      ? Duration.fromPartial(object.proposalDuration)
      : undefined;
    message.tallyOption = object.tallyOption ?? 0;
    return message;
  },
};

function createBaseMemberCommittee(): MemberCommittee {
  return { baseCommittee: undefined };
}

export const MemberCommittee = {
  encode(message: MemberCommittee, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseCommittee !== undefined) {
      BaseCommittee.encode(message.baseCommittee, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MemberCommittee {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMemberCommittee();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseCommittee = BaseCommittee.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MemberCommittee {
    return { baseCommittee: isSet(object.baseCommittee) ? BaseCommittee.fromJSON(object.baseCommittee) : undefined };
  },

  toJSON(message: MemberCommittee): unknown {
    const obj: any = {};
    if (message.baseCommittee !== undefined) {
      obj.baseCommittee = BaseCommittee.toJSON(message.baseCommittee);
    }
    return obj;
  },

  create(base?: DeepPartial<MemberCommittee>): MemberCommittee {
    return MemberCommittee.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MemberCommittee>): MemberCommittee {
    const message = createBaseMemberCommittee();
    message.baseCommittee = (object.baseCommittee !== undefined && object.baseCommittee !== null)
      ? BaseCommittee.fromPartial(object.baseCommittee)
      : undefined;
    return message;
  },
};

function createBaseTokenCommittee(): TokenCommittee {
  return { baseCommittee: undefined, quorum: "", tallyDenom: "" };
}

export const TokenCommittee = {
  encode(message: TokenCommittee, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseCommittee !== undefined) {
      BaseCommittee.encode(message.baseCommittee, writer.uint32(10).fork()).ldelim();
    }
    if (message.quorum !== "") {
      writer.uint32(18).string(message.quorum);
    }
    if (message.tallyDenom !== "") {
      writer.uint32(26).string(message.tallyDenom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): TokenCommittee {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseTokenCommittee();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseCommittee = BaseCommittee.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.quorum = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.tallyDenom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): TokenCommittee {
    return {
      baseCommittee: isSet(object.baseCommittee) ? BaseCommittee.fromJSON(object.baseCommittee) : undefined,
      quorum: isSet(object.quorum) ? globalThis.String(object.quorum) : "",
      tallyDenom: isSet(object.tallyDenom) ? globalThis.String(object.tallyDenom) : "",
    };
  },

  toJSON(message: TokenCommittee): unknown {
    const obj: any = {};
    if (message.baseCommittee !== undefined) {
      obj.baseCommittee = BaseCommittee.toJSON(message.baseCommittee);
    }
    if (message.quorum !== "") {
      obj.quorum = message.quorum;
    }
    if (message.tallyDenom !== "") {
      obj.tallyDenom = message.tallyDenom;
    }
    return obj;
  },

  create(base?: DeepPartial<TokenCommittee>): TokenCommittee {
    return TokenCommittee.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<TokenCommittee>): TokenCommittee {
    const message = createBaseTokenCommittee();
    message.baseCommittee = (object.baseCommittee !== undefined && object.baseCommittee !== null)
      ? BaseCommittee.fromPartial(object.baseCommittee)
      : undefined;
    message.quorum = object.quorum ?? "";
    message.tallyDenom = object.tallyDenom ?? "";
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
