// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/community/v1beta1/proposal.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";

export const protobufPackage = "kava.community.v1beta1";

/** CommunityPoolLendDepositProposal deposits from the community pool into lend */
export interface CommunityPoolLendDepositProposal {
  title: string;
  description: string;
  amount: Coin[];
}

/** CommunityPoolLendWithdrawProposal withdraws a lend position back to the community pool */
export interface CommunityPoolLendWithdrawProposal {
  title: string;
  description: string;
  amount: Coin[];
}

/**
 * CommunityCDPRepayDebtProposal repays a cdp debt position owned by the community module
 * This proposal exists primarily to allow committees to repay community module cdp debts.
 */
export interface CommunityCDPRepayDebtProposal {
  title: string;
  description: string;
  collateralType: string;
  payment?: Coin | undefined;
}

/**
 * CommunityCDPWithdrawCollateralProposal withdraws cdp collateral owned by the community module
 * This proposal exists primarily to allow committees to withdraw community module cdp collateral.
 */
export interface CommunityCDPWithdrawCollateralProposal {
  title: string;
  description: string;
  collateralType: string;
  collateral?: Coin | undefined;
}

function createBaseCommunityPoolLendDepositProposal(): CommunityPoolLendDepositProposal {
  return { title: "", description: "", amount: [] };
}

export const CommunityPoolLendDepositProposal = {
  encode(message: CommunityPoolLendDepositProposal, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.title !== "") {
      writer.uint32(10).string(message.title);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolLendDepositProposal {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommunityPoolLendDepositProposal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.title = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.description = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CommunityPoolLendDepositProposal {
    return {
      title: isSet(object.title) ? globalThis.String(object.title) : "",
      description: isSet(object.description) ? globalThis.String(object.description) : "",
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
    };
  },

  toJSON(message: CommunityPoolLendDepositProposal): unknown {
    const obj: any = {};
    if (message.title !== "") {
      obj.title = message.title;
    }
    if (message.description !== "") {
      obj.description = message.description;
    }
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<CommunityPoolLendDepositProposal>): CommunityPoolLendDepositProposal {
    return CommunityPoolLendDepositProposal.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CommunityPoolLendDepositProposal>): CommunityPoolLendDepositProposal {
    const message = createBaseCommunityPoolLendDepositProposal();
    message.title = object.title ?? "";
    message.description = object.description ?? "";
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseCommunityPoolLendWithdrawProposal(): CommunityPoolLendWithdrawProposal {
  return { title: "", description: "", amount: [] };
}

export const CommunityPoolLendWithdrawProposal = {
  encode(message: CommunityPoolLendWithdrawProposal, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.title !== "") {
      writer.uint32(10).string(message.title);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CommunityPoolLendWithdrawProposal {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommunityPoolLendWithdrawProposal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.title = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.description = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CommunityPoolLendWithdrawProposal {
    return {
      title: isSet(object.title) ? globalThis.String(object.title) : "",
      description: isSet(object.description) ? globalThis.String(object.description) : "",
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
    };
  },

  toJSON(message: CommunityPoolLendWithdrawProposal): unknown {
    const obj: any = {};
    if (message.title !== "") {
      obj.title = message.title;
    }
    if (message.description !== "") {
      obj.description = message.description;
    }
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<CommunityPoolLendWithdrawProposal>): CommunityPoolLendWithdrawProposal {
    return CommunityPoolLendWithdrawProposal.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CommunityPoolLendWithdrawProposal>): CommunityPoolLendWithdrawProposal {
    const message = createBaseCommunityPoolLendWithdrawProposal();
    message.title = object.title ?? "";
    message.description = object.description ?? "";
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseCommunityCDPRepayDebtProposal(): CommunityCDPRepayDebtProposal {
  return { title: "", description: "", collateralType: "", payment: undefined };
}

export const CommunityCDPRepayDebtProposal = {
  encode(message: CommunityCDPRepayDebtProposal, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.title !== "") {
      writer.uint32(10).string(message.title);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    if (message.collateralType !== "") {
      writer.uint32(26).string(message.collateralType);
    }
    if (message.payment !== undefined) {
      Coin.encode(message.payment, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CommunityCDPRepayDebtProposal {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommunityCDPRepayDebtProposal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.title = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.description = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.payment = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CommunityCDPRepayDebtProposal {
    return {
      title: isSet(object.title) ? globalThis.String(object.title) : "",
      description: isSet(object.description) ? globalThis.String(object.description) : "",
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      payment: isSet(object.payment) ? Coin.fromJSON(object.payment) : undefined,
    };
  },

  toJSON(message: CommunityCDPRepayDebtProposal): unknown {
    const obj: any = {};
    if (message.title !== "") {
      obj.title = message.title;
    }
    if (message.description !== "") {
      obj.description = message.description;
    }
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.payment !== undefined) {
      obj.payment = Coin.toJSON(message.payment);
    }
    return obj;
  },

  create(base?: DeepPartial<CommunityCDPRepayDebtProposal>): CommunityCDPRepayDebtProposal {
    return CommunityCDPRepayDebtProposal.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CommunityCDPRepayDebtProposal>): CommunityCDPRepayDebtProposal {
    const message = createBaseCommunityCDPRepayDebtProposal();
    message.title = object.title ?? "";
    message.description = object.description ?? "";
    message.collateralType = object.collateralType ?? "";
    message.payment = (object.payment !== undefined && object.payment !== null)
      ? Coin.fromPartial(object.payment)
      : undefined;
    return message;
  },
};

function createBaseCommunityCDPWithdrawCollateralProposal(): CommunityCDPWithdrawCollateralProposal {
  return { title: "", description: "", collateralType: "", collateral: undefined };
}

export const CommunityCDPWithdrawCollateralProposal = {
  encode(message: CommunityCDPWithdrawCollateralProposal, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.title !== "") {
      writer.uint32(10).string(message.title);
    }
    if (message.description !== "") {
      writer.uint32(18).string(message.description);
    }
    if (message.collateralType !== "") {
      writer.uint32(26).string(message.collateralType);
    }
    if (message.collateral !== undefined) {
      Coin.encode(message.collateral, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CommunityCDPWithdrawCollateralProposal {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommunityCDPWithdrawCollateralProposal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.title = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.description = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.collateral = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CommunityCDPWithdrawCollateralProposal {
    return {
      title: isSet(object.title) ? globalThis.String(object.title) : "",
      description: isSet(object.description) ? globalThis.String(object.description) : "",
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      collateral: isSet(object.collateral) ? Coin.fromJSON(object.collateral) : undefined,
    };
  },

  toJSON(message: CommunityCDPWithdrawCollateralProposal): unknown {
    const obj: any = {};
    if (message.title !== "") {
      obj.title = message.title;
    }
    if (message.description !== "") {
      obj.description = message.description;
    }
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.collateral !== undefined) {
      obj.collateral = Coin.toJSON(message.collateral);
    }
    return obj;
  },

  create(base?: DeepPartial<CommunityCDPWithdrawCollateralProposal>): CommunityCDPWithdrawCollateralProposal {
    return CommunityCDPWithdrawCollateralProposal.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CommunityCDPWithdrawCollateralProposal>): CommunityCDPWithdrawCollateralProposal {
    const message = createBaseCommunityCDPWithdrawCollateralProposal();
    message.title = object.title ?? "";
    message.description = object.description ?? "";
    message.collateralType = object.collateralType ?? "";
    message.collateral = (object.collateral !== undefined && object.collateral !== null)
      ? Coin.fromPartial(object.collateral)
      : undefined;
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
