// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/earn/v1beta1/vault.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { StrategyType, strategyTypeFromJSON, strategyTypeToJSON } from "./strategy";

export const protobufPackage = "kava.earn.v1beta1";

/**
 * AllowedVault is a vault that is allowed to be created. These can be
 * modified via parameter governance.
 */
export interface AllowedVault {
  /** Denom is the only supported denomination of the vault for deposits and withdrawals. */
  denom: string;
  /** VaultStrategy is the strategy used for this vault. */
  strategies: StrategyType[];
  /**
   * IsPrivateVault is true if the vault only allows depositors contained in
   * AllowedDepositors.
   */
  isPrivateVault: boolean;
  /**
   * AllowedDepositors is a list of addresses that are allowed to deposit to
   * this vault if IsPrivateVault is true. Addresses not contained in this list
   * are not allowed to deposit into this vault. If IsPrivateVault is false,
   * this should be empty and ignored.
   */
  allowedDepositors: Uint8Array[];
}

/** VaultRecord is the state of a vault. */
export interface VaultRecord {
  /** TotalShares is the total distributed number of shares in the vault. */
  totalShares?: VaultShare | undefined;
}

/** VaultShareRecord defines the vault shares owned by a depositor. */
export interface VaultShareRecord {
  /** Depositor represents the owner of the shares */
  depositor: Uint8Array;
  /** Shares represent the vault shares owned by the depositor. */
  shares: VaultShare[];
}

/** VaultShare defines shares of a vault owned by a depositor. */
export interface VaultShare {
  denom: string;
  amount: string;
}

function createBaseAllowedVault(): AllowedVault {
  return { denom: "", strategies: [], isPrivateVault: false, allowedDepositors: [] };
}

export const AllowedVault = {
  encode(message: AllowedVault, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    writer.uint32(18).fork();
    for (const v of message.strategies) {
      writer.int32(v);
    }
    writer.ldelim();
    if (message.isPrivateVault !== false) {
      writer.uint32(24).bool(message.isPrivateVault);
    }
    for (const v of message.allowedDepositors) {
      writer.uint32(34).bytes(v!);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AllowedVault {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAllowedVault();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag === 16) {
            message.strategies.push(reader.int32() as any);

            continue;
          }

          if (tag === 18) {
            const end2 = reader.uint32() + reader.pos;
            while (reader.pos < end2) {
              message.strategies.push(reader.int32() as any);
            }

            continue;
          }

          break;
        case 3:
          if (tag !== 24) {
            break;
          }

          message.isPrivateVault = reader.bool();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.allowedDepositors.push(reader.bytes());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AllowedVault {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      strategies: globalThis.Array.isArray(object?.strategies)
        ? object.strategies.map((e: any) => strategyTypeFromJSON(e))
        : [],
      isPrivateVault: isSet(object.isPrivateVault) ? globalThis.Boolean(object.isPrivateVault) : false,
      allowedDepositors: globalThis.Array.isArray(object?.allowedDepositors)
        ? object.allowedDepositors.map((e: any) => bytesFromBase64(e))
        : [],
    };
  },

  toJSON(message: AllowedVault): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.strategies?.length) {
      obj.strategies = message.strategies.map((e) => strategyTypeToJSON(e));
    }
    if (message.isPrivateVault !== false) {
      obj.isPrivateVault = message.isPrivateVault;
    }
    if (message.allowedDepositors?.length) {
      obj.allowedDepositors = message.allowedDepositors.map((e) => base64FromBytes(e));
    }
    return obj;
  },

  create(base?: DeepPartial<AllowedVault>): AllowedVault {
    return AllowedVault.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AllowedVault>): AllowedVault {
    const message = createBaseAllowedVault();
    message.denom = object.denom ?? "";
    message.strategies = object.strategies?.map((e) => e) || [];
    message.isPrivateVault = object.isPrivateVault ?? false;
    message.allowedDepositors = object.allowedDepositors?.map((e) => e) || [];
    return message;
  },
};

function createBaseVaultRecord(): VaultRecord {
  return { totalShares: undefined };
}

export const VaultRecord = {
  encode(message: VaultRecord, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.totalShares !== undefined) {
      VaultShare.encode(message.totalShares, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VaultRecord {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVaultRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.totalShares = VaultShare.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VaultRecord {
    return { totalShares: isSet(object.totalShares) ? VaultShare.fromJSON(object.totalShares) : undefined };
  },

  toJSON(message: VaultRecord): unknown {
    const obj: any = {};
    if (message.totalShares !== undefined) {
      obj.totalShares = VaultShare.toJSON(message.totalShares);
    }
    return obj;
  },

  create(base?: DeepPartial<VaultRecord>): VaultRecord {
    return VaultRecord.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<VaultRecord>): VaultRecord {
    const message = createBaseVaultRecord();
    message.totalShares = (object.totalShares !== undefined && object.totalShares !== null)
      ? VaultShare.fromPartial(object.totalShares)
      : undefined;
    return message;
  },
};

function createBaseVaultShareRecord(): VaultShareRecord {
  return { depositor: new Uint8Array(0), shares: [] };
}

export const VaultShareRecord = {
  encode(message: VaultShareRecord, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.depositor.length !== 0) {
      writer.uint32(10).bytes(message.depositor);
    }
    for (const v of message.shares) {
      VaultShare.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VaultShareRecord {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVaultShareRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.depositor = reader.bytes();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.shares.push(VaultShare.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VaultShareRecord {
    return {
      depositor: isSet(object.depositor) ? bytesFromBase64(object.depositor) : new Uint8Array(0),
      shares: globalThis.Array.isArray(object?.shares) ? object.shares.map((e: any) => VaultShare.fromJSON(e)) : [],
    };
  },

  toJSON(message: VaultShareRecord): unknown {
    const obj: any = {};
    if (message.depositor.length !== 0) {
      obj.depositor = base64FromBytes(message.depositor);
    }
    if (message.shares?.length) {
      obj.shares = message.shares.map((e) => VaultShare.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<VaultShareRecord>): VaultShareRecord {
    return VaultShareRecord.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<VaultShareRecord>): VaultShareRecord {
    const message = createBaseVaultShareRecord();
    message.depositor = object.depositor ?? new Uint8Array(0);
    message.shares = object.shares?.map((e) => VaultShare.fromPartial(e)) || [];
    return message;
  },
};

function createBaseVaultShare(): VaultShare {
  return { denom: "", amount: "" };
}

export const VaultShare = {
  encode(message: VaultShare, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.amount !== "") {
      writer.uint32(18).string(message.amount);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): VaultShare {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseVaultShare();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.amount = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): VaultShare {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      amount: isSet(object.amount) ? globalThis.String(object.amount) : "",
    };
  },

  toJSON(message: VaultShare): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.amount !== "") {
      obj.amount = message.amount;
    }
    return obj;
  },

  create(base?: DeepPartial<VaultShare>): VaultShare {
    return VaultShare.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<VaultShare>): VaultShare {
    const message = createBaseVaultShare();
    message.denom = object.denom ?? "";
    message.amount = object.amount ?? "";
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
