// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/evmutil/v1beta1/query.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Params } from "./genesis";

export const protobufPackage = "kava.evmutil.v1beta1";

/** QueryParamsRequest defines the request type for querying x/evmutil parameters. */
export interface QueryParamsRequest {
}

/** QueryParamsResponse defines the response type for querying x/evmutil parameters. */
export interface QueryParamsResponse {
  params?: Params | undefined;
}

/** QueryDeployedCosmosCoinContractsRequest defines the request type for Query/DeployedCosmosCoinContracts method. */
export interface QueryDeployedCosmosCoinContractsRequest {
  /**
   * optional query param to only return specific denoms in the list
   * denoms that do not have deployed contracts will be omitted from the result
   * must request fewer than 100 denoms at a time.
   */
  cosmosDenoms: string[];
  /** pagination defines an optional pagination for the request. */
  pagination?: PageRequest | undefined;
}

/** QueryDeployedCosmosCoinContractsResponse defines the response type for the Query/DeployedCosmosCoinContracts method. */
export interface QueryDeployedCosmosCoinContractsResponse {
  /** deployed_cosmos_coin_contracts is a list of cosmos-sdk coin denom and its deployed contract address */
  deployedCosmosCoinContracts: DeployedCosmosCoinContract[];
  /** pagination defines the pagination in the response. */
  pagination?: PageResponse | undefined;
}

/** DeployedCosmosCoinContract defines a deployed token contract to the evm representing a native cosmos-sdk coin */
export interface DeployedCosmosCoinContract {
  cosmosDenom: string;
  address: string;
}

function createBaseQueryParamsRequest(): QueryParamsRequest {
  return {};
}

export const QueryParamsRequest = {
  encode(_: QueryParamsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): QueryParamsRequest {
    return {};
  },

  toJSON(_: QueryParamsRequest): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest {
    return QueryParamsRequest.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest {
    const message = createBaseQueryParamsRequest();
    return message;
  },
};

function createBaseQueryParamsResponse(): QueryParamsResponse {
  return { params: undefined };
}

export const QueryParamsResponse = {
  encode(message: QueryParamsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryParamsResponse {
    return { params: isSet(object.params) ? Params.fromJSON(object.params) : undefined };
  },

  toJSON(message: QueryParamsResponse): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse {
    return QueryParamsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse {
    const message = createBaseQueryParamsResponse();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    return message;
  },
};

function createBaseQueryDeployedCosmosCoinContractsRequest(): QueryDeployedCosmosCoinContractsRequest {
  return { cosmosDenoms: [], pagination: undefined };
}

export const QueryDeployedCosmosCoinContractsRequest = {
  encode(message: QueryDeployedCosmosCoinContractsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.cosmosDenoms) {
      writer.uint32(10).string(v!);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryDeployedCosmosCoinContractsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDeployedCosmosCoinContractsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.cosmosDenoms.push(reader.string());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.pagination = PageRequest.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryDeployedCosmosCoinContractsRequest {
    return {
      cosmosDenoms: globalThis.Array.isArray(object?.cosmosDenoms)
        ? object.cosmosDenoms.map((e: any) => globalThis.String(e))
        : [],
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryDeployedCosmosCoinContractsRequest): unknown {
    const obj: any = {};
    if (message.cosmosDenoms?.length) {
      obj.cosmosDenoms = message.cosmosDenoms;
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageRequest.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryDeployedCosmosCoinContractsRequest>): QueryDeployedCosmosCoinContractsRequest {
    return QueryDeployedCosmosCoinContractsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryDeployedCosmosCoinContractsRequest>): QueryDeployedCosmosCoinContractsRequest {
    const message = createBaseQueryDeployedCosmosCoinContractsRequest();
    message.cosmosDenoms = object.cosmosDenoms?.map((e) => e) || [];
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageRequest.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryDeployedCosmosCoinContractsResponse(): QueryDeployedCosmosCoinContractsResponse {
  return { deployedCosmosCoinContracts: [], pagination: undefined };
}

export const QueryDeployedCosmosCoinContractsResponse = {
  encode(message: QueryDeployedCosmosCoinContractsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.deployedCosmosCoinContracts) {
      DeployedCosmosCoinContract.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryDeployedCosmosCoinContractsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDeployedCosmosCoinContractsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.deployedCosmosCoinContracts.push(DeployedCosmosCoinContract.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.pagination = PageResponse.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryDeployedCosmosCoinContractsResponse {
    return {
      deployedCosmosCoinContracts: globalThis.Array.isArray(object?.deployedCosmosCoinContracts)
        ? object.deployedCosmosCoinContracts.map((e: any) => DeployedCosmosCoinContract.fromJSON(e))
        : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryDeployedCosmosCoinContractsResponse): unknown {
    const obj: any = {};
    if (message.deployedCosmosCoinContracts?.length) {
      obj.deployedCosmosCoinContracts = message.deployedCosmosCoinContracts.map((e) =>
        DeployedCosmosCoinContract.toJSON(e)
      );
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageResponse.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryDeployedCosmosCoinContractsResponse>): QueryDeployedCosmosCoinContractsResponse {
    return QueryDeployedCosmosCoinContractsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryDeployedCosmosCoinContractsResponse>): QueryDeployedCosmosCoinContractsResponse {
    const message = createBaseQueryDeployedCosmosCoinContractsResponse();
    message.deployedCosmosCoinContracts =
      object.deployedCosmosCoinContracts?.map((e) => DeployedCosmosCoinContract.fromPartial(e)) || [];
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageResponse.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseDeployedCosmosCoinContract(): DeployedCosmosCoinContract {
  return { cosmosDenom: "", address: "" };
}

export const DeployedCosmosCoinContract = {
  encode(message: DeployedCosmosCoinContract, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.cosmosDenom !== "") {
      writer.uint32(10).string(message.cosmosDenom);
    }
    if (message.address !== "") {
      writer.uint32(18).string(message.address);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): DeployedCosmosCoinContract {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDeployedCosmosCoinContract();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.cosmosDenom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.address = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): DeployedCosmosCoinContract {
    return {
      cosmosDenom: isSet(object.cosmosDenom) ? globalThis.String(object.cosmosDenom) : "",
      address: isSet(object.address) ? globalThis.String(object.address) : "",
    };
  },

  toJSON(message: DeployedCosmosCoinContract): unknown {
    const obj: any = {};
    if (message.cosmosDenom !== "") {
      obj.cosmosDenom = message.cosmosDenom;
    }
    if (message.address !== "") {
      obj.address = message.address;
    }
    return obj;
  },

  create(base?: DeepPartial<DeployedCosmosCoinContract>): DeployedCosmosCoinContract {
    return DeployedCosmosCoinContract.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<DeployedCosmosCoinContract>): DeployedCosmosCoinContract {
    const message = createBaseDeployedCosmosCoinContract();
    message.cosmosDenom = object.cosmosDenom ?? "";
    message.address = object.address ?? "";
    return message;
  },
};

/** Query defines the gRPC querier service for evmutil module */
export interface Query {
  /** Params queries all parameters of the evmutil module. */
  Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
  /** DeployedCosmosCoinContracts queries a list cosmos coin denom and their deployed erc20 address */
  DeployedCosmosCoinContracts(
    request: QueryDeployedCosmosCoinContractsRequest,
  ): Promise<QueryDeployedCosmosCoinContractsResponse>;
}

export const QueryServiceName = "kava.evmutil.v1beta1.Query";
export class QueryClientImpl implements Query {
  private readonly rpc: Rpc;
  private readonly service: string;
  constructor(rpc: Rpc, opts?: { service?: string }) {
    this.service = opts?.service || QueryServiceName;
    this.rpc = rpc;
    this.Params = this.Params.bind(this);
    this.DeployedCosmosCoinContracts = this.DeployedCosmosCoinContracts.bind(this);
  }
  Params(request: QueryParamsRequest): Promise<QueryParamsResponse> {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Params", data);
    return promise.then((data) => QueryParamsResponse.decode(_m0.Reader.create(data)));
  }

  DeployedCosmosCoinContracts(
    request: QueryDeployedCosmosCoinContractsRequest,
  ): Promise<QueryDeployedCosmosCoinContractsResponse> {
    const data = QueryDeployedCosmosCoinContractsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "DeployedCosmosCoinContracts", data);
    return promise.then((data) => QueryDeployedCosmosCoinContractsResponse.decode(_m0.Reader.create(data)));
  }
}

interface Rpc {
  request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
