// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/evmutil/v1beta1/tx.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";

export const protobufPackage = "kava.evmutil.v1beta1";

/** MsgConvertCoinToERC20 defines a conversion from sdk.Coin to Kava ERC20 for EVM-native assets. */
export interface MsgConvertCoinToERC20 {
  /** Kava bech32 address initiating the conversion. */
  initiator: string;
  /** EVM 0x hex address that will receive the converted Kava ERC20 tokens. */
  receiver: string;
  /** Amount is the sdk.Coin amount to convert. */
  amount?: Coin | undefined;
}

/** MsgConvertCoinToERC20Response defines the response value from Msg/ConvertCoinToERC20. */
export interface MsgConvertCoinToERC20Response {
}

/** MsgConvertERC20ToCoin defines a conversion from Kava ERC20 to sdk.Coin for EVM-native assets. */
export interface MsgConvertERC20ToCoin {
  /** EVM 0x hex address initiating the conversion. */
  initiator: string;
  /** Kava bech32 address that will receive the converted sdk.Coin. */
  receiver: string;
  /** EVM 0x hex address of the ERC20 contract. */
  kavaErc20Address: string;
  /** ERC20 token amount to convert. */
  amount: string;
}

/**
 * MsgConvertERC20ToCoinResponse defines the response value from
 * Msg/MsgConvertERC20ToCoin.
 */
export interface MsgConvertERC20ToCoinResponse {
}

/** MsgConvertCosmosCoinToERC20 defines a conversion from cosmos sdk.Coin to ERC20 for cosmos-native assets. */
export interface MsgConvertCosmosCoinToERC20 {
  /** Kava bech32 address initiating the conversion. */
  initiator: string;
  /** EVM hex address that will receive the ERC20 tokens. */
  receiver: string;
  /** Amount is the sdk.Coin amount to convert. */
  amount?: Coin | undefined;
}

/** MsgConvertCosmosCoinToERC20Response defines the response value from Msg/MsgConvertCosmosCoinToERC20. */
export interface MsgConvertCosmosCoinToERC20Response {
}

/** MsgConvertCosmosCoinFromERC20 defines a conversion from ERC20 to cosmos coins for cosmos-native assets. */
export interface MsgConvertCosmosCoinFromERC20 {
  /** EVM hex address initiating the conversion. */
  initiator: string;
  /** Kava bech32 address that will receive the cosmos coins. */
  receiver: string;
  /** Amount is the amount to convert, expressed as a Cosmos coin. */
  amount?: Coin | undefined;
}

/** MsgConvertCosmosCoinFromERC20Response defines the response value from Msg/MsgConvertCosmosCoinFromERC20. */
export interface MsgConvertCosmosCoinFromERC20Response {
}

function createBaseMsgConvertCoinToERC20(): MsgConvertCoinToERC20 {
  return { initiator: "", receiver: "", amount: undefined };
}

export const MsgConvertCoinToERC20 = {
  encode(message: MsgConvertCoinToERC20, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.initiator !== "") {
      writer.uint32(10).string(message.initiator);
    }
    if (message.receiver !== "") {
      writer.uint32(18).string(message.receiver);
    }
    if (message.amount !== undefined) {
      Coin.encode(message.amount, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCoinToERC20 {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCoinToERC20();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.initiator = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.receiver = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.amount = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MsgConvertCoinToERC20 {
    return {
      initiator: isSet(object.initiator) ? globalThis.String(object.initiator) : "",
      receiver: isSet(object.receiver) ? globalThis.String(object.receiver) : "",
      amount: isSet(object.amount) ? Coin.fromJSON(object.amount) : undefined,
    };
  },

  toJSON(message: MsgConvertCoinToERC20): unknown {
    const obj: any = {};
    if (message.initiator !== "") {
      obj.initiator = message.initiator;
    }
    if (message.receiver !== "") {
      obj.receiver = message.receiver;
    }
    if (message.amount !== undefined) {
      obj.amount = Coin.toJSON(message.amount);
    }
    return obj;
  },

  create(base?: DeepPartial<MsgConvertCoinToERC20>): MsgConvertCoinToERC20 {
    return MsgConvertCoinToERC20.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MsgConvertCoinToERC20>): MsgConvertCoinToERC20 {
    const message = createBaseMsgConvertCoinToERC20();
    message.initiator = object.initiator ?? "";
    message.receiver = object.receiver ?? "";
    message.amount = (object.amount !== undefined && object.amount !== null)
      ? Coin.fromPartial(object.amount)
      : undefined;
    return message;
  },
};

function createBaseMsgConvertCoinToERC20Response(): MsgConvertCoinToERC20Response {
  return {};
}

export const MsgConvertCoinToERC20Response = {
  encode(_: MsgConvertCoinToERC20Response, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCoinToERC20Response {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCoinToERC20Response();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): MsgConvertCoinToERC20Response {
    return {};
  },

  toJSON(_: MsgConvertCoinToERC20Response): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<MsgConvertCoinToERC20Response>): MsgConvertCoinToERC20Response {
    return MsgConvertCoinToERC20Response.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<MsgConvertCoinToERC20Response>): MsgConvertCoinToERC20Response {
    const message = createBaseMsgConvertCoinToERC20Response();
    return message;
  },
};

function createBaseMsgConvertERC20ToCoin(): MsgConvertERC20ToCoin {
  return { initiator: "", receiver: "", kavaErc20Address: "", amount: "" };
}

export const MsgConvertERC20ToCoin = {
  encode(message: MsgConvertERC20ToCoin, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.initiator !== "") {
      writer.uint32(10).string(message.initiator);
    }
    if (message.receiver !== "") {
      writer.uint32(18).string(message.receiver);
    }
    if (message.kavaErc20Address !== "") {
      writer.uint32(26).string(message.kavaErc20Address);
    }
    if (message.amount !== "") {
      writer.uint32(34).string(message.amount);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertERC20ToCoin {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertERC20ToCoin();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.initiator = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.receiver = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.kavaErc20Address = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.amount = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MsgConvertERC20ToCoin {
    return {
      initiator: isSet(object.initiator) ? globalThis.String(object.initiator) : "",
      receiver: isSet(object.receiver) ? globalThis.String(object.receiver) : "",
      kavaErc20Address: isSet(object.kavaErc20Address) ? globalThis.String(object.kavaErc20Address) : "",
      amount: isSet(object.amount) ? globalThis.String(object.amount) : "",
    };
  },

  toJSON(message: MsgConvertERC20ToCoin): unknown {
    const obj: any = {};
    if (message.initiator !== "") {
      obj.initiator = message.initiator;
    }
    if (message.receiver !== "") {
      obj.receiver = message.receiver;
    }
    if (message.kavaErc20Address !== "") {
      obj.kavaErc20Address = message.kavaErc20Address;
    }
    if (message.amount !== "") {
      obj.amount = message.amount;
    }
    return obj;
  },

  create(base?: DeepPartial<MsgConvertERC20ToCoin>): MsgConvertERC20ToCoin {
    return MsgConvertERC20ToCoin.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MsgConvertERC20ToCoin>): MsgConvertERC20ToCoin {
    const message = createBaseMsgConvertERC20ToCoin();
    message.initiator = object.initiator ?? "";
    message.receiver = object.receiver ?? "";
    message.kavaErc20Address = object.kavaErc20Address ?? "";
    message.amount = object.amount ?? "";
    return message;
  },
};

function createBaseMsgConvertERC20ToCoinResponse(): MsgConvertERC20ToCoinResponse {
  return {};
}

export const MsgConvertERC20ToCoinResponse = {
  encode(_: MsgConvertERC20ToCoinResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertERC20ToCoinResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertERC20ToCoinResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): MsgConvertERC20ToCoinResponse {
    return {};
  },

  toJSON(_: MsgConvertERC20ToCoinResponse): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<MsgConvertERC20ToCoinResponse>): MsgConvertERC20ToCoinResponse {
    return MsgConvertERC20ToCoinResponse.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<MsgConvertERC20ToCoinResponse>): MsgConvertERC20ToCoinResponse {
    const message = createBaseMsgConvertERC20ToCoinResponse();
    return message;
  },
};

function createBaseMsgConvertCosmosCoinToERC20(): MsgConvertCosmosCoinToERC20 {
  return { initiator: "", receiver: "", amount: undefined };
}

export const MsgConvertCosmosCoinToERC20 = {
  encode(message: MsgConvertCosmosCoinToERC20, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.initiator !== "") {
      writer.uint32(10).string(message.initiator);
    }
    if (message.receiver !== "") {
      writer.uint32(18).string(message.receiver);
    }
    if (message.amount !== undefined) {
      Coin.encode(message.amount, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinToERC20 {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCosmosCoinToERC20();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.initiator = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.receiver = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.amount = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MsgConvertCosmosCoinToERC20 {
    return {
      initiator: isSet(object.initiator) ? globalThis.String(object.initiator) : "",
      receiver: isSet(object.receiver) ? globalThis.String(object.receiver) : "",
      amount: isSet(object.amount) ? Coin.fromJSON(object.amount) : undefined,
    };
  },

  toJSON(message: MsgConvertCosmosCoinToERC20): unknown {
    const obj: any = {};
    if (message.initiator !== "") {
      obj.initiator = message.initiator;
    }
    if (message.receiver !== "") {
      obj.receiver = message.receiver;
    }
    if (message.amount !== undefined) {
      obj.amount = Coin.toJSON(message.amount);
    }
    return obj;
  },

  create(base?: DeepPartial<MsgConvertCosmosCoinToERC20>): MsgConvertCosmosCoinToERC20 {
    return MsgConvertCosmosCoinToERC20.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MsgConvertCosmosCoinToERC20>): MsgConvertCosmosCoinToERC20 {
    const message = createBaseMsgConvertCosmosCoinToERC20();
    message.initiator = object.initiator ?? "";
    message.receiver = object.receiver ?? "";
    message.amount = (object.amount !== undefined && object.amount !== null)
      ? Coin.fromPartial(object.amount)
      : undefined;
    return message;
  },
};

function createBaseMsgConvertCosmosCoinToERC20Response(): MsgConvertCosmosCoinToERC20Response {
  return {};
}

export const MsgConvertCosmosCoinToERC20Response = {
  encode(_: MsgConvertCosmosCoinToERC20Response, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinToERC20Response {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCosmosCoinToERC20Response();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): MsgConvertCosmosCoinToERC20Response {
    return {};
  },

  toJSON(_: MsgConvertCosmosCoinToERC20Response): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<MsgConvertCosmosCoinToERC20Response>): MsgConvertCosmosCoinToERC20Response {
    return MsgConvertCosmosCoinToERC20Response.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<MsgConvertCosmosCoinToERC20Response>): MsgConvertCosmosCoinToERC20Response {
    const message = createBaseMsgConvertCosmosCoinToERC20Response();
    return message;
  },
};

function createBaseMsgConvertCosmosCoinFromERC20(): MsgConvertCosmosCoinFromERC20 {
  return { initiator: "", receiver: "", amount: undefined };
}

export const MsgConvertCosmosCoinFromERC20 = {
  encode(message: MsgConvertCosmosCoinFromERC20, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.initiator !== "") {
      writer.uint32(10).string(message.initiator);
    }
    if (message.receiver !== "") {
      writer.uint32(18).string(message.receiver);
    }
    if (message.amount !== undefined) {
      Coin.encode(message.amount, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinFromERC20 {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCosmosCoinFromERC20();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.initiator = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.receiver = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.amount = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MsgConvertCosmosCoinFromERC20 {
    return {
      initiator: isSet(object.initiator) ? globalThis.String(object.initiator) : "",
      receiver: isSet(object.receiver) ? globalThis.String(object.receiver) : "",
      amount: isSet(object.amount) ? Coin.fromJSON(object.amount) : undefined,
    };
  },

  toJSON(message: MsgConvertCosmosCoinFromERC20): unknown {
    const obj: any = {};
    if (message.initiator !== "") {
      obj.initiator = message.initiator;
    }
    if (message.receiver !== "") {
      obj.receiver = message.receiver;
    }
    if (message.amount !== undefined) {
      obj.amount = Coin.toJSON(message.amount);
    }
    return obj;
  },

  create(base?: DeepPartial<MsgConvertCosmosCoinFromERC20>): MsgConvertCosmosCoinFromERC20 {
    return MsgConvertCosmosCoinFromERC20.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MsgConvertCosmosCoinFromERC20>): MsgConvertCosmosCoinFromERC20 {
    const message = createBaseMsgConvertCosmosCoinFromERC20();
    message.initiator = object.initiator ?? "";
    message.receiver = object.receiver ?? "";
    message.amount = (object.amount !== undefined && object.amount !== null)
      ? Coin.fromPartial(object.amount)
      : undefined;
    return message;
  },
};

function createBaseMsgConvertCosmosCoinFromERC20Response(): MsgConvertCosmosCoinFromERC20Response {
  return {};
}

export const MsgConvertCosmosCoinFromERC20Response = {
  encode(_: MsgConvertCosmosCoinFromERC20Response, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MsgConvertCosmosCoinFromERC20Response {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMsgConvertCosmosCoinFromERC20Response();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): MsgConvertCosmosCoinFromERC20Response {
    return {};
  },

  toJSON(_: MsgConvertCosmosCoinFromERC20Response): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<MsgConvertCosmosCoinFromERC20Response>): MsgConvertCosmosCoinFromERC20Response {
    return MsgConvertCosmosCoinFromERC20Response.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<MsgConvertCosmosCoinFromERC20Response>): MsgConvertCosmosCoinFromERC20Response {
    const message = createBaseMsgConvertCosmosCoinFromERC20Response();
    return message;
  },
};

/** Msg defines the evmutil Msg service. */
export interface Msg {
  /** ConvertCoinToERC20 defines a method for converting sdk.Coin to Kava ERC20. */
  ConvertCoinToERC20(request: MsgConvertCoinToERC20): Promise<MsgConvertCoinToERC20Response>;
  /** ConvertERC20ToCoin defines a method for converting Kava ERC20 to sdk.Coin. */
  ConvertERC20ToCoin(request: MsgConvertERC20ToCoin): Promise<MsgConvertERC20ToCoinResponse>;
  /** ConvertCosmosCoinToERC20 defines a method for converting a cosmos sdk.Coin to an ERC20. */
  ConvertCosmosCoinToERC20(request: MsgConvertCosmosCoinToERC20): Promise<MsgConvertCosmosCoinToERC20Response>;
  /** ConvertCosmosCoinFromERC20 defines a method for converting a cosmos sdk.Coin to an ERC20. */
  ConvertCosmosCoinFromERC20(request: MsgConvertCosmosCoinFromERC20): Promise<MsgConvertCosmosCoinFromERC20Response>;
}

export const MsgServiceName = "kava.evmutil.v1beta1.Msg";
export class MsgClientImpl implements Msg {
  private readonly rpc: Rpc;
  private readonly service: string;
  constructor(rpc: Rpc, opts?: { service?: string }) {
    this.service = opts?.service || MsgServiceName;
    this.rpc = rpc;
    this.ConvertCoinToERC20 = this.ConvertCoinToERC20.bind(this);
    this.ConvertERC20ToCoin = this.ConvertERC20ToCoin.bind(this);
    this.ConvertCosmosCoinToERC20 = this.ConvertCosmosCoinToERC20.bind(this);
    this.ConvertCosmosCoinFromERC20 = this.ConvertCosmosCoinFromERC20.bind(this);
  }
  ConvertCoinToERC20(request: MsgConvertCoinToERC20): Promise<MsgConvertCoinToERC20Response> {
    const data = MsgConvertCoinToERC20.encode(request).finish();
    const promise = this.rpc.request(this.service, "ConvertCoinToERC20", data);
    return promise.then((data) => MsgConvertCoinToERC20Response.decode(_m0.Reader.create(data)));
  }

  ConvertERC20ToCoin(request: MsgConvertERC20ToCoin): Promise<MsgConvertERC20ToCoinResponse> {
    const data = MsgConvertERC20ToCoin.encode(request).finish();
    const promise = this.rpc.request(this.service, "ConvertERC20ToCoin", data);
    return promise.then((data) => MsgConvertERC20ToCoinResponse.decode(_m0.Reader.create(data)));
  }

  ConvertCosmosCoinToERC20(request: MsgConvertCosmosCoinToERC20): Promise<MsgConvertCosmosCoinToERC20Response> {
    const data = MsgConvertCosmosCoinToERC20.encode(request).finish();
    const promise = this.rpc.request(this.service, "ConvertCosmosCoinToERC20", data);
    return promise.then((data) => MsgConvertCosmosCoinToERC20Response.decode(_m0.Reader.create(data)));
  }

  ConvertCosmosCoinFromERC20(request: MsgConvertCosmosCoinFromERC20): Promise<MsgConvertCosmosCoinFromERC20Response> {
    const data = MsgConvertCosmosCoinFromERC20.encode(request).finish();
    const promise = this.rpc.request(this.service, "ConvertCosmosCoinFromERC20", data);
    return promise.then((data) => MsgConvertCosmosCoinFromERC20Response.decode(_m0.Reader.create(data)));
  }
}

interface Rpc {
  request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
