// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/hard/v1beta1/genesis.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";
import { Borrow, Deposit, Params } from "./hard";

export const protobufPackage = "kava.hard.v1beta1";

/** GenesisState defines the hard module's genesis state. */
export interface GenesisState {
  params?: Params | undefined;
  previousAccumulationTimes: GenesisAccumulationTime[];
  deposits: Deposit[];
  borrows: Borrow[];
  totalSupplied: Coin[];
  totalBorrowed: Coin[];
  totalReserves: Coin[];
}

/** GenesisAccumulationTime stores the previous distribution time and its corresponding denom. */
export interface GenesisAccumulationTime {
  collateralType: string;
  previousAccumulationTime?: Date | undefined;
  supplyInterestFactor: string;
  borrowInterestFactor: string;
}

function createBaseGenesisState(): GenesisState {
  return {
    params: undefined,
    previousAccumulationTimes: [],
    deposits: [],
    borrows: [],
    totalSupplied: [],
    totalBorrowed: [],
    totalReserves: [],
  };
}

export const GenesisState = {
  encode(message: GenesisState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.previousAccumulationTimes) {
      GenesisAccumulationTime.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.deposits) {
      Deposit.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.borrows) {
      Borrow.encode(v!, writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.totalSupplied) {
      Coin.encode(v!, writer.uint32(42).fork()).ldelim();
    }
    for (const v of message.totalBorrowed) {
      Coin.encode(v!, writer.uint32(50).fork()).ldelim();
    }
    for (const v of message.totalReserves) {
      Coin.encode(v!, writer.uint32(58).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.previousAccumulationTimes.push(GenesisAccumulationTime.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.deposits.push(Deposit.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.borrows.push(Borrow.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.totalSupplied.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.totalBorrowed.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.totalReserves.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisState {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      previousAccumulationTimes: globalThis.Array.isArray(object?.previousAccumulationTimes)
        ? object.previousAccumulationTimes.map((e: any) => GenesisAccumulationTime.fromJSON(e))
        : [],
      deposits: globalThis.Array.isArray(object?.deposits) ? object.deposits.map((e: any) => Deposit.fromJSON(e)) : [],
      borrows: globalThis.Array.isArray(object?.borrows) ? object.borrows.map((e: any) => Borrow.fromJSON(e)) : [],
      totalSupplied: globalThis.Array.isArray(object?.totalSupplied)
        ? object.totalSupplied.map((e: any) => Coin.fromJSON(e))
        : [],
      totalBorrowed: globalThis.Array.isArray(object?.totalBorrowed)
        ? object.totalBorrowed.map((e: any) => Coin.fromJSON(e))
        : [],
      totalReserves: globalThis.Array.isArray(object?.totalReserves)
        ? object.totalReserves.map((e: any) => Coin.fromJSON(e))
        : [],
    };
  },

  toJSON(message: GenesisState): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    if (message.previousAccumulationTimes?.length) {
      obj.previousAccumulationTimes = message.previousAccumulationTimes.map((e) => GenesisAccumulationTime.toJSON(e));
    }
    if (message.deposits?.length) {
      obj.deposits = message.deposits.map((e) => Deposit.toJSON(e));
    }
    if (message.borrows?.length) {
      obj.borrows = message.borrows.map((e) => Borrow.toJSON(e));
    }
    if (message.totalSupplied?.length) {
      obj.totalSupplied = message.totalSupplied.map((e) => Coin.toJSON(e));
    }
    if (message.totalBorrowed?.length) {
      obj.totalBorrowed = message.totalBorrowed.map((e) => Coin.toJSON(e));
    }
    if (message.totalReserves?.length) {
      obj.totalReserves = message.totalReserves.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisState>): GenesisState {
    return GenesisState.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisState>): GenesisState {
    const message = createBaseGenesisState();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    message.previousAccumulationTimes =
      object.previousAccumulationTimes?.map((e) => GenesisAccumulationTime.fromPartial(e)) || [];
    message.deposits = object.deposits?.map((e) => Deposit.fromPartial(e)) || [];
    message.borrows = object.borrows?.map((e) => Borrow.fromPartial(e)) || [];
    message.totalSupplied = object.totalSupplied?.map((e) => Coin.fromPartial(e)) || [];
    message.totalBorrowed = object.totalBorrowed?.map((e) => Coin.fromPartial(e)) || [];
    message.totalReserves = object.totalReserves?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseGenesisAccumulationTime(): GenesisAccumulationTime {
  return {
    collateralType: "",
    previousAccumulationTime: undefined,
    supplyInterestFactor: "",
    borrowInterestFactor: "",
  };
}

export const GenesisAccumulationTime = {
  encode(message: GenesisAccumulationTime, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.previousAccumulationTime !== undefined) {
      Timestamp.encode(toTimestamp(message.previousAccumulationTime), writer.uint32(18).fork()).ldelim();
    }
    if (message.supplyInterestFactor !== "") {
      writer.uint32(26).string(message.supplyInterestFactor);
    }
    if (message.borrowInterestFactor !== "") {
      writer.uint32(34).string(message.borrowInterestFactor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisAccumulationTime {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisAccumulationTime();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.previousAccumulationTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.supplyInterestFactor = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.borrowInterestFactor = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisAccumulationTime {
    return {
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      previousAccumulationTime: isSet(object.previousAccumulationTime)
        ? fromJsonTimestamp(object.previousAccumulationTime)
        : undefined,
      supplyInterestFactor: isSet(object.supplyInterestFactor) ? globalThis.String(object.supplyInterestFactor) : "",
      borrowInterestFactor: isSet(object.borrowInterestFactor) ? globalThis.String(object.borrowInterestFactor) : "",
    };
  },

  toJSON(message: GenesisAccumulationTime): unknown {
    const obj: any = {};
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.previousAccumulationTime !== undefined) {
      obj.previousAccumulationTime = message.previousAccumulationTime.toISOString();
    }
    if (message.supplyInterestFactor !== "") {
      obj.supplyInterestFactor = message.supplyInterestFactor;
    }
    if (message.borrowInterestFactor !== "") {
      obj.borrowInterestFactor = message.borrowInterestFactor;
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisAccumulationTime>): GenesisAccumulationTime {
    return GenesisAccumulationTime.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisAccumulationTime>): GenesisAccumulationTime {
    const message = createBaseGenesisAccumulationTime();
    message.collateralType = object.collateralType ?? "";
    message.previousAccumulationTime = object.previousAccumulationTime ?? undefined;
    message.supplyInterestFactor = object.supplyInterestFactor ?? "";
    message.borrowInterestFactor = object.borrowInterestFactor ?? "";
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function toTimestamp(date: Date): Timestamp {
  const seconds = numberToLong(Math.trunc(date.getTime() / 1_000));
  const nanos = (date.getTime() % 1_000) * 1_000_000;
  return { seconds, nanos };
}

function fromTimestamp(t: Timestamp): Date {
  let millis = (t.seconds.toNumber() || 0) * 1_000;
  millis += (t.nanos || 0) / 1_000_000;
  return new globalThis.Date(millis);
}

function fromJsonTimestamp(o: any): Date {
  if (o instanceof globalThis.Date) {
    return o;
  } else if (typeof o === "string") {
    return new globalThis.Date(o);
  } else {
    return fromTimestamp(Timestamp.fromJSON(o));
  }
}

function numberToLong(number: number) {
  return Long.fromNumber(number);
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
