// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/hard/v1beta1/hard.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";

export const protobufPackage = "kava.hard.v1beta1";

/** Params defines the parameters for the hard module. */
export interface Params {
  moneyMarkets: MoneyMarket[];
  minimumBorrowUsdValue: string;
}

/** MoneyMarket is a money market for an individual asset. */
export interface MoneyMarket {
  denom: string;
  borrowLimit?: BorrowLimit | undefined;
  spotMarketId: string;
  conversionFactor: string;
  interestRateModel?: InterestRateModel | undefined;
  reserveFactor: string;
  keeperRewardPercentage: string;
}

/** BorrowLimit enforces restrictions on a money market. */
export interface BorrowLimit {
  hasMaxLimit: boolean;
  maximumLimit: string;
  loanToValue: string;
}

/** InterestRateModel contains information about an asset's interest rate. */
export interface InterestRateModel {
  baseRateApy: string;
  baseMultiplier: string;
  kink: string;
  jumpMultiplier: string;
}

/** Deposit defines an amount of coins deposited into a hard module account. */
export interface Deposit {
  depositor: string;
  amount: Coin[];
  index: SupplyInterestFactor[];
}

/** Borrow defines an amount of coins borrowed from a hard module account. */
export interface Borrow {
  borrower: string;
  amount: Coin[];
  index: BorrowInterestFactor[];
}

/** SupplyInterestFactor defines an individual borrow interest factor. */
export interface SupplyInterestFactor {
  denom: string;
  value: string;
}

/** BorrowInterestFactor defines an individual borrow interest factor. */
export interface BorrowInterestFactor {
  denom: string;
  value: string;
}

/** CoinsProto defines a Protobuf wrapper around a Coins slice */
export interface CoinsProto {
  coins: Coin[];
}

function createBaseParams(): Params {
  return { moneyMarkets: [], minimumBorrowUsdValue: "" };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.moneyMarkets) {
      MoneyMarket.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.minimumBorrowUsdValue !== "") {
      writer.uint32(18).string(message.minimumBorrowUsdValue);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.moneyMarkets.push(MoneyMarket.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.minimumBorrowUsdValue = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      moneyMarkets: globalThis.Array.isArray(object?.moneyMarkets)
        ? object.moneyMarkets.map((e: any) => MoneyMarket.fromJSON(e))
        : [],
      minimumBorrowUsdValue: isSet(object.minimumBorrowUsdValue) ? globalThis.String(object.minimumBorrowUsdValue) : "",
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.moneyMarkets?.length) {
      obj.moneyMarkets = message.moneyMarkets.map((e) => MoneyMarket.toJSON(e));
    }
    if (message.minimumBorrowUsdValue !== "") {
      obj.minimumBorrowUsdValue = message.minimumBorrowUsdValue;
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.moneyMarkets = object.moneyMarkets?.map((e) => MoneyMarket.fromPartial(e)) || [];
    message.minimumBorrowUsdValue = object.minimumBorrowUsdValue ?? "";
    return message;
  },
};

function createBaseMoneyMarket(): MoneyMarket {
  return {
    denom: "",
    borrowLimit: undefined,
    spotMarketId: "",
    conversionFactor: "",
    interestRateModel: undefined,
    reserveFactor: "",
    keeperRewardPercentage: "",
  };
}

export const MoneyMarket = {
  encode(message: MoneyMarket, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.borrowLimit !== undefined) {
      BorrowLimit.encode(message.borrowLimit, writer.uint32(18).fork()).ldelim();
    }
    if (message.spotMarketId !== "") {
      writer.uint32(26).string(message.spotMarketId);
    }
    if (message.conversionFactor !== "") {
      writer.uint32(34).string(message.conversionFactor);
    }
    if (message.interestRateModel !== undefined) {
      InterestRateModel.encode(message.interestRateModel, writer.uint32(42).fork()).ldelim();
    }
    if (message.reserveFactor !== "") {
      writer.uint32(50).string(message.reserveFactor);
    }
    if (message.keeperRewardPercentage !== "") {
      writer.uint32(58).string(message.keeperRewardPercentage);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MoneyMarket {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMoneyMarket();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.borrowLimit = BorrowLimit.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.spotMarketId = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.conversionFactor = reader.string();
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.interestRateModel = InterestRateModel.decode(reader, reader.uint32());
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.reserveFactor = reader.string();
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.keeperRewardPercentage = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MoneyMarket {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      borrowLimit: isSet(object.borrowLimit) ? BorrowLimit.fromJSON(object.borrowLimit) : undefined,
      spotMarketId: isSet(object.spotMarketId) ? globalThis.String(object.spotMarketId) : "",
      conversionFactor: isSet(object.conversionFactor) ? globalThis.String(object.conversionFactor) : "",
      interestRateModel: isSet(object.interestRateModel)
        ? InterestRateModel.fromJSON(object.interestRateModel)
        : undefined,
      reserveFactor: isSet(object.reserveFactor) ? globalThis.String(object.reserveFactor) : "",
      keeperRewardPercentage: isSet(object.keeperRewardPercentage)
        ? globalThis.String(object.keeperRewardPercentage)
        : "",
    };
  },

  toJSON(message: MoneyMarket): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.borrowLimit !== undefined) {
      obj.borrowLimit = BorrowLimit.toJSON(message.borrowLimit);
    }
    if (message.spotMarketId !== "") {
      obj.spotMarketId = message.spotMarketId;
    }
    if (message.conversionFactor !== "") {
      obj.conversionFactor = message.conversionFactor;
    }
    if (message.interestRateModel !== undefined) {
      obj.interestRateModel = InterestRateModel.toJSON(message.interestRateModel);
    }
    if (message.reserveFactor !== "") {
      obj.reserveFactor = message.reserveFactor;
    }
    if (message.keeperRewardPercentage !== "") {
      obj.keeperRewardPercentage = message.keeperRewardPercentage;
    }
    return obj;
  },

  create(base?: DeepPartial<MoneyMarket>): MoneyMarket {
    return MoneyMarket.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MoneyMarket>): MoneyMarket {
    const message = createBaseMoneyMarket();
    message.denom = object.denom ?? "";
    message.borrowLimit = (object.borrowLimit !== undefined && object.borrowLimit !== null)
      ? BorrowLimit.fromPartial(object.borrowLimit)
      : undefined;
    message.spotMarketId = object.spotMarketId ?? "";
    message.conversionFactor = object.conversionFactor ?? "";
    message.interestRateModel = (object.interestRateModel !== undefined && object.interestRateModel !== null)
      ? InterestRateModel.fromPartial(object.interestRateModel)
      : undefined;
    message.reserveFactor = object.reserveFactor ?? "";
    message.keeperRewardPercentage = object.keeperRewardPercentage ?? "";
    return message;
  },
};

function createBaseBorrowLimit(): BorrowLimit {
  return { hasMaxLimit: false, maximumLimit: "", loanToValue: "" };
}

export const BorrowLimit = {
  encode(message: BorrowLimit, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.hasMaxLimit !== false) {
      writer.uint32(8).bool(message.hasMaxLimit);
    }
    if (message.maximumLimit !== "") {
      writer.uint32(18).string(message.maximumLimit);
    }
    if (message.loanToValue !== "") {
      writer.uint32(26).string(message.loanToValue);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BorrowLimit {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrowLimit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.hasMaxLimit = reader.bool();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.maximumLimit = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.loanToValue = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BorrowLimit {
    return {
      hasMaxLimit: isSet(object.hasMaxLimit) ? globalThis.Boolean(object.hasMaxLimit) : false,
      maximumLimit: isSet(object.maximumLimit) ? globalThis.String(object.maximumLimit) : "",
      loanToValue: isSet(object.loanToValue) ? globalThis.String(object.loanToValue) : "",
    };
  },

  toJSON(message: BorrowLimit): unknown {
    const obj: any = {};
    if (message.hasMaxLimit !== false) {
      obj.hasMaxLimit = message.hasMaxLimit;
    }
    if (message.maximumLimit !== "") {
      obj.maximumLimit = message.maximumLimit;
    }
    if (message.loanToValue !== "") {
      obj.loanToValue = message.loanToValue;
    }
    return obj;
  },

  create(base?: DeepPartial<BorrowLimit>): BorrowLimit {
    return BorrowLimit.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BorrowLimit>): BorrowLimit {
    const message = createBaseBorrowLimit();
    message.hasMaxLimit = object.hasMaxLimit ?? false;
    message.maximumLimit = object.maximumLimit ?? "";
    message.loanToValue = object.loanToValue ?? "";
    return message;
  },
};

function createBaseInterestRateModel(): InterestRateModel {
  return { baseRateApy: "", baseMultiplier: "", kink: "", jumpMultiplier: "" };
}

export const InterestRateModel = {
  encode(message: InterestRateModel, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseRateApy !== "") {
      writer.uint32(10).string(message.baseRateApy);
    }
    if (message.baseMultiplier !== "") {
      writer.uint32(18).string(message.baseMultiplier);
    }
    if (message.kink !== "") {
      writer.uint32(26).string(message.kink);
    }
    if (message.jumpMultiplier !== "") {
      writer.uint32(34).string(message.jumpMultiplier);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): InterestRateModel {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseInterestRateModel();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseRateApy = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.baseMultiplier = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.kink = reader.string();
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.jumpMultiplier = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): InterestRateModel {
    return {
      baseRateApy: isSet(object.baseRateApy) ? globalThis.String(object.baseRateApy) : "",
      baseMultiplier: isSet(object.baseMultiplier) ? globalThis.String(object.baseMultiplier) : "",
      kink: isSet(object.kink) ? globalThis.String(object.kink) : "",
      jumpMultiplier: isSet(object.jumpMultiplier) ? globalThis.String(object.jumpMultiplier) : "",
    };
  },

  toJSON(message: InterestRateModel): unknown {
    const obj: any = {};
    if (message.baseRateApy !== "") {
      obj.baseRateApy = message.baseRateApy;
    }
    if (message.baseMultiplier !== "") {
      obj.baseMultiplier = message.baseMultiplier;
    }
    if (message.kink !== "") {
      obj.kink = message.kink;
    }
    if (message.jumpMultiplier !== "") {
      obj.jumpMultiplier = message.jumpMultiplier;
    }
    return obj;
  },

  create(base?: DeepPartial<InterestRateModel>): InterestRateModel {
    return InterestRateModel.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<InterestRateModel>): InterestRateModel {
    const message = createBaseInterestRateModel();
    message.baseRateApy = object.baseRateApy ?? "";
    message.baseMultiplier = object.baseMultiplier ?? "";
    message.kink = object.kink ?? "";
    message.jumpMultiplier = object.jumpMultiplier ?? "";
    return message;
  },
};

function createBaseDeposit(): Deposit {
  return { depositor: "", amount: [], index: [] };
}

export const Deposit = {
  encode(message: Deposit, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.index) {
      SupplyInterestFactor.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Deposit {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDeposit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.depositor = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.index.push(SupplyInterestFactor.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Deposit {
    return {
      depositor: isSet(object.depositor) ? globalThis.String(object.depositor) : "",
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
      index: globalThis.Array.isArray(object?.index)
        ? object.index.map((e: any) => SupplyInterestFactor.fromJSON(e))
        : [],
    };
  },

  toJSON(message: Deposit): unknown {
    const obj: any = {};
    if (message.depositor !== "") {
      obj.depositor = message.depositor;
    }
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    if (message.index?.length) {
      obj.index = message.index.map((e) => SupplyInterestFactor.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<Deposit>): Deposit {
    return Deposit.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Deposit>): Deposit {
    const message = createBaseDeposit();
    message.depositor = object.depositor ?? "";
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    message.index = object.index?.map((e) => SupplyInterestFactor.fromPartial(e)) || [];
    return message;
  },
};

function createBaseBorrow(): Borrow {
  return { borrower: "", amount: [], index: [] };
}

export const Borrow = {
  encode(message: Borrow, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.borrower !== "") {
      writer.uint32(10).string(message.borrower);
    }
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.index) {
      BorrowInterestFactor.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Borrow {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrow();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.borrower = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.index.push(BorrowInterestFactor.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Borrow {
    return {
      borrower: isSet(object.borrower) ? globalThis.String(object.borrower) : "",
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
      index: globalThis.Array.isArray(object?.index)
        ? object.index.map((e: any) => BorrowInterestFactor.fromJSON(e))
        : [],
    };
  },

  toJSON(message: Borrow): unknown {
    const obj: any = {};
    if (message.borrower !== "") {
      obj.borrower = message.borrower;
    }
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    if (message.index?.length) {
      obj.index = message.index.map((e) => BorrowInterestFactor.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<Borrow>): Borrow {
    return Borrow.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Borrow>): Borrow {
    const message = createBaseBorrow();
    message.borrower = object.borrower ?? "";
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    message.index = object.index?.map((e) => BorrowInterestFactor.fromPartial(e)) || [];
    return message;
  },
};

function createBaseSupplyInterestFactor(): SupplyInterestFactor {
  return { denom: "", value: "" };
}

export const SupplyInterestFactor = {
  encode(message: SupplyInterestFactor, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SupplyInterestFactor {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSupplyInterestFactor();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.value = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SupplyInterestFactor {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      value: isSet(object.value) ? globalThis.String(object.value) : "",
    };
  },

  toJSON(message: SupplyInterestFactor): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.value !== "") {
      obj.value = message.value;
    }
    return obj;
  },

  create(base?: DeepPartial<SupplyInterestFactor>): SupplyInterestFactor {
    return SupplyInterestFactor.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<SupplyInterestFactor>): SupplyInterestFactor {
    const message = createBaseSupplyInterestFactor();
    message.denom = object.denom ?? "";
    message.value = object.value ?? "";
    return message;
  },
};

function createBaseBorrowInterestFactor(): BorrowInterestFactor {
  return { denom: "", value: "" };
}

export const BorrowInterestFactor = {
  encode(message: BorrowInterestFactor, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BorrowInterestFactor {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrowInterestFactor();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.value = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BorrowInterestFactor {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      value: isSet(object.value) ? globalThis.String(object.value) : "",
    };
  },

  toJSON(message: BorrowInterestFactor): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.value !== "") {
      obj.value = message.value;
    }
    return obj;
  },

  create(base?: DeepPartial<BorrowInterestFactor>): BorrowInterestFactor {
    return BorrowInterestFactor.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BorrowInterestFactor>): BorrowInterestFactor {
    const message = createBaseBorrowInterestFactor();
    message.denom = object.denom ?? "";
    message.value = object.value ?? "";
    return message;
  },
};

function createBaseCoinsProto(): CoinsProto {
  return { coins: [] };
}

export const CoinsProto = {
  encode(message: CoinsProto, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.coins) {
      Coin.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CoinsProto {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCoinsProto();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.coins.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CoinsProto {
    return { coins: globalThis.Array.isArray(object?.coins) ? object.coins.map((e: any) => Coin.fromJSON(e)) : [] };
  },

  toJSON(message: CoinsProto): unknown {
    const obj: any = {};
    if (message.coins?.length) {
      obj.coins = message.coins.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<CoinsProto>): CoinsProto {
    return CoinsProto.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CoinsProto>): CoinsProto {
    const message = createBaseCoinsProto();
    message.coins = object.coins?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
