// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/hard/v1beta1/query.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { ModuleAccount } from "../../../cosmos/auth/v1beta1/auth";
import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Params } from "./hard";

export const protobufPackage = "kava.hard.v1beta1";

/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}

/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
  params?: Params | undefined;
}

/** QueryAccountsRequest is the request type for the Query/Accounts RPC method. */
export interface QueryAccountsRequest {
}

/** QueryAccountsResponse is the response type for the Query/Accounts RPC method. */
export interface QueryAccountsResponse {
  accounts: ModuleAccount[];
}

/** QueryDepositsRequest is the request type for the Query/Deposits RPC method. */
export interface QueryDepositsRequest {
  denom: string;
  owner: string;
  pagination?: PageRequest | undefined;
}

/** QueryDepositsResponse is the response type for the Query/Deposits RPC method. */
export interface QueryDepositsResponse {
  deposits: DepositResponse[];
  pagination?: PageResponse | undefined;
}

/** QueryUnsyncedDepositsRequest is the request type for the Query/UnsyncedDeposits RPC method. */
export interface QueryUnsyncedDepositsRequest {
  denom: string;
  owner: string;
  pagination?: PageRequest | undefined;
}

/** QueryUnsyncedDepositsResponse is the response type for the Query/UnsyncedDeposits RPC method. */
export interface QueryUnsyncedDepositsResponse {
  deposits: DepositResponse[];
  pagination?: PageResponse | undefined;
}

/** QueryTotalDepositedRequest is the request type for the Query/TotalDeposited RPC method. */
export interface QueryTotalDepositedRequest {
  denom: string;
}

/** QueryTotalDepositedResponse is the response type for the Query/TotalDeposited RPC method. */
export interface QueryTotalDepositedResponse {
  suppliedCoins: Coin[];
}

/** QueryBorrowsRequest is the request type for the Query/Borrows RPC method. */
export interface QueryBorrowsRequest {
  denom: string;
  owner: string;
  pagination?: PageRequest | undefined;
}

/** QueryBorrowsResponse is the response type for the Query/Borrows RPC method. */
export interface QueryBorrowsResponse {
  borrows: BorrowResponse[];
  pagination?: PageResponse | undefined;
}

/** QueryUnsyncedBorrowsRequest is the request type for the Query/UnsyncedBorrows RPC method. */
export interface QueryUnsyncedBorrowsRequest {
  denom: string;
  owner: string;
  pagination?: PageRequest | undefined;
}

/** QueryUnsyncedBorrowsResponse is the response type for the Query/UnsyncedBorrows RPC method. */
export interface QueryUnsyncedBorrowsResponse {
  borrows: BorrowResponse[];
  pagination?: PageResponse | undefined;
}

/** QueryTotalBorrowedRequest is the request type for the Query/TotalBorrowed RPC method. */
export interface QueryTotalBorrowedRequest {
  denom: string;
}

/** QueryTotalBorrowedResponse is the response type for the Query/TotalBorrowed RPC method. */
export interface QueryTotalBorrowedResponse {
  borrowedCoins: Coin[];
}

/** QueryInterestRateRequest is the request type for the Query/InterestRate RPC method. */
export interface QueryInterestRateRequest {
  denom: string;
}

/** QueryInterestRateResponse is the response type for the Query/InterestRate RPC method. */
export interface QueryInterestRateResponse {
  interestRates: MoneyMarketInterestRate[];
}

/** QueryReservesRequest is the request type for the Query/Reserves RPC method. */
export interface QueryReservesRequest {
  denom: string;
}

/** QueryReservesResponse is the response type for the Query/Reserves RPC method. */
export interface QueryReservesResponse {
  amount: Coin[];
}

/** QueryInterestFactorsRequest is the request type for the Query/InterestFactors RPC method. */
export interface QueryInterestFactorsRequest {
  denom: string;
}

/** QueryInterestFactorsResponse is the response type for the Query/InterestFactors RPC method. */
export interface QueryInterestFactorsResponse {
  interestFactors: InterestFactor[];
}

/** DepositResponse defines an amount of coins deposited into a hard module account. */
export interface DepositResponse {
  depositor: string;
  amount: Coin[];
  index: SupplyInterestFactorResponse[];
}

/** SupplyInterestFactorResponse defines an individual borrow interest factor. */
export interface SupplyInterestFactorResponse {
  denom: string;
  /** sdk.Dec as string */
  value: string;
}

/** BorrowResponse defines an amount of coins borrowed from a hard module account. */
export interface BorrowResponse {
  borrower: string;
  amount: Coin[];
  index: BorrowInterestFactorResponse[];
}

/** BorrowInterestFactorResponse defines an individual borrow interest factor. */
export interface BorrowInterestFactorResponse {
  denom: string;
  /** sdk.Dec as string */
  value: string;
}

/** MoneyMarketInterestRate is a unique type returned by interest rate queries */
export interface MoneyMarketInterestRate {
  denom: string;
  /** sdk.Dec as String */
  supplyInterestRate: string;
  /** sdk.Dec as String */
  borrowInterestRate: string;
}

/** InterestFactor is a unique type returned by interest factor queries */
export interface InterestFactor {
  denom: string;
  /** sdk.Dec as String */
  borrowInterestFactor: string;
  /** sdk.Dec as String */
  supplyInterestFactor: string;
}

function createBaseQueryParamsRequest(): QueryParamsRequest {
  return {};
}

export const QueryParamsRequest = {
  encode(_: QueryParamsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): QueryParamsRequest {
    return {};
  },

  toJSON(_: QueryParamsRequest): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest {
    return QueryParamsRequest.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest {
    const message = createBaseQueryParamsRequest();
    return message;
  },
};

function createBaseQueryParamsResponse(): QueryParamsResponse {
  return { params: undefined };
}

export const QueryParamsResponse = {
  encode(message: QueryParamsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryParamsResponse {
    return { params: isSet(object.params) ? Params.fromJSON(object.params) : undefined };
  },

  toJSON(message: QueryParamsResponse): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse {
    return QueryParamsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse {
    const message = createBaseQueryParamsResponse();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    return message;
  },
};

function createBaseQueryAccountsRequest(): QueryAccountsRequest {
  return {};
}

export const QueryAccountsRequest = {
  encode(_: QueryAccountsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryAccountsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAccountsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): QueryAccountsRequest {
    return {};
  },

  toJSON(_: QueryAccountsRequest): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<QueryAccountsRequest>): QueryAccountsRequest {
    return QueryAccountsRequest.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<QueryAccountsRequest>): QueryAccountsRequest {
    const message = createBaseQueryAccountsRequest();
    return message;
  },
};

function createBaseQueryAccountsResponse(): QueryAccountsResponse {
  return { accounts: [] };
}

export const QueryAccountsResponse = {
  encode(message: QueryAccountsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.accounts) {
      ModuleAccount.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryAccountsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryAccountsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.accounts.push(ModuleAccount.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryAccountsResponse {
    return {
      accounts: globalThis.Array.isArray(object?.accounts)
        ? object.accounts.map((e: any) => ModuleAccount.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryAccountsResponse): unknown {
    const obj: any = {};
    if (message.accounts?.length) {
      obj.accounts = message.accounts.map((e) => ModuleAccount.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryAccountsResponse>): QueryAccountsResponse {
    return QueryAccountsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryAccountsResponse>): QueryAccountsResponse {
    const message = createBaseQueryAccountsResponse();
    message.accounts = object.accounts?.map((e) => ModuleAccount.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryDepositsRequest(): QueryDepositsRequest {
  return { denom: "", owner: "", pagination: undefined };
}

export const QueryDepositsRequest = {
  encode(message: QueryDepositsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryDepositsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDepositsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.owner = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.pagination = PageRequest.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryDepositsRequest {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      owner: isSet(object.owner) ? globalThis.String(object.owner) : "",
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryDepositsRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.owner !== "") {
      obj.owner = message.owner;
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageRequest.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryDepositsRequest>): QueryDepositsRequest {
    return QueryDepositsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryDepositsRequest>): QueryDepositsRequest {
    const message = createBaseQueryDepositsRequest();
    message.denom = object.denom ?? "";
    message.owner = object.owner ?? "";
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageRequest.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryDepositsResponse(): QueryDepositsResponse {
  return { deposits: [], pagination: undefined };
}

export const QueryDepositsResponse = {
  encode(message: QueryDepositsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.deposits) {
      DepositResponse.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryDepositsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryDepositsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.deposits.push(DepositResponse.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.pagination = PageResponse.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryDepositsResponse {
    return {
      deposits: globalThis.Array.isArray(object?.deposits)
        ? object.deposits.map((e: any) => DepositResponse.fromJSON(e))
        : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryDepositsResponse): unknown {
    const obj: any = {};
    if (message.deposits?.length) {
      obj.deposits = message.deposits.map((e) => DepositResponse.toJSON(e));
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageResponse.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryDepositsResponse>): QueryDepositsResponse {
    return QueryDepositsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryDepositsResponse>): QueryDepositsResponse {
    const message = createBaseQueryDepositsResponse();
    message.deposits = object.deposits?.map((e) => DepositResponse.fromPartial(e)) || [];
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageResponse.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryUnsyncedDepositsRequest(): QueryUnsyncedDepositsRequest {
  return { denom: "", owner: "", pagination: undefined };
}

export const QueryUnsyncedDepositsRequest = {
  encode(message: QueryUnsyncedDepositsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryUnsyncedDepositsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryUnsyncedDepositsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.owner = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.pagination = PageRequest.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryUnsyncedDepositsRequest {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      owner: isSet(object.owner) ? globalThis.String(object.owner) : "",
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryUnsyncedDepositsRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.owner !== "") {
      obj.owner = message.owner;
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageRequest.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryUnsyncedDepositsRequest>): QueryUnsyncedDepositsRequest {
    return QueryUnsyncedDepositsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryUnsyncedDepositsRequest>): QueryUnsyncedDepositsRequest {
    const message = createBaseQueryUnsyncedDepositsRequest();
    message.denom = object.denom ?? "";
    message.owner = object.owner ?? "";
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageRequest.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryUnsyncedDepositsResponse(): QueryUnsyncedDepositsResponse {
  return { deposits: [], pagination: undefined };
}

export const QueryUnsyncedDepositsResponse = {
  encode(message: QueryUnsyncedDepositsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.deposits) {
      DepositResponse.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryUnsyncedDepositsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryUnsyncedDepositsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.deposits.push(DepositResponse.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.pagination = PageResponse.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryUnsyncedDepositsResponse {
    return {
      deposits: globalThis.Array.isArray(object?.deposits)
        ? object.deposits.map((e: any) => DepositResponse.fromJSON(e))
        : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryUnsyncedDepositsResponse): unknown {
    const obj: any = {};
    if (message.deposits?.length) {
      obj.deposits = message.deposits.map((e) => DepositResponse.toJSON(e));
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageResponse.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryUnsyncedDepositsResponse>): QueryUnsyncedDepositsResponse {
    return QueryUnsyncedDepositsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryUnsyncedDepositsResponse>): QueryUnsyncedDepositsResponse {
    const message = createBaseQueryUnsyncedDepositsResponse();
    message.deposits = object.deposits?.map((e) => DepositResponse.fromPartial(e)) || [];
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageResponse.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryTotalDepositedRequest(): QueryTotalDepositedRequest {
  return { denom: "" };
}

export const QueryTotalDepositedRequest = {
  encode(message: QueryTotalDepositedRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalDepositedRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalDepositedRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryTotalDepositedRequest {
    return { denom: isSet(object.denom) ? globalThis.String(object.denom) : "" };
  },

  toJSON(message: QueryTotalDepositedRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    return obj;
  },

  create(base?: DeepPartial<QueryTotalDepositedRequest>): QueryTotalDepositedRequest {
    return QueryTotalDepositedRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryTotalDepositedRequest>): QueryTotalDepositedRequest {
    const message = createBaseQueryTotalDepositedRequest();
    message.denom = object.denom ?? "";
    return message;
  },
};

function createBaseQueryTotalDepositedResponse(): QueryTotalDepositedResponse {
  return { suppliedCoins: [] };
}

export const QueryTotalDepositedResponse = {
  encode(message: QueryTotalDepositedResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.suppliedCoins) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalDepositedResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalDepositedResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 2:
          if (tag !== 18) {
            break;
          }

          message.suppliedCoins.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryTotalDepositedResponse {
    return {
      suppliedCoins: globalThis.Array.isArray(object?.suppliedCoins)
        ? object.suppliedCoins.map((e: any) => Coin.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryTotalDepositedResponse): unknown {
    const obj: any = {};
    if (message.suppliedCoins?.length) {
      obj.suppliedCoins = message.suppliedCoins.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryTotalDepositedResponse>): QueryTotalDepositedResponse {
    return QueryTotalDepositedResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryTotalDepositedResponse>): QueryTotalDepositedResponse {
    const message = createBaseQueryTotalDepositedResponse();
    message.suppliedCoins = object.suppliedCoins?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryBorrowsRequest(): QueryBorrowsRequest {
  return { denom: "", owner: "", pagination: undefined };
}

export const QueryBorrowsRequest = {
  encode(message: QueryBorrowsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryBorrowsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryBorrowsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.owner = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.pagination = PageRequest.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryBorrowsRequest {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      owner: isSet(object.owner) ? globalThis.String(object.owner) : "",
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryBorrowsRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.owner !== "") {
      obj.owner = message.owner;
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageRequest.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryBorrowsRequest>): QueryBorrowsRequest {
    return QueryBorrowsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryBorrowsRequest>): QueryBorrowsRequest {
    const message = createBaseQueryBorrowsRequest();
    message.denom = object.denom ?? "";
    message.owner = object.owner ?? "";
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageRequest.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryBorrowsResponse(): QueryBorrowsResponse {
  return { borrows: [], pagination: undefined };
}

export const QueryBorrowsResponse = {
  encode(message: QueryBorrowsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.borrows) {
      BorrowResponse.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryBorrowsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryBorrowsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.borrows.push(BorrowResponse.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.pagination = PageResponse.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryBorrowsResponse {
    return {
      borrows: globalThis.Array.isArray(object?.borrows)
        ? object.borrows.map((e: any) => BorrowResponse.fromJSON(e))
        : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryBorrowsResponse): unknown {
    const obj: any = {};
    if (message.borrows?.length) {
      obj.borrows = message.borrows.map((e) => BorrowResponse.toJSON(e));
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageResponse.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryBorrowsResponse>): QueryBorrowsResponse {
    return QueryBorrowsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryBorrowsResponse>): QueryBorrowsResponse {
    const message = createBaseQueryBorrowsResponse();
    message.borrows = object.borrows?.map((e) => BorrowResponse.fromPartial(e)) || [];
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageResponse.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryUnsyncedBorrowsRequest(): QueryUnsyncedBorrowsRequest {
  return { denom: "", owner: "", pagination: undefined };
}

export const QueryUnsyncedBorrowsRequest = {
  encode(message: QueryUnsyncedBorrowsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.owner !== "") {
      writer.uint32(18).string(message.owner);
    }
    if (message.pagination !== undefined) {
      PageRequest.encode(message.pagination, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryUnsyncedBorrowsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryUnsyncedBorrowsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.owner = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.pagination = PageRequest.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryUnsyncedBorrowsRequest {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      owner: isSet(object.owner) ? globalThis.String(object.owner) : "",
      pagination: isSet(object.pagination) ? PageRequest.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryUnsyncedBorrowsRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.owner !== "") {
      obj.owner = message.owner;
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageRequest.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryUnsyncedBorrowsRequest>): QueryUnsyncedBorrowsRequest {
    return QueryUnsyncedBorrowsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryUnsyncedBorrowsRequest>): QueryUnsyncedBorrowsRequest {
    const message = createBaseQueryUnsyncedBorrowsRequest();
    message.denom = object.denom ?? "";
    message.owner = object.owner ?? "";
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageRequest.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryUnsyncedBorrowsResponse(): QueryUnsyncedBorrowsResponse {
  return { borrows: [], pagination: undefined };
}

export const QueryUnsyncedBorrowsResponse = {
  encode(message: QueryUnsyncedBorrowsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.borrows) {
      BorrowResponse.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.pagination !== undefined) {
      PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryUnsyncedBorrowsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryUnsyncedBorrowsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.borrows.push(BorrowResponse.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.pagination = PageResponse.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryUnsyncedBorrowsResponse {
    return {
      borrows: globalThis.Array.isArray(object?.borrows)
        ? object.borrows.map((e: any) => BorrowResponse.fromJSON(e))
        : [],
      pagination: isSet(object.pagination) ? PageResponse.fromJSON(object.pagination) : undefined,
    };
  },

  toJSON(message: QueryUnsyncedBorrowsResponse): unknown {
    const obj: any = {};
    if (message.borrows?.length) {
      obj.borrows = message.borrows.map((e) => BorrowResponse.toJSON(e));
    }
    if (message.pagination !== undefined) {
      obj.pagination = PageResponse.toJSON(message.pagination);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryUnsyncedBorrowsResponse>): QueryUnsyncedBorrowsResponse {
    return QueryUnsyncedBorrowsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryUnsyncedBorrowsResponse>): QueryUnsyncedBorrowsResponse {
    const message = createBaseQueryUnsyncedBorrowsResponse();
    message.borrows = object.borrows?.map((e) => BorrowResponse.fromPartial(e)) || [];
    message.pagination = (object.pagination !== undefined && object.pagination !== null)
      ? PageResponse.fromPartial(object.pagination)
      : undefined;
    return message;
  },
};

function createBaseQueryTotalBorrowedRequest(): QueryTotalBorrowedRequest {
  return { denom: "" };
}

export const QueryTotalBorrowedRequest = {
  encode(message: QueryTotalBorrowedRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalBorrowedRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalBorrowedRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryTotalBorrowedRequest {
    return { denom: isSet(object.denom) ? globalThis.String(object.denom) : "" };
  },

  toJSON(message: QueryTotalBorrowedRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    return obj;
  },

  create(base?: DeepPartial<QueryTotalBorrowedRequest>): QueryTotalBorrowedRequest {
    return QueryTotalBorrowedRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryTotalBorrowedRequest>): QueryTotalBorrowedRequest {
    const message = createBaseQueryTotalBorrowedRequest();
    message.denom = object.denom ?? "";
    return message;
  },
};

function createBaseQueryTotalBorrowedResponse(): QueryTotalBorrowedResponse {
  return { borrowedCoins: [] };
}

export const QueryTotalBorrowedResponse = {
  encode(message: QueryTotalBorrowedResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.borrowedCoins) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryTotalBorrowedResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryTotalBorrowedResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 2:
          if (tag !== 18) {
            break;
          }

          message.borrowedCoins.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryTotalBorrowedResponse {
    return {
      borrowedCoins: globalThis.Array.isArray(object?.borrowedCoins)
        ? object.borrowedCoins.map((e: any) => Coin.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryTotalBorrowedResponse): unknown {
    const obj: any = {};
    if (message.borrowedCoins?.length) {
      obj.borrowedCoins = message.borrowedCoins.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryTotalBorrowedResponse>): QueryTotalBorrowedResponse {
    return QueryTotalBorrowedResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryTotalBorrowedResponse>): QueryTotalBorrowedResponse {
    const message = createBaseQueryTotalBorrowedResponse();
    message.borrowedCoins = object.borrowedCoins?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryInterestRateRequest(): QueryInterestRateRequest {
  return { denom: "" };
}

export const QueryInterestRateRequest = {
  encode(message: QueryInterestRateRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryInterestRateRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryInterestRateRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryInterestRateRequest {
    return { denom: isSet(object.denom) ? globalThis.String(object.denom) : "" };
  },

  toJSON(message: QueryInterestRateRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    return obj;
  },

  create(base?: DeepPartial<QueryInterestRateRequest>): QueryInterestRateRequest {
    return QueryInterestRateRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryInterestRateRequest>): QueryInterestRateRequest {
    const message = createBaseQueryInterestRateRequest();
    message.denom = object.denom ?? "";
    return message;
  },
};

function createBaseQueryInterestRateResponse(): QueryInterestRateResponse {
  return { interestRates: [] };
}

export const QueryInterestRateResponse = {
  encode(message: QueryInterestRateResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.interestRates) {
      MoneyMarketInterestRate.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryInterestRateResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryInterestRateResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.interestRates.push(MoneyMarketInterestRate.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryInterestRateResponse {
    return {
      interestRates: globalThis.Array.isArray(object?.interestRates)
        ? object.interestRates.map((e: any) => MoneyMarketInterestRate.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryInterestRateResponse): unknown {
    const obj: any = {};
    if (message.interestRates?.length) {
      obj.interestRates = message.interestRates.map((e) => MoneyMarketInterestRate.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryInterestRateResponse>): QueryInterestRateResponse {
    return QueryInterestRateResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryInterestRateResponse>): QueryInterestRateResponse {
    const message = createBaseQueryInterestRateResponse();
    message.interestRates = object.interestRates?.map((e) => MoneyMarketInterestRate.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryReservesRequest(): QueryReservesRequest {
  return { denom: "" };
}

export const QueryReservesRequest = {
  encode(message: QueryReservesRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryReservesRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryReservesRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryReservesRequest {
    return { denom: isSet(object.denom) ? globalThis.String(object.denom) : "" };
  },

  toJSON(message: QueryReservesRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    return obj;
  },

  create(base?: DeepPartial<QueryReservesRequest>): QueryReservesRequest {
    return QueryReservesRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryReservesRequest>): QueryReservesRequest {
    const message = createBaseQueryReservesRequest();
    message.denom = object.denom ?? "";
    return message;
  },
};

function createBaseQueryReservesResponse(): QueryReservesResponse {
  return { amount: [] };
}

export const QueryReservesResponse = {
  encode(message: QueryReservesResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryReservesResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryReservesResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 2:
          if (tag !== 18) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryReservesResponse {
    return { amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [] };
  },

  toJSON(message: QueryReservesResponse): unknown {
    const obj: any = {};
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryReservesResponse>): QueryReservesResponse {
    return QueryReservesResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryReservesResponse>): QueryReservesResponse {
    const message = createBaseQueryReservesResponse();
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryInterestFactorsRequest(): QueryInterestFactorsRequest {
  return { denom: "" };
}

export const QueryInterestFactorsRequest = {
  encode(message: QueryInterestFactorsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryInterestFactorsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryInterestFactorsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryInterestFactorsRequest {
    return { denom: isSet(object.denom) ? globalThis.String(object.denom) : "" };
  },

  toJSON(message: QueryInterestFactorsRequest): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    return obj;
  },

  create(base?: DeepPartial<QueryInterestFactorsRequest>): QueryInterestFactorsRequest {
    return QueryInterestFactorsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryInterestFactorsRequest>): QueryInterestFactorsRequest {
    const message = createBaseQueryInterestFactorsRequest();
    message.denom = object.denom ?? "";
    return message;
  },
};

function createBaseQueryInterestFactorsResponse(): QueryInterestFactorsResponse {
  return { interestFactors: [] };
}

export const QueryInterestFactorsResponse = {
  encode(message: QueryInterestFactorsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.interestFactors) {
      InterestFactor.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryInterestFactorsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryInterestFactorsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.interestFactors.push(InterestFactor.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryInterestFactorsResponse {
    return {
      interestFactors: globalThis.Array.isArray(object?.interestFactors)
        ? object.interestFactors.map((e: any) => InterestFactor.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryInterestFactorsResponse): unknown {
    const obj: any = {};
    if (message.interestFactors?.length) {
      obj.interestFactors = message.interestFactors.map((e) => InterestFactor.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryInterestFactorsResponse>): QueryInterestFactorsResponse {
    return QueryInterestFactorsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryInterestFactorsResponse>): QueryInterestFactorsResponse {
    const message = createBaseQueryInterestFactorsResponse();
    message.interestFactors = object.interestFactors?.map((e) => InterestFactor.fromPartial(e)) || [];
    return message;
  },
};

function createBaseDepositResponse(): DepositResponse {
  return { depositor: "", amount: [], index: [] };
}

export const DepositResponse = {
  encode(message: DepositResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.depositor !== "") {
      writer.uint32(10).string(message.depositor);
    }
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.index) {
      SupplyInterestFactorResponse.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): DepositResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDepositResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.depositor = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.index.push(SupplyInterestFactorResponse.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): DepositResponse {
    return {
      depositor: isSet(object.depositor) ? globalThis.String(object.depositor) : "",
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
      index: globalThis.Array.isArray(object?.index)
        ? object.index.map((e: any) => SupplyInterestFactorResponse.fromJSON(e))
        : [],
    };
  },

  toJSON(message: DepositResponse): unknown {
    const obj: any = {};
    if (message.depositor !== "") {
      obj.depositor = message.depositor;
    }
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    if (message.index?.length) {
      obj.index = message.index.map((e) => SupplyInterestFactorResponse.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<DepositResponse>): DepositResponse {
    return DepositResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<DepositResponse>): DepositResponse {
    const message = createBaseDepositResponse();
    message.depositor = object.depositor ?? "";
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    message.index = object.index?.map((e) => SupplyInterestFactorResponse.fromPartial(e)) || [];
    return message;
  },
};

function createBaseSupplyInterestFactorResponse(): SupplyInterestFactorResponse {
  return { denom: "", value: "" };
}

export const SupplyInterestFactorResponse = {
  encode(message: SupplyInterestFactorResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SupplyInterestFactorResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSupplyInterestFactorResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.value = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SupplyInterestFactorResponse {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      value: isSet(object.value) ? globalThis.String(object.value) : "",
    };
  },

  toJSON(message: SupplyInterestFactorResponse): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.value !== "") {
      obj.value = message.value;
    }
    return obj;
  },

  create(base?: DeepPartial<SupplyInterestFactorResponse>): SupplyInterestFactorResponse {
    return SupplyInterestFactorResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<SupplyInterestFactorResponse>): SupplyInterestFactorResponse {
    const message = createBaseSupplyInterestFactorResponse();
    message.denom = object.denom ?? "";
    message.value = object.value ?? "";
    return message;
  },
};

function createBaseBorrowResponse(): BorrowResponse {
  return { borrower: "", amount: [], index: [] };
}

export const BorrowResponse = {
  encode(message: BorrowResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.borrower !== "") {
      writer.uint32(10).string(message.borrower);
    }
    for (const v of message.amount) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.index) {
      BorrowInterestFactorResponse.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BorrowResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrowResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.borrower = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.amount.push(Coin.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.index.push(BorrowInterestFactorResponse.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BorrowResponse {
    return {
      borrower: isSet(object.borrower) ? globalThis.String(object.borrower) : "",
      amount: globalThis.Array.isArray(object?.amount) ? object.amount.map((e: any) => Coin.fromJSON(e)) : [],
      index: globalThis.Array.isArray(object?.index)
        ? object.index.map((e: any) => BorrowInterestFactorResponse.fromJSON(e))
        : [],
    };
  },

  toJSON(message: BorrowResponse): unknown {
    const obj: any = {};
    if (message.borrower !== "") {
      obj.borrower = message.borrower;
    }
    if (message.amount?.length) {
      obj.amount = message.amount.map((e) => Coin.toJSON(e));
    }
    if (message.index?.length) {
      obj.index = message.index.map((e) => BorrowInterestFactorResponse.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<BorrowResponse>): BorrowResponse {
    return BorrowResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BorrowResponse>): BorrowResponse {
    const message = createBaseBorrowResponse();
    message.borrower = object.borrower ?? "";
    message.amount = object.amount?.map((e) => Coin.fromPartial(e)) || [];
    message.index = object.index?.map((e) => BorrowInterestFactorResponse.fromPartial(e)) || [];
    return message;
  },
};

function createBaseBorrowInterestFactorResponse(): BorrowInterestFactorResponse {
  return { denom: "", value: "" };
}

export const BorrowInterestFactorResponse = {
  encode(message: BorrowInterestFactorResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.value !== "") {
      writer.uint32(18).string(message.value);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BorrowInterestFactorResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBorrowInterestFactorResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.value = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BorrowInterestFactorResponse {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      value: isSet(object.value) ? globalThis.String(object.value) : "",
    };
  },

  toJSON(message: BorrowInterestFactorResponse): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.value !== "") {
      obj.value = message.value;
    }
    return obj;
  },

  create(base?: DeepPartial<BorrowInterestFactorResponse>): BorrowInterestFactorResponse {
    return BorrowInterestFactorResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BorrowInterestFactorResponse>): BorrowInterestFactorResponse {
    const message = createBaseBorrowInterestFactorResponse();
    message.denom = object.denom ?? "";
    message.value = object.value ?? "";
    return message;
  },
};

function createBaseMoneyMarketInterestRate(): MoneyMarketInterestRate {
  return { denom: "", supplyInterestRate: "", borrowInterestRate: "" };
}

export const MoneyMarketInterestRate = {
  encode(message: MoneyMarketInterestRate, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.supplyInterestRate !== "") {
      writer.uint32(18).string(message.supplyInterestRate);
    }
    if (message.borrowInterestRate !== "") {
      writer.uint32(26).string(message.borrowInterestRate);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MoneyMarketInterestRate {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMoneyMarketInterestRate();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.supplyInterestRate = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.borrowInterestRate = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MoneyMarketInterestRate {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      supplyInterestRate: isSet(object.supplyInterestRate) ? globalThis.String(object.supplyInterestRate) : "",
      borrowInterestRate: isSet(object.borrowInterestRate) ? globalThis.String(object.borrowInterestRate) : "",
    };
  },

  toJSON(message: MoneyMarketInterestRate): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.supplyInterestRate !== "") {
      obj.supplyInterestRate = message.supplyInterestRate;
    }
    if (message.borrowInterestRate !== "") {
      obj.borrowInterestRate = message.borrowInterestRate;
    }
    return obj;
  },

  create(base?: DeepPartial<MoneyMarketInterestRate>): MoneyMarketInterestRate {
    return MoneyMarketInterestRate.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MoneyMarketInterestRate>): MoneyMarketInterestRate {
    const message = createBaseMoneyMarketInterestRate();
    message.denom = object.denom ?? "";
    message.supplyInterestRate = object.supplyInterestRate ?? "";
    message.borrowInterestRate = object.borrowInterestRate ?? "";
    return message;
  },
};

function createBaseInterestFactor(): InterestFactor {
  return { denom: "", borrowInterestFactor: "", supplyInterestFactor: "" };
}

export const InterestFactor = {
  encode(message: InterestFactor, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    if (message.borrowInterestFactor !== "") {
      writer.uint32(18).string(message.borrowInterestFactor);
    }
    if (message.supplyInterestFactor !== "") {
      writer.uint32(26).string(message.supplyInterestFactor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): InterestFactor {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseInterestFactor();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.borrowInterestFactor = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.supplyInterestFactor = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): InterestFactor {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      borrowInterestFactor: isSet(object.borrowInterestFactor) ? globalThis.String(object.borrowInterestFactor) : "",
      supplyInterestFactor: isSet(object.supplyInterestFactor) ? globalThis.String(object.supplyInterestFactor) : "",
    };
  },

  toJSON(message: InterestFactor): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.borrowInterestFactor !== "") {
      obj.borrowInterestFactor = message.borrowInterestFactor;
    }
    if (message.supplyInterestFactor !== "") {
      obj.supplyInterestFactor = message.supplyInterestFactor;
    }
    return obj;
  },

  create(base?: DeepPartial<InterestFactor>): InterestFactor {
    return InterestFactor.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<InterestFactor>): InterestFactor {
    const message = createBaseInterestFactor();
    message.denom = object.denom ?? "";
    message.borrowInterestFactor = object.borrowInterestFactor ?? "";
    message.supplyInterestFactor = object.supplyInterestFactor ?? "";
    return message;
  },
};

/** Query defines the gRPC querier service for bep3 module. */
export interface Query {
  /** Params queries module params. */
  Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
  /** Accounts queries module accounts. */
  Accounts(request: QueryAccountsRequest): Promise<QueryAccountsResponse>;
  /** Deposits queries hard deposits. */
  Deposits(request: QueryDepositsRequest): Promise<QueryDepositsResponse>;
  /** UnsyncedDeposits queries unsynced deposits. */
  UnsyncedDeposits(request: QueryUnsyncedDepositsRequest): Promise<QueryUnsyncedDepositsResponse>;
  /** TotalDeposited queries total coins deposited to hard liquidity pools. */
  TotalDeposited(request: QueryTotalDepositedRequest): Promise<QueryTotalDepositedResponse>;
  /** Borrows queries hard borrows. */
  Borrows(request: QueryBorrowsRequest): Promise<QueryBorrowsResponse>;
  /** UnsyncedBorrows queries unsynced borrows. */
  UnsyncedBorrows(request: QueryUnsyncedBorrowsRequest): Promise<QueryUnsyncedBorrowsResponse>;
  /** TotalBorrowed queries total coins borrowed from hard liquidity pools. */
  TotalBorrowed(request: QueryTotalBorrowedRequest): Promise<QueryTotalBorrowedResponse>;
  /** InterestRate queries the hard module interest rates. */
  InterestRate(request: QueryInterestRateRequest): Promise<QueryInterestRateResponse>;
  /** Reserves queries total hard reserve coins. */
  Reserves(request: QueryReservesRequest): Promise<QueryReservesResponse>;
  /** InterestFactors queries hard module interest factors. */
  InterestFactors(request: QueryInterestFactorsRequest): Promise<QueryInterestFactorsResponse>;
}

export const QueryServiceName = "kava.hard.v1beta1.Query";
export class QueryClientImpl implements Query {
  private readonly rpc: Rpc;
  private readonly service: string;
  constructor(rpc: Rpc, opts?: { service?: string }) {
    this.service = opts?.service || QueryServiceName;
    this.rpc = rpc;
    this.Params = this.Params.bind(this);
    this.Accounts = this.Accounts.bind(this);
    this.Deposits = this.Deposits.bind(this);
    this.UnsyncedDeposits = this.UnsyncedDeposits.bind(this);
    this.TotalDeposited = this.TotalDeposited.bind(this);
    this.Borrows = this.Borrows.bind(this);
    this.UnsyncedBorrows = this.UnsyncedBorrows.bind(this);
    this.TotalBorrowed = this.TotalBorrowed.bind(this);
    this.InterestRate = this.InterestRate.bind(this);
    this.Reserves = this.Reserves.bind(this);
    this.InterestFactors = this.InterestFactors.bind(this);
  }
  Params(request: QueryParamsRequest): Promise<QueryParamsResponse> {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Params", data);
    return promise.then((data) => QueryParamsResponse.decode(_m0.Reader.create(data)));
  }

  Accounts(request: QueryAccountsRequest): Promise<QueryAccountsResponse> {
    const data = QueryAccountsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Accounts", data);
    return promise.then((data) => QueryAccountsResponse.decode(_m0.Reader.create(data)));
  }

  Deposits(request: QueryDepositsRequest): Promise<QueryDepositsResponse> {
    const data = QueryDepositsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Deposits", data);
    return promise.then((data) => QueryDepositsResponse.decode(_m0.Reader.create(data)));
  }

  UnsyncedDeposits(request: QueryUnsyncedDepositsRequest): Promise<QueryUnsyncedDepositsResponse> {
    const data = QueryUnsyncedDepositsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "UnsyncedDeposits", data);
    return promise.then((data) => QueryUnsyncedDepositsResponse.decode(_m0.Reader.create(data)));
  }

  TotalDeposited(request: QueryTotalDepositedRequest): Promise<QueryTotalDepositedResponse> {
    const data = QueryTotalDepositedRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "TotalDeposited", data);
    return promise.then((data) => QueryTotalDepositedResponse.decode(_m0.Reader.create(data)));
  }

  Borrows(request: QueryBorrowsRequest): Promise<QueryBorrowsResponse> {
    const data = QueryBorrowsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Borrows", data);
    return promise.then((data) => QueryBorrowsResponse.decode(_m0.Reader.create(data)));
  }

  UnsyncedBorrows(request: QueryUnsyncedBorrowsRequest): Promise<QueryUnsyncedBorrowsResponse> {
    const data = QueryUnsyncedBorrowsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "UnsyncedBorrows", data);
    return promise.then((data) => QueryUnsyncedBorrowsResponse.decode(_m0.Reader.create(data)));
  }

  TotalBorrowed(request: QueryTotalBorrowedRequest): Promise<QueryTotalBorrowedResponse> {
    const data = QueryTotalBorrowedRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "TotalBorrowed", data);
    return promise.then((data) => QueryTotalBorrowedResponse.decode(_m0.Reader.create(data)));
  }

  InterestRate(request: QueryInterestRateRequest): Promise<QueryInterestRateResponse> {
    const data = QueryInterestRateRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "InterestRate", data);
    return promise.then((data) => QueryInterestRateResponse.decode(_m0.Reader.create(data)));
  }

  Reserves(request: QueryReservesRequest): Promise<QueryReservesResponse> {
    const data = QueryReservesRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Reserves", data);
    return promise.then((data) => QueryReservesResponse.decode(_m0.Reader.create(data)));
  }

  InterestFactors(request: QueryInterestFactorsRequest): Promise<QueryInterestFactorsResponse> {
    const data = QueryInterestFactorsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "InterestFactors", data);
    return promise.then((data) => QueryInterestFactorsResponse.decode(_m0.Reader.create(data)));
  }
}

interface Rpc {
  request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
