// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/incentive/v1beta1/claims.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";

export const protobufPackage = "kava.incentive.v1beta1";

/** BaseClaim is a claim with a single reward coin types */
export interface BaseClaim {
  owner: Uint8Array;
  reward?: Coin | undefined;
}

/** BaseMultiClaim is a claim with multiple reward coin types */
export interface BaseMultiClaim {
  owner: Uint8Array;
  reward: Coin[];
}

/** RewardIndex stores reward accumulation information */
export interface RewardIndex {
  collateralType: string;
  rewardFactor: Uint8Array;
}

/** RewardIndexesProto defines a Protobuf wrapper around a RewardIndexes slice */
export interface RewardIndexesProto {
  rewardIndexes: RewardIndex[];
}

/** MultiRewardIndex stores reward accumulation information on multiple reward types */
export interface MultiRewardIndex {
  collateralType: string;
  rewardIndexes: RewardIndex[];
}

/** MultiRewardIndexesProto defines a Protobuf wrapper around a MultiRewardIndexes slice */
export interface MultiRewardIndexesProto {
  multiRewardIndexes: MultiRewardIndex[];
}

/** USDXMintingClaim is for USDX minting rewards */
export interface USDXMintingClaim {
  baseClaim?: BaseClaim | undefined;
  rewardIndexes: RewardIndex[];
}

/** HardLiquidityProviderClaim stores the hard liquidity provider rewards that can be claimed by owner */
export interface HardLiquidityProviderClaim {
  baseClaim?: BaseMultiClaim | undefined;
  supplyRewardIndexes: MultiRewardIndex[];
  borrowRewardIndexes: MultiRewardIndex[];
}

/** DelegatorClaim stores delegation rewards that can be claimed by owner */
export interface DelegatorClaim {
  baseClaim?: BaseMultiClaim | undefined;
  rewardIndexes: MultiRewardIndex[];
}

/** SwapClaim stores the swap rewards that can be claimed by owner */
export interface SwapClaim {
  baseClaim?: BaseMultiClaim | undefined;
  rewardIndexes: MultiRewardIndex[];
}

/** SavingsClaim stores the savings rewards that can be claimed by owner */
export interface SavingsClaim {
  baseClaim?: BaseMultiClaim | undefined;
  rewardIndexes: MultiRewardIndex[];
}

/** EarnClaim stores the earn rewards that can be claimed by owner */
export interface EarnClaim {
  baseClaim?: BaseMultiClaim | undefined;
  rewardIndexes: MultiRewardIndex[];
}

function createBaseBaseClaim(): BaseClaim {
  return { owner: new Uint8Array(0), reward: undefined };
}

export const BaseClaim = {
  encode(message: BaseClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.owner.length !== 0) {
      writer.uint32(10).bytes(message.owner);
    }
    if (message.reward !== undefined) {
      Coin.encode(message.reward, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BaseClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.owner = reader.bytes();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.reward = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BaseClaim {
    return {
      owner: isSet(object.owner) ? bytesFromBase64(object.owner) : new Uint8Array(0),
      reward: isSet(object.reward) ? Coin.fromJSON(object.reward) : undefined,
    };
  },

  toJSON(message: BaseClaim): unknown {
    const obj: any = {};
    if (message.owner.length !== 0) {
      obj.owner = base64FromBytes(message.owner);
    }
    if (message.reward !== undefined) {
      obj.reward = Coin.toJSON(message.reward);
    }
    return obj;
  },

  create(base?: DeepPartial<BaseClaim>): BaseClaim {
    return BaseClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BaseClaim>): BaseClaim {
    const message = createBaseBaseClaim();
    message.owner = object.owner ?? new Uint8Array(0);
    message.reward = (object.reward !== undefined && object.reward !== null)
      ? Coin.fromPartial(object.reward)
      : undefined;
    return message;
  },
};

function createBaseBaseMultiClaim(): BaseMultiClaim {
  return { owner: new Uint8Array(0), reward: [] };
}

export const BaseMultiClaim = {
  encode(message: BaseMultiClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.owner.length !== 0) {
      writer.uint32(10).bytes(message.owner);
    }
    for (const v of message.reward) {
      Coin.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): BaseMultiClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseBaseMultiClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.owner = reader.bytes();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.reward.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): BaseMultiClaim {
    return {
      owner: isSet(object.owner) ? bytesFromBase64(object.owner) : new Uint8Array(0),
      reward: globalThis.Array.isArray(object?.reward) ? object.reward.map((e: any) => Coin.fromJSON(e)) : [],
    };
  },

  toJSON(message: BaseMultiClaim): unknown {
    const obj: any = {};
    if (message.owner.length !== 0) {
      obj.owner = base64FromBytes(message.owner);
    }
    if (message.reward?.length) {
      obj.reward = message.reward.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<BaseMultiClaim>): BaseMultiClaim {
    return BaseMultiClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<BaseMultiClaim>): BaseMultiClaim {
    const message = createBaseBaseMultiClaim();
    message.owner = object.owner ?? new Uint8Array(0);
    message.reward = object.reward?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseRewardIndex(): RewardIndex {
  return { collateralType: "", rewardFactor: new Uint8Array(0) };
}

export const RewardIndex = {
  encode(message: RewardIndex, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.rewardFactor.length !== 0) {
      writer.uint32(18).bytes(message.rewardFactor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): RewardIndex {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRewardIndex();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardFactor = reader.bytes();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): RewardIndex {
    return {
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      rewardFactor: isSet(object.rewardFactor) ? bytesFromBase64(object.rewardFactor) : new Uint8Array(0),
    };
  },

  toJSON(message: RewardIndex): unknown {
    const obj: any = {};
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.rewardFactor.length !== 0) {
      obj.rewardFactor = base64FromBytes(message.rewardFactor);
    }
    return obj;
  },

  create(base?: DeepPartial<RewardIndex>): RewardIndex {
    return RewardIndex.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<RewardIndex>): RewardIndex {
    const message = createBaseRewardIndex();
    message.collateralType = object.collateralType ?? "";
    message.rewardFactor = object.rewardFactor ?? new Uint8Array(0);
    return message;
  },
};

function createBaseRewardIndexesProto(): RewardIndexesProto {
  return { rewardIndexes: [] };
}

export const RewardIndexesProto = {
  encode(message: RewardIndexesProto, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.rewardIndexes) {
      RewardIndex.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): RewardIndexesProto {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRewardIndexesProto();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.rewardIndexes.push(RewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): RewardIndexesProto {
    return {
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => RewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: RewardIndexesProto): unknown {
    const obj: any = {};
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => RewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<RewardIndexesProto>): RewardIndexesProto {
    return RewardIndexesProto.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<RewardIndexesProto>): RewardIndexesProto {
    const message = createBaseRewardIndexesProto();
    message.rewardIndexes = object.rewardIndexes?.map((e) => RewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseMultiRewardIndex(): MultiRewardIndex {
  return { collateralType: "", rewardIndexes: [] };
}

export const MultiRewardIndex = {
  encode(message: MultiRewardIndex, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    for (const v of message.rewardIndexes) {
      RewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MultiRewardIndex {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiRewardIndex();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardIndexes.push(RewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MultiRewardIndex {
    return {
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => RewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: MultiRewardIndex): unknown {
    const obj: any = {};
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => RewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<MultiRewardIndex>): MultiRewardIndex {
    return MultiRewardIndex.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MultiRewardIndex>): MultiRewardIndex {
    const message = createBaseMultiRewardIndex();
    message.collateralType = object.collateralType ?? "";
    message.rewardIndexes = object.rewardIndexes?.map((e) => RewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseMultiRewardIndexesProto(): MultiRewardIndexesProto {
  return { multiRewardIndexes: [] };
}

export const MultiRewardIndexesProto = {
  encode(message: MultiRewardIndexesProto, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.multiRewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MultiRewardIndexesProto {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiRewardIndexesProto();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.multiRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MultiRewardIndexesProto {
    return {
      multiRewardIndexes: globalThis.Array.isArray(object?.multiRewardIndexes)
        ? object.multiRewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: MultiRewardIndexesProto): unknown {
    const obj: any = {};
    if (message.multiRewardIndexes?.length) {
      obj.multiRewardIndexes = message.multiRewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<MultiRewardIndexesProto>): MultiRewardIndexesProto {
    return MultiRewardIndexesProto.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MultiRewardIndexesProto>): MultiRewardIndexesProto {
    const message = createBaseMultiRewardIndexesProto();
    message.multiRewardIndexes = object.multiRewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseUSDXMintingClaim(): USDXMintingClaim {
  return { baseClaim: undefined, rewardIndexes: [] };
}

export const USDXMintingClaim = {
  encode(message: USDXMintingClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseClaim !== undefined) {
      BaseClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      RewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): USDXMintingClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseUSDXMintingClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseClaim = BaseClaim.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardIndexes.push(RewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): USDXMintingClaim {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => RewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: USDXMintingClaim): unknown {
    const obj: any = {};
    if (message.baseClaim !== undefined) {
      obj.baseClaim = BaseClaim.toJSON(message.baseClaim);
    }
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => RewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<USDXMintingClaim>): USDXMintingClaim {
    return USDXMintingClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<USDXMintingClaim>): USDXMintingClaim {
    const message = createBaseUSDXMintingClaim();
    message.baseClaim = (object.baseClaim !== undefined && object.baseClaim !== null)
      ? BaseClaim.fromPartial(object.baseClaim)
      : undefined;
    message.rewardIndexes = object.rewardIndexes?.map((e) => RewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseHardLiquidityProviderClaim(): HardLiquidityProviderClaim {
  return { baseClaim: undefined, supplyRewardIndexes: [], borrowRewardIndexes: [] };
}

export const HardLiquidityProviderClaim = {
  encode(message: HardLiquidityProviderClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.supplyRewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.borrowRewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): HardLiquidityProviderClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseHardLiquidityProviderClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.supplyRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.borrowRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): HardLiquidityProviderClaim {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      supplyRewardIndexes: globalThis.Array.isArray(object?.supplyRewardIndexes)
        ? object.supplyRewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
      borrowRewardIndexes: globalThis.Array.isArray(object?.borrowRewardIndexes)
        ? object.borrowRewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: HardLiquidityProviderClaim): unknown {
    const obj: any = {};
    if (message.baseClaim !== undefined) {
      obj.baseClaim = BaseMultiClaim.toJSON(message.baseClaim);
    }
    if (message.supplyRewardIndexes?.length) {
      obj.supplyRewardIndexes = message.supplyRewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    if (message.borrowRewardIndexes?.length) {
      obj.borrowRewardIndexes = message.borrowRewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<HardLiquidityProviderClaim>): HardLiquidityProviderClaim {
    return HardLiquidityProviderClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<HardLiquidityProviderClaim>): HardLiquidityProviderClaim {
    const message = createBaseHardLiquidityProviderClaim();
    message.baseClaim = (object.baseClaim !== undefined && object.baseClaim !== null)
      ? BaseMultiClaim.fromPartial(object.baseClaim)
      : undefined;
    message.supplyRewardIndexes = object.supplyRewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    message.borrowRewardIndexes = object.borrowRewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseDelegatorClaim(): DelegatorClaim {
  return { baseClaim: undefined, rewardIndexes: [] };
}

export const DelegatorClaim = {
  encode(message: DelegatorClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): DelegatorClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseDelegatorClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): DelegatorClaim {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: DelegatorClaim): unknown {
    const obj: any = {};
    if (message.baseClaim !== undefined) {
      obj.baseClaim = BaseMultiClaim.toJSON(message.baseClaim);
    }
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<DelegatorClaim>): DelegatorClaim {
    return DelegatorClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<DelegatorClaim>): DelegatorClaim {
    const message = createBaseDelegatorClaim();
    message.baseClaim = (object.baseClaim !== undefined && object.baseClaim !== null)
      ? BaseMultiClaim.fromPartial(object.baseClaim)
      : undefined;
    message.rewardIndexes = object.rewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseSwapClaim(): SwapClaim {
  return { baseClaim: undefined, rewardIndexes: [] };
}

export const SwapClaim = {
  encode(message: SwapClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SwapClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSwapClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SwapClaim {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: SwapClaim): unknown {
    const obj: any = {};
    if (message.baseClaim !== undefined) {
      obj.baseClaim = BaseMultiClaim.toJSON(message.baseClaim);
    }
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<SwapClaim>): SwapClaim {
    return SwapClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<SwapClaim>): SwapClaim {
    const message = createBaseSwapClaim();
    message.baseClaim = (object.baseClaim !== undefined && object.baseClaim !== null)
      ? BaseMultiClaim.fromPartial(object.baseClaim)
      : undefined;
    message.rewardIndexes = object.rewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseSavingsClaim(): SavingsClaim {
  return { baseClaim: undefined, rewardIndexes: [] };
}

export const SavingsClaim = {
  encode(message: SavingsClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SavingsClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSavingsClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SavingsClaim {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: SavingsClaim): unknown {
    const obj: any = {};
    if (message.baseClaim !== undefined) {
      obj.baseClaim = BaseMultiClaim.toJSON(message.baseClaim);
    }
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<SavingsClaim>): SavingsClaim {
    return SavingsClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<SavingsClaim>): SavingsClaim {
    const message = createBaseSavingsClaim();
    message.baseClaim = (object.baseClaim !== undefined && object.baseClaim !== null)
      ? BaseMultiClaim.fromPartial(object.baseClaim)
      : undefined;
    message.rewardIndexes = object.rewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseEarnClaim(): EarnClaim {
  return { baseClaim: undefined, rewardIndexes: [] };
}

export const EarnClaim = {
  encode(message: EarnClaim, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.baseClaim !== undefined) {
      BaseMultiClaim.encode(message.baseClaim, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.rewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): EarnClaim {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseEarnClaim();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.baseClaim = BaseMultiClaim.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): EarnClaim {
    return {
      baseClaim: isSet(object.baseClaim) ? BaseMultiClaim.fromJSON(object.baseClaim) : undefined,
      rewardIndexes: globalThis.Array.isArray(object?.rewardIndexes)
        ? object.rewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: EarnClaim): unknown {
    const obj: any = {};
    if (message.baseClaim !== undefined) {
      obj.baseClaim = BaseMultiClaim.toJSON(message.baseClaim);
    }
    if (message.rewardIndexes?.length) {
      obj.rewardIndexes = message.rewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<EarnClaim>): EarnClaim {
    return EarnClaim.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<EarnClaim>): EarnClaim {
    const message = createBaseEarnClaim();
    message.baseClaim = (object.baseClaim !== undefined && object.baseClaim !== null)
      ? BaseMultiClaim.fromPartial(object.baseClaim)
      : undefined;
    message.rewardIndexes = object.rewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
