// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/incentive/v1beta1/genesis.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Timestamp } from "../../../google/protobuf/timestamp";
import {
  DelegatorClaim,
  EarnClaim,
  HardLiquidityProviderClaim,
  MultiRewardIndex,
  SavingsClaim,
  SwapClaim,
  USDXMintingClaim,
} from "./claims";
import { Params } from "./params";

export const protobufPackage = "kava.incentive.v1beta1";

/** AccumulationTime stores the previous reward distribution time and its corresponding collateral type */
export interface AccumulationTime {
  collateralType: string;
  previousAccumulationTime?: Date | undefined;
}

/** GenesisRewardState groups together the global state for a particular reward so it can be exported in genesis. */
export interface GenesisRewardState {
  accumulationTimes: AccumulationTime[];
  multiRewardIndexes: MultiRewardIndex[];
}

/** GenesisState is the state that must be provided at genesis. */
export interface GenesisState {
  params?: Params | undefined;
  usdxRewardState?: GenesisRewardState | undefined;
  hardSupplyRewardState?: GenesisRewardState | undefined;
  hardBorrowRewardState?: GenesisRewardState | undefined;
  delegatorRewardState?: GenesisRewardState | undefined;
  swapRewardState?: GenesisRewardState | undefined;
  usdxMintingClaims: USDXMintingClaim[];
  hardLiquidityProviderClaims: HardLiquidityProviderClaim[];
  delegatorClaims: DelegatorClaim[];
  swapClaims: SwapClaim[];
  savingsRewardState?: GenesisRewardState | undefined;
  savingsClaims: SavingsClaim[];
  earnRewardState?: GenesisRewardState | undefined;
  earnClaims: EarnClaim[];
}

function createBaseAccumulationTime(): AccumulationTime {
  return { collateralType: "", previousAccumulationTime: undefined };
}

export const AccumulationTime = {
  encode(message: AccumulationTime, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.collateralType !== "") {
      writer.uint32(10).string(message.collateralType);
    }
    if (message.previousAccumulationTime !== undefined) {
      Timestamp.encode(toTimestamp(message.previousAccumulationTime), writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AccumulationTime {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAccumulationTime();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.previousAccumulationTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AccumulationTime {
    return {
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      previousAccumulationTime: isSet(object.previousAccumulationTime)
        ? fromJsonTimestamp(object.previousAccumulationTime)
        : undefined,
    };
  },

  toJSON(message: AccumulationTime): unknown {
    const obj: any = {};
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.previousAccumulationTime !== undefined) {
      obj.previousAccumulationTime = message.previousAccumulationTime.toISOString();
    }
    return obj;
  },

  create(base?: DeepPartial<AccumulationTime>): AccumulationTime {
    return AccumulationTime.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AccumulationTime>): AccumulationTime {
    const message = createBaseAccumulationTime();
    message.collateralType = object.collateralType ?? "";
    message.previousAccumulationTime = object.previousAccumulationTime ?? undefined;
    return message;
  },
};

function createBaseGenesisRewardState(): GenesisRewardState {
  return { accumulationTimes: [], multiRewardIndexes: [] };
}

export const GenesisRewardState = {
  encode(message: GenesisRewardState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.accumulationTimes) {
      AccumulationTime.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.multiRewardIndexes) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisRewardState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisRewardState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.accumulationTimes.push(AccumulationTime.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.multiRewardIndexes.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisRewardState {
    return {
      accumulationTimes: globalThis.Array.isArray(object?.accumulationTimes)
        ? object.accumulationTimes.map((e: any) => AccumulationTime.fromJSON(e))
        : [],
      multiRewardIndexes: globalThis.Array.isArray(object?.multiRewardIndexes)
        ? object.multiRewardIndexes.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: GenesisRewardState): unknown {
    const obj: any = {};
    if (message.accumulationTimes?.length) {
      obj.accumulationTimes = message.accumulationTimes.map((e) => AccumulationTime.toJSON(e));
    }
    if (message.multiRewardIndexes?.length) {
      obj.multiRewardIndexes = message.multiRewardIndexes.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisRewardState>): GenesisRewardState {
    return GenesisRewardState.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisRewardState>): GenesisRewardState {
    const message = createBaseGenesisRewardState();
    message.accumulationTimes = object.accumulationTimes?.map((e) => AccumulationTime.fromPartial(e)) || [];
    message.multiRewardIndexes = object.multiRewardIndexes?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseGenesisState(): GenesisState {
  return {
    params: undefined,
    usdxRewardState: undefined,
    hardSupplyRewardState: undefined,
    hardBorrowRewardState: undefined,
    delegatorRewardState: undefined,
    swapRewardState: undefined,
    usdxMintingClaims: [],
    hardLiquidityProviderClaims: [],
    delegatorClaims: [],
    swapClaims: [],
    savingsRewardState: undefined,
    savingsClaims: [],
    earnRewardState: undefined,
    earnClaims: [],
  };
}

export const GenesisState = {
  encode(message: GenesisState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    if (message.usdxRewardState !== undefined) {
      GenesisRewardState.encode(message.usdxRewardState, writer.uint32(18).fork()).ldelim();
    }
    if (message.hardSupplyRewardState !== undefined) {
      GenesisRewardState.encode(message.hardSupplyRewardState, writer.uint32(26).fork()).ldelim();
    }
    if (message.hardBorrowRewardState !== undefined) {
      GenesisRewardState.encode(message.hardBorrowRewardState, writer.uint32(34).fork()).ldelim();
    }
    if (message.delegatorRewardState !== undefined) {
      GenesisRewardState.encode(message.delegatorRewardState, writer.uint32(42).fork()).ldelim();
    }
    if (message.swapRewardState !== undefined) {
      GenesisRewardState.encode(message.swapRewardState, writer.uint32(50).fork()).ldelim();
    }
    for (const v of message.usdxMintingClaims) {
      USDXMintingClaim.encode(v!, writer.uint32(58).fork()).ldelim();
    }
    for (const v of message.hardLiquidityProviderClaims) {
      HardLiquidityProviderClaim.encode(v!, writer.uint32(66).fork()).ldelim();
    }
    for (const v of message.delegatorClaims) {
      DelegatorClaim.encode(v!, writer.uint32(74).fork()).ldelim();
    }
    for (const v of message.swapClaims) {
      SwapClaim.encode(v!, writer.uint32(82).fork()).ldelim();
    }
    if (message.savingsRewardState !== undefined) {
      GenesisRewardState.encode(message.savingsRewardState, writer.uint32(90).fork()).ldelim();
    }
    for (const v of message.savingsClaims) {
      SavingsClaim.encode(v!, writer.uint32(98).fork()).ldelim();
    }
    if (message.earnRewardState !== undefined) {
      GenesisRewardState.encode(message.earnRewardState, writer.uint32(106).fork()).ldelim();
    }
    for (const v of message.earnClaims) {
      EarnClaim.encode(v!, writer.uint32(114).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.usdxRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.hardSupplyRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.hardBorrowRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.delegatorRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.swapRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.usdxMintingClaims.push(USDXMintingClaim.decode(reader, reader.uint32()));
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.hardLiquidityProviderClaims.push(HardLiquidityProviderClaim.decode(reader, reader.uint32()));
          continue;
        case 9:
          if (tag !== 74) {
            break;
          }

          message.delegatorClaims.push(DelegatorClaim.decode(reader, reader.uint32()));
          continue;
        case 10:
          if (tag !== 82) {
            break;
          }

          message.swapClaims.push(SwapClaim.decode(reader, reader.uint32()));
          continue;
        case 11:
          if (tag !== 90) {
            break;
          }

          message.savingsRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 12:
          if (tag !== 98) {
            break;
          }

          message.savingsClaims.push(SavingsClaim.decode(reader, reader.uint32()));
          continue;
        case 13:
          if (tag !== 106) {
            break;
          }

          message.earnRewardState = GenesisRewardState.decode(reader, reader.uint32());
          continue;
        case 14:
          if (tag !== 114) {
            break;
          }

          message.earnClaims.push(EarnClaim.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisState {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      usdxRewardState: isSet(object.usdxRewardState) ? GenesisRewardState.fromJSON(object.usdxRewardState) : undefined,
      hardSupplyRewardState: isSet(object.hardSupplyRewardState)
        ? GenesisRewardState.fromJSON(object.hardSupplyRewardState)
        : undefined,
      hardBorrowRewardState: isSet(object.hardBorrowRewardState)
        ? GenesisRewardState.fromJSON(object.hardBorrowRewardState)
        : undefined,
      delegatorRewardState: isSet(object.delegatorRewardState)
        ? GenesisRewardState.fromJSON(object.delegatorRewardState)
        : undefined,
      swapRewardState: isSet(object.swapRewardState) ? GenesisRewardState.fromJSON(object.swapRewardState) : undefined,
      usdxMintingClaims: globalThis.Array.isArray(object?.usdxMintingClaims)
        ? object.usdxMintingClaims.map((e: any) => USDXMintingClaim.fromJSON(e))
        : [],
      hardLiquidityProviderClaims: globalThis.Array.isArray(object?.hardLiquidityProviderClaims)
        ? object.hardLiquidityProviderClaims.map((e: any) => HardLiquidityProviderClaim.fromJSON(e))
        : [],
      delegatorClaims: globalThis.Array.isArray(object?.delegatorClaims)
        ? object.delegatorClaims.map((e: any) => DelegatorClaim.fromJSON(e))
        : [],
      swapClaims: globalThis.Array.isArray(object?.swapClaims)
        ? object.swapClaims.map((e: any) => SwapClaim.fromJSON(e))
        : [],
      savingsRewardState: isSet(object.savingsRewardState)
        ? GenesisRewardState.fromJSON(object.savingsRewardState)
        : undefined,
      savingsClaims: globalThis.Array.isArray(object?.savingsClaims)
        ? object.savingsClaims.map((e: any) => SavingsClaim.fromJSON(e))
        : [],
      earnRewardState: isSet(object.earnRewardState) ? GenesisRewardState.fromJSON(object.earnRewardState) : undefined,
      earnClaims: globalThis.Array.isArray(object?.earnClaims)
        ? object.earnClaims.map((e: any) => EarnClaim.fromJSON(e))
        : [],
    };
  },

  toJSON(message: GenesisState): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    if (message.usdxRewardState !== undefined) {
      obj.usdxRewardState = GenesisRewardState.toJSON(message.usdxRewardState);
    }
    if (message.hardSupplyRewardState !== undefined) {
      obj.hardSupplyRewardState = GenesisRewardState.toJSON(message.hardSupplyRewardState);
    }
    if (message.hardBorrowRewardState !== undefined) {
      obj.hardBorrowRewardState = GenesisRewardState.toJSON(message.hardBorrowRewardState);
    }
    if (message.delegatorRewardState !== undefined) {
      obj.delegatorRewardState = GenesisRewardState.toJSON(message.delegatorRewardState);
    }
    if (message.swapRewardState !== undefined) {
      obj.swapRewardState = GenesisRewardState.toJSON(message.swapRewardState);
    }
    if (message.usdxMintingClaims?.length) {
      obj.usdxMintingClaims = message.usdxMintingClaims.map((e) => USDXMintingClaim.toJSON(e));
    }
    if (message.hardLiquidityProviderClaims?.length) {
      obj.hardLiquidityProviderClaims = message.hardLiquidityProviderClaims.map((e) =>
        HardLiquidityProviderClaim.toJSON(e)
      );
    }
    if (message.delegatorClaims?.length) {
      obj.delegatorClaims = message.delegatorClaims.map((e) => DelegatorClaim.toJSON(e));
    }
    if (message.swapClaims?.length) {
      obj.swapClaims = message.swapClaims.map((e) => SwapClaim.toJSON(e));
    }
    if (message.savingsRewardState !== undefined) {
      obj.savingsRewardState = GenesisRewardState.toJSON(message.savingsRewardState);
    }
    if (message.savingsClaims?.length) {
      obj.savingsClaims = message.savingsClaims.map((e) => SavingsClaim.toJSON(e));
    }
    if (message.earnRewardState !== undefined) {
      obj.earnRewardState = GenesisRewardState.toJSON(message.earnRewardState);
    }
    if (message.earnClaims?.length) {
      obj.earnClaims = message.earnClaims.map((e) => EarnClaim.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisState>): GenesisState {
    return GenesisState.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisState>): GenesisState {
    const message = createBaseGenesisState();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    message.usdxRewardState = (object.usdxRewardState !== undefined && object.usdxRewardState !== null)
      ? GenesisRewardState.fromPartial(object.usdxRewardState)
      : undefined;
    message.hardSupplyRewardState =
      (object.hardSupplyRewardState !== undefined && object.hardSupplyRewardState !== null)
        ? GenesisRewardState.fromPartial(object.hardSupplyRewardState)
        : undefined;
    message.hardBorrowRewardState =
      (object.hardBorrowRewardState !== undefined && object.hardBorrowRewardState !== null)
        ? GenesisRewardState.fromPartial(object.hardBorrowRewardState)
        : undefined;
    message.delegatorRewardState = (object.delegatorRewardState !== undefined && object.delegatorRewardState !== null)
      ? GenesisRewardState.fromPartial(object.delegatorRewardState)
      : undefined;
    message.swapRewardState = (object.swapRewardState !== undefined && object.swapRewardState !== null)
      ? GenesisRewardState.fromPartial(object.swapRewardState)
      : undefined;
    message.usdxMintingClaims = object.usdxMintingClaims?.map((e) => USDXMintingClaim.fromPartial(e)) || [];
    message.hardLiquidityProviderClaims =
      object.hardLiquidityProviderClaims?.map((e) => HardLiquidityProviderClaim.fromPartial(e)) || [];
    message.delegatorClaims = object.delegatorClaims?.map((e) => DelegatorClaim.fromPartial(e)) || [];
    message.swapClaims = object.swapClaims?.map((e) => SwapClaim.fromPartial(e)) || [];
    message.savingsRewardState = (object.savingsRewardState !== undefined && object.savingsRewardState !== null)
      ? GenesisRewardState.fromPartial(object.savingsRewardState)
      : undefined;
    message.savingsClaims = object.savingsClaims?.map((e) => SavingsClaim.fromPartial(e)) || [];
    message.earnRewardState = (object.earnRewardState !== undefined && object.earnRewardState !== null)
      ? GenesisRewardState.fromPartial(object.earnRewardState)
      : undefined;
    message.earnClaims = object.earnClaims?.map((e) => EarnClaim.fromPartial(e)) || [];
    return message;
  },
};

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function toTimestamp(date: Date): Timestamp {
  const seconds = numberToLong(Math.trunc(date.getTime() / 1_000));
  const nanos = (date.getTime() % 1_000) * 1_000_000;
  return { seconds, nanos };
}

function fromTimestamp(t: Timestamp): Date {
  let millis = (t.seconds.toNumber() || 0) * 1_000;
  millis += (t.nanos || 0) / 1_000_000;
  return new globalThis.Date(millis);
}

function fromJsonTimestamp(o: any): Date {
  if (o instanceof globalThis.Date) {
    return o;
  } else if (typeof o === "string") {
    return new globalThis.Date(o);
  } else {
    return fromTimestamp(Timestamp.fromJSON(o));
  }
}

function numberToLong(number: number) {
  return Long.fromNumber(number);
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
