// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/incentive/v1beta1/params.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";

export const protobufPackage = "kava.incentive.v1beta1";

/** RewardPeriod stores the state of an ongoing reward */
export interface RewardPeriod {
  active: boolean;
  collateralType: string;
  start?: Date | undefined;
  end?: Date | undefined;
  rewardsPerSecond?: Coin | undefined;
}

/** MultiRewardPeriod supports multiple reward types */
export interface MultiRewardPeriod {
  active: boolean;
  collateralType: string;
  start?: Date | undefined;
  end?: Date | undefined;
  rewardsPerSecond: Coin[];
}

/** Multiplier amount the claim rewards get increased by, along with how long the claim rewards are locked */
export interface Multiplier {
  name: string;
  monthsLockup: Long;
  factor: Uint8Array;
}

/** MultipliersPerDenom is a map of denoms to a set of multipliers */
export interface MultipliersPerDenom {
  denom: string;
  multipliers: Multiplier[];
}

/** Params */
export interface Params {
  usdxMintingRewardPeriods: RewardPeriod[];
  hardSupplyRewardPeriods: MultiRewardPeriod[];
  hardBorrowRewardPeriods: MultiRewardPeriod[];
  delegatorRewardPeriods: MultiRewardPeriod[];
  swapRewardPeriods: MultiRewardPeriod[];
  claimMultipliers: MultipliersPerDenom[];
  claimEnd?: Date | undefined;
  savingsRewardPeriods: MultiRewardPeriod[];
  earnRewardPeriods: MultiRewardPeriod[];
}

function createBaseRewardPeriod(): RewardPeriod {
  return { active: false, collateralType: "", start: undefined, end: undefined, rewardsPerSecond: undefined };
}

export const RewardPeriod = {
  encode(message: RewardPeriod, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.active !== false) {
      writer.uint32(8).bool(message.active);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.start !== undefined) {
      Timestamp.encode(toTimestamp(message.start), writer.uint32(26).fork()).ldelim();
    }
    if (message.end !== undefined) {
      Timestamp.encode(toTimestamp(message.end), writer.uint32(34).fork()).ldelim();
    }
    if (message.rewardsPerSecond !== undefined) {
      Coin.encode(message.rewardsPerSecond, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): RewardPeriod {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRewardPeriod();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.active = reader.bool();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.start = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.end = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.rewardsPerSecond = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): RewardPeriod {
    return {
      active: isSet(object.active) ? globalThis.Boolean(object.active) : false,
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      start: isSet(object.start) ? fromJsonTimestamp(object.start) : undefined,
      end: isSet(object.end) ? fromJsonTimestamp(object.end) : undefined,
      rewardsPerSecond: isSet(object.rewardsPerSecond) ? Coin.fromJSON(object.rewardsPerSecond) : undefined,
    };
  },

  toJSON(message: RewardPeriod): unknown {
    const obj: any = {};
    if (message.active !== false) {
      obj.active = message.active;
    }
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.start !== undefined) {
      obj.start = message.start.toISOString();
    }
    if (message.end !== undefined) {
      obj.end = message.end.toISOString();
    }
    if (message.rewardsPerSecond !== undefined) {
      obj.rewardsPerSecond = Coin.toJSON(message.rewardsPerSecond);
    }
    return obj;
  },

  create(base?: DeepPartial<RewardPeriod>): RewardPeriod {
    return RewardPeriod.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<RewardPeriod>): RewardPeriod {
    const message = createBaseRewardPeriod();
    message.active = object.active ?? false;
    message.collateralType = object.collateralType ?? "";
    message.start = object.start ?? undefined;
    message.end = object.end ?? undefined;
    message.rewardsPerSecond = (object.rewardsPerSecond !== undefined && object.rewardsPerSecond !== null)
      ? Coin.fromPartial(object.rewardsPerSecond)
      : undefined;
    return message;
  },
};

function createBaseMultiRewardPeriod(): MultiRewardPeriod {
  return { active: false, collateralType: "", start: undefined, end: undefined, rewardsPerSecond: [] };
}

export const MultiRewardPeriod = {
  encode(message: MultiRewardPeriod, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.active !== false) {
      writer.uint32(8).bool(message.active);
    }
    if (message.collateralType !== "") {
      writer.uint32(18).string(message.collateralType);
    }
    if (message.start !== undefined) {
      Timestamp.encode(toTimestamp(message.start), writer.uint32(26).fork()).ldelim();
    }
    if (message.end !== undefined) {
      Timestamp.encode(toTimestamp(message.end), writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.rewardsPerSecond) {
      Coin.encode(v!, writer.uint32(42).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MultiRewardPeriod {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiRewardPeriod();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.active = reader.bool();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.collateralType = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.start = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.end = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.rewardsPerSecond.push(Coin.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MultiRewardPeriod {
    return {
      active: isSet(object.active) ? globalThis.Boolean(object.active) : false,
      collateralType: isSet(object.collateralType) ? globalThis.String(object.collateralType) : "",
      start: isSet(object.start) ? fromJsonTimestamp(object.start) : undefined,
      end: isSet(object.end) ? fromJsonTimestamp(object.end) : undefined,
      rewardsPerSecond: globalThis.Array.isArray(object?.rewardsPerSecond)
        ? object.rewardsPerSecond.map((e: any) => Coin.fromJSON(e))
        : [],
    };
  },

  toJSON(message: MultiRewardPeriod): unknown {
    const obj: any = {};
    if (message.active !== false) {
      obj.active = message.active;
    }
    if (message.collateralType !== "") {
      obj.collateralType = message.collateralType;
    }
    if (message.start !== undefined) {
      obj.start = message.start.toISOString();
    }
    if (message.end !== undefined) {
      obj.end = message.end.toISOString();
    }
    if (message.rewardsPerSecond?.length) {
      obj.rewardsPerSecond = message.rewardsPerSecond.map((e) => Coin.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<MultiRewardPeriod>): MultiRewardPeriod {
    return MultiRewardPeriod.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MultiRewardPeriod>): MultiRewardPeriod {
    const message = createBaseMultiRewardPeriod();
    message.active = object.active ?? false;
    message.collateralType = object.collateralType ?? "";
    message.start = object.start ?? undefined;
    message.end = object.end ?? undefined;
    message.rewardsPerSecond = object.rewardsPerSecond?.map((e) => Coin.fromPartial(e)) || [];
    return message;
  },
};

function createBaseMultiplier(): Multiplier {
  return { name: "", monthsLockup: Long.ZERO, factor: new Uint8Array(0) };
}

export const Multiplier = {
  encode(message: Multiplier, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    if (!message.monthsLockup.equals(Long.ZERO)) {
      writer.uint32(16).int64(message.monthsLockup);
    }
    if (message.factor.length !== 0) {
      writer.uint32(26).bytes(message.factor);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Multiplier {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultiplier();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.name = reader.string();
          continue;
        case 2:
          if (tag !== 16) {
            break;
          }

          message.monthsLockup = reader.int64() as Long;
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.factor = reader.bytes();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Multiplier {
    return {
      name: isSet(object.name) ? globalThis.String(object.name) : "",
      monthsLockup: isSet(object.monthsLockup) ? Long.fromValue(object.monthsLockup) : Long.ZERO,
      factor: isSet(object.factor) ? bytesFromBase64(object.factor) : new Uint8Array(0),
    };
  },

  toJSON(message: Multiplier): unknown {
    const obj: any = {};
    if (message.name !== "") {
      obj.name = message.name;
    }
    if (!message.monthsLockup.equals(Long.ZERO)) {
      obj.monthsLockup = (message.monthsLockup || Long.ZERO).toString();
    }
    if (message.factor.length !== 0) {
      obj.factor = base64FromBytes(message.factor);
    }
    return obj;
  },

  create(base?: DeepPartial<Multiplier>): Multiplier {
    return Multiplier.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Multiplier>): Multiplier {
    const message = createBaseMultiplier();
    message.name = object.name ?? "";
    message.monthsLockup = (object.monthsLockup !== undefined && object.monthsLockup !== null)
      ? Long.fromValue(object.monthsLockup)
      : Long.ZERO;
    message.factor = object.factor ?? new Uint8Array(0);
    return message;
  },
};

function createBaseMultipliersPerDenom(): MultipliersPerDenom {
  return { denom: "", multipliers: [] };
}

export const MultipliersPerDenom = {
  encode(message: MultipliersPerDenom, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.denom !== "") {
      writer.uint32(10).string(message.denom);
    }
    for (const v of message.multipliers) {
      Multiplier.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MultipliersPerDenom {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMultipliersPerDenom();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.multipliers.push(Multiplier.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): MultipliersPerDenom {
    return {
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      multipliers: globalThis.Array.isArray(object?.multipliers)
        ? object.multipliers.map((e: any) => Multiplier.fromJSON(e))
        : [],
    };
  },

  toJSON(message: MultipliersPerDenom): unknown {
    const obj: any = {};
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.multipliers?.length) {
      obj.multipliers = message.multipliers.map((e) => Multiplier.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<MultipliersPerDenom>): MultipliersPerDenom {
    return MultipliersPerDenom.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<MultipliersPerDenom>): MultipliersPerDenom {
    const message = createBaseMultipliersPerDenom();
    message.denom = object.denom ?? "";
    message.multipliers = object.multipliers?.map((e) => Multiplier.fromPartial(e)) || [];
    return message;
  },
};

function createBaseParams(): Params {
  return {
    usdxMintingRewardPeriods: [],
    hardSupplyRewardPeriods: [],
    hardBorrowRewardPeriods: [],
    delegatorRewardPeriods: [],
    swapRewardPeriods: [],
    claimMultipliers: [],
    claimEnd: undefined,
    savingsRewardPeriods: [],
    earnRewardPeriods: [],
  };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.usdxMintingRewardPeriods) {
      RewardPeriod.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.hardSupplyRewardPeriods) {
      MultiRewardPeriod.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.hardBorrowRewardPeriods) {
      MultiRewardPeriod.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.delegatorRewardPeriods) {
      MultiRewardPeriod.encode(v!, writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.swapRewardPeriods) {
      MultiRewardPeriod.encode(v!, writer.uint32(42).fork()).ldelim();
    }
    for (const v of message.claimMultipliers) {
      MultipliersPerDenom.encode(v!, writer.uint32(50).fork()).ldelim();
    }
    if (message.claimEnd !== undefined) {
      Timestamp.encode(toTimestamp(message.claimEnd), writer.uint32(58).fork()).ldelim();
    }
    for (const v of message.savingsRewardPeriods) {
      MultiRewardPeriod.encode(v!, writer.uint32(66).fork()).ldelim();
    }
    for (const v of message.earnRewardPeriods) {
      MultiRewardPeriod.encode(v!, writer.uint32(74).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.usdxMintingRewardPeriods.push(RewardPeriod.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.hardSupplyRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.hardBorrowRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.delegatorRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.swapRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.claimMultipliers.push(MultipliersPerDenom.decode(reader, reader.uint32()));
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.claimEnd = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 8:
          if (tag !== 66) {
            break;
          }

          message.savingsRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          continue;
        case 9:
          if (tag !== 74) {
            break;
          }

          message.earnRewardPeriods.push(MultiRewardPeriod.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      usdxMintingRewardPeriods: globalThis.Array.isArray(object?.usdxMintingRewardPeriods)
        ? object.usdxMintingRewardPeriods.map((e: any) => RewardPeriod.fromJSON(e))
        : [],
      hardSupplyRewardPeriods: globalThis.Array.isArray(object?.hardSupplyRewardPeriods)
        ? object.hardSupplyRewardPeriods.map((e: any) => MultiRewardPeriod.fromJSON(e))
        : [],
      hardBorrowRewardPeriods: globalThis.Array.isArray(object?.hardBorrowRewardPeriods)
        ? object.hardBorrowRewardPeriods.map((e: any) => MultiRewardPeriod.fromJSON(e))
        : [],
      delegatorRewardPeriods: globalThis.Array.isArray(object?.delegatorRewardPeriods)
        ? object.delegatorRewardPeriods.map((e: any) => MultiRewardPeriod.fromJSON(e))
        : [],
      swapRewardPeriods: globalThis.Array.isArray(object?.swapRewardPeriods)
        ? object.swapRewardPeriods.map((e: any) => MultiRewardPeriod.fromJSON(e))
        : [],
      claimMultipliers: globalThis.Array.isArray(object?.claimMultipliers)
        ? object.claimMultipliers.map((e: any) => MultipliersPerDenom.fromJSON(e))
        : [],
      claimEnd: isSet(object.claimEnd) ? fromJsonTimestamp(object.claimEnd) : undefined,
      savingsRewardPeriods: globalThis.Array.isArray(object?.savingsRewardPeriods)
        ? object.savingsRewardPeriods.map((e: any) => MultiRewardPeriod.fromJSON(e))
        : [],
      earnRewardPeriods: globalThis.Array.isArray(object?.earnRewardPeriods)
        ? object.earnRewardPeriods.map((e: any) => MultiRewardPeriod.fromJSON(e))
        : [],
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.usdxMintingRewardPeriods?.length) {
      obj.usdxMintingRewardPeriods = message.usdxMintingRewardPeriods.map((e) => RewardPeriod.toJSON(e));
    }
    if (message.hardSupplyRewardPeriods?.length) {
      obj.hardSupplyRewardPeriods = message.hardSupplyRewardPeriods.map((e) => MultiRewardPeriod.toJSON(e));
    }
    if (message.hardBorrowRewardPeriods?.length) {
      obj.hardBorrowRewardPeriods = message.hardBorrowRewardPeriods.map((e) => MultiRewardPeriod.toJSON(e));
    }
    if (message.delegatorRewardPeriods?.length) {
      obj.delegatorRewardPeriods = message.delegatorRewardPeriods.map((e) => MultiRewardPeriod.toJSON(e));
    }
    if (message.swapRewardPeriods?.length) {
      obj.swapRewardPeriods = message.swapRewardPeriods.map((e) => MultiRewardPeriod.toJSON(e));
    }
    if (message.claimMultipliers?.length) {
      obj.claimMultipliers = message.claimMultipliers.map((e) => MultipliersPerDenom.toJSON(e));
    }
    if (message.claimEnd !== undefined) {
      obj.claimEnd = message.claimEnd.toISOString();
    }
    if (message.savingsRewardPeriods?.length) {
      obj.savingsRewardPeriods = message.savingsRewardPeriods.map((e) => MultiRewardPeriod.toJSON(e));
    }
    if (message.earnRewardPeriods?.length) {
      obj.earnRewardPeriods = message.earnRewardPeriods.map((e) => MultiRewardPeriod.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.usdxMintingRewardPeriods = object.usdxMintingRewardPeriods?.map((e) => RewardPeriod.fromPartial(e)) || [];
    message.hardSupplyRewardPeriods = object.hardSupplyRewardPeriods?.map((e) => MultiRewardPeriod.fromPartial(e)) ||
      [];
    message.hardBorrowRewardPeriods = object.hardBorrowRewardPeriods?.map((e) => MultiRewardPeriod.fromPartial(e)) ||
      [];
    message.delegatorRewardPeriods = object.delegatorRewardPeriods?.map((e) => MultiRewardPeriod.fromPartial(e)) || [];
    message.swapRewardPeriods = object.swapRewardPeriods?.map((e) => MultiRewardPeriod.fromPartial(e)) || [];
    message.claimMultipliers = object.claimMultipliers?.map((e) => MultipliersPerDenom.fromPartial(e)) || [];
    message.claimEnd = object.claimEnd ?? undefined;
    message.savingsRewardPeriods = object.savingsRewardPeriods?.map((e) => MultiRewardPeriod.fromPartial(e)) || [];
    message.earnRewardPeriods = object.earnRewardPeriods?.map((e) => MultiRewardPeriod.fromPartial(e)) || [];
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function toTimestamp(date: Date): Timestamp {
  const seconds = numberToLong(Math.trunc(date.getTime() / 1_000));
  const nanos = (date.getTime() % 1_000) * 1_000_000;
  return { seconds, nanos };
}

function fromTimestamp(t: Timestamp): Date {
  let millis = (t.seconds.toNumber() || 0) * 1_000;
  millis += (t.nanos || 0) / 1_000_000;
  return new globalThis.Date(millis);
}

function fromJsonTimestamp(o: any): Date {
  if (o instanceof globalThis.Date) {
    return o;
  } else if (typeof o === "string") {
    return new globalThis.Date(o);
  } else {
    return fromTimestamp(Timestamp.fromJSON(o));
  }
}

function numberToLong(number: number) {
  return Long.fromNumber(number);
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
