// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/incentive/v1beta1/query.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Apy } from "./apy";
import {
  DelegatorClaim,
  EarnClaim,
  HardLiquidityProviderClaim,
  MultiRewardIndex,
  RewardIndex,
  SavingsClaim,
  SwapClaim,
  USDXMintingClaim,
} from "./claims";
import { Params } from "./params";

export const protobufPackage = "kava.incentive.v1beta1";

/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}

/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
  params?: Params | undefined;
}

/** QueryRewardsRequest is the request type for the Query/Rewards RPC method. */
export interface QueryRewardsRequest {
  /** owner is the address of the user to query rewards for. */
  owner: string;
  /**
   * reward_type is the type of reward to query rewards for, e.g. hard, earn,
   * swap.
   */
  rewardType: string;
  /**
   * unsynchronized is a flag to query rewards that are not simulated for reward
   * synchronized for the current block.
   */
  unsynchronized: boolean;
}

/** QueryRewardsResponse is the response type for the Query/Rewards RPC method. */
export interface QueryRewardsResponse {
  usdxMintingClaims: USDXMintingClaim[];
  hardLiquidityProviderClaims: HardLiquidityProviderClaim[];
  delegatorClaims: DelegatorClaim[];
  swapClaims: SwapClaim[];
  savingsClaims: SavingsClaim[];
  earnClaims: EarnClaim[];
}

/** QueryRewardFactorsRequest is the request type for the Query/RewardFactors RPC method. */
export interface QueryRewardFactorsRequest {
}

/** QueryRewardFactorsResponse is the response type for the Query/RewardFactors RPC method. */
export interface QueryRewardFactorsResponse {
  usdxMintingRewardFactors: RewardIndex[];
  hardSupplyRewardFactors: MultiRewardIndex[];
  hardBorrowRewardFactors: MultiRewardIndex[];
  delegatorRewardFactors: MultiRewardIndex[];
  swapRewardFactors: MultiRewardIndex[];
  savingsRewardFactors: MultiRewardIndex[];
  earnRewardFactors: MultiRewardIndex[];
}

/** QueryApysRequest is the request type for the Query/Apys RPC method. */
export interface QueryApyRequest {
}

/** QueryApysResponse is the response type for the Query/Apys RPC method. */
export interface QueryApyResponse {
  earn: Apy[];
}

function createBaseQueryParamsRequest(): QueryParamsRequest {
  return {};
}

export const QueryParamsRequest = {
  encode(_: QueryParamsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): QueryParamsRequest {
    return {};
  },

  toJSON(_: QueryParamsRequest): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<QueryParamsRequest>): QueryParamsRequest {
    return QueryParamsRequest.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest {
    const message = createBaseQueryParamsRequest();
    return message;
  },
};

function createBaseQueryParamsResponse(): QueryParamsResponse {
  return { params: undefined };
}

export const QueryParamsResponse = {
  encode(message: QueryParamsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryParamsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryParamsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryParamsResponse {
    return { params: isSet(object.params) ? Params.fromJSON(object.params) : undefined };
  },

  toJSON(message: QueryParamsResponse): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    return obj;
  },

  create(base?: DeepPartial<QueryParamsResponse>): QueryParamsResponse {
    return QueryParamsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse {
    const message = createBaseQueryParamsResponse();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    return message;
  },
};

function createBaseQueryRewardsRequest(): QueryRewardsRequest {
  return { owner: "", rewardType: "", unsynchronized: false };
}

export const QueryRewardsRequest = {
  encode(message: QueryRewardsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.owner !== "") {
      writer.uint32(10).string(message.owner);
    }
    if (message.rewardType !== "") {
      writer.uint32(18).string(message.rewardType);
    }
    if (message.unsynchronized !== false) {
      writer.uint32(24).bool(message.unsynchronized);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryRewardsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.owner = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardType = reader.string();
          continue;
        case 3:
          if (tag !== 24) {
            break;
          }

          message.unsynchronized = reader.bool();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryRewardsRequest {
    return {
      owner: isSet(object.owner) ? globalThis.String(object.owner) : "",
      rewardType: isSet(object.rewardType) ? globalThis.String(object.rewardType) : "",
      unsynchronized: isSet(object.unsynchronized) ? globalThis.Boolean(object.unsynchronized) : false,
    };
  },

  toJSON(message: QueryRewardsRequest): unknown {
    const obj: any = {};
    if (message.owner !== "") {
      obj.owner = message.owner;
    }
    if (message.rewardType !== "") {
      obj.rewardType = message.rewardType;
    }
    if (message.unsynchronized !== false) {
      obj.unsynchronized = message.unsynchronized;
    }
    return obj;
  },

  create(base?: DeepPartial<QueryRewardsRequest>): QueryRewardsRequest {
    return QueryRewardsRequest.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryRewardsRequest>): QueryRewardsRequest {
    const message = createBaseQueryRewardsRequest();
    message.owner = object.owner ?? "";
    message.rewardType = object.rewardType ?? "";
    message.unsynchronized = object.unsynchronized ?? false;
    return message;
  },
};

function createBaseQueryRewardsResponse(): QueryRewardsResponse {
  return {
    usdxMintingClaims: [],
    hardLiquidityProviderClaims: [],
    delegatorClaims: [],
    swapClaims: [],
    savingsClaims: [],
    earnClaims: [],
  };
}

export const QueryRewardsResponse = {
  encode(message: QueryRewardsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.usdxMintingClaims) {
      USDXMintingClaim.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.hardLiquidityProviderClaims) {
      HardLiquidityProviderClaim.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.delegatorClaims) {
      DelegatorClaim.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.swapClaims) {
      SwapClaim.encode(v!, writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.savingsClaims) {
      SavingsClaim.encode(v!, writer.uint32(42).fork()).ldelim();
    }
    for (const v of message.earnClaims) {
      EarnClaim.encode(v!, writer.uint32(50).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryRewardsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.usdxMintingClaims.push(USDXMintingClaim.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.hardLiquidityProviderClaims.push(HardLiquidityProviderClaim.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.delegatorClaims.push(DelegatorClaim.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.swapClaims.push(SwapClaim.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.savingsClaims.push(SavingsClaim.decode(reader, reader.uint32()));
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.earnClaims.push(EarnClaim.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryRewardsResponse {
    return {
      usdxMintingClaims: globalThis.Array.isArray(object?.usdxMintingClaims)
        ? object.usdxMintingClaims.map((e: any) => USDXMintingClaim.fromJSON(e))
        : [],
      hardLiquidityProviderClaims: globalThis.Array.isArray(object?.hardLiquidityProviderClaims)
        ? object.hardLiquidityProviderClaims.map((e: any) => HardLiquidityProviderClaim.fromJSON(e))
        : [],
      delegatorClaims: globalThis.Array.isArray(object?.delegatorClaims)
        ? object.delegatorClaims.map((e: any) => DelegatorClaim.fromJSON(e))
        : [],
      swapClaims: globalThis.Array.isArray(object?.swapClaims)
        ? object.swapClaims.map((e: any) => SwapClaim.fromJSON(e))
        : [],
      savingsClaims: globalThis.Array.isArray(object?.savingsClaims)
        ? object.savingsClaims.map((e: any) => SavingsClaim.fromJSON(e))
        : [],
      earnClaims: globalThis.Array.isArray(object?.earnClaims)
        ? object.earnClaims.map((e: any) => EarnClaim.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryRewardsResponse): unknown {
    const obj: any = {};
    if (message.usdxMintingClaims?.length) {
      obj.usdxMintingClaims = message.usdxMintingClaims.map((e) => USDXMintingClaim.toJSON(e));
    }
    if (message.hardLiquidityProviderClaims?.length) {
      obj.hardLiquidityProviderClaims = message.hardLiquidityProviderClaims.map((e) =>
        HardLiquidityProviderClaim.toJSON(e)
      );
    }
    if (message.delegatorClaims?.length) {
      obj.delegatorClaims = message.delegatorClaims.map((e) => DelegatorClaim.toJSON(e));
    }
    if (message.swapClaims?.length) {
      obj.swapClaims = message.swapClaims.map((e) => SwapClaim.toJSON(e));
    }
    if (message.savingsClaims?.length) {
      obj.savingsClaims = message.savingsClaims.map((e) => SavingsClaim.toJSON(e));
    }
    if (message.earnClaims?.length) {
      obj.earnClaims = message.earnClaims.map((e) => EarnClaim.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryRewardsResponse>): QueryRewardsResponse {
    return QueryRewardsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryRewardsResponse>): QueryRewardsResponse {
    const message = createBaseQueryRewardsResponse();
    message.usdxMintingClaims = object.usdxMintingClaims?.map((e) => USDXMintingClaim.fromPartial(e)) || [];
    message.hardLiquidityProviderClaims =
      object.hardLiquidityProviderClaims?.map((e) => HardLiquidityProviderClaim.fromPartial(e)) || [];
    message.delegatorClaims = object.delegatorClaims?.map((e) => DelegatorClaim.fromPartial(e)) || [];
    message.swapClaims = object.swapClaims?.map((e) => SwapClaim.fromPartial(e)) || [];
    message.savingsClaims = object.savingsClaims?.map((e) => SavingsClaim.fromPartial(e)) || [];
    message.earnClaims = object.earnClaims?.map((e) => EarnClaim.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryRewardFactorsRequest(): QueryRewardFactorsRequest {
  return {};
}

export const QueryRewardFactorsRequest = {
  encode(_: QueryRewardFactorsRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardFactorsRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryRewardFactorsRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): QueryRewardFactorsRequest {
    return {};
  },

  toJSON(_: QueryRewardFactorsRequest): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<QueryRewardFactorsRequest>): QueryRewardFactorsRequest {
    return QueryRewardFactorsRequest.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<QueryRewardFactorsRequest>): QueryRewardFactorsRequest {
    const message = createBaseQueryRewardFactorsRequest();
    return message;
  },
};

function createBaseQueryRewardFactorsResponse(): QueryRewardFactorsResponse {
  return {
    usdxMintingRewardFactors: [],
    hardSupplyRewardFactors: [],
    hardBorrowRewardFactors: [],
    delegatorRewardFactors: [],
    swapRewardFactors: [],
    savingsRewardFactors: [],
    earnRewardFactors: [],
  };
}

export const QueryRewardFactorsResponse = {
  encode(message: QueryRewardFactorsResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.usdxMintingRewardFactors) {
      RewardIndex.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.hardSupplyRewardFactors) {
      MultiRewardIndex.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.hardBorrowRewardFactors) {
      MultiRewardIndex.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    for (const v of message.delegatorRewardFactors) {
      MultiRewardIndex.encode(v!, writer.uint32(34).fork()).ldelim();
    }
    for (const v of message.swapRewardFactors) {
      MultiRewardIndex.encode(v!, writer.uint32(42).fork()).ldelim();
    }
    for (const v of message.savingsRewardFactors) {
      MultiRewardIndex.encode(v!, writer.uint32(50).fork()).ldelim();
    }
    for (const v of message.earnRewardFactors) {
      MultiRewardIndex.encode(v!, writer.uint32(58).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryRewardFactorsResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryRewardFactorsResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.usdxMintingRewardFactors.push(RewardIndex.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.hardSupplyRewardFactors.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.hardBorrowRewardFactors.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.delegatorRewardFactors.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
        case 5:
          if (tag !== 42) {
            break;
          }

          message.swapRewardFactors.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.savingsRewardFactors.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
        case 7:
          if (tag !== 58) {
            break;
          }

          message.earnRewardFactors.push(MultiRewardIndex.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryRewardFactorsResponse {
    return {
      usdxMintingRewardFactors: globalThis.Array.isArray(object?.usdxMintingRewardFactors)
        ? object.usdxMintingRewardFactors.map((e: any) => RewardIndex.fromJSON(e))
        : [],
      hardSupplyRewardFactors: globalThis.Array.isArray(object?.hardSupplyRewardFactors)
        ? object.hardSupplyRewardFactors.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
      hardBorrowRewardFactors: globalThis.Array.isArray(object?.hardBorrowRewardFactors)
        ? object.hardBorrowRewardFactors.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
      delegatorRewardFactors: globalThis.Array.isArray(object?.delegatorRewardFactors)
        ? object.delegatorRewardFactors.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
      swapRewardFactors: globalThis.Array.isArray(object?.swapRewardFactors)
        ? object.swapRewardFactors.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
      savingsRewardFactors: globalThis.Array.isArray(object?.savingsRewardFactors)
        ? object.savingsRewardFactors.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
      earnRewardFactors: globalThis.Array.isArray(object?.earnRewardFactors)
        ? object.earnRewardFactors.map((e: any) => MultiRewardIndex.fromJSON(e))
        : [],
    };
  },

  toJSON(message: QueryRewardFactorsResponse): unknown {
    const obj: any = {};
    if (message.usdxMintingRewardFactors?.length) {
      obj.usdxMintingRewardFactors = message.usdxMintingRewardFactors.map((e) => RewardIndex.toJSON(e));
    }
    if (message.hardSupplyRewardFactors?.length) {
      obj.hardSupplyRewardFactors = message.hardSupplyRewardFactors.map((e) => MultiRewardIndex.toJSON(e));
    }
    if (message.hardBorrowRewardFactors?.length) {
      obj.hardBorrowRewardFactors = message.hardBorrowRewardFactors.map((e) => MultiRewardIndex.toJSON(e));
    }
    if (message.delegatorRewardFactors?.length) {
      obj.delegatorRewardFactors = message.delegatorRewardFactors.map((e) => MultiRewardIndex.toJSON(e));
    }
    if (message.swapRewardFactors?.length) {
      obj.swapRewardFactors = message.swapRewardFactors.map((e) => MultiRewardIndex.toJSON(e));
    }
    if (message.savingsRewardFactors?.length) {
      obj.savingsRewardFactors = message.savingsRewardFactors.map((e) => MultiRewardIndex.toJSON(e));
    }
    if (message.earnRewardFactors?.length) {
      obj.earnRewardFactors = message.earnRewardFactors.map((e) => MultiRewardIndex.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryRewardFactorsResponse>): QueryRewardFactorsResponse {
    return QueryRewardFactorsResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryRewardFactorsResponse>): QueryRewardFactorsResponse {
    const message = createBaseQueryRewardFactorsResponse();
    message.usdxMintingRewardFactors = object.usdxMintingRewardFactors?.map((e) => RewardIndex.fromPartial(e)) || [];
    message.hardSupplyRewardFactors = object.hardSupplyRewardFactors?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    message.hardBorrowRewardFactors = object.hardBorrowRewardFactors?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    message.delegatorRewardFactors = object.delegatorRewardFactors?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    message.swapRewardFactors = object.swapRewardFactors?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    message.savingsRewardFactors = object.savingsRewardFactors?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    message.earnRewardFactors = object.earnRewardFactors?.map((e) => MultiRewardIndex.fromPartial(e)) || [];
    return message;
  },
};

function createBaseQueryApyRequest(): QueryApyRequest {
  return {};
}

export const QueryApyRequest = {
  encode(_: QueryApyRequest, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryApyRequest {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryApyRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): QueryApyRequest {
    return {};
  },

  toJSON(_: QueryApyRequest): unknown {
    const obj: any = {};
    return obj;
  },

  create(base?: DeepPartial<QueryApyRequest>): QueryApyRequest {
    return QueryApyRequest.fromPartial(base ?? {});
  },
  fromPartial(_: DeepPartial<QueryApyRequest>): QueryApyRequest {
    const message = createBaseQueryApyRequest();
    return message;
  },
};

function createBaseQueryApyResponse(): QueryApyResponse {
  return { earn: [] };
}

export const QueryApyResponse = {
  encode(message: QueryApyResponse, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.earn) {
      Apy.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): QueryApyResponse {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseQueryApyResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.earn.push(Apy.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): QueryApyResponse {
    return { earn: globalThis.Array.isArray(object?.earn) ? object.earn.map((e: any) => Apy.fromJSON(e)) : [] };
  },

  toJSON(message: QueryApyResponse): unknown {
    const obj: any = {};
    if (message.earn?.length) {
      obj.earn = message.earn.map((e) => Apy.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<QueryApyResponse>): QueryApyResponse {
    return QueryApyResponse.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<QueryApyResponse>): QueryApyResponse {
    const message = createBaseQueryApyResponse();
    message.earn = object.earn?.map((e) => Apy.fromPartial(e)) || [];
    return message;
  },
};

/** Query defines the gRPC querier service for incentive module. */
export interface Query {
  /** Params queries module params. */
  Params(request: QueryParamsRequest): Promise<QueryParamsResponse>;
  /** Rewards queries reward information for a given user. */
  Rewards(request: QueryRewardsRequest): Promise<QueryRewardsResponse>;
  /** Rewards queries the reward factors. */
  RewardFactors(request: QueryRewardFactorsRequest): Promise<QueryRewardFactorsResponse>;
  /** Apy queries incentive reward apy for a reward. */
  Apy(request: QueryApyRequest): Promise<QueryApyResponse>;
}

export const QueryServiceName = "kava.incentive.v1beta1.Query";
export class QueryClientImpl implements Query {
  private readonly rpc: Rpc;
  private readonly service: string;
  constructor(rpc: Rpc, opts?: { service?: string }) {
    this.service = opts?.service || QueryServiceName;
    this.rpc = rpc;
    this.Params = this.Params.bind(this);
    this.Rewards = this.Rewards.bind(this);
    this.RewardFactors = this.RewardFactors.bind(this);
    this.Apy = this.Apy.bind(this);
  }
  Params(request: QueryParamsRequest): Promise<QueryParamsResponse> {
    const data = QueryParamsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Params", data);
    return promise.then((data) => QueryParamsResponse.decode(_m0.Reader.create(data)));
  }

  Rewards(request: QueryRewardsRequest): Promise<QueryRewardsResponse> {
    const data = QueryRewardsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Rewards", data);
    return promise.then((data) => QueryRewardsResponse.decode(_m0.Reader.create(data)));
  }

  RewardFactors(request: QueryRewardFactorsRequest): Promise<QueryRewardFactorsResponse> {
    const data = QueryRewardFactorsRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "RewardFactors", data);
    return promise.then((data) => QueryRewardFactorsResponse.decode(_m0.Reader.create(data)));
  }

  Apy(request: QueryApyRequest): Promise<QueryApyResponse> {
    const data = QueryApyRequest.encode(request).finish();
    const promise = this.rpc.request(this.service, "Apy", data);
    return promise.then((data) => QueryApyResponse.decode(_m0.Reader.create(data)));
  }
}

interface Rpc {
  request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
