// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/issuance/v1beta1/genesis.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Duration } from "../../../google/protobuf/duration";

export const protobufPackage = "kava.issuance.v1beta1";

/** GenesisState defines the issuance module's genesis state. */
export interface GenesisState {
  /** params defines all the paramaters of the module. */
  params?: Params | undefined;
  supplies: AssetSupply[];
}

/** Params defines the parameters for the issuance module. */
export interface Params {
  assets: Asset[];
}

/** Asset type for assets in the issuance module */
export interface Asset {
  owner: string;
  denom: string;
  blockedAddresses: string[];
  paused: boolean;
  blockable: boolean;
  rateLimit?: RateLimit | undefined;
}

/** RateLimit parameters for rate-limiting the supply of an issued asset */
export interface RateLimit {
  active: boolean;
  limit: Uint8Array;
  timePeriod?: Duration | undefined;
}

/**
 * AssetSupply contains information about an asset's rate-limited supply (the
 * total supply of the asset is tracked in the top-level supply module)
 */
export interface AssetSupply {
  currentSupply?: Coin | undefined;
  timeElapsed?: Duration | undefined;
}

function createBaseGenesisState(): GenesisState {
  return { params: undefined, supplies: [] };
}

export const GenesisState = {
  encode(message: GenesisState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.params !== undefined) {
      Params.encode(message.params, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.supplies) {
      AssetSupply.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): GenesisState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseGenesisState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.params = Params.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.supplies.push(AssetSupply.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): GenesisState {
    return {
      params: isSet(object.params) ? Params.fromJSON(object.params) : undefined,
      supplies: globalThis.Array.isArray(object?.supplies)
        ? object.supplies.map((e: any) => AssetSupply.fromJSON(e))
        : [],
    };
  },

  toJSON(message: GenesisState): unknown {
    const obj: any = {};
    if (message.params !== undefined) {
      obj.params = Params.toJSON(message.params);
    }
    if (message.supplies?.length) {
      obj.supplies = message.supplies.map((e) => AssetSupply.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<GenesisState>): GenesisState {
    return GenesisState.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<GenesisState>): GenesisState {
    const message = createBaseGenesisState();
    message.params = (object.params !== undefined && object.params !== null)
      ? Params.fromPartial(object.params)
      : undefined;
    message.supplies = object.supplies?.map((e) => AssetSupply.fromPartial(e)) || [];
    return message;
  },
};

function createBaseParams(): Params {
  return { assets: [] };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.assets) {
      Asset.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.assets.push(Asset.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return { assets: globalThis.Array.isArray(object?.assets) ? object.assets.map((e: any) => Asset.fromJSON(e)) : [] };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.assets?.length) {
      obj.assets = message.assets.map((e) => Asset.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.assets = object.assets?.map((e) => Asset.fromPartial(e)) || [];
    return message;
  },
};

function createBaseAsset(): Asset {
  return { owner: "", denom: "", blockedAddresses: [], paused: false, blockable: false, rateLimit: undefined };
}

export const Asset = {
  encode(message: Asset, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.owner !== "") {
      writer.uint32(10).string(message.owner);
    }
    if (message.denom !== "") {
      writer.uint32(18).string(message.denom);
    }
    for (const v of message.blockedAddresses) {
      writer.uint32(26).string(v!);
    }
    if (message.paused !== false) {
      writer.uint32(32).bool(message.paused);
    }
    if (message.blockable !== false) {
      writer.uint32(40).bool(message.blockable);
    }
    if (message.rateLimit !== undefined) {
      RateLimit.encode(message.rateLimit, writer.uint32(50).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Asset {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAsset();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.owner = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.denom = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.blockedAddresses.push(reader.string());
          continue;
        case 4:
          if (tag !== 32) {
            break;
          }

          message.paused = reader.bool();
          continue;
        case 5:
          if (tag !== 40) {
            break;
          }

          message.blockable = reader.bool();
          continue;
        case 6:
          if (tag !== 50) {
            break;
          }

          message.rateLimit = RateLimit.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Asset {
    return {
      owner: isSet(object.owner) ? globalThis.String(object.owner) : "",
      denom: isSet(object.denom) ? globalThis.String(object.denom) : "",
      blockedAddresses: globalThis.Array.isArray(object?.blockedAddresses)
        ? object.blockedAddresses.map((e: any) => globalThis.String(e))
        : [],
      paused: isSet(object.paused) ? globalThis.Boolean(object.paused) : false,
      blockable: isSet(object.blockable) ? globalThis.Boolean(object.blockable) : false,
      rateLimit: isSet(object.rateLimit) ? RateLimit.fromJSON(object.rateLimit) : undefined,
    };
  },

  toJSON(message: Asset): unknown {
    const obj: any = {};
    if (message.owner !== "") {
      obj.owner = message.owner;
    }
    if (message.denom !== "") {
      obj.denom = message.denom;
    }
    if (message.blockedAddresses?.length) {
      obj.blockedAddresses = message.blockedAddresses;
    }
    if (message.paused !== false) {
      obj.paused = message.paused;
    }
    if (message.blockable !== false) {
      obj.blockable = message.blockable;
    }
    if (message.rateLimit !== undefined) {
      obj.rateLimit = RateLimit.toJSON(message.rateLimit);
    }
    return obj;
  },

  create(base?: DeepPartial<Asset>): Asset {
    return Asset.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Asset>): Asset {
    const message = createBaseAsset();
    message.owner = object.owner ?? "";
    message.denom = object.denom ?? "";
    message.blockedAddresses = object.blockedAddresses?.map((e) => e) || [];
    message.paused = object.paused ?? false;
    message.blockable = object.blockable ?? false;
    message.rateLimit = (object.rateLimit !== undefined && object.rateLimit !== null)
      ? RateLimit.fromPartial(object.rateLimit)
      : undefined;
    return message;
  },
};

function createBaseRateLimit(): RateLimit {
  return { active: false, limit: new Uint8Array(0), timePeriod: undefined };
}

export const RateLimit = {
  encode(message: RateLimit, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.active !== false) {
      writer.uint32(8).bool(message.active);
    }
    if (message.limit.length !== 0) {
      writer.uint32(18).bytes(message.limit);
    }
    if (message.timePeriod !== undefined) {
      Duration.encode(message.timePeriod, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): RateLimit {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRateLimit();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.active = reader.bool();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.limit = reader.bytes();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.timePeriod = Duration.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): RateLimit {
    return {
      active: isSet(object.active) ? globalThis.Boolean(object.active) : false,
      limit: isSet(object.limit) ? bytesFromBase64(object.limit) : new Uint8Array(0),
      timePeriod: isSet(object.timePeriod) ? Duration.fromJSON(object.timePeriod) : undefined,
    };
  },

  toJSON(message: RateLimit): unknown {
    const obj: any = {};
    if (message.active !== false) {
      obj.active = message.active;
    }
    if (message.limit.length !== 0) {
      obj.limit = base64FromBytes(message.limit);
    }
    if (message.timePeriod !== undefined) {
      obj.timePeriod = Duration.toJSON(message.timePeriod);
    }
    return obj;
  },

  create(base?: DeepPartial<RateLimit>): RateLimit {
    return RateLimit.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<RateLimit>): RateLimit {
    const message = createBaseRateLimit();
    message.active = object.active ?? false;
    message.limit = object.limit ?? new Uint8Array(0);
    message.timePeriod = (object.timePeriod !== undefined && object.timePeriod !== null)
      ? Duration.fromPartial(object.timePeriod)
      : undefined;
    return message;
  },
};

function createBaseAssetSupply(): AssetSupply {
  return { currentSupply: undefined, timeElapsed: undefined };
}

export const AssetSupply = {
  encode(message: AssetSupply, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.currentSupply !== undefined) {
      Coin.encode(message.currentSupply, writer.uint32(10).fork()).ldelim();
    }
    if (message.timeElapsed !== undefined) {
      Duration.encode(message.timeElapsed, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AssetSupply {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAssetSupply();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.currentSupply = Coin.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.timeElapsed = Duration.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AssetSupply {
    return {
      currentSupply: isSet(object.currentSupply) ? Coin.fromJSON(object.currentSupply) : undefined,
      timeElapsed: isSet(object.timeElapsed) ? Duration.fromJSON(object.timeElapsed) : undefined,
    };
  },

  toJSON(message: AssetSupply): unknown {
    const obj: any = {};
    if (message.currentSupply !== undefined) {
      obj.currentSupply = Coin.toJSON(message.currentSupply);
    }
    if (message.timeElapsed !== undefined) {
      obj.timeElapsed = Duration.toJSON(message.timeElapsed);
    }
    return obj;
  },

  create(base?: DeepPartial<AssetSupply>): AssetSupply {
    return AssetSupply.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AssetSupply>): AssetSupply {
    const message = createBaseAssetSupply();
    message.currentSupply = (object.currentSupply !== undefined && object.currentSupply !== null)
      ? Coin.fromPartial(object.currentSupply)
      : undefined;
    message.timeElapsed = (object.timeElapsed !== undefined && object.timeElapsed !== null)
      ? Duration.fromPartial(object.timeElapsed)
      : undefined;
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
