// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/kavadist/v1beta1/params.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Timestamp } from "../../../google/protobuf/timestamp";

export const protobufPackage = "kava.kavadist.v1beta1";

/** Params governance parameters for kavadist module */
export interface Params {
  active: boolean;
  periods: Period[];
  infrastructureParams?: InfrastructureParams | undefined;
}

/** InfrastructureParams define the parameters for infrastructure rewards. */
export interface InfrastructureParams {
  infrastructurePeriods: Period[];
  coreRewards: CoreReward[];
  partnerRewards: PartnerReward[];
}

/** CoreReward defines the reward weights for core infrastructure providers. */
export interface CoreReward {
  address: Uint8Array;
  weight: string;
}

/** PartnerRewards defines the reward schedule for partner infrastructure providers. */
export interface PartnerReward {
  address: Uint8Array;
  rewardsPerSecond?: Coin | undefined;
}

/**
 * Period stores the specified start and end dates, and the inflation, expressed as a decimal
 * representing the yearly APR of KAVA tokens that will be minted during that period
 */
export interface Period {
  /** example "2020-03-01T15:20:00Z" */
  start?:
    | Date
    | undefined;
  /** example "2020-06-01T15:20:00Z" */
  end?:
    | Date
    | undefined;
  /** example "1.000000003022265980"  - 10% inflation */
  inflation: Uint8Array;
}

function createBaseParams(): Params {
  return { active: false, periods: [], infrastructureParams: undefined };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.active !== false) {
      writer.uint32(8).bool(message.active);
    }
    for (const v of message.periods) {
      Period.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    if (message.infrastructureParams !== undefined) {
      InfrastructureParams.encode(message.infrastructureParams, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 8) {
            break;
          }

          message.active = reader.bool();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.periods.push(Period.decode(reader, reader.uint32()));
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.infrastructureParams = InfrastructureParams.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      active: isSet(object.active) ? globalThis.Boolean(object.active) : false,
      periods: globalThis.Array.isArray(object?.periods) ? object.periods.map((e: any) => Period.fromJSON(e)) : [],
      infrastructureParams: isSet(object.infrastructureParams)
        ? InfrastructureParams.fromJSON(object.infrastructureParams)
        : undefined,
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.active !== false) {
      obj.active = message.active;
    }
    if (message.periods?.length) {
      obj.periods = message.periods.map((e) => Period.toJSON(e));
    }
    if (message.infrastructureParams !== undefined) {
      obj.infrastructureParams = InfrastructureParams.toJSON(message.infrastructureParams);
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.active = object.active ?? false;
    message.periods = object.periods?.map((e) => Period.fromPartial(e)) || [];
    message.infrastructureParams = (object.infrastructureParams !== undefined && object.infrastructureParams !== null)
      ? InfrastructureParams.fromPartial(object.infrastructureParams)
      : undefined;
    return message;
  },
};

function createBaseInfrastructureParams(): InfrastructureParams {
  return { infrastructurePeriods: [], coreRewards: [], partnerRewards: [] };
}

export const InfrastructureParams = {
  encode(message: InfrastructureParams, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.infrastructurePeriods) {
      Period.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    for (const v of message.coreRewards) {
      CoreReward.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.partnerRewards) {
      PartnerReward.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): InfrastructureParams {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseInfrastructureParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.infrastructurePeriods.push(Period.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.coreRewards.push(CoreReward.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.partnerRewards.push(PartnerReward.decode(reader, reader.uint32()));
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): InfrastructureParams {
    return {
      infrastructurePeriods: globalThis.Array.isArray(object?.infrastructurePeriods)
        ? object.infrastructurePeriods.map((e: any) => Period.fromJSON(e))
        : [],
      coreRewards: globalThis.Array.isArray(object?.coreRewards)
        ? object.coreRewards.map((e: any) => CoreReward.fromJSON(e))
        : [],
      partnerRewards: globalThis.Array.isArray(object?.partnerRewards)
        ? object.partnerRewards.map((e: any) => PartnerReward.fromJSON(e))
        : [],
    };
  },

  toJSON(message: InfrastructureParams): unknown {
    const obj: any = {};
    if (message.infrastructurePeriods?.length) {
      obj.infrastructurePeriods = message.infrastructurePeriods.map((e) => Period.toJSON(e));
    }
    if (message.coreRewards?.length) {
      obj.coreRewards = message.coreRewards.map((e) => CoreReward.toJSON(e));
    }
    if (message.partnerRewards?.length) {
      obj.partnerRewards = message.partnerRewards.map((e) => PartnerReward.toJSON(e));
    }
    return obj;
  },

  create(base?: DeepPartial<InfrastructureParams>): InfrastructureParams {
    return InfrastructureParams.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<InfrastructureParams>): InfrastructureParams {
    const message = createBaseInfrastructureParams();
    message.infrastructurePeriods = object.infrastructurePeriods?.map((e) => Period.fromPartial(e)) || [];
    message.coreRewards = object.coreRewards?.map((e) => CoreReward.fromPartial(e)) || [];
    message.partnerRewards = object.partnerRewards?.map((e) => PartnerReward.fromPartial(e)) || [];
    return message;
  },
};

function createBaseCoreReward(): CoreReward {
  return { address: new Uint8Array(0), weight: "" };
}

export const CoreReward = {
  encode(message: CoreReward, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.address.length !== 0) {
      writer.uint32(10).bytes(message.address);
    }
    if (message.weight !== "") {
      writer.uint32(18).string(message.weight);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CoreReward {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCoreReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.address = reader.bytes();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.weight = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): CoreReward {
    return {
      address: isSet(object.address) ? bytesFromBase64(object.address) : new Uint8Array(0),
      weight: isSet(object.weight) ? globalThis.String(object.weight) : "",
    };
  },

  toJSON(message: CoreReward): unknown {
    const obj: any = {};
    if (message.address.length !== 0) {
      obj.address = base64FromBytes(message.address);
    }
    if (message.weight !== "") {
      obj.weight = message.weight;
    }
    return obj;
  },

  create(base?: DeepPartial<CoreReward>): CoreReward {
    return CoreReward.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<CoreReward>): CoreReward {
    const message = createBaseCoreReward();
    message.address = object.address ?? new Uint8Array(0);
    message.weight = object.weight ?? "";
    return message;
  },
};

function createBasePartnerReward(): PartnerReward {
  return { address: new Uint8Array(0), rewardsPerSecond: undefined };
}

export const PartnerReward = {
  encode(message: PartnerReward, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.address.length !== 0) {
      writer.uint32(10).bytes(message.address);
    }
    if (message.rewardsPerSecond !== undefined) {
      Coin.encode(message.rewardsPerSecond, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PartnerReward {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePartnerReward();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.address = reader.bytes();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.rewardsPerSecond = Coin.decode(reader, reader.uint32());
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PartnerReward {
    return {
      address: isSet(object.address) ? bytesFromBase64(object.address) : new Uint8Array(0),
      rewardsPerSecond: isSet(object.rewardsPerSecond) ? Coin.fromJSON(object.rewardsPerSecond) : undefined,
    };
  },

  toJSON(message: PartnerReward): unknown {
    const obj: any = {};
    if (message.address.length !== 0) {
      obj.address = base64FromBytes(message.address);
    }
    if (message.rewardsPerSecond !== undefined) {
      obj.rewardsPerSecond = Coin.toJSON(message.rewardsPerSecond);
    }
    return obj;
  },

  create(base?: DeepPartial<PartnerReward>): PartnerReward {
    return PartnerReward.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<PartnerReward>): PartnerReward {
    const message = createBasePartnerReward();
    message.address = object.address ?? new Uint8Array(0);
    message.rewardsPerSecond = (object.rewardsPerSecond !== undefined && object.rewardsPerSecond !== null)
      ? Coin.fromPartial(object.rewardsPerSecond)
      : undefined;
    return message;
  },
};

function createBasePeriod(): Period {
  return { start: undefined, end: undefined, inflation: new Uint8Array(0) };
}

export const Period = {
  encode(message: Period, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.start !== undefined) {
      Timestamp.encode(toTimestamp(message.start), writer.uint32(10).fork()).ldelim();
    }
    if (message.end !== undefined) {
      Timestamp.encode(toTimestamp(message.end), writer.uint32(18).fork()).ldelim();
    }
    if (message.inflation.length !== 0) {
      writer.uint32(26).bytes(message.inflation);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Period {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePeriod();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.start = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.end = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.inflation = reader.bytes();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Period {
    return {
      start: isSet(object.start) ? fromJsonTimestamp(object.start) : undefined,
      end: isSet(object.end) ? fromJsonTimestamp(object.end) : undefined,
      inflation: isSet(object.inflation) ? bytesFromBase64(object.inflation) : new Uint8Array(0),
    };
  },

  toJSON(message: Period): unknown {
    const obj: any = {};
    if (message.start !== undefined) {
      obj.start = message.start.toISOString();
    }
    if (message.end !== undefined) {
      obj.end = message.end.toISOString();
    }
    if (message.inflation.length !== 0) {
      obj.inflation = base64FromBytes(message.inflation);
    }
    return obj;
  },

  create(base?: DeepPartial<Period>): Period {
    return Period.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Period>): Period {
    const message = createBasePeriod();
    message.start = object.start ?? undefined;
    message.end = object.end ?? undefined;
    message.inflation = object.inflation ?? new Uint8Array(0);
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

function toTimestamp(date: Date): Timestamp {
  const seconds = numberToLong(Math.trunc(date.getTime() / 1_000));
  const nanos = (date.getTime() % 1_000) * 1_000_000;
  return { seconds, nanos };
}

function fromTimestamp(t: Timestamp): Date {
  let millis = (t.seconds.toNumber() || 0) * 1_000;
  millis += (t.nanos || 0) / 1_000_000;
  return new globalThis.Date(millis);
}

function fromJsonTimestamp(o: any): Date {
  if (o instanceof globalThis.Date) {
    return o;
  } else if (typeof o === "string") {
    return new globalThis.Date(o);
  } else {
    return fromTimestamp(Timestamp.fromJSON(o));
  }
}

function numberToLong(number: number) {
  return Long.fromNumber(number);
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
