// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.181.0
//   protoc               v5.27.1
// source: kava/swap/v1beta1/swap.proto

/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Coin } from "../../../cosmos/base/v1beta1/coin";

export const protobufPackage = "kava.swap.v1beta1";

/** Params defines the parameters for the swap module. */
export interface Params {
  /** allowed_pools defines that pools that are allowed to be created */
  allowedPools: AllowedPool[];
  /** swap_fee defines the swap fee for all pools */
  swapFee: string;
}

/** AllowedPool defines a pool that is allowed to be created */
export interface AllowedPool {
  /** token_a represents the a token allowed */
  tokenA: string;
  /** token_b represents the b token allowed */
  tokenB: string;
}

/**
 * PoolRecord represents the state of a liquidity pool
 * and is used to store the state of a denominated pool
 */
export interface PoolRecord {
  /** pool_id represents the unique id of the pool */
  poolId: string;
  /** reserves_a is the a token coin reserves */
  reservesA?:
    | Coin
    | undefined;
  /** reserves_b is the a token coin reserves */
  reservesB?:
    | Coin
    | undefined;
  /** total_shares is the total distrubuted shares of the pool */
  totalShares: string;
}

/** ShareRecord stores the shares owned for a depositor and pool */
export interface ShareRecord {
  /** depositor represents the owner of the shares */
  depositor: Uint8Array;
  /** pool_id represents the pool the shares belong to */
  poolId: string;
  /** shares_owned represents the number of shares owned by depsoitor for the pool_id */
  sharesOwned: string;
}

function createBaseParams(): Params {
  return { allowedPools: [], swapFee: "" };
}

export const Params = {
  encode(message: Params, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    for (const v of message.allowedPools) {
      AllowedPool.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.swapFee !== "") {
      writer.uint32(18).string(message.swapFee);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Params {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseParams();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.allowedPools.push(AllowedPool.decode(reader, reader.uint32()));
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.swapFee = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Params {
    return {
      allowedPools: globalThis.Array.isArray(object?.allowedPools)
        ? object.allowedPools.map((e: any) => AllowedPool.fromJSON(e))
        : [],
      swapFee: isSet(object.swapFee) ? globalThis.String(object.swapFee) : "",
    };
  },

  toJSON(message: Params): unknown {
    const obj: any = {};
    if (message.allowedPools?.length) {
      obj.allowedPools = message.allowedPools.map((e) => AllowedPool.toJSON(e));
    }
    if (message.swapFee !== "") {
      obj.swapFee = message.swapFee;
    }
    return obj;
  },

  create(base?: DeepPartial<Params>): Params {
    return Params.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<Params>): Params {
    const message = createBaseParams();
    message.allowedPools = object.allowedPools?.map((e) => AllowedPool.fromPartial(e)) || [];
    message.swapFee = object.swapFee ?? "";
    return message;
  },
};

function createBaseAllowedPool(): AllowedPool {
  return { tokenA: "", tokenB: "" };
}

export const AllowedPool = {
  encode(message: AllowedPool, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.tokenA !== "") {
      writer.uint32(10).string(message.tokenA);
    }
    if (message.tokenB !== "") {
      writer.uint32(18).string(message.tokenB);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AllowedPool {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAllowedPool();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.tokenA = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.tokenB = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): AllowedPool {
    return {
      tokenA: isSet(object.tokenA) ? globalThis.String(object.tokenA) : "",
      tokenB: isSet(object.tokenB) ? globalThis.String(object.tokenB) : "",
    };
  },

  toJSON(message: AllowedPool): unknown {
    const obj: any = {};
    if (message.tokenA !== "") {
      obj.tokenA = message.tokenA;
    }
    if (message.tokenB !== "") {
      obj.tokenB = message.tokenB;
    }
    return obj;
  },

  create(base?: DeepPartial<AllowedPool>): AllowedPool {
    return AllowedPool.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<AllowedPool>): AllowedPool {
    const message = createBaseAllowedPool();
    message.tokenA = object.tokenA ?? "";
    message.tokenB = object.tokenB ?? "";
    return message;
  },
};

function createBasePoolRecord(): PoolRecord {
  return { poolId: "", reservesA: undefined, reservesB: undefined, totalShares: "" };
}

export const PoolRecord = {
  encode(message: PoolRecord, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.poolId !== "") {
      writer.uint32(10).string(message.poolId);
    }
    if (message.reservesA !== undefined) {
      Coin.encode(message.reservesA, writer.uint32(18).fork()).ldelim();
    }
    if (message.reservesB !== undefined) {
      Coin.encode(message.reservesB, writer.uint32(26).fork()).ldelim();
    }
    if (message.totalShares !== "") {
      writer.uint32(34).string(message.totalShares);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): PoolRecord {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePoolRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.poolId = reader.string();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.reservesA = Coin.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.reservesB = Coin.decode(reader, reader.uint32());
          continue;
        case 4:
          if (tag !== 34) {
            break;
          }

          message.totalShares = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): PoolRecord {
    return {
      poolId: isSet(object.poolId) ? globalThis.String(object.poolId) : "",
      reservesA: isSet(object.reservesA) ? Coin.fromJSON(object.reservesA) : undefined,
      reservesB: isSet(object.reservesB) ? Coin.fromJSON(object.reservesB) : undefined,
      totalShares: isSet(object.totalShares) ? globalThis.String(object.totalShares) : "",
    };
  },

  toJSON(message: PoolRecord): unknown {
    const obj: any = {};
    if (message.poolId !== "") {
      obj.poolId = message.poolId;
    }
    if (message.reservesA !== undefined) {
      obj.reservesA = Coin.toJSON(message.reservesA);
    }
    if (message.reservesB !== undefined) {
      obj.reservesB = Coin.toJSON(message.reservesB);
    }
    if (message.totalShares !== "") {
      obj.totalShares = message.totalShares;
    }
    return obj;
  },

  create(base?: DeepPartial<PoolRecord>): PoolRecord {
    return PoolRecord.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<PoolRecord>): PoolRecord {
    const message = createBasePoolRecord();
    message.poolId = object.poolId ?? "";
    message.reservesA = (object.reservesA !== undefined && object.reservesA !== null)
      ? Coin.fromPartial(object.reservesA)
      : undefined;
    message.reservesB = (object.reservesB !== undefined && object.reservesB !== null)
      ? Coin.fromPartial(object.reservesB)
      : undefined;
    message.totalShares = object.totalShares ?? "";
    return message;
  },
};

function createBaseShareRecord(): ShareRecord {
  return { depositor: new Uint8Array(0), poolId: "", sharesOwned: "" };
}

export const ShareRecord = {
  encode(message: ShareRecord, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.depositor.length !== 0) {
      writer.uint32(10).bytes(message.depositor);
    }
    if (message.poolId !== "") {
      writer.uint32(18).string(message.poolId);
    }
    if (message.sharesOwned !== "") {
      writer.uint32(26).string(message.sharesOwned);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): ShareRecord {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseShareRecord();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag !== 10) {
            break;
          }

          message.depositor = reader.bytes();
          continue;
        case 2:
          if (tag !== 18) {
            break;
          }

          message.poolId = reader.string();
          continue;
        case 3:
          if (tag !== 26) {
            break;
          }

          message.sharesOwned = reader.string();
          continue;
      }
      if ((tag & 7) === 4 || tag === 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): ShareRecord {
    return {
      depositor: isSet(object.depositor) ? bytesFromBase64(object.depositor) : new Uint8Array(0),
      poolId: isSet(object.poolId) ? globalThis.String(object.poolId) : "",
      sharesOwned: isSet(object.sharesOwned) ? globalThis.String(object.sharesOwned) : "",
    };
  },

  toJSON(message: ShareRecord): unknown {
    const obj: any = {};
    if (message.depositor.length !== 0) {
      obj.depositor = base64FromBytes(message.depositor);
    }
    if (message.poolId !== "") {
      obj.poolId = message.poolId;
    }
    if (message.sharesOwned !== "") {
      obj.sharesOwned = message.sharesOwned;
    }
    return obj;
  },

  create(base?: DeepPartial<ShareRecord>): ShareRecord {
    return ShareRecord.fromPartial(base ?? {});
  },
  fromPartial(object: DeepPartial<ShareRecord>): ShareRecord {
    const message = createBaseShareRecord();
    message.depositor = object.depositor ?? new Uint8Array(0);
    message.poolId = object.poolId ?? "";
    message.sharesOwned = object.sharesOwned ?? "";
    return message;
  },
};

function bytesFromBase64(b64: string): Uint8Array {
  if ((globalThis as any).Buffer) {
    return Uint8Array.from(globalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = globalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if ((globalThis as any).Buffer) {
    return globalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(globalThis.String.fromCharCode(byte));
    });
    return globalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Long ? string | number | Long : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
